<?php

/**
 *  Funkcje globalne dla esculap.pl i stron podlehgających.
 *  @package DB_Easy.class.php
 **/

if(!isset($db)){
    require_once('PDOS.class.php');
    $db = PDOS::getInstance();
}

/**
 *  Pobiera rekord z main_users.
 *  @global $GLOBALS['db'] - uchwyt do bazy pgsql
 *  @param string $user_login - login użytkownika
 *  @return array - jednowymiarowa tablica z rekordem użytkownika
 **/
function get_user_data($user_login)
{
    global $db;
    $sql = "SELECT * FROM main_users WHERE user_login='{$user_login}'";
    $data = $db->getRow($sql);
    $sql = "SELECT spec_code, spec_type FROM rel_users_spec WHERE user_login='{$user_login}'";
    foreach($db->getAll($sql) as $spec){
        switch($spec['spec_type']){
            case 'MAIN':
                $data['main_spec'] = $spec['spec_code'];
                break;
            case 'CURR':
                $data['current_spec'] = $spec['spec_code'];
                break;
            case 'ADDIT':
                $data['addit_spec'] = $spec['spec_code'];
                break;
            case 'INTE':
                $data['interested'][$spec['spec_code']] = $spec['spec_code'];
                break;
        }
    }
    return $data;
}

/**
 *  Pobiera pełną nazwę specjalizacji
 **/
function get_spec_full_name($spec)
{
    global $db;
    return $db->getOne("SELECT mdm_name FROM dict_spec WHERE spec_code='{$spec}'");
}

/**
 *  Szuka w nagłówkach domyślnego języka przeglądarki.
 *  @param string $delault - język zwracany gdy nie znajdzie się żaden inny
 *  @return string - kod języka
 **/
function get_browser_language($default = null)
{
    $tmp = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
    if(strpos($tmp, ';'))
        $tmp = explode(';', $tmp);
    else
        $tmp = array($tmp);
    $tmp = $tmp[0];
    if(strpos($tmp, ','))
        $tmp = explode(',', $tmp);
    else{
        $tmp = array($tmp);
    }
    $tmp = $tmp[0];
    if(empty($tmp))
        $tmp = $default;
    
    return strtoupper($tmp);
}

/**
 *  Wykorzystuje geoip aby odnaleźć kraj użytkownika
 *  @return string - kod kraju
 **/
function get_ip_country()
{
    $tmp = geoip_country_code_by_name($_SERVER['REMOTE_ADDR']);
    return strtoupper($tmp);
}


function get_calendar( $month, $day )
{
	global $db;
    $sql = "select * from esculap.dict_calendar WHERE month='{$month}' AND day='{$day}';";
    $data = $db->getRow($sql);
	return $data;
}

?>