<?php

/**
 *  Funkcje związane z SocialEngine dla esculap.pl i stron podlehgających.
 *  @package DB_Easy.class.php
 **/

if(!isset($sdb)){
    require_once('DB_Easy.class.php');
    $sdb = DB_connect('social');
    if(!isset($db))
        $db = DB_connect('portal');
}

/**
 *  Sprawdza czy użytkownik jest już w socialu
 *  @global $GLOBALS['sdb'] - uchwyt do mysql
 *  @param string $user_login - login użytkownika
 *  @return boolean - czy użytkownik należy już do SocialNetwork
 **/
function user_in_social($user_login)
{
    global $sdb;
    $sql = "SELECT COUNT(1) FROM se_users WHERE user_username='{$user_login}'";
    if($sdb->getOne($sql)>0)
        return true;
    return false;
}

/**
 *  Pobiera user_id z SocialEngine
 *  @global $GLOBALS['sdb'] - uchwyt do mysql
 *  @param string $user_login - login użytkownika
 *  @return integer - user_id
 **/
function get_social_user_id($user_login)
{
    global $sdb;
    $sql = "SELECT user_id FROM se_users WHERE user_username='{$user_login}'";
    return $sdb->getOne($sql);
}

/**
 *  Zlicza ilość powiadomień
 *  @global $GLOBALS['sdb'] - uchwyt do mysql
 *  @param string $user_login - login użytkownika
 *  @return integer - ilość nowych powiadomień
 **/
function count_notifys($user_login)
{
    global $sdb;
    $user_id = get_social_user_id($user_login);
    $sql = "SELECT COUNT(1) FROM se_notifys WHERE notify_user_id = '{$user_id}'";
    $amount = $sdb->getOne($sql);
    return $amount;
}

/**
 *  Ostatnio dodani użytkownicy
 *  @global $GLOBALS['sdb'] - uchwyt do mysql
 *  @param integer $limit - ilość
 *  @return array - dane użytkowników
 **/
function last_join_users($limit = 1)
{
    global $sdb;
    $sql = "SELECT * FROM se_users ORDER BY user_signupdate DESC LIMIT {$limit}";
    $data = $sdb->getAll($sql);
    for($i=0;$i<count($data);$i++){
        if(strlen($data[$i]['user_photo'])){
            $subdir = $data[$i]['user_id']+999-(($data[$i]['user_id']-1)%1000);
            $data[$i]['user_photo_link'] = "./uploads_user/{$subdir}/{$data[$i]['user_id']}/{$data[$i]['user_photo']}";
            $user_photo_thumb = str_replace('.', '_thumb.', $data[$i]['user_photo']);
            $data[$i]['user_photo_thumb_link'] = "./uploads_user/{$subdir}/{$data[$i]['user_id']}/{$user_photo_thumb}";
        }else{
            $data[$i]['user_photo_link'] = null;
            $data[$i]['user_photo_thumb_link'] = null;
        }
    }
    return $data;
}

/**
 *  Ostatni temat na forum
 *  @global $GLOBALS['sdb'] - uchwyt do mysql
 *  @param integer/array $forum_id - identyfikatory forów
 *  @param integer $limit - ilość
 *  @return array - ilość nowych powiadomień
 **/
function last_subject_forum($forum_id, $limit = 1)
{
    global $sdb;
    if(!is_array($forum_id))
        $forum_id = array($forum_id);
    $forum_id = implode(', ', $forum_id);
    $sql = "SELECT * FROM se_forumtopics WHERE forumtopic_forum_id IN ({$forum_id}) ORDER BY forumtopic_date DESC LIMIT {$limit}";
    $data = $sdb->getAll($sql);
    return $data;
}


?>