<?php

require_once(dirname(__FILE__) . "/htmlMimeMail5.php");

class htmlMimeMail5Ext extends htmlMimeMail5
{

    public function checkContentType($img)
    {
        $ext = preg_replace('#^.*\.(\w{3,4})$#e', 'strtolower("$1")', $img);
        $content_type = $this->image_types[$ext];
        return $content_type;
    }
    
    /**
     *  Zwraca sparsowaną treść wiadomości
     */
    public function returnOutput()
    {
        if (!$this->is_built) {
            $this->build();
        }
        return $this->output;
    }
    
    /**
     *  Zwraca nagłówki wiadomości
     */
    public function returnHeaders()
    {
        return serialize($this->headers);
    }
    
    /**
     *  Ustawia treść i nagłówki wiadomości
     */
    public function setBuild($output,$headers)
    {
        $this->output = $output;
        $this->is_built = true;
        $this->headers = unserialize($headers);
    }
    
    public function send_SMTP($header_to, $change = null)
    {
        //Ustawienie nagłówka To
        $this->headers['To'] = $header_to;
        
        if (!defined('CRLF')) {
            $this->setCRLF( "\r\n");
        }
        
        if (!$this->is_built) {
            $this->build();
        }
        
        require_once(dirname(__FILE__) . '/smtp.php');
        require_once(dirname(__FILE__) . '/RFC822.php');
        $smtp = &smtp::connect($this->smtp_params);
        
        $output = $this->output;
        
        //Zmiana danych dla personalizacji części body
        if(is_array($change)){
            $text_start = strpos($output, 'Content-Type: text/plain;');
            $text_stop = strpos($output, '--=_', $text_start);
            $text_part = substr($output,$text_start,$text_stop-$text_start);
            $html_start = strpos($output, 'Content-Type: text/html;');
            $html_stop = strpos($output, '--=_', $html_start);
            $html_part = substr($output,$html_start,$html_stop-$html_start);
            foreach($change as $ch_key => $ch_value){
                if(substr($ch_key,1,4) == 'BODY' || substr($ch_key,1,9) == 'FULL_NAME'){
                    $text_part = str_replace($ch_key,$ch_value,$text_part);
                    $ch_value = str_replace('=','=3D',$ch_value);
                    $html_part = str_replace($ch_key,$ch_value,$html_part);
                    unset($change[$ch_key]);
                }
            }
            if($text_start>$html_start){
                $output = substr_replace($output,$text_part,$text_start,$text_stop-$text_start);
                $output = substr_replace($output,$html_part,$html_start,$html_stop-$html_start);
            }else{
                $output = substr_replace($output,$html_part,$html_start,$html_stop-$html_start);
                $output = substr_replace($output,$text_part,$text_start,$text_stop-$text_start);
            }
        }
        
        // Get flat representation of headers, parsing
        // Cc and Bcc as we go
        foreach ($this->headers as $name => $value) {
            //Zmiana danych dla personalizacji części header
            if(is_array($change)){
                foreach($change as $ch_key => $ch_value){
                    if(substr($ch_key,1,6) == 'HEADER'){
                        $ch_value = str_replace('=','=3D',$ch_value);
                        $value = str_replace($ch_key,$ch_value,$value);
                    }
                }
            }
            if ($name == 'Cc' OR $name == 'Bcc' OR $name == 'To') {
                $addresses = Mail_RFC822::parseAddressList($value, $this->smtp_params['helo'], null, false);
                foreach ($addresses as $address) {
                    $smtp_recipients[] = sprintf('%s@%s', $address->mailbox, $address->host);
                }
            }
            if ($name == 'Bcc') {
                continue;
            }
            
            $headers[] = $name . ': ' . $this->encodeHeader($value, $this->build_params['head_charset']);
        }
        
        // Add headers to send_params
        $send_params['headers']    = $headers;
        $send_params['recipients'] = array_values(array_unique($smtp_recipients));
        $send_params['body']       = $output;
        
        // Setup return path
        if (isset($this->return_path)) {
            $send_params['from'] = $this->return_path;
        } elseif (!empty($this->headers['From'])) {
            $from = Mail_RFC822::parseAddressList($this->headers['From'], null, null, false);
            $send_params['from'] = sprintf('%s@%s', $from[0]->mailbox, $from[0]->host);
        } else {
            $send_params['from'] = 'postmaster@' . $this->smtp_params['helo'];
        }
        //echo '<pre>';print_r($send_params);echo '</pre>';exit;
        // Send it
        if (!$smtp->send($send_params)) {
            $this->errors = $smtp->getErrors();
            return false;
        }
        return true;
    }
    
    /**
     *  Tworzy pełną wersję emaila
     */
    private function prepareFullOutput()
    {
        $headers = $this->headers;
        $headers['To'] = "spam@esculap.pl";
        $headers2 = null;
        foreach ($headers as $name => $value) {
            $headers2[] = $name . ': ' . $this->encodeHeader($value, $this->output['charset']);
        }
        return implode("\r\n",$headers2)."\r\n\r\n".$this->output;
    }
    
    /**
     *  Sprawdza prawdopodobieństwo trafienia wiadomości do spamu
     */
    public function checkSpam()
    {
        $raw = $this->prepareFullOutput();
        $contentlength = strlen($raw);
        $message  = "REPORT SPAMC/1.2\r\n";
        $message .="Content-Length: " . $contentlength . "\r\n\r\n";
        $message  .= $raw;
        $s = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
        socket_connect($s, '10.10.1.136'/*gethostbyname('spamgate.esculap.pl')*/, 783);
        socket_write($s, $message, strlen($message));
        @socket_shutdown($s, 1);
        $response = socket_read($s,1024);
        $score = socket_read($s,1024,PHP_NORMAL_READ);
        $banner = socket_read($s,10024);
      //  $qq = socket_read($s,1024,PHP_NORMAL_READ);
      //  $explain = socket_read($s,1024);
      //  $repo = socket_read($s,1024);
        @socket_shutdown($s, 2);
        return $score."<pre>".$banner."</pre>";
    }
    
    /**
     *  Zwraca przypuszczalny rozmiar wiadomości
     */
    public function getWeight()
    {
        return strlen($this->prepareFullOutput());
    }
}

?>
