<?php

require_once 'phrase.class.php';

/**
 * 
 * Funkcja umożliwiająca wyświetlenie holderów banera
 * @param array $params
 * @param object $template
 * 
 */
function smarty_function_phrase($params, $template)
{
    if(!isset($params['id']) || empty($params['id'])){
        trigger_error("Brak identyfikatora frazy [id]!", E_USER_WARNING);
        return;
    }
    $phrase_id = $params['id'];
    unset($params['id']);
    
    if(!isset($params['lang_id']) || empty($params['lang_id'])){
        $lang_id = defined('CONTR_LANG')?CONTR_LANG:'PL';
    }else{
        $lang_id = $params['lang_id'];
        unset($params['lang_id']);
    }
    
    if(isset($params['prefix'])){
        if(is_string($phrase_id))
            $phrase_id = $params['prefix'].$phrase_id;
        unset($params['prefix']);
    }
    
    if(isset($params['postfix'])){
        if(is_string($phrase_id))
            $phrase_id = $phrase_id.$params['postfix'];
        unset($params['postfix']);
    }
    
    $tags = $defs = array();
    foreach($params as $k=>$v){
        if(preg_match('/^def_[a-zA-Z]{2}$/i', $k))
            $defs[substr(strtoupper($k), -2, 2)] = $v;
        else
            $tags[$k] = $v;
    }
    
    
    $anchor = phrase::get($phrase_id, $lang_id, $tags, $defs);
    return $anchor;
}

?>