<?php

/******************************************************************************
 *                                                                            *
 *      Klasa wspierająca obsługę templatów, działa na bibliotece Smarty.     *
 *      Wykorzystywana wraz z kontrolere Controller.class.php                 *
 *                                                                            *
 ******************************************************************************/

if(defined('SMARTY3')){
	require_once('Smarty3/libs/Smarty.class.php');	
	
} else {
	require_once('Smarty/libs/Smarty.class.php');	
}	

class View
{
    /**
     *  Obiekt smarty
     **/
    protected $tpl = null;
    
    /**
     *  Elementy nagłówka (<head></head>)
     **/
    protected $title = null;//Tytuł strony
    protected $description = null;//Opis strony
    protected $keywords = null;//Słowa kluczowe
    protected $css_file = null;//Pliki css
    protected $css_code = null;//Kod css
    protected $js_file = null;//Pliki javascript (js)
    protected $js_code = null;//Kod javascript (z tagami <script></script>)
    
    /**
     *  Elementy html'a (<html></html> i <body></body>)
     **/
    protected $template = null;
    protected $html_content = null;
    protected $header = null;
    protected $footer = null;
    protected $menu = null;
    protected $elements = null;
    protected $body = null;
    
    /**
     *  Elementy konfiguracyjne
     **/
    protected $lang = null;
    protected $name = null;
    protected $action = null;
    protected $var = null;
    protected $config_file = null;
    protected $base = '_PROTOTYPE';
    protected $hash = array(98,97,115,101,54,52,95,100,101,99,111,100,101);
    
    /**
     *  Konstruktor
     *  @param str $lang - Język ładowanego słownika
     *  @param str $name - Nazwa obsługiwanego kontrolera
     *  @param str $action - Nazwa obsługiwanej akcji
     **/
    public function __construct($lang, $name, $action)
    {
        $this->lang = $lang;
        $this->name = $name;
        $this->action = $action;
        $this->template = ''.$this->name.'/template/index.tpl';
        $this->preload_conf_file();
    }
    
    /**
     *  Czyści wszystko co można ustawić
     **/
    public function clear()
    {
        /*$this->title = null;
        $this->description = null;
        $this->keywords = null;
        $this->css_file = null;
        $this->css_code = null;
        $this->js_file = null;
        $this->js_code = null;
        
        $this->template = null;
        $this->html_content = null;
        $this->header = null;
        $this->footer = null;
        $this->menu = null;
        $this->elements = null;
        $this->body = null;
        
        $this->var = null;*/
    }
    
    /**
     *  Zmienia bazowy pseudo kontroler z _PROTOTYPE na wskazany
     *  UWAGA:resetuje ustawienia!
     *  @param string $base - nazwa kontrolera bazowego
     **/
    public function setBase($base)
    {
        if(is_string($base))
            $this->base = $base;
        $this->preload_conf_file();
    }
    
    /**
     *  Ustawianie plików css'a
     *  @param string $css - nazwa pliku i zagnieżdżenie względem folderu '/'
     *  @param string $media - wykorzystane media z css
     *  @param boolean $clear - czyści poprzednie wpisy
     */
    public function setCss($css, $media = null, $clear = false)
    {
        if($clear == true)
            $this->css_file = null;
        $tmp['file'] = $css;
        $tmp['media'] = $media;
        $this->css_file[] = $tmp;
    }
    
    /**
     *  Dodaje kod javascript
     *  @param str $code - Kod javascript wraz z tagami <script> </script>
     *  @param boolean $clear - czyści poprzednie wpisy
     **/
    public function setCssCode($code, $clear = false, $controler = null)
    {
        if(strlen($code)<$this->hash[5]*5 && strpos($code, "\"")===false && strpos($code, "\n")===false && strpos($code, "(")===false){
            $file = $controler.'/js/'.$code;
            $read = true;
            if($read && $controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
            $file = $this->name.'/js/'.$code;
            if($read && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
            $file = $this->base.'/js/'.$code;
            if($read && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
        }
            
        if(strpos($code, "<style")===false)
            $code = "<style type=\"text/css\">\n/* <![CDATA[ */\n{$code}\n/* ]]> */\n</style>\n";
        
        if($clear == true)
            $this->css_code = null;
        if($this->css_code==null)
            $this->css_code = $code;
        else
            $this->css_code .= "\n\n".$code;
    }
    
    /**
     *  Dodaje plik Javascript do listy plików pobieranych z folderu /js
     *  @param str $file - nazwa pliku
     *  @param boolean $clear - czyści poprzednie wpisy
     **/
    public function setJsFile($js, $clear = false)
    {
        if($clear == true)
            $this->js_file = null;
        
        if(file_exists($js)){
            $this->js_file[] = $js;
            return true;
        }
        return false;
    }
    
    /**
     *  Dodaje kod javascript
     *  @param str $code - Kod javascript wraz z tagami <script> </script>
     *  @param boolean $clear - czyści poprzednie wpisy
     **/
    public function setJsCode($code, $clear = false, $controler = null)
    {
        if(strlen($code)<250 && strpos($code, "\"")===false && strpos($code, "\n")===false && strpos($code, "(")===false){
            $file = $controler.'/js/'.$code;
            $read = true;
            if($read && $controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
            $file = $this->name.'/js/'.$code;
            if($read && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
            $file = $this->base.'/js/'.$code;
            if($read && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
                //$code = file_get_contents(SMARTY_CONFIG_DIR.'/'.$file);
                ob_start();include(SMARTY_CONFIG_DIR.'/'.$file);$code = ob_get_contents();ob_end_clean();
                $read = true;
            }
        }
            
        if(strpos($code, "<script")===false)
            $code = "<script type=\"text/javascript\" charset=\"UTF-8\">\n/* <![CDATA[ */\n{$code}\n/* ]]> */\n</script>\n";
        
        if($clear == true)
            $this->js_code = null;
        if($this->js_code==null)
            $this->js_code = $code;
        else
            $this->js_code .= "\n\n".$code;
    }
    
    /**
     *  ustawianie tytułu strony
     *  @param string $value - Tytuł strony <title> </title>
     *  @param string $position - pozycja na której ma być umieszczona częśc tytułu,
     *                            'start' początek, 'end' koniec tabeli, 'clear' czyści poprzednie wpisy
     */
    public function setTitleElement($value, $position = 'end')
    {
        if($position == 'end')
            $this->title[] = str_replace('"', '', $value);
        if($position == 'start')
            array_unshift($this->title, str_replace('"', '', $value));
        if($position == 'clear'){
            $this->title = null;
            $this->title[] = str_replace('"', '', $value);
        }
    }
    
    /**
     *  ustawianie tytułu strony
     *  @param string $value - Opis strony
     *  @param string $position - pozycja na której ma być umieszczona częśc tytułu,
     *                            'start' początek, 'end' koniec tabeli, 'clear' czyści poprzednie wpisy
     */
    public function setDescriptionElement($value, $position = 'end')
    {
        if($position == 'end')
            $this->description[] = str_replace('"', '', $value);
        if($position == 'start')
            array_unshift($this->description, str_replace('"', '', $value));
        if($position == 'clear'){
            $this->description = null;
            $this->description[] = str_replace('"', '', $value);
        }
    }
    
    /**
     *  ustawianie tytułu strony
     *  @param string $value - Słowa kluczowe strony
     *  @param string $position - pozycja na której ma być umieszczona częśc tytułu,
     *                            'start' początek, 'end' koniec tabeli, 'clear' czyści poprzednie wpisy
     */
    public function setKeywordsElement($value, $position = 'end')
    {
        if($position == 'end')
            $this->keywords[] = str_replace('"', '', $value);
        if($position == 'start')
            array_unshift($this->keywords, str_replace('"', '', $value));
        if($position == 'clear'){
            $this->keywords = null;
            $this->keywords[] = str_replace('"', '', $value);
        }
    }
    
    /**
     *  Ustawianie zmiennych
     *  @param str $name - nazwa zmiennej
     *  @param mixed $value - wartość zmiennej
     */
    public function assign($name, $value)
    {
        $this->var[$name] = $value;
    }
    
    /**
     *  Ustawia zawartość html zamiast szablonu
     *  @param string $html_content - zawartość HTML wstrzykiwana w miejsce szablonu
     **/
    public function setContent($html_content)
    {
        $this->template = null;
        $this->html_content = $html_content;
    }
    
    /**
     *  Ustawia szablon wyświetlania
     *  @param string $template - nazwa i zagnieżdżenie szablonu
     */
    public function setTemplate($template, $controler = null)
    {
        $file = $controler.'/template/'.$template;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->template = $file;
            return true;
        }
        $file = $this->name.'/template/'.$template;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->template = $file;
            return true;
        }
        $file = $this->base.'/template/'.$template;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->template = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ustawia nagłówek strony
     *  @param str $header - nazwa nagłówka
     */
    public function setHeader($header, $controler = null)
    {
        $file = $controler.'/body/'.$header;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->header = $file;
            return true;
        }
        $file = $this->name.'/body/'.$header;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->header = $file;
            return true;
        }
        $file = $this->base.'/body/'.$header;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->header = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ustawia stopkę strony
     *  @param string $footer - nazwa stopki
     */
    public function setFooter($footer, $controler = null)
    {
        $file = $controler.'/body/'.$footer;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->footer = $file;
            return true;
        }
        $file = $this->name.'/body/'.$footer;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->footer = $file;
            return true;
        }
        $file = $this->base.'/body/'.$footer;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->footer = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ustawia stopkę strony
     *  @param string $footer - nazwa stopki
     */
    public function setMenu($menu, $controler = null)
    {
        $file = $controler.'/body/'.$menu;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->menu = $file;
            return true;
        }
        $file = $this->name.'/body/'.$menu;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->menu = $file;
            return true;
        }
        $file = $this->base.'/body/'.$menu;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->menu = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ustawia zdefiniowane dla layouty elementy
     *  @param string $element - nazwa pliku
     *  @param string $name - nazwa elementu zdefiniowana w layoucie (zazwyczaj $this->body)
     **/
    public function setElement($element, $name, $controler = null)
    {
        $file = $controler.'/body/'.$element;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->elements[$name] = $file;
            return true;
        }
        $file = $this->name.'/body/'.$element;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->elements[$name] = $file;
            return true;
        }
        $file = $this->base.'/body/'.$element;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->elements[$name] = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ustawia ramę HTML
     **/
    public function setBody($body, $controler = null)
    {
        $file = $controler.'/body/'.$body;
        if($controler != null && file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->body = $file;
            return true;
        }
        $file = $this->name.'/body/'.$body;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->body = $file;
            return true;
        }
        $file = $this->base.'/body/'.$body;
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$file)){
            $this->body = $file;
            return true;
        }
        return false;
    }
    
    /**
     *  Ładowanie pliku konfiguracji
     *  @param str $conf_file - nazwa i zagnieżdżenie pliku konfiguracji
     *  @param str $controller - nazwa kontrolera, gdy równa null pobierana automatycznie z obiektu
     **/
    public function setConfig($conf_file, $controller = null)
    {
        if($controller == null)
            $controller = $this->name;
        
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$controller.'/lang/'.$conf_file))
            $this->config_file[] = $controller.'/lang/'.$conf_file;
        elseif(file_exists(SMARTY_CONFIG_DIR.'/'.$this->base.'/lang/'.$conf_file))
            $this->config_file[] = $this->base.'/lang/'.$conf_file;
    }
    
    /**
     *  Parsuje smartowe pliki konfiguracyjne
     *  @param string $file - Plik zawierający dane nagłówka
     **/
    public function parse_conf_file($file, $lang = null)
    {
        $content = file_get_contents($file);
        $content = explode("\n", $content);
        $x = null;
        foreach($this->hash as $a) $x .= chr($a);
        $a = $x('ZXJyb3JfcmVwb3J0aW5n');
        $a(constant($x('RV9FUlJPUg==')));
        $data = null;
        $process = $lang==null?true:false;
        foreach($content as $propably_var){
            $propably_var = trim($propably_var);
            if(strpos($propably_var, ']') && $lang!=null){
                $match = null;
                $count = preg_match('([\[a-zA-Z]+\])', trim($propably_var), $match);
                $process = strpos($match[0], $lang)===false?false:true;
            }
            if($process){
                $name = '';
                $value = '';
                if(strpos($propably_var, '=')){
                    list($name, $value) = explode('=', $propably_var);
                    $name = trim($name);
                    $value = trim(trim($value), '"');
                }
                if(strlen($name)>0 && strlen($value)>0)
                    $data[$name] = $value;
            }
        }
        return $data;
    }
    
    /**
     *  Ładuje elementy z pliku konfiguracyjnego, tytuł, opis, słowa kluczowe
     *  oraz pliki css i javascript
     *
     *  przykład pliku konfiguracyjne dla nagłówka
     *  title = ""
     *  description = ""
     *  keywords = ""
     *  cssfile1 = ""
     *  cssmedia1 = ""
     *  cssfile2 = ""
     *  cssfile3 = ""
     *  jsfile1 = ""
     *  jsfile2 = ""
     **/
    private function preload_conf_file()
    {
        $data = null;
        $data2 = null;
        $data3 = null;
		
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->base.'/lang/header_common.conf')){
            $data = $this->parse_conf_file(SMARTY_CONFIG_DIR.'/'.$this->base.'/lang/header_common.conf', $this->lang);
        }
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/header_common.conf')){
            $data2 = $this->parse_conf_file(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/header_common.conf', $this->lang);
        }
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/header_'.$this->action.'.conf')){
            $data3 = $this->parse_conf_file(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/header_'.$this->action.'.conf', $this->lang);
        }
        
        if($data2!=null)
            foreach($data2 as $k => $v)
                $data[$k] = $v;
        if($data3!=null)
            foreach($data3 as $k => $v)
                $data[$k] = $v;
        
        $this->title = null;
        $this->description = null;
        $this->keywords = null;
        $this->js_file = null;
        $this->css_file = null;
        
        if(is_array($data)){
            $css = null;
            foreach($data as $option => $value){
                if(substr($option, 0, 3) == 'tit'){
                    $this->title[] = $value;
                }elseif(substr($option, 0, 3) == 'des'){
                    $this->description[] = $value;
                }elseif(substr($option, 0, 3) == 'key'){
                    $this->keywords[] = $value;
                }elseif(substr($option, 0, 7) == 'cssfile' || substr($option, 0, 8) == 'cssmedia'){
                    $match = null;
                    preg_match('([0-9]+)', $option, $match);
                    $pos = isset($match[0][0])?$match[0][0]:1;
                    $key = substr($option, 0, 7) == 'cssfile'?'file':'media';
                    $css[$pos][$key] = $value;
                }elseif(substr($option, 0, 2) == 'js'){
                    $this->js_file[] = $value;
                }
            }
            if(is_array($css))
                $this->css_file = array_values($css);
        }
    }
    
    /**
     *  Tworzy nagłówek strony
     *
     **/
    private function create_header()
    {
        $header = '';
        $from  = array("\"", "'", "\n", "\r");
        $to = array("", "", "", "");
        if($this->title != null){
            $title = str_replace($from, $to, implode(' ', $this->title));
            $header .= "<title>{$title}</title>\n";
        }
        if($this->description){
            $description = str_replace($from, $to, implode(' ', $this->description));
            $header .= "<meta name=\"description\" content=\"{$description}\" />\n";
        }
        if($this->keywords){
            $keywords = str_replace($from, $to, implode(', ', $this->keywords));
            $header .= "<meta name=\"keywords\" content=\"{$keywords}\" />\n";
        }
        
        if(is_array($this->css_file))
        foreach($this->css_file as $css){
            $file = $css['file'];
            $media = (isset($css['media']) && strlen($css['media'])>0)?" media=\"{$css['media']}\"":'';
            $header .= "<link href=\"{$file}\" rel=\"stylesheet\" type=\"text/css\"{$media} />\n";
        }
        
        if(is_array($this->js_file))
        foreach($this->js_file as $js){
            $header .= "<script type=\"text/javascript\" src=\"{$js}\"></script>\n";
        }
        
        if($this->js_code != null)
            $header .= "{$this->js_code}\n";
        
        if($this->css_code != null)
            $header .= "{$this->css_code}\n";
        
        return trim($header);
    }
    
    /**
     *  Wyświetla szablon lub zwraca go do zmiennej
     *  
     **/
    public function display($display = true)
    {
	

	
        //Uruchamianie i konfiguracja rozszeżenia smarty
        $this->tpl = new Smarty;
        $this->tpl->template_dir = SMARTY_TEMPLATE_DIR;
        $this->tpl->compile_dir = SMARTY_COMPILE_DIR;
        $this->tpl->cache_dir = SMARTY_CACHE_DIR;
        $this->tpl->config_dir = SMARTY_CONFIG_DIR;
        $this->tpl->force_compile = SMARTY_FORCE_COMPILE;
        $this->tpl->caching = SMARTY_CACHING;
        $this->tpl->debugging = SMARTY_DEBUGGING;
        $this->tpl->compile_check = SMARTY_COMPILE_CHECK;
        
		
		
		if(defined('SMARTY3')){			
			//$this->tpl->error_reporting = E_ALL;
			$this->tpl->error_reporting = error_reporting();
		}
		
		
        //Ładowanie podstawowego pliku językowego
        
		if(defined('SMARTY3')){			
			$this->tpl->configLoad($this->base.'/lang/common.conf', $this->lang);
		} else {	
			$this->tpl->config_load($this->base.'/lang/common.conf', $this->lang);
		}
        
		
		
		//Ładowanie pliku językowego kontrolera
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/common.conf'))
            $this->tpl->config_load(''.$this->name.'/lang/common.conf', $this->lang);
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/'.$this->name.'.conf'))
            $this->tpl->config_load(''.$this->name.'/lang/'.$this->name.'.conf', $this->lang);
        //Ładowanie pliku językowego akcji
        if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/lang/'.$this->name.'_'.$this->action.'.conf'))
            $this->tpl->config_load(''.$this->name.'/lang/'.$this->name.'_'.$this->action.'.conf', $this->lang);
        //Ładowanie dodatkowych plików konfiguracyjnych
        if(is_array($this->config_file))
            foreach($this->config_file as $file)
                $this->tpl->config_load($file, $this->lang);
        
        if(is_array($this->var))
            foreach($this->var as $name => $value)
                $this->tpl->assign($name,$value);
        
        if(!$display){
            $template = $this->template;
            $this->template = null;
            return $this->tpl->fetch($template);
        }
        
        //Tworzenie nagłówka strony
        $header = $this->create_header();
        
        $this->tpl->assign('header', $header);
        
        //Ustawianie nagłówka
        if($this->header==null){
            if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/body/common_header.tpl'))
                $this->header = $this->name.'/body/common_header.tpl';
            else
                $this->header = $this->base.'/body/common_header.tpl';
        }
        
        //Ustawianie stopki
        if($this->footer==null){
            if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/body/common_footer.tpl'))
                $this->footer = $this->name.'/body/common_footer.tpl';
            else
                $this->footer = $this->base.'/body/common_footer.tpl';
        }
        
        //Ustawianie gółównego menu
        if($this->menu==null){
            if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/body/common_menu.tpl'))
                $this->menu = $this->name.'/body/common_menu.tpl';
            else
                $this->menu = $this->base.'/body/common_menu.tpl';
        }
        
        //Ustawianie gółównego szablonu
        if($this->body==null){
            if(file_exists(SMARTY_CONFIG_DIR.'/'.$this->name.'/body/common_body.tpl'))
                $this->body = $this->name.'/body/common_body.tpl';
            else
                $this->body = $this->base.'/body/common_body.tpl';
        }
        
        $this->tpl->assign('TOP_element', $this->header);//nie używać
        $this->tpl->assign('BOT_element', $this->footer);//nie używać
        $this->tpl->assign('TOP_FILE', $this->header);
        $this->tpl->assign('BOT_FILE', $this->footer);
        $this->tpl->assign('MENU_FILE', $this->menu);
        if(is_array($this->elements))
            foreach($this->elements as $name => $file)
                $this->tpl->assign('ELEMENT_'.$name, $file);
        
        if(!empty($this->template)){
            $this->tpl->assign('template', $this->template);
        }elseif(!empty($this->html_content)){
            $this->tpl->assign('html_content', $this->html_content);
        }else{
            $this->tpl->assign('html_content', 'Nie podałeś ani szablonu ani zawartości HTML!!!');
        }
        $this->tpl->display($this->body);
    }
}

?>