<?php

namespace Model;

use System\Database\AbstractTable;
use System\Admin\AdminModelInterface;

class AdminMainAdminGroups extends AbstractTable implements AdminModelInterface {

    protected $table = 'esculap_int.main_admin_groups';
    protected $fields = array('group_code', 'group_name');

    public function getRecords(array $queryConfig = array()) {
        try {
            $query = "SELECT * FROM {$this->table}";

            $query = $this->prepareWhereQuery($query, $queryConfig);
            $query = $this->prepareQuery($query, $queryConfig);
            $resource = $this->get($query);
            return array($resource, $this->getRecordsCount($queryConfig));
        } catch (\Exception $Exception) {
            return array(array(), 0);
        }
    }

    public function getRecordsCount(array $queryConfig = array()) {
        try {
            $query = "SELECT COUNT(*) as amount FROM {$this->table}";

            $query = $this->prepareWhereQuery($query, $queryConfig);
            $resource = $this->get($query)->current();
            return (int) $resource['amount'];
        } catch (\Exception $Exception) {
            return 0;
        }
    }

    public function getRecord($ID) {
        try {
            return $resource = $this->get("SELECT * FROM {$this->table} WHERE group_code = '{$ID}'")->current();
        } catch (\Exception $Exception) {
            return array();
        }
    }

    public function insertRecord(array $recordData) {
        try {
            $fields = array();
            $values = array();
            foreach ($recordData as $field => $value) {
                if ($value && $value != "''") {
                    $fields[] = $field;
                    $values[] = $value;
                }
            }

            $fields = '(' . implode(',', $fields) . ')';
            $values = '(' . implode(',', $values) . ')';

            $ID = (string) $this->adapter->createStatement("INSERT INTO {$this->table}
                {$fields} VALUES {$values}
                RETURNING group_code")->execute()->current()['group_code'];

            return ($ID && $ID != '') ? $ID : null;
        } catch (\Exception $Exception) {
            return null;
        }
    }

    public function updateRecord($ID, array $recordData) {
        try {
            $fieldsAndValues = array();
            foreach ($recordData as $field => $value) {
                if ($value && $value != "''") {
                    $fieldsAndValues[] = ' ' . $field . '=' . $value . ' ';
                } else {
                    $fieldsAndValues[] = ' ' . $field . '= null ';
                }
            }
            $fieldsAndValues = implode(',', $fieldsAndValues);

            $this->adapter->createStatement("UPDATE {$this->table} SET {$fieldsAndValues} WHERE group_code = '{$ID}'")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function deleteRecord($ID) {
        try {
            $this->adapter->createStatement("DELETE FROM {$this->table} WHERE group_code = '{$ID}'")->execute();
            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    protected function prepareWhereQuery($query, array $queryConfig = array()) {
        if (isset($queryConfig['where']) && count($queryConfig['where']) > 0) {
            $whereQuery = array();
            foreach ($queryConfig['where'] as $where) {
                reset($where);
                $field = trim(key($where));
                $value = trim($where[$field]);
                if (in_array($field, $this->fields)) {
                    switch ($field) {
                        case 'group_code':
                        case 'group_name':
                            $whereQuery[] = " {$field} ILIKE '%{$value}%' ";
                            break;
                    }
                }
            }
            if (!empty($whereQuery)) {
                $query .= ' WHERE ' . implode(' AND ', $whereQuery);
            }
        }

        return $query;
    }

}

?>