<?php

namespace Model;

use System\Database\AbstractTable;
use Zend\Db\Sql\Sql as Sql;
use Zend\Db\Sql\TableIdentifier as TableIdentifier;
use Zend\Db\ResultSet\ResultSet as ResultSet;

class AdminRelGroupUser extends AbstractTable {

    protected $table = 'cms.rel_group_user';
    protected $fields = array('user_id', 'group_id');

    public function getRelatedGroups($userID) {
        $SQL = new Sql($this->adapter);
        $select = $SQL->select(new TableIdentifier(explode('.', $this->table)[1], explode('.', $this->table)[0]));

        $select = $select->where("user_id = {$userID}");
        $select = $SQL->prepareStatementForSqlObject($select);
        $resultSet = new ResultSet;
        $resultSet->initialize($select->execute());

        $groups = array();
        foreach ($resultSet as $result) {
            $groups[] = $result->getArrayCopy();
        }

        return $groups;
    }

    public function getRelatedUsers($groupID) {
        $SQL = new Sql($this->adapter);
        $select = $SQL->select(new TableIdentifier(explode('.', $this->table)[1], explode('.', $this->table)[0]));

        $select = $select->where("group_id = {$groupID}");
        $select = $SQL->prepareStatementForSqlObject($select);
        $resultSet = new ResultSet;
        $resultSet->initialize($select->execute());

        $users = array();
        foreach ($resultSet as $result) {
            $users[] = $result->getArrayCopy();
        }

        return $users;
    }

    public function insertRecord($data) {
        try {
            $SQL = new Sql($this->adapter);
            $insert = $SQL->insert(new TableIdentifier(explode('.', $this->table)[1], explode('.', $this->table)[0]));

            $insert->columns(array('group_id', 'user_id'))->values(array(
                'group_id' => $data['group_id'],
                'user_id' => $data['user_id']
            ));

            $insert = $SQL->prepareStatementForSqlObject($insert);
            if (!$insert->execute()) {
                return false;
            }

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function deleteRecord($data) {
        try {
            $SQL = new Sql($this->adapter);
            $delete = $SQL->delete(new TableIdentifier(explode('.', $this->table)[1], explode('.', $this->table)[0]));

            $where = new \Zend\Db\Sql\Where();
            $where->equalTo('group_id', $data['group_id'])->and->equalTo('user_id', $data['user_id']);

            $delete->where($where);

            $delete = $SQL->prepareStatementForSqlObject($delete);
            if (!$delete->execute()) {
                return false;
            }

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

}

?>
