<?php

namespace Model;

use System\Database\AbstractTable;

class DictBcElementPlace extends AbstractTable
{
    protected $table = 'dict_bc_element_place';

    /**
     * @param integer|null $elementTypeId
     * @throws \Exception
     * @return array
     */
    public function getAll($elementTypeId = null)
    {
        try {
            $where = '';
            if (null !== $elementTypeId) {
                $elementTypeId = (int)$elementTypeId;
                $where = " WHERE ( {$elementTypeId} = ANY ( available_for_elements ) ) ";
            }

            if ($where == '') {
                $where = ' WHERE site.active = true ';
            } else {
                $where .= ' AND site.active = true ';
            }

            $res = $this->get("SELECT place.* FROM {$this->table()} AS place INNER JOIN {$this->table('main_site')} AS site ON (place.main_site_id = site.id) {$where}");

            return $res;
        } catch (\Exception $exception) {
            throw new \Exception(__METHOD__ . '. ' . $exception->getMessage());
        }
    }

    public function getPlaceData($placeId)
    {
        try {
            $placeId = (int)$placeId;
            $res = $this->get("SELECT * FROM {$this->table()} WHERE id = {$placeId}");

            return $this->translate($res);
        } catch (\Exception $exception) {
            throw new \Exception(__METHOD__ . '. ' . $exception->getMessage());
        }
    }

    public function isPlaceAvailabelFormElement($dictBcElementPlaceId, $dictBcElementTypeId)
    {
        try {
            $res = $this->get("SELECT * FROM {$this->table()} WHERE id = {$dictBcElementPlaceId} AND ( {$dictBcElementTypeId} = ANY ( available_for_elements ) )");

            if (0 < $res->count()) {
                return true;
            }

            return false;
        } catch (\Exception $exception) {
            throw new \Exception(__METHOD__ . '. ' . $exception->getMessage());
        }
    }
}
