<?php
namespace Model;

class DictBcElementSet extends \System\Database\AbstractTable {

    protected $table = 'dict_bc_element_set';

    public function getSetsDescriptions() {

        try {

            $res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()}
			")->execute();

            if (!$res->count()) return array();

            $result = array();

            foreach ($res as $row) {

                $result[$row['name']] = json_decode($row['description'], true);
            }

            return $result;
        } catch (\Exception $e) {

            throw new \Exception(__METHOD__ . ' ' . $e->getMEssage());
        }
    }

    public function addOccurrencesForEverySet($placeId, $maxOccurrences) {
        $res = $this->adapter->createStatement("SELECT * FROM {$this->table()}")->execute();
        if (!$res->count()) return false;

        foreach ($res as $row) {
            if ($row['description'] && $row['description'] != '{}') {
                $description = rtrim($row['description'], '}') . ',"' . $placeId . '":' . $maxOccurrences . '}';
            } else {
                $description = '{' . trim($row['description'], '{}') . '"' . $placeId . '":' . $maxOccurrences . '}';
            }

            $res = $this->adapter->createStatement("UPDATE {$this->table()} SET description = '{$description}' WHERE id = {$row['id']}")->execute();

            if ($res->getAffectedRows() == 0) {
                return false;
            }
        }
    }
    
    public function removeOccurrencesForEverySet($placeId) {
        $res = $this->adapter->createStatement("SELECT * FROM {$this->table()}")->execute();
        if (!$res->count()) return false;

        foreach ($res as $row) {
            if ($row['description'] && $row['description'] != '{}') {
                $description = trim($row['description'], '{}');
                $description = explode(',', $description);
                
                foreach ($description as $key => $descriptionSegment) {
                    $descriptionSegment = trim(explode(':', $descriptionSegment)[0], '"');
                    if ($descriptionSegment == $placeId) {
                        unset($description[$key]);
                        break;
                    }
                }
            }
            
            $description = '{' . implode(',', $description) . '}';
            $res = $this->adapter->createStatement("UPDATE {$this->table()} SET description = '{$description}' WHERE id = {$row['id']}")->execute();

            if ($res->getAffectedRows() == 0) {
                return false;
            }
        }
    }
    
    public function getOccurrencesForPlace($placeId) {
        $res = $this->adapter->createStatement("SELECT * FROM {$this->table()}")->execute();
        if (!$res->count()) return false;

        foreach ($res as $row) {
            if ($row['description'] && $row['description'] != '{}') {
                $description = trim($row['description'], '{}');
                $description = explode(',', $description);
                
                $occurrences = 0;
                foreach ($description as $key => $descriptionSegment) {
                    if (trim(explode(':', $descriptionSegment)[0], '"') == $placeId) {
                        $occurrences = trim(explode(':', $descriptionSegment)[1], '"');
                        break;
                    }
                }
            }
            
            return $occurrences;
        }
    }

}

?>