<?php

namespace Model;
use System\Database\AbstractTable;

class DictCountries extends AbstractTable {
	protected $table = 'dict_countries';

	/**
	 * Pobiera nazwy krajów w podanym języku i pasujące do podanego opcionalnie wzoru
	 * @param string $lang jeden z trzech dostępnych skrówów języków pl,en,ru
	 * @param string $pattern wzór do porównania nazwy 
	 * @returns array lista par nazwa międzynarodowa( skrót ) oraz nazwa w podanym języku
	 */
	public function getCountryies( $lang , $pattern = null ) {
		
		try {
			
			$lang = strtolower( $lang );
			if( !in_array( $lang , array( 'pl' , 'en' , 'ru' ) ) ) {
				$lang = 'en';
			}
			
			$res = $this->adapter->createStatement("
				SELECT country_code , country_name_{$lang} FROM {$this->table} " . ( strlen( $pattern ) ?  " country_name_{$lang} like =\"%{$pattern}%\"" : '' ) . "
			")->execute();
			
			$result = array();
			
			foreach( $res as $row ) {
				$result[ $row[ 'country_code' ] ] = $row[ "country_name_{$lang}" ]; 
			}
			
			return $result;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". Neiudana próba pobrania nazw krajów dla danych: $lang=\"{$lang}\" i pattern=\"{$pattern}\" " );
		}
	}
}

?>