<?php
namespace Model\Entity;

use Model\Entity\MainSite;

class BannerPlace {

    protected $id;
    protected $name;
    protected $describe;
    protected $image;
    protected $preview;
    protected $region;
    protected $maxCollisions;
    protected $maxOccurrences;
    protected $availableForElements;
    protected $mainSiteId;
    protected $mainSite;

    public function setId($id) {
        $this->id = (int)$id;
        return $this;
    }

    public function getId() {
        return (int)$this->id;
    }

    public function setName($name) {
        $this->name = (string)$name;
        return $this;
    }

    public function getName() {
        return (string)$this->name;
    }

    public function setDescribe($describe) {
        $this->describe = (string)$describe;
        return $this;
    }

    public function getDescribe() {
        return (string)$this->describe;
    }

    public function setImage($image) {
        $this->image = (string)$image;
        return $this;
    }

    public function getImage() {
        return (string)$this->image;
    }

    public function setPreview($preview) {
        if (is_array($preview)) {
            $this->preview = $preview;
        } else {
            $this->preview = (string)$preview;
        }
        return $this;
    }

    public function getPreview() {
        if (is_array($this->preview)) {
            return $this->preview;
        } else {
            return (string)$this->preview;
        }
    }

    public function setRegion($region) {
        $this->region = (string)$region;
        return $this;
    }

    public function getRegion() {
        return (string)$this->region;
    }

    public function setMaxCollisions($maxCollisions) {
        $this->maxCollisions = (int)$maxCollisions;
        return $this;
    }

    public function getMaxCollisions() {
        return (int)$this->maxCollisions;
    }

    public function setAvailableForElements($availableForElements) {
        if (!is_array($availableForElements)) {
            $availableForElements = trim($availableForElements, '{}');
            $availableForElements = explode(',', $availableForElements);
        }

        $this->availableForElements = $availableForElements;
        return $this;
    }

    public function getAvailableForElements() {
        return $this->availableForElements;
    }

    public function setMainSiteId($mainSiteId) {
        $this->mainSiteId = (int)$mainSiteId;
        return $this;
    }

    public function getMainSiteId() {
        return (int)$this->mainSiteId;
    }

    public function setMainSite(MainSite $mainSite) {
        $this->mainSite = $mainSite;
        return $this;
    }

    public function getMainSite() {
        return $this->mainSite;
    }

    public function setMaxOccurrences($maxOccurrences) {
        $this->maxOccurrences = (int)$maxOccurrences;
        return $this;
    }

    public function getMaxOccurrences() {
        return (int)$this->maxOccurrences;
    }

}
