<?php
namespace Model\Entity;

class MainSite {

    protected $id = null;
    protected $name = null;
    protected $url = null;
    protected $active = null;
    protected $layout = null;
    protected $public = null;

    public function setId($id) {
        if ($id == null) {
            $this->id = null;
        } else {
            $this->id = (int)$id;
        }
        return $this;
    }

    public function getId() {
        if ($this->id == null) {
            return null;
        } else {
            return (int)$this->id;
        }
    }

    public function setName($name) {
        if ($name == null) {
            $this->name = null;
        } else {
            $this->name = (string)$name;
        }
        return $this;
    }

    public function getName() {
        if ($this->name == null) {
            return null;
        } else {
            return (string)$this->name;
        }
    }

    public function setUrl($url) {
        if ($url == null) {
            $this->url = null;
        } else {
            $this->url = (string)$url;
        }
        return $this;
    }

    public function getUrl() {
        if ($this->url == null) {
            return null;
        } else {
            return (string)$this->url;
        }
    }

    public function getUrlForViewHelper() {
        if (!$this->getPublic() || $this->url == null) {
            return '';
        } else {
            return (string)$this->url;
        }
    }

    public function setActive($active) {
        $this->active = (bool)$active;
        return $this;
    }

    public function getActive() {
        return (bool)$this->active;
    }

    public function setLayout($layout) {
        if ($layout == null) {
            $this->layout = null;
        } else {
            $this->layout = (string)$layout;
        }
        return $this;
    }

    public function getLayout() {
        if ($this->layout == null) {
            return null;
        } else {
            return (string)$this->layout;
        }
    }

    public function setPublic($public) {
        if ($public == null) {
            $this->public = null;
        } else {
            $this->public = (boolean) $public;
        }
        return $this;
    }

    public function getPublic() {
        if ($this->public == null) {
            return null;
        } else {
            return (boolean) $this->public;
        }
    }

}
