<?php

namespace Model;
use System\Database\AbstractTable,
	System\File\NameGeneratorInterface;

class Ffu2s extends AbstractTable implements NameGeneratorInterface {
	protected $table = 'ffu2s';
	
	public function generateName() {
		
		$charSet = array( 'A' ,  'B' ,  'C' ,  'D' ,  'E' ,  'F' ,  'G' ,  'H' ,  'I' ,  'J' ,  'K' ,  'L' ,  'M' ,  'N' ,  'O' ,  'P' ,  'R' , 
						  'S' ,  'T' ,  'U' ,  'W' ,  'X' ,  'Y' ,  'Z' ,  0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 );
						
		try {
			$count = 0;
			do {
				if( $count++ > 100 ) throw new \Exception( "przekroczono limit prób utworzenia kodu: \"{$count}\"" ); 
				
				$code = '';
				
				for( $i = 0 ; $i < 12 ; $i++ ) {
					
					$code .= $charSet[ rand( 0 , count( $charSet ) -1 ) ];
				}
				
			} while( !$this->isUnique( $code ) );
			
			return $code;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. Neiudało się wygenerować nazwy dla nowego pliku' );
		}
		
	}
	
	public function isUnique( $code ) { 
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * from {$this->table()} WHERE code = '{$code}'
			")->execute();
			
			
			if( $res->count() == 1 )
				return false;
			return true;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. nieudało sie sprawdzić czy wartość jest unikatowa' )  ;
		}
	}
	
	
	public function addRow( $code , $name , $type , $size , $addBy , $path ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} ( code , name , type , size , add_by , add_date , path ) VALUES 
										   ( '{$code}' , '{$name}' , '{$type}' , '{$size}' , {$addBy} , now() , '{$path}' )
			")->execute();
			
			
			if( $res->getAffectedRows() == 1 ) {
				
				$res = $this->adapter->createStatement("
					SELECT max( id ) FROM {$this->table}
				")->execute();
				
				$res = $res->current();
				return $res[ 'max' ];
			}
			
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. nieudana próba dodania wpisu' );
		}
	}
	
	
	public function getAllFromCategory( $type ) {
		
		try {
		
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} WHERE type = '{$type}'	ORDER BY name ASC
			")->execute();
			
			if( 1 > $res->count() ) return array();
			
			$result = array();
			
			foreach( $res as $row ) {
				
				$result[] = $row;
			}
			
			return $result;
			
		} catch( \Exception $e ) {
			throw new \Exception( __METHOD__ . '. Nieudana próba pobrania obrazków dla kategorii' );
		}
	}
	
	
	public function getFile( $code ) {
		
		try {
		
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} WHERE code = '{$code}'
			")->execute();
			
			
			if( 1 !== $res->count() ) return array();
			return $res->current();
			
			
		} catch( \Exception $e ) {
			throw new \Exception( __METHOD__ . '. Nieudana próba pobrania obrazka' );
		}
	}
	
	
	public function incrementDownloads( $code ) {
	
		try {
			
			$res = $this->adapter->createStatement("
				UPDATE {$this->table()} set downloads = downloads + 1 WHERE code = '{$code}'
			")->execute();
			
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
			
			
		} catch( \Exception $e ) {
				
			throw new \Exceptin( __METHOD__ . ". Nieudana próba inkrementacji licznika pobrań dla kodu \"{$code}\". " . $e->getMessage() );
		}
	}	
}	
	
?>