<?php
namespace Model\HydratingResultSet;

use Zend\Db\ResultSet\HydratingResultSet;
use Zend\Stdlib\Hydrator\ClassMethods;
use Model\Entity\MainSiteCustomPage as MainSiteCustomPageEntity;
use Model\Entity\MainSite as MainSiteEntity;
use Model\TableGateway\MainSiteCustomPage as MainSiteCustomPageTableGateway;
use Model\TableGateway\MainSite as MainSiteTableGateway;

class MainSiteCustomPage extends HydratingResultSet {

    protected $mainSiteCustomPageHydrator = null;
    protected $mainSiteHydrator = null;
    protected $mainSiteCustomPagePrototype = null;
    protected $mainSitePrototype = null;

    public function __construct() {
        $this->mainSiteCustomPageHydrator = new ClassMethods();
        $this->mainSiteHydrator = new ClassMethods();

        $this->mainSiteCustomPagePrototype = new MainSiteCustomPageEntity();
        $this->mainSitePrototype = new MainSiteEntity();
    }

    public function getMainSiteCustomPageHydrator() {
        return $this->mainSiteCustomPageHydrator;
    }

    public function getMainSiteHydrator() {
        return $this->mainSiteHydrator;
    }

    public function current() {
        if ($this->buffer === null) {
            $this->buffer = -2;
        } elseif (is_array($this->buffer) && isset($this->buffer[$this->position])) {
            return $this->buffer[$this->position];
        }

        $data = $this->dataSource->current();

        $mainSiteCustomPageData = array();
        $mainSiteData = array();

        foreach ($data as $dataColumn => $dataValue) {
            if (substr($dataColumn, 0, strlen(MainSiteTableGateway::getAlias()) + 1) == MainSiteTableGateway::getAlias() . '.') {
                unset($data[$dataColumn]);
                $mainSiteData[str_replace(MainSiteTableGateway::getAlias() . '.', '', $dataColumn)] = $dataValue;
            }
        }
        $mainSiteCustomPageData = $data;

        if (!empty($mainSiteCustomPageData)) {
            $mainSiteCustomTypeEntity = $this->getMainSiteCustomPageHydrator()->hydrate($mainSiteCustomPageData, clone $this->mainSiteCustomPagePrototype);
        } else {
            $mainSiteCustomTypeEntity = null;
        }
        if (!empty($mainSiteData)) {
            $mainSiteEntity = $this->getMainSiteHydrator()->hydrate($mainSiteData, clone $this->mainSitePrototype);
        } else {
            $mainSiteEntity = null;
        }

        if ($mainSiteCustomTypeEntity != null) {
            if ($mainSiteEntity != null) {
                $mainSiteCustomTypeEntity->setMainSite($mainSiteEntity);
            }
        }

        if (is_array($this->buffer)) {
            $this->buffer[$this->position] = $mainSiteCustomTypeEntity;
        }

        return $mainSiteCustomTypeEntity;
    }

    public function toArray() {
        $return = array();
        foreach ($this as $row) {
            $return[] = array_merge(
                    $this->getMainSiteCustomPageHydrator()->extract($row), $this->getMainSiteHydrator()->extract($row)
            );
        }
        return $return;
    }

}
