<?php
namespace System\View;

use System\Translator;

class LayoutCreator {

    protected static $_data;
    protected static $_prepeared = false;

    protected function __construct() {

    }

    protected static $_module = '';
    protected static $_action = '';

    public static function getModule() {
        return self::$_module;
    }

    public static function getAction() {
        return self::$_action;
    }

    protected static $urlHelper = null;

    public static function setUrlHelper($urlHelper) {
        self::$urlHelper = $urlHelper;
    }

    public static function prepearMenu($acl, $user) {
        $translator = Translator\TranslatorEx::get();

        // nazwa modułu => akcja
        // akcja => url,nazwa wyświetlana

        $base = array(
            'emailing' => array(
                'name' => 'Emailing',
                'url' => '/new/emailing/',
                'items' => array(
                    'emailing-list' => array('url' => '/new/emailing/list/', 'name' => 'Bieżące emailingi'),
                    'emailing-list' => array('url' => '/new/emailing/list/arc,true/', 'name' => 'Archiwalne emailingi'),
                    'emailing-set' => array('url' => '/new/emailing/set/', 'name' => 'Dodaj emailing'),
                    'emailing-sender' => array('url' => '/new/emailing/sender/', 'name' => 'Aktywne wysyłki'),
                    'emailing-stats' => array('url' => '/new/emailing/stats/', 'name' => 'Statystyki')
                )
            ),
            'messenger' => array(
                'name' => 'Goniec',
                'url' => '/cms_v3/messenger/',
                'items' => array(
                    'messenger-list' => array('url' => '/cms_v3/messenger_list', 'name' => 'Lista gońców'),
                    'messenger-template' => array('url' => '/cms_v3/messenger_template', 'name' => 'Szablony')
                )
            ),
            'banner' => array(
                'name' => $translator->translate('main_banners'),
                'url' => '/cms_v3/banne_campaign',
                'items' => array(
                    'banner' => array('url' => '/cms_v3/banne_campaign', 'name' => $translator->translate('main_banners_list')),
                    'banner-campaign' => array('url' => '/cms_v3/banner_campaign_add', 'name' => $translator->translate('main_banners_add_campaign')),
                    'banner-campaign_availability' => array('url' => '/cms_v3/banner_campaign_check_availability', 'name' => $translator->translate('main_banners_availability_check')),
                    'banner-bannerPlace' => array('url' => self::$urlHelper->fromRoute('bannerPlace'), 'name' => $translator->translate('bannerPlace')),

                /* 'banner-banner' => array('url' => '/new/banner/banner/', 'name' => 'Banery'),

                  'banner-holder' => array('url' => '/new/banner/holder/', 'name' => 'Holdery'),
                  'banner-stats' => array('url' => '/new/banner/stats/', 'name' => 'Statystyki') */
                )
            ),
            'content,content_news,content_publ,content_event,content_section,content_misc,content_quiz' => array(
                'name' => $translator->translate('main_contents'),
                'url' => '/cms_v3/content/',
                'items' => array(
                    'content_quiz' => array('url' => '/cms_v3/content_quiz', 'name' => $translator->translate('main_quiz')),//, 'new' => 1),
                    'content_news' => array('url' => '/cms_v3/content_news', 'name' => $translator->translate('main_news')),
                    'content_publ' => array('url' => '/cms_v3/content_publ', 'name' => $translator->translate('main_publications')),
                    'content_event' => array('url' => '/cms_v3/content_event', 'name' => $translator->translate('main_event')),
                    'content-video' => array('url' => '/cms_v3/content_video', 'name' => $translator->translate('main_videos'),),
                    'content-journal' => array('url' => self::$urlHelper->fromRoute('content_journal'), 'name' => $translator->translate('journals')),
                    'content-phrase' => array('url' => '/new/content/phrase/', 'name' => 'Lokalizacja'),
                    'content-phrase' => array('url' => '/cms_v3/phrase', 'name' => $translator->translate('main_localizations')),
                    'content-albums' => array('url' => '/new/content/albums/', 'name' => 'Albumy'),
                    'content_misc' => array('url' => '/cms_v3/content_misc', 'name' => $translator->translate('main_misc')),
                    'content-file' => array('url' => '/cms_v3/file', 'name' => $translator->translate('main_files')),
                    'content-file_avatar' => array('url' => '/cms_v3/file_avatar', 'name' => $translator->translate('main_avatars')),
                /* 'content_news' => array('url' => '/new/content_news/', 'name' => 'Aktualności (news)'), */


                /* 'content_publ' => array('url' => '/cms_v3/content_publ/', 'name' => $this->translator->translate( '' ) ), */

                /* 'content_event' => array('url' => '/new/content_event/', 'name' => $this->translator->translate( '' ) ),
                  'content_section' => array('url' => '/new/content_section/', 'name' => 'Sekcje'), */


                //'content-calendar' => array('url' => '/new/content/calendar/', 'name' => 'Kalendarz - po godzinach'),
                )
            ),
            'user' => array(
                'name' => 'Użytkownik',
                'url' => '/new/user/',
                'items' => array(
                    'user-list' => array('url' => '/new/user/list/', 'name' => 'Lista i wyszukiwanie'),
                    'user-calc' => array('url' => '/new/user/calc/', 'name' => 'Agregacja')
                )
            ),
            'sync' => array(
                'name' => 'Sync DB',
                'url' => '/new/sync/',
                'items' => array(
                    'sync-import' => array('url' => '/new/sync/import/', 'name' => 'Import użytkowników'),
                    'sync-export' => array('url' => '/new/sync/export/', 'name' => 'Eksport użytkowników'),
                )
            ),
            /* 'toolbox' => array(
              'name' => 'Narzędzia',
              'url' => '/new/toolbox/',
              'items' => array(
              'toolbox-extkey' => array('url' => '/new/toolbox/extkey/', 'name' => 'Klucze zewnetrzne'),
              'toolbox-ccl' => array('url' => '/new/toolbox/ccl/', 'name' => 'Kliknięć zliczanie'),
              'toolbox-clients' => array('url' => '/new/toolbox/clients/', 'name' => 'Klienci projektowi'),
              'toolbox-ffu2s' => array('url' => '/name/toolbox/ffu2s/', 'name' => 'Pliki internetowe'),
              )
              ), */
            'admin' => array(
                'name' => 'Administracja',
                'url' => '/cms_v3/admin',
                'items' => array(
                    'admin-mainSite' => array('url' => self::$urlHelper->fromRoute('mainSite'), 'name' => $translator->translate('mainSite')),
                    'admin-action' => array('url' => '/cms_v3/admin/action', 'name' => 'Lista akcji'),
                    'admin-user' => array('url' => '/cms_v3/admin/user', 'name' => 'Użytkownicy CMS'),
                    'admin-group' => array('url' => '/cms_v3/admin/group', 'name' => 'Grupy CMS'),
                    'admin-lgroup' => array('url' => '/cms_v3/admin/lgroup', 'name' => 'Grupy językowe CMS'),
                    'admin-agroup' => array('url' => '/cms_v3/admin/agroup', 'name' => 'Grupy esculap'),
                    'admin-avatarTypeDictionary' => array('url' => self::$urlHelper->fromRoute('avatarTypeDictionary'), 'name' => $translator->translate('avatarTypeDictionary')),
                )
            ),
            /* 'changelog' => array(
              'name' => 'Dziennik zmian',
              'url' => '/new/changelog/',
              'items' => array(
              'changelog-index' => array('url' => '/new.changelog/', 'name' => 'Lista zmian'),
              'changelog-add' => array('url' => '/new/changelog/add/', 'name' => 'Dodaj zmianę')
              )
              ), */
            'users_mapping' => array(
                'name' => $translator->translate('main_ok_mapping'),
                'url' => '/cms_v3/users_mapping',
                'items' => array(
                    'users_mapping-new_rejestractions' => array('url' => '/cms_v3/nowe_rejestracje', 'name' => $translator->translate('main_onekey_new_registrations')),
                    'users_mapping-changed_data' => array('url' => '/cms_v3/zmienione_dane', 'name' => $translator->translate('main_onekey_changed_data')),
                    'users_mapping-view_all' => array('url' => '/cms_v3/podglad_wszystkich_uzytkownikow', 'name' => $translator->translate('main_onekey_all_users'))
                )
            ),
            /* Wyżej jest poprzedni toolbox (namespace /new/)
             * To jest nowy toolbox (namespace /cms_v3/) i nie ma związku z poprzednim */
            'toolbox' => array(
                'name' => $translator->translate('toolbox'),
                'url' => self::$urlHelper->fromRoute('toolbox'),
                'items' => array(
                    'tool-statistics' => array('url' => self::$urlHelper->fromRoute('toolStatistics'), 'name' => $translator->translate('toolStatistics')),

                    'tool-generator' => array('url' => '/cms_v3/generator/', 'name' => $translator->translate('generator')),
                    'content-peephole' => array('url' => '/cms_v3/peephole', 'name' => $translator->translate('main_peephole')),
                )
            ),
        );

        $availableModules = array();
        $index = 0;

        $url = explode('/cms_v3/', $_SERVER['REQUEST_URI']);
        $url = @$url[1];

        foreach ($base as $module => $actions) {
            $alloweed = false;

            if (strpos($module, ',')) {

                foreach (explode(',', $module) as $_module) {

                    if (!$acl->isAllowed($user, $_module)) continue;
                    $alloweed = true;
                    break;
                }
            } else {
                if ($acl->isAllowed($user, $module)) {

                    $alloweed = true;
                }
            }

            if (!$alloweed) continue;
            $index++;


            $availableModules[$index] = $actions;

            // sprawdzam czy obecnie oglądany url jest obecnie porzetwarzany w przypadku gdy kliknięty został element głównego menu
            if ($actions['url'] == $url || preg_match('/' . preg_replace('/\//', '\/', $actions['url']) . '/', '/cms_v3/' . $url)) {
                // zaznaczam element menu jako aktywny
                $availableModules[$index]['selected'] = 1;
                // nadanie nagłówka
                self::$_module = $availableModules[$index]['name'];
            }

            $availableModules[$index]['items'] = array();

            foreach ($actions['items'] as $controller => $item) {

                // sprawdzam czy obecnie oglądany url jest obecnie porzetwarzany w przypadku gdy klinkniety został element menu dolnego
                if ($acl->isAllowed($user, $controller)) {

                    if ((substr($url, 0, 11) == 'file_avatar' && $item['url'] != '/cms_v3/file') || substr($url, 0, 11) != 'file_avatar') { // poprawka na szybko
                        if (($item['url'] == $url || preg_match('/' . preg_replace('/\//', '\/', $item['url']) . '/', '/cms_v3/' . $url)) ||
                            ($item['url'] == '/cms_v3/tool_statistics/' && substr($url, 0, 15) == 'edu_statistics/')) {
                            // zaznaczam element podmenu jako aktywny
                            $item['selected'] = 1;
                            // nadanie nagłówka 2
                            self::$_action = $item['name'];
                            // zaznaczam element menu jako aktywny
                            $availableModules[$index]['selected'] = 1;
                            // nadanie nagłówka
                            self::$_module = $availableModules[$index]['name'];
                        }
                    }
                    if ($item['url'] == '/cms_v3/admin/main_site/' && substr($url, 0, 28) == 'admin/main_site_user_access/' ||
                        $item['url'] == '/cms_v3/admin/main_site/' && substr($url, 0, 28) == 'admin/main_site_custom_page/' ||
                        $item['url'] == '/cms_v3/admin/main_site/' && substr($url, 0, 34) == 'admin/main_site_insomnia_question/' ||
                        $item['url'] == '/cms_v3/admin/main_site/' && substr($url, 0, 29) == 'admin/main_site_content_page/') {
                        // zaznaczam element podmenu jako aktywny
                        $item['selected'] = 1;
                        // nadanie nagłówka 2
                        self::$_action = $item['name'];
                        // zaznaczam element menu jako aktywny
                        $availableModules[$index]['selected'] = 1;
                        // nadanie nagłówka
                        self::$_module = $availableModules[$index]['name'];
                    }

                    $availableModules[$index]['items'][$controller] = $item;
                }
            }
        }

        self::$_prepeared = true;
        self::$_data = $availableModules;
    }

    public static function getMenu() {
        //if(!self::$_prepeared) throw new \Exception('Obiekt kreatora menu nie został przygotowany'); 
        return self::$_data;
    }

}

?>