<?php

namespace Model;
use \Zend\Db\Adapter\Exception\InvalidQueryException;
use \Zend\Db\Sql\Where;

class MainAuthCode extends \System\Database\AbstractTable {

	protected $table = 'main_auth_code';
	
	public function isCodeExists($userLogin) {
		
		$userLogin = (string)$userLogin;
		
		try {
			
			$where = new Where();
			$res = $this->fetchRow(array('user_login' => $userLogin,$where->greaterThan('terminate','NOW()')));
			
			if(!$res)
				return 0;
			return $res['auth_code'];
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	public function removeCode($authCode) {
		$authCode = (string)$authCode;
		
		try {
			
			$res = $this->delete(array('auth_code' => $authCode));
			
			if(!$res)
				return 0;
			return 1;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	public function refresh($authCode,$minutes) {
		
		try {
			
			$res = $this->update(array('terminate' => $this->getInterval($minutes)),array('auth_code' => $authCode));
			if( $res )
				return 1;
			return 0;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	protected function getInterval($interval) {
		$adapter = $this->adapter;
		$statement = $adapter->createStatement("SELECT NOW() + INTERVAL '$interval MINUTES'");
		$result = $statement->execute();
		
		foreach($result as $k => $v) {
			
			return reset($v);
		}
	}
	
	public function isAuthCodeExists($authCode) {
		
		try {
			
			$res = $this->fetchRow(array('auth_code' => $authCode));
			
			if(!$res)
				return 0;
			return 1;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	public function getUserLogin($authCode) {
		
		try {
			
			$res = $this->query( "SELECT * FROM {$this->table} WHERE auth_code = '{$authCode}'" );
			
			if( !$res->count() ) 
				return 0;
			
			$res = $res->current();
			
			return $res[ 'login' ];
		
		} catch(InvalidQueryException $e) {
			return -1;
		}	
	}
	
	
	public function gc() {
		
		try {
			$Where = new Where();
			$res = $this->remove(array($Where->lessThan('terminate','NOW()')));
			
			if($res > 0)
				return true;
			return false;
			
		} catch(InvalidQueryException $e) {
			
			try {
				
				$this->gcEx();
			
			} catch( \Exception $e ) {
				
				return -1;
			}
		}
	}
	
	
	
	/************************ Nowe struktura ***********************/
	public function getUserId( $authCode ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT user_id FROM {$this->table} WHERE auth_code = '{$authCode}'
			")->execute();
			
			if( !$res->count() )
				return false;
			
			
			
			$res = $res->current();
			return $res[ 'user_id' ];
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function gcEx() {
		
		try {
			$Where = new Where();
			$res = $this->adapter->createStatement("
				DELETE FROM {$this->table} WHERE terminate < NOW();
			")->execute();
			
			if( $res->getAffectedRows() )
				return true;
			return false;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	
	public function isCodeExistsForUserEx( $userId ) {
		
		$this->gcEx();
		
		try {
			
			$res = $this->adapter->createStatement( "
				SELECT * FROM {$this->table} WHERE user_id = {$userId}
			" )->execute();
			
			if( !$res->count() ) 
				return false;
			
			$res = $res->current();
			return $res[ 'auth_code' ];
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function getNewAuthCodeEx( $userId , $userSystem , $userProxy , $userIp ) {
		
		try {
			
			$c = $this->generateCode();
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table} ( 
				
					auth_code,
					user_id,
					user_system,
					user_proxy,
					user_ip
				
				) VALUES (
				
					'{$c}',
					{$userId},
					'{$userSystem}',
					'{$userProxy}',
					'{$userIp}'
				);
			")->execute();
			
			
			if( 1 == $res->getAffectedRows() ) 
				return $c;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function generateCode($l = 12) {
		$l--;
        if($l<5) $l=5;
        if($l>20) $l=20;
        
        $code = null;
	    while(strlen($code)<$l) $code .= chr(($z=rand(55,90))>64?$z:$z-7);
        
		$codeCheck = $this->adapter->createStatement("
			SELECT * FROM {$this->table} WHERE auth_code = '{$code}';
		")->execute();
		
		
	    if( $codeCheck->count() ) {
			return $this->generateCode($l);
		}
		
		return $code . 'A';
    }
	
	
	public function refreshEx( $authCode , $minutes ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				UPDATE {$this->table} SET terminate = '{$this->getInterval( $minutes )}' WHERE auth_code = '{$authCode}'
			")->execute();
			
			if( 1 == $res->getAffectedRows() )
				return 1;
			return 0;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
}


?>