<?php

namespace Model;
use \Zend\Db\Adapter\Exception\InvalidQueryException;

class MainAuthSite extends \System\Database\AbstractTable {
	
	protected $table = 'main_auth_site';
	
	
	public function get( $sitecode ) {
		
		try {
			
			$res = $this->fetchRow( array( 'site_code' => $sitecode ) );
			
			if( count( $res ) > 0 )
				return $res;
			return false;
			
		} catch( \Exception $e ) {
			
			new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}	
	}
	
	public function getAll() {
		
		$queryRes = $this->adapter->createStatement( "select * from {$this->table}" )->execute();
		$result = array();
		
		foreach($queryRes as $row) {
			$result[] = array(
				'siteCode' => $row['site_code'],
				'backData' => $row['back_data'],
				'soapAuth' => $row['soap_auth'],
				'location' => $row['location'],
				'returnUrl' => $row['return_url'] 
			);
		}
		
		return $result;
	}
	
	/**
	* Sprawdza czy istnieje kod strony dla podanego hosta
	* je�li kod istnieje zwracam go, je�li nie zwracam 0 je�li wyst�pi� wyj�tek zwraca -1
	*
	* @param $host $_SERVER['HTTP_HOST']
	* @return int/string
	*/
	public function isCodeExosts( $host ) {
		$host = (string)$host;
		if(!strlen($host)) {
			return 0;
		}
		
		try {
			
			if(!preg_match('/http:\/\//',$host)) {
					$host = "http://$host";
			}
			
			$res = $this->fetchRow( array( 'location' => $host ) );
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
		
		if(!count($res))
			return 0;
		return $res['site_code'];
	}
	
	public function isSiteCodeExists( $siteCode ) {
		
		try {
			
			$res = $this->adapter->createStatement( "select * from {$this->table} where site_code = '{$siteCode}'" )->execute();
			if( !$res->count() )
				return 0;
			return 1;
			
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
	
	public function isSoapLoginAvailable( $siteCode ) {
		
		try {
		
			$res = $this->adapter->createStatement("
				SELECT soap_auth FROM {$this->table} WHERE site_code = '{$siteCode}'
			")->execute();
			
			if( $res->count() ) {
				$res = $res->current();
				
				return (bool)$res[ 'soap_auth' ];
			}
			
			return false;
			
		} catch( \Exception $e) {
			
			return false;
			
		}
	}
	
	public function getAllowedFieldsList( $sitecode ) {
		$dafeultSetForAllValue = array("onekey_id","first_name","last_name","email","id","login","cegedim_id","work_place_type","region","middle_name","quick_reg","birth_date","correspondence_to","education_year","real_status","need_attention","retired","education_finish","education_place","modification_date","work_country","work_ward_id","work_place_id","country","activated","activation_key","user_type","tel2","addr_apartm","addr_house","work_tel","workcity","work_zip","work_addr_apartm","addr_prefix","work_addr_house","work_addr_str","work_addr_prefix","work_ward_name","work_place_name","work_addr_name","phys_license","sync","start_date_tz","phys_licence","start_date","source","status","date_session","id_session","email_ext","email_esc","tel","zip","id_city","cityname","address","last_name","first_name","specs:INTE:MAIN:ok_spec1:ok_spec2:ok_spec3:ok_tend1:ok_tend2:ok_tend3","services","okc_update_date");
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table} WHERE site_code = '{$sitecode}'
			")->execute();
			
			if( !$res->count() )
				return null;
			$res = $res->current();	
			
			
			if(!strlen($res['back_data'])) return array();
			$res = explode(',',$res['back_data']);
			if(!is_array($res)) $res = array($res);
			
			if('all' == strtolower($res[0])) {
				$res = $dafeultSetForAllValue;
			}
			
			return $res;
			
		} catch( \Exception $e) {
			
			trigger_error( $e->getMessage() );
			return null;
		}
	}
	
	public function getLocationForSiteCode($siteCode) {

		try {
			
			$res = $this->fetchRow(array('site_code' => $siteCode));
			if(!$res)
				return false;
			return $res['location'];
		
		} catch(InvalidQueryException $e) {
			return false;
		}
	}
	
	public function isSoapAllowed($siteCode) {
		
		try {
			
			$res = $this->fetchRow(array('site_code' => $siteCode));
			
			if(!$res)
				return 0;
			return (int)$res['soap_auth'];
		
		} catch(InvalidQueryException $e) {
			return -1;
		}
	}
}

?>
