<?php

namespace Model;
use System\Database\AbstractTableContent;

class MainBannerCampaign extends AbstractTableContent {
	protected $table = 'main_banner_campaign';
	
	public function getCampaigns($specs,$types,$from = null) {
		
		try {
			if($from == null) $from = time();
			
			// przygotowanie listy typów w celu dołączenia tabel
			$campaignsTypes = array(
				'mainBanner' => array('name' => 'main_banner_type_billboard','sc' => 'mbtb'), // baner błówny bilbordem zwany na głównej stronie wyświetlany :D
				'sponsored'  => array('name' => 'main_banner_type_content', 'sc' => 'mbtc'), // content sponsorowany 
				'slider' => array('name' => 'main_banner_type_slider', 'sc' => 'mbts'),
				'rightSide' => array('name' => 'main_banner_type_banner', 'sc' => 'mbtbb')
			);
			
			// przygotowanie specializacji
			if(!is_array($specs) || !count($specs)) {
				throw new \Exception(__METHOD__.". Specializacje muszą być przekazane jako tablica");
			}
			
			$specs = implode(',',$specs);
			$specs = preg_replace('/([a-zA-Z\.0-9]+)/',"'$1'",$specs);
			
			
			$typeSelect = '';
			$typesFrom = '';
			$typesWhere = '';
			
			$result = array();
			
			foreach($types as $type) {
				if(array_key_exists($type,$campaignsTypes)) {
					
					$res = $this->adapter->createStatement("
						SELECT {$campaignsTypes[$type]['sc']}.*,mbtcfg.* FROM {$this->table('main_banner_type_config')} mbtcfg, {$this->table('main_banner_campaign_target')} mbct, {$this->table($campaignsTypes[$type]['name'])} {$campaignsTypes[$type]['sc']}
						WHERE mbct.spec_code in ({$specs}) AND {$campaignsTypes[$type]['sc']}.mbc_id = mbct.mbc_id AND
						     {$campaignsTypes[$type]['sc']}.mbtc_id = mbtcfg.mbtc_id 
							 order by mbtcfg.views ASC
					")->execute();
					
					
					foreach($res as $row) {
						$result[$type][] = $row;
					}
				}
			}
			
			return $result;
			
		} catch(\Exception $e) {
			throw new \Exception(__METHOD__.'. Błąd przy odczycie kampanii. '.$e->getMessage());
		}
	}
	
}


?>