<?php

namespace Model;

use System\Database\AbstractTable;

class MainBcElementView extends AbstractTable {
	protected $table = 'main_bc_element_view';
	
	public function registerView( $bcElementId , $userId , $sitecode , $usercode ) {
		
		try {
			
			$values = '';
			
			if( is_array( $bcElementId ) ) {
				
				foreach( $bcElementId as $elementId ) {
				
					$elementId = (int)$elementId;
				
					if( strlen( $values ) )
						$values .= ',';
						
						
					$values .= " ( {$elementId} , {$userId} , NOW() , '{$usercode}' , '{$sitecode}' ) ";
				}
				
			} else {
				
				$bcElementId = (int)$bcELementId;
				
				$values = " ( {$bcElementId} , {$userId} , NOW() , '{$usercode}' , '{$sitecode}' ) ";
				
			}
			
			//trigger_error( $values );
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} ( main_bc_element_id , main_user_id , time , usercode , sitecode ) values {$values}
			")->execute();
			
			
		} catch( \Excepttion $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}	

	public function loadStatistics( $bcElementId , $date = null ) {
		
		$intervals = array( 'day' , 'month' );
		
		try {
			
			
			$bcElementId = (int)$bcElementId;
			
			if( null == $date ) {
				
				$res = $this->adapter->createStatement("
					SELECT date_part( 'month' , time ) || '/' || date_part( 'day' , time ) || '/' || date_part( 'year' , time ) as date , count( 1 )
					FROM {$this->table()} bv
					WHERE main_bc_element_id = {$bcElementId}
					GROUP BY date
					ORDER BY date ASC
				")->execute();
			
			} else {
				
				$dayStart = strtotime( 'midnight' , $date );
				$dayEnd = strtotime( '23:59:59' , $date );
				
				
				$res = $this->adapter->createStatement("
					SELECT date_part( 'hour' , time ) as hour , count( 1 )
					FROM {$this->table()}
					WHERE extract( epoch from time ) >= {$dayStart} AND extract( epoch from time ) <= {$dayEnd} AND main_bc_element_id = {$bcElementId}
					GROUP BY hour
					ORDER BY hour ASC
				")->execute();
				
			}
			
			
			return $this->fetchAll( $res );
		
		} catch( \Exception $e ) {
			trigger_error( $e->getMessage() );
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
		
}

?>