<?php

namespace Model;

use System\Database\AbstractTable;

class MainBcViewCode extends AbstractTable {
	
	protected $table = 'main_bc_view_code';
	
	protected $rules = array(
		'views_used' => 'used'
	);
	
	public function getCodeSettings( $code , $decrement = false ) {
		
		try {
			
			$res = $this->get("
				SELECT id , lifetime ,  code , array_to_string( elements_set , ',' ) as elements , test , main_bc_id as bc_id FROM {$this->table()} WHERE code = '{$code}' and lifetime > NOW() AND views_used < views
			");

			if( $res->count() ) {
				
				try {
					if( $decrement ) {
						$this->adapter->createStatement("
							UPDATE {$this->table()} SET views_used = views_used + 1 WHERE code = '{$code}'
						")->execute();
					} 
				} catch( \Exception $e ) {}
				
				return $res->current();
				
			}
			
			return false;

			
		} catch( \Exceptoin $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMEssage() );
		}	
	}
	
	
	public function createCode( $mainBcId , $elementsSet , $seconds , $creator , $viewLimit ,  $test = false ) {
		
		try {
			
			$this->gc();
			
			if( !is_array( $elementsSet ) || !count( $elementsSet ) ) {
				
				if( 1 > (int)$elementsSet ) 
					throw new \Exception( '$elementsSet musi bś tablicą!' );
					
				$elementsSet = array( $elementsSet );
			}
			
			$found = false;
			$charset = array( 'a' , 'b' , 'c' , 'd' , 'e' , 'f' , 'g' , 'h' , 'i' , 'j' , 'k' , 'l' , 'm' , 'n' , 'o' , 'p' , 'r' , 's' , 't' , 'u' , 'w' , 'x' , 'y' , 'z' , 
							  'A' , 'B' , 'C' , 'D' , 'E' , 'F' , 'G' , 'H' , 'I' , 'J' , 'K' , 'L' , 'M' , 'N' , 'O' , 'P' , 'R' , 'D' , 'T' , 'U' , 'E' , 'X' , 'Y' , 'Z' ,
							   0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 );
			
			while( false == $found ) {
				
				$code = '';
				for( $i = 0; $i < 15; $i++ ) {
					
					$code .= $charset[ rand( 0 ,count( $charset ) - 1 ) ];
				}
				
				$res = $this->get("
					SELECT * FROM {$this->table()} WHERE code = '{$code}'
				");
				
				if( !$res->count() ) {
					
					$found = true;
				}
			}
			
			$test = (int)$test;
			
			$eSet = '{';
			
			foreach( $elementsSet as $element ) {
				
				if( strlen( $eSet ) > 1 )
					$eSet .= ',';
				
				$eSet .= $element;
			}
			
			$eSet .= '}';

			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} ( code , main_bc_id , elements_set , lifetime , test , main_users_user_id , views ) VALUES ( '{$code}' , {$mainBcId} , '{$eSet}' , ( select cast( to_timestamp( {$seconds} ) as timestamp )), '" . ( $test ? "true" : "false" ) . "' , {$creator} , {$viewLimit} )
			")->execute();
			
			
			if( 1 == $res->getAffectedRows() ) 
				return $code;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
		
	public function getCodesForCampaign( $mainBcId ) {
		
		$this->gc();
		
		try {
			
			$mainBcId = (int)$mainBcId;
			
			$res = $this->get("
				SELECT  id , code , extract( 'epoch' from lifetime ) as lifetime , elements_set , test , main_bc_id , views , views_used FROM {$this->table()} WHERE main_bc_id = {$mainBcId} AND test = false ORDER BY lifetime DESC
			");
			
			return $this->translate( $this->fetchAll( $res ) );
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' .$e->getMessage() );
		}
	}
	
	public function gc() {
		
		try {
			
			$res = $this->adapter->createStatement("
				DELETE FROM {$this->table()} WHERE ( lifetime < NOW() OR views <= views_used ) AND test is true
			")->execute();
			
		} catch( \Exception $e ) {
			
			return false;
		}
	}
}

?>