<?php

namespace Model;
use System\Database\AbstractTableContent;
 
class MainContent extends AbstractTableContent {
	protected $table = 'main_content';
	
	const TYPE_NEWS = 'news';
	const TYPE_EVENT = 'event';
	const TYPE_PUBLICATION = 'publ';
	const TYPE_VIDEO = 'video';
	
	public function getElements($start,$offset,$subQuery = null,$active = 1) {
		$active = (int)$active;
	
		$query = "
			SELECT {$this->table()}.*, {$this->table('main_content')}.type
			FROM {$this->table()}
			WHERE {$this->table()}.content_id = {$this->table('main_content')}.content_id AND
				  
				  " . (null !== $subQuery ? "{$this->table()}.content_id in ( {$subQuery} ) AND" : '' ) . "
				  
			      {$this->table('main_content')}.active = true
			LIMIT {$start} OFFSET {$offset}
		";
		
		$res = $this->adapter->createStatement($query)->execute();
		
		return $res;
	}
	
	public function isContentExists( $contentId ) {
		
		try {
			
			$res = $this->adapter->createStatement("SELECT content_id FROM {$this->table()} WHERE content_id = $contentId")->execute();
			$res = $res->current();
			
			if(isset($res['content_id']))
				return true;
			return false;
			
		} catch(\Exception $e) {
			throw new \Exception($e->getMessage().'. pg_last_error:'.pg_last_error(),1);		
		}
	}	
	
	public function addContent( $langId , $type , $active , $searchable , $tsearch , $search , $avatar , $creator , $visibleInEsculap = false , $contentOfTheDay = false, array $additionalFields = array()) {
		
		try { 
			
			$langId = strtoupper($langId);
			
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} 
				(lang_id,type,active,searchable,tsearch,search,avatar_id,creator , visible_in_esculap , content_of_the_day " . (isset($additionalFields['main_site_id']) ? ', main_site_id' : '') . " )
				VALUES ('{$langId}','{$type}','".((bool)$active == true ? 'true' : 'false' )."','".((bool)$searchable == true ? 'true' : 'false' )."','{$tsearch}','{$search}', " . ( null == $avatar ? 'NULL' : "'{$avatar}'" ) . " ,'{$creator}' , '".( (bool)$visibleInEsculap == true ? 'true' : 'false' )."' , '".( (bool)$contentOfTheDay == true ? 'true' : 'false' )."' ".( isset($additionalFields['main_site_id']) ? ', ' . (int)$additionalFields['main_site_id'] : '' )." )
			")->execute();
			
			$res = $this->adapter->createStatement("SELECT LASTVAL()")->execute();
			$res = $res->current();
			return $res['lastval'];
			
		} catch(\Exception $e) {
			throw new \Exception(__NAMESPACE__.' .'.pg_last_error().'. '.$e->getMessage());
		}
	}
	
	
	public function updateContent( $contentId , $langId , $type , $active , $searchable , $tsearch , $search , $avatar , $modifier , $visibleInEsculap = false , $contentOfTheDay = false, array $additionalFields = array()) {
		
			
		try {	
			$res = $this->adapter->createStatement("
				UPDATE {$this->table()}
				SET lang_id = '{$langId}' , type = '{$type}' , active = '".((bool)$active == true ? 'true' : 'false' )."' , " . (isset($additionalFields['main_site_id']) ? 'main_site_id = ' . $additionalFields['main_site_id'] . ',' : '') . "
					searchable = '".((bool)$searchable == true ? 'true' : 'false' )."' , search = '{$search}' , tsearch = '{$tsearch}' , last_modified_by = '{$modifier}', 
					avatar_id = " . ( null == $avatar ? 'NULL' : "'{$avatar}'" ) . " , visible_in_esculap = '".( (bool)$visibleInEsculap == true ? 'true' : 'false' )."' , 
					content_of_the_day = '".( (bool)$contentOfTheDay == true ? 'true' : 'false' )."'
				WHERE content_id = {$contentId}
			")->execute();
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
			
		
		} catch( \Exception $e ) {
		
			throw new \Exception( __NAMESPACE__ . ". Błąd przy updacie contentu" . $e->getMessage() );
		}
	}
	
	
	public function getLangId( $contentId ) {
		
		try {
			

		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". Neiudana próba pobrania id języka kontentu dla contentId=\"{$contentId}\" ");
		}
	}
	
	
	public function deleteContent( $contentId ) {
		
		try {
			
			$contentId = (int)$contentId;
			
			$res = $this->get("
				DELETE FROM {$this->table()} WHERE content_id = {$contentId}
			");
			
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( "Nieudana próba usunięcia kontentu id=\"{$contentId}\". " . $e->getMessage() );
		}
	}
	
	
	public function searchContent( $query ) {
		
		try {
			
			$id = (int)$query;
			$res = $this->get("
				SELECT * from {$this->table()} WHERE cast( content_id as text ) like '%{$id}%' OR cast( tsearch as text ) like '%{$query}%' ORDER BY content_id desc
			");
			
			$result = array();
			
			foreach( $res as $row ) {
				
				$result[] = $row;
			}
			
			return $result;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". " . $e->getMessage() );
		}
	}
	
	
	public function isContnetExists( $contentId ) {

		try {
			
			$contentId = (int)$contentId;
			
			
			$res = $this->get("
				SELECT * FROM {$this->table()} WHERE content_id = {$contentId}
			");
			
			return (bool)$res->count();
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function getContent( $contentId , $language , $joinExtensionTable = false ) {
		
		try {
			
			$language = strtoupper( $language );
			
			$res = $this->get("
				SELECT * FROM {$this->table()} WHERE
				lang_id = '{$language}' AND 
				content_id = {$contentId}
			");
			
			if( $res->count() !== 1 )
				return false;
			
			if( false === $joinExtensionTable ) {
				
				return $res->current();
			}
			
			$res = $res->current();
			
			$ext = $this->get("
				SELECT * FROM {$this->table( 'main_content_' . $res[ 'type' ] )}
				WHERE content_id = {$contentId} AND lang_id = '{$language}'
			");
			
			return array_merge(
				$res,
				$ext->current()
			);
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
}


?>