<?php

namespace Model;
use System\Database\AbstractTableContent;

class MainContentEvent extends MainContentHelper {
	
	protected $table = 'main_content_event';
	
	public function query($specTypes,$additionalRestrictions = array()) {
			
			
		if(!is_string($specTypes) || !preg_match('/^([,]?\'[A-Za-z0-9\.]+\')+$/',$specTypes)) $specTypes = '';
		
		
		if( isset( $additionalRestrictions['CONTENT_ID'] ) ) {
			
			return (int)$additionalRestrictions['CONTENT_ID'];
			
		} else {
			
			
			$query = "
				SELECT distinct( mce.content_id )
				FROM {$this->table()} mce
				LEFT JOIN {$this->table( 'main_content' )} AS mc ON mc.content_id = mce.content_id and mc.lang_id = mce.lang_id
				LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mce.content_id = rcs.content_id and mce.lang_id = rcs.lang_id
				WHERE mce.content_id > 0
				".( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
				".( strlen( $specTypes ) ? "AND rcs.spec_code in({$specTypes})" : '' )."
				".(isset($additionalRestrictions['CONTENT_ID']) ? " AND mce.content_id = {$additionalRestrictions['CONTENT_ID']}" : '')."
				".(isset($additionalRestrictions['EVENT_TYPE']) ? " AND mce.event_type = '{$additionalRestrictions['EVENT_TYPE']}'" : '')."
				".(isset($additionalRestrictions['EVENT_ORG']) ? " AND mce.org_name ilike '%{$additionalRestrictions['EVENT_ORG']}%'" : '')."
				".(isset($additionalRestrictions['EVENT_TO']) ? " AND mce.date_start < '".date('Y-m-d',$additionalRestrictions['EVENT_TO'])."'" : '')."
			";
			
		}
		
		
		
		return $query;
	}
	
	public function getElements($specTypes,$start,$offset,$additionalRestrictions = array()) {
		
		$query = $this->query($specTypes,$additionalRestrictions);
		
		$res = $this->queryHelper( 
			$start, 
			$offset, 
			$query, 
			$additionalRestrictions,
			null, 
			array( 													
				$this->table( 'ext_content_event' ) => "{$this->table( 'ext_content_event' )}.content_id = {$this->table()}.content_id AND {$this->table( 'ext_content_event' )}.lang_id = {$this->table()}.lang_id" 
			) 
		);
		
                
		return $this->fetchAll($res);
	}
	
	/**
	 * profilowanie treści. Aby sprofilować rezultat trzeba podać jako dodatkowe ograniczenie klucz ORDER_SPECS o wartości array(  match_level => arra( spec1 , spec2 ) )
	 * @param array specsTypes używany kiedyś do prostego profilowania bez sortowania po poziomie zmapowania.
	 * @param int $limit
	 * @param int $offset
	 * @param array $additionalRestrictions 
	 */
	public function getElementsEx( $specTypes , $limit = null , $offset = null , $additionalRestrictions = array() , $count = false ) {
		$order = '';
		// ustalanie priowytetu dla specek
		if( isset( $additionalRestrictions[ 'ORDER_SPECS' ] ) ) {
			$specsStr = '';
			$order = 'match_level ASC, ';
			$other = false;
			$clearCase = true; // szyści case
			$columns = "mc.content_id , min( CASE";
			
			ksort( $additionalRestrictions[ 'ORDER_SPECS' ] );
			
			
			foreach( $additionalRestrictions[ 'ORDER_SPECS' ] as $priority => $specsList ) {
				
				foreach( $specsList as $spec ) {
					$other = true;
					
					$clearCase = false;
					
					$columns .= " WHEN rcs.spec_code = '{$spec}' THEN {$priority}";
					
					if( strlen( $specsStr ) )
						$specsStr .= ',';
						
					$specsStr .= "'{$spec}'";
				}
			}
			
			if( $clearCase ) {
				
				$order = '';
				unset( $specsStr );
				$columns = "mc.content_id";
				
			} else {
				if( $other )
					$columns .= " ELSE 10";
				
				$columns .= " END ) as match_level";
			}
			
		} else {
			
			$columns = 'mc.content_id';
		}
		
		// tu mam listę idków posortowanych jak należy
		if( isset( $additionalRestrictions[ 'SPEC_TYPES' ] ) ) {
			$specs = array();
			foreach( (array)$additionalRestrictions[ 'SPEC_TYPES' ] as $spec ) {
				
				if( !preg_match( '/^[a-zA-Z0-9]{2}$/' , $spec ) )
					continue;
				
				$specs[] = "'{$spec}'";
			}
			
			
			if( !count( $specs ) ) {
				
				unset( $specs );
			} else {
			
				$specs = implode( ',' , $specs );
			}
		}
		
                if (isset($additionalRestrictions['ACTIVE']) && $additionalRestrictions['ACTIVE'] === false) {
                    $additionalRestrictions['ALL'] = true;
                }

        if (isset($additionalRestrictions['EVENT_TO'])) {
            if (!is_array($additionalRestrictions['EVENT_TO'])) {
                $dateCriteria = " AND (
                (mce.date_start < '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01' AND mce.date_end >= '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01')
                OR
                (mce.date_start = '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01')
                OR
                (mce.date_start > '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01' AND mce.date_start <= (date_trunc('MONTH', '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date)
                OR
                (mce.date_start < (date_trunc('MONTH', '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date AND mce.date_end >= '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01')
                OR
                (mce.date_start = (date_trunc('MONTH', '".(date('Y-m', (int)$additionalRestrictions['EVENT_TO']))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date)
                ) ";
            } else {
                $dateCriteria = " AND ( ";

                $i = 0;
                foreach ($additionalRestrictions['EVENT_TO'] as $date) {
                    if ($i > 0) {
                       $dateCriteria .= " OR ";
                    }
                    $dateCriteria .= " (mce.date_start < '".(date('Y-m', (int)$date))."-01' AND mce.date_end >= '".(date('Y-m', (int)$date))."-01')
                    OR
                    (mce.date_start = '".(date('Y-m', (int)$date))."-01')
                    OR
                    (mce.date_start > '".(date('Y-m', (int)$date))."-01' AND mce.date_start <= (date_trunc('MONTH', '".(date('Y-m', (int)$date))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date)
                    OR
                    (mce.date_start < (date_trunc('MONTH', '".(date('Y-m', (int)$date))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date AND mce.date_end >= '".(date('Y-m', (int)$date))."-01')
                    OR
                    (mce.date_start = (date_trunc('MONTH', '".(date('Y-m', (int)$date))."-01'::date) + INTERVAL '1 MONTH - 1 day')::date) ";
                    $i++;
                }

                $dateCriteria .= " ) ";
            }
        }

		$select = "
			SELECT {$columns}
			FROM {$this->table()} mce, {$this->table( 'main_content' )} mc
			LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
			WHERE 
				mc.content_id = mce.content_id AND mc.lang_id = mce.lang_id 
				".( (isset( $additionalRestrictions['ACTIVE']) && $additionalRestrictions['ACTIVE'] === false) ? '' : "AND mce.date_end > '" . date( 'Y-m-d' ) . "' ") . "
				".( (isset( $additionalRestrictions['UPCOMING_EVENTS']) && $additionalRestrictions['UPCOMING_EVENTS'] == true) ? "AND mce.date_start >= '" . date( 'Y-m-d' ) . "' " : '') . "
				".( isset( $additionalRestrictions['CONTENT_OF_THE_DAY'] ) ? ' AND mc.content_of_the_day = true ' : '' )."
				".(!isset( $additionalRestrictions['ALL'] ) ? 'AND mc.visible_in_esculap = true ' : '' )."
				".( isset( $additionalRestrictions[ 'EVENT_TO' ] ) ?

                //"AND mce.date_start < '" . ( date( 'Y-m-d' , (int)$additionalRestrictions[ 'EVENT_TO' ] ) ) . "'"
                $dateCriteria

                : '' )."
				".( isset( $additionalRestrictions[ 'EVENT_ORG' ] ) && strlen( $additionalRestrictions[ 'EVENT_ORG' ] ) ? "AND mce.org_name ilike '%{$additionalRestrictions[ 'EVENT_ORG' ]}%'" : '' )."
				".( isset( $additionalRestrictions[ 'EVENT_TYPE' ] ) ? "AND mce.event_type = '{$additionalRestrictions[ 'EVENT_TYPE' ]}'" : '' )."
				".( isset( $additionalRestrictions[ 'MAIN_SITE_ID' ] ) && $additionalRestrictions[ 'MAIN_SITE_ID' ] ? "AND mc.main_site_id = {$additionalRestrictions[ 'MAIN_SITE_ID' ]}" : '' )."
				".( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
				".( isset( $specs ) ? "AND rcs.spec_code in ( {$specs} )" : '' )."
				".( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( ". $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' )."
			GROUP BY mc.content_id , mce.date_start
			" . ( false === $count && !isset($additionalRestrictions['ESCULAP_ORDER'])
				?
					" ORDER BY {$order} mce.date_start ASC
					  LIMIT {$limit}
					  OFFSET {$offset}" 
				: '' ) . " " . (false === $count && isset($additionalRestrictions['ESCULAP_ORDER'])
				?
					" ORDER BY {$additionalRestrictions['ESCULAP_ORDER']}
					  LIMIT {$limit}
					  OFFSET {$offset}"
				: '' ) . "
		";
                
		try {
			
			$lastMatched = 0;
			if( isset( $additionalRestrictions[ 'MARK_LAST_MATCHED' ] ) ) {
				
				$lastMatch = "
					SELECT " . preg_replace( '/10/' , '0' , $columns ) . "
					FROM {$this->table()} mce, {$this->table( 'main_content' )} mc
					LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
					WHERE 
						mc.content_id = mce.content_id AND mc.lang_id = mce.lang_id
						AND mce.date_end > '" . date( 'Y-m-d' ) . "'
						" . ( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_TO' ] ) ? "AND mce.date_start < '" . ( date( 'Y-m-d' , (int)$additionalRestrictions[ 'EVENT_TO' ] ) ) . "'" : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_ORG' ] ) && strlen( $additionalRestrictions[ 'EVENT_ORG' ] ) ? "AND mce.org_name ilike '%{$additionalRestrictions[ 'EVENT_ORG' ]}%'" : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_TYPE' ] ) ? "AND mce.event_type = '{$additionalRestrictions[ 'EVENT_TYPE' ]}'" : '' )."
						" . ( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
						" . ( isset( $specs ) ? "AND rcs.spec_code in ( {$specs} )" : '' ) . "
						" . ( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( ". $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' ).
						" GROUP BY mc.content_id , mce.date_start ,  mce.content_id " .
						(isset($additionalRestrictions['ORDER_SPECS']) ?
								" ORDER BY match_level ASC , mce.date_start DESC , mce.content_id DESC " :
								" ORDER BY mce.date_start DESC , mce.content_id DESC ") .
					" LIMIT 1 ";
				
				
				$lastMatchedRow = $this->adapter->createStatement( $lastMatch )->execute();
				if( $lastMatchedRow->count() ) {
					$lastMatchedRow = $lastMatchedRow->current();
					
					
					$lastMatched = $lastMatchedRow[ 'content_id' ];
				}
			}

			$res = $this->adapter->createStatement( $select )->execute();
                        
			if( $count ) 
				return $res->count();
			
			
			// jeśli nic nie znalazłem nie póbuje pobierać danych
			if( !$res->count() ) 
				return array();
			
			
			$contentList = array();
			$matchLevels = array();
			
			foreach( $res as $row ) {
				
				if( isset( $row[ 'match_level' ] ) )
					$matchLevels[ $row[ 'content_id' ] ] = $row[ 'match_level' ];
					
				$contentList[ $row[ 'content_id' ] ] = $row[ 'content_id' ];
			}
			
			
			$idListSearch = implode( ',' , $contentList );
			
			$select = "
				SELECT 
					* ,
					coalesce( ( SELECT ROUND( AVG( evaluation ) , 1 ) FROM {$this->table( 'main_content_evaluation' )} mce where mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluation ,
					coalesce( ( SELECT count( 1 ) FROM {$this->table( 'main_content_evaluation' )} mce WHERE mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluated
				FROM {$this->table()} mcn, {$this->table( 'main_content' )} mc, {$this->table( 'ext_content_event' )} ece
				WHERE mc.content_id = mcn.content_id AND mc.lang_id = mcn.lang_id AND mc.content_id in ( {$idListSearch} ) AND 
					  mc.content_id = ece.content_id AND mc.lang_id = ece.lang_id
					  ORDER BY array_index(array[{$idListSearch}], mc.content_id) --array_index to procedura
			";
                        
			$res = $this->adapter->createStatement( $select )->execute();
			
			// sprawdzam czy jest jakiś dopasowany element z match_level-em większym niż 10 - jeśli nie to nieoznaczam ostatniego pasującego
			$markLast = false;
			foreach( $matchLevels as $matchLevel ) {
				
				if( $matchLevel !== 10 ) {
					
					$markLast = true;
					break;
				}
			}
			
			
			foreach( $res as $row ) {
				
				if( count( $matchLevels ) )
					$row[ 'match_level' ] = $matchLevels[ $row[ 'content_id' ] ];
				
				if( true === $markLast &&
					$lastMatched == $row[ 'content_id' ] )
					$row[ 'last_matched' ] = 1;
				
					
				$contentList[ $row[ 'content_id' ] ] = $row;
			}

			return $contentList;
			
		} catch( \Exception $e ) {
			
			return array();
		}
	}
	
	public function countEx( $specTypes,$additionalRestrictions = array() ) {
		
		return $this->getElementsEx( $specTypes, null , null , $additionalRestrictions , true );
	}
	
	public function count($specTypes,$additionalRestrictions = array()) {
		
		$query = $this->query( $specTypes , $additionalRestrictions );
		$res = $this->queryHelper(0,1,$query,$additionalRestrictions,true);
		
		$res = $res->current();
		
		return $res['total'];
	}
	
	public function addEvent($contentId,$langId,$title,$info,$link,$city,$zip,$address,$eventType,$telephone,$fax,$email,$country,$dateStart,$dateEnd,$orgName,$orgAddr,$addByUser) {
		
		try {
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} (content_id,lang_id,title,info,link,city,zip,address,event_type,tel,fax,email,country,date_start,date_end,org_name,org_addr,add_by_user) VALUES
				({$contentId},'{$langId}','{$title}','{$info}','{$link}','{$city}','{$zip}','{$address}','{$eventType}','{$telephone}','{$fax}','{$email}','{$country}','{$dateStart}','{$dateEnd}','{$orgName}','{$orgAddr}'," . ((bool)$addByUser ? 'true' : 'false' ) . ")				
			")->execute();
			
			$res = $this->adapter->createStatement("SELECT LASTVAL()")->execute();
			$res = $res->current();
			return $res['lastval'];
			
		} catch(\Exception $e) {
			throw new \Exception(__METHOD__.'. '.pg_last_error().'. '.$e->getMessage());
		}
	}
	
	
	public function updateEvent( $contentId , $langId , $title , $info , $link , $city , $zip , $address , $eventType , $telephone , $fax , $email , $country , $dateStart , $dateEnd , $orgName , $orgAddr ) {
		
		try {
			
			$res = $this->adapter->query ("
				UPDATE {$this->table()} SET lang_id = '{$langId}' , title = '{$title}' , info = '{$info}' , link = '{$link}' , city = '{$city}' , zip = '{$zip}' , address = '{$address}' ,
				event_type = '{$eventType}' , tel = '{$telephone}' , fax = '{$fax}' , email = '{$email}' , country = '{$country}' , date_start = '{$dateStart}' ,
				date_end = '{$dateEnd}' , org_name = '{$orgName}' , org_addr = '{$orgAddr}'
				WHERE content_id = {$contentId}
			")->execute();
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". Nieudana próba nadpisania treści eventu argumenty zgodnie z kolejnością \"$contentId,$langId,$title,$info,$link,$city,$zip,$address,$eventType,$telephone,$fax,$email,$country,$dateStart,$dateEnd,$orgName,$orgAddr\"." . $e->getMessage() );
		}
	}	
	
	public function getEndDateOfFirstEvent() {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT date_end FROM {$this->table()} ORDER BY date_end ASC LIMIT 1
			")->execute();
			
			if( $res->count() == 1) {
				
				$res = $res->current();
				return $res[ 'date_end' ];
				
			}
			
			return null;
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. Nieudane pobranie najwczśniejszego eventu. ' . $e->getMessage() );
		}
	}
	
	
	public function getStartDataForLastEvent() {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT date_start FROM {$this->table()} ORDER BY date_start DESC limit 1
			")->execute();
			
			if( $res->count() == 1) {
				
				$res = $res->current();
				return $res[ 'date_start' ];
				
			}
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. Nieudane pobranie najpóźniejszego eventu. ' . $e->getMessage() );
		}
	}
	
	
	public function getOrganizators() {
		
		try {
			
			$res = $this->get("
				SELECT org_name , org_addr FROM {$this->table()} GROUP BY org_name , org_addr
			");
			
			return $this->fetchAll( $res ); 
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __NAMESPACE__ . '. ' . $e->getMessage() );
		}
	}
	
	public function getElement( $contentId , $language ) {
		
		try {
			
			$language = strtoupper( $language );
			
			$res = $this->get("
				SELECT mct.info as body , * FROM {$this->table()} mct , {$this->table( 'main_content' )} mc WHERE
				mct.content_id = mc.content_id AND
				mc.lang_id = '{$language}' AND 
				mc.content_id = {$contentId}
			");
			
			if( 0 == $res->count() )
				return false;
				
			return $res->current();
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
}

?>
