<?php

namespace Model;
use System\Database\AbstractTableContent;

abstract class MainContentHelper extends AbstractTableContent {
	
	protected static $CMS = false;
	
	public static function setCms() {
	
		self::$CMS = true;
	}
	
	private $mc_fields;
	
	/**
	 * Uniwersalny punkt dostępu dla pobieranie danych z bazy dla contentu. Wszystkie typy kontentu wykożystują tą metod
	 * @param $rows klauzula LIMIT
	 * @param $offset klauzula OFFSET 
	 */
	public function queryHelper($rows,$offset,$subQuery = null,$additional = array(),$countOnly = false,$additionalTables = array()) {
		
		$this->mc_fields = "{$this->table( 'main_content' )}.content_id, 
						    {$this->table( 'main_content' )}.lang_id, 
						    {$this->table( 'main_content' )}.type, 
						    {$this->table( 'main_content' )}.active, 
						    {$this->table( 'main_content' )}.searchable, 
						    {$this->table( 'main_content' )}.add_date, 
						    {$this->table( 'main_content' )}.mod_date, 
						    {$this->table( 'main_content' )}.avatar_id, 
						    {$this->table( 'main_content' )}.creator,
                                                    {$this->table( 'main_content' )}.content_of_the_day,
                                                    {$this->table( 'main_content' )}.main_site_id
                                                    ";
		
		
		if( isset( $additional['ACTIVE'] ) ) {
			if( $additional['ACTIVE'] !== false ) {
				
				$active = (int)$additional['ACTIVE'];
			} else {
				$active = -1;
			}
			
		} else {
			$active = 1;
		}
		
		$inEsculap = !self::$CMS;
		
		
		
		// parsowanie dodatkowych tabel do podłączenia
		$additionalTablesSelect = null;
		$additionslTablesFrom = null;
		$additionslTablesWhere = null;
		$esculapOrder = null;
		
		foreach($additionalTables as $additionslTable => $on) {
		
			if( null == $on ) {
				
				$on = "{$this->table()}.content_id = {$additionslTable}.content_id";
			} 
			
			$additionslTablesFrom .= ",{$additionslTable}";
			$additionalTablesSelect .= ",{$additionslTable}.*";
			$additionslTablesWhere .= " AND {$on}";
			
		}
		
		
		$fields = null;
		
		/*
		{$this->table()}.*, 
					   {$this->table('main_content')}.* 
					   {$additionalTablesSelect}
		*/
		
		if( !$countOnly ) {
			$fields = $this->mc_fields . ", {$this->table}.* , cast( visible_in_esculap as integer ) as visible_in_esculap,
					   coalesce( ( SELECT ROUND( AVG( evaluation ) , 1 ) from {$this->table( 'main_content_evaluation' )} mce where mce.content_id = {$this->table()}.content_id AND mce.lang_id = {$this->table()}.lang_id ) , 0 )  as evaluation ,
					   coalesce( ( SELECT count( 1 ) FROM {$this->table( 'main_content_evaluation' )} mce WHERE mce.content_id = {$this->table()}.content_id AND mce.lang_id = {$this->table()}.lang_id ) , 0 ) as evaluated";
			if( isset( $additional[ 'EVALUATION_CHECK' ] ) ) $fields .= ", ( SELECT count( 1 ) FROM {$this->table( 'main_content_evaluation' )} mce WHERE mce.content_id = {$this->table()}.content_id AND mce.lang_id = {$this->table()}.lang_id AND mce.user_id = " . ((int)$additional[ 'EVALUATION_CHECK' ]) . " ) as evaluation_available ";
			if ($this->table == 'main_content_event') {
                            $fields .= ", ext_content_event.scored, ext_content_event.points, ext_content_event.paid, ext_content_event.price, ext_content_event.file_url";
                        }
		} else {
			
			$fields = "count({$this->table()}.content_id) as \"total\"";
		} 
		
		
		$cmsWhere = null;
		$cmsWhereCheck = false;
		if( isset( $additional[ 'CMS_WHERE' ] ) || isset( $additional[ 'CMS_ORDER' ] ) ) {
			$cmsWhereCheck = true;
			$inEsculap = false;
			
			// sprawdzam dodatkowe warunki wykorzystywane w cmsie
			$cmsOrder = null;
			if( isset( $additional[ 'CMS_ORDER' ] ) ) {
				
				if( is_array( $additional[ 'CMS_ORDER' ] ) ) {
					$ord = $additional[ 'CMS_ORDER' ];
					
					$column = key( $ord );
					
					if( 'content_id' == $column ) {
						$column = "{$this->table()}.{$column}";
					}
					
					$cmsOrder = $column . '  ' . current( $ord );
				}
			}
			
			if( is_array( $additional[ 'CMS_WHERE' ] ) ) {
				
				foreach( $additional[ 'CMS_WHERE' ] as $constraint ) {
					
					foreach( $constraint as $column => $value) {
						
						switch( $column ) {
							case 'title':
								$cmsWhere .= " AND lower( {$this->table()}.{$column} ) like '%' || lower( '{$value}' ) || '%'";
								break;
							case 'content_id':
								$value = (int) $value;
								$cmsWhere .= " AND {$this->table()}.{$column} = {$value}";
								break;
                                                        case 'main_site_name':
								$cmsWhere .= " AND {$this->table('main_content')}.main_site_id IN ({$value})";
                                                                break;
							case 'add_date':
								$from = "( select TIMESTAMP WITH TIME ZONE 'epoch' + " . $value . " * INTERVAL '1 second')";
								$to = "(select TIMESTAMP WITH TIME ZONE 'epoch' + " . strtotime( '23:59' , $value ) . " * INTERVAL '1 second')";
								$cmsWhere .= " AND {$this->table( 'main_content' )}.add_date > {$from} AND {$this->table('main_content')}.add_date < {$to}";
								break;
							case 'lang_id':
								$value = preg_replace( "/([A-Z0-9]+)/" , "'$1'" , strtoupper( $value ) );
								$cmsWhere .= " AND {$this->table( 'main_content' )}.{$column} in ({$value})";
								break;
							case 'news_type':
								$value = preg_replace( "/([A-Z0-9]+)/" , "'$1'" , strtoupper( $value ) );
								$cmsWhere .= " AND {$this->table( 'main_content_news' )}.{$column} in ({$value})";
								break;
							case 'event_type':
								$value = preg_replace( "/([A-Z0-9]+)/" , "'$1'" , strtoupper( $value ) );
								$cmsWhere .= " AND {$this->table( 'main_content_event' )}.{$column} in ({$value})";
								break;
							case 'date_from':
								$from = "( select TIMESTAMP WITH TIME ZONE 'epoch' + " . $value . " * INTERVAL '1 second')";
								$cmsWhere .= " AND {$this->table( 'main_content' )}.add_date >= {$from}";
								break;
							case 'date_to':
								$to = "( select TIMESTAMP WITH TIME ZONE 'epoch' + " . strtotime( '23:59' , $value ) . " * INTERVAL '1 second')";
								$cmsWhere .= " AND {$this->table( 'main_content' )}.add_date <= {$to}";
								break;
							case 'active':
								$val = '';
								$value = explode( ',' , $value );
								foreach( $value as $row ) {
									
									if( strlen( $val ) ) $val .= ',';
									
									$val .= "{$row}";
								}
								
								$cmsWhere .= " AND {$this->table( 'main_content' )}.active in( {$val} )";
								break;
                            case 'add_by_user':
                                $val = '';
                                $value = explode( ',' , $value );
                                foreach( $value as $row ) {

                                    if( strlen( $val ) ) $val .= ',';

                                    $val .= "{$row}";
                                }

                                $cmsWhere .= " AND {$this->table( 'main_content_event' )}.add_by_user in( {$val} )";
                            break;
							case 'journal_id':
								
								if( preg_match( '/([0-9]+(,[0-9]+)+)/' , $value ) ) {
									
									// trochę dziadostwo ale skoro każą...
									$value = preg_replace( '/[\,]?0$/' , '' , $value );
									
									$cmsWhere .= " AND ( {$this->table( 'main_content_publ' )}.journal_id in ( null,{$value} )";
									
									if( -1 < strpos( $value , '-1' ) ) {
										
										$cmsWhere .= " OR {$this->table( 'main_content_publ' )}.journal_id is NULL";
									}
									
									$cmsWhere .= " )";
								}
								
								break;
							case 'publ_type':
								$val = '';
								$value = explode( ',' , $value );
								foreach( $value as $row ) {
									
									if( strlen( $val ) ) $val .= ',';
									if( $row == '0' ) {
										$row = -1;
									}
									$val .= "'{$row}'";
								}
								
								$cmsWhere .= " AND ( {$this->table( 'main_content_publ' )}.publ_type in( {$val} ) or {$this->table( 'main_content_publ' )}.publ_type is NULL )";
								break;
						}
					}
				}
			}
		} elseif( isset( $additional[ 'ESCULAP_ORDER' ] ) ) {
			
			$esculapOrder = $additional[ 'ESCULAP_ORDER' ];
		}	
		
		$query = "
			SELECT {$fields}
			FROM {$this->table()}, {$this->table('main_content')}, {$this->table('main_site')} AS main_site {$additionslTablesFrom}
			WHERE 
				{$this->table()}.content_id = {$this->table('main_content')}.content_id AND
				{$this->table()}.lang_id = {$this->table('main_content')}.lang_id AND
                                main_site.id = {$this->table('main_content')}.main_site_id
				
				" . ( null !== $additional[ 'NOT_CONTENT_ID' ] ? " AND {$this->table('main_content')}.content_id not in( {$additional[ 'NOT_CONTENT_ID' ]} )" : '' ) . "
				
				{$additionslTablesWhere}
				
				
				" . ( null !== $subQuery 
						? 
							" AND {$this->table()}.content_id in ( {$subQuery} ) " 
						: 
							'' 
					)
				. "
				
				
				" . 
					
					( true == $inEsculap 
						?
							" AND {$this->table( 'main_content' )}.visible_in_esculap = true "
						: 
							""
					)
					
				. "
				
				
				" . ( $cmsWhereCheck ?
							
							( null !== $cmsWhere ?
									$cmsWhere
								:
									''
							) .
							
							
							( null !== $cmsOrder ? 
									" ORDER BY {$cmsOrder}" 
								:
									''
							)
						:
							
							
							( null !== $esculapOrder ?
									
									" ORDER BY {$esculapOrder}"
								:
									( 1 == $active ?
											" AND {$this->table( 'main_content' )}.active = 'true' and  {$this->table( 'main_content' )}.visible_in_esculap = 'true'"
										:
											''
									) . ( null == $countOnly ? 
											" ORDER BY {$this->table('main_content')}.content_id DESC" 
										:
											''
									)
							)
					) .
				
				( null == $countOnly ? " LIMIT {$rows} OFFSET {$offset}" : '' )."
		";
		
		//if( 'MainContentPublication' == get_class( $this ) )
		
		
		/*$conn = pg_connect( "host=10.10.1.175 port=9999 user=admin dbname=int_esculap password=Hter53@5lehu&" );
		$queryResult = pg_query( $conn , $query );
		
		$result = array();
		$c = 0;
		while( null !== ( $row = pg_fetch_assoc( $queryResult ) ) ) {
			if( $c++ > 100 )
				break;
			
			$result[] = $row;
		}*/
		
		//echo '<br><br>', $query, '<br><br>';

		$res = $this->adapter->createStatement( $query )->execute();
		return $res;
		
		if( 1 < count( $result ) ) {
			//exit( $query );
			
			//$t = $res->current();
			
			//trigger_error( strlen( $query ) . ' - ' . sha1( $query ) . ' - ' . $res->count() . ' | ' . $t[ 'content_id' ] );
			
			//exit( $query );
		}
		
		return $result;
	}
	
	
	public function getElement( $contentId , $language ) {
		
		try {
			
			$language = strtoupper( $language );
			
			$res = $this->get("
				SELECT * FROM {$this->table()} mct , {$this->table( 'main_content' )} mc WHERE
				mct.content_id = mc.content_id AND
				mc.lang_id = '{$language}' AND 
				mc.content_id = {$contentId}
			");
			
			if( 0 == $res->count() )
				return false;
				
			return $res->current();
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
}









?>














