<?php

namespace Model;
use System\Database\AbstractTableContent,
	\Zend\Db\Sql\Select;

class MainContentNews extends MainContentHelper {
	
	protected $table = 'main_content_news';
	
	protected function query($specTypes,$additionalRestrictions = array()) {
		
		if(!is_string($specTypes) || !preg_match('/^([,]?\'[A-Za-z0-9\.]+\')+$/',$specTypes)) $specTypes = '';
		
		
		if( isset( $additionalRestrictions['CONTENT_ID'] ) ) {
			
			return (int)$additionalRestrictions['CONTENT_ID'];
			
		} else {
			
			
			if(isset($additionalRestrictions['ID_LIST'])) {
				$additionalRestrictions['ID_LIST'] = implode(',',$additionalRestrictions['ID_LIST']);
			}
			
			
			$query = "
				SELECT distinct( mcn.content_id )
				FROM {$this->table()} mcn
				LEFT JOIN {$this->table( 'main_content' )} AS mc ON mc.content_id = mcn.content_id and mc.lang_id = mcn.lang_id
				LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mcn.content_id = rcs.content_id and mcn.lang_id = rcs.lang_id
				WHERE mcn.content_id > 0
				".( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
				".( !isset( $additionalRestrictions['ID_LIST'] ) && strlen( $specTypes )? "AND rcs.spec_code in({$specTypes})" : '')."
				".(isset($additionalRestrictions['NEWS_TYPE']) 						  ? "AND mcn.news_type = {$additionalRestrictions['NEWS_TYPE']}" : '')."
				".(isset($additionalRestrictions['ID_LIST']) ? "and mcn.content_id in ({$additionalRestrictions['ID_LIST']})" : '' )."
			";
		}
		
		
		return $query;
	}
	
	
	
	public function getElementsEx( $specTypes,$limit,$offset,$additionalRestrictions = array() , $count = false ) {
		$order = '';
		
		// ustalanie priowytetu dla specek
		if( isset( $additionalRestrictions[ 'ORDER_SPECS' ] ) ) {
			$specsStr = '';
			$order = 'match_level ASC, ';
			$other = false;
			$clearCase = true; // szyści case
			$columns = "mc.content_id , min( CASE";
			
			ksort( $additionalRestrictions[ 'ORDER_SPECS' ] );
			
			
			foreach( $additionalRestrictions[ 'ORDER_SPECS' ] as $priority => $specs ) {
				
				foreach( $specs as $spec ) {
					if( false !== $other )
						$other = true;
					
					$clearCase = false;
					
					
					$columns .= " WHEN rcs.spec_code = '{$spec}' THEN {$priority}";
					
					if( strlen( $specsStr ) )
						$specsStr .= ',';
						
					$specsStr .= "'{$spec}'";
				}
			}
			
			if( $clearCase ) {
				
				$order = '';
				unset( $specsStr );
				$columns = "mc.content_id";
				
			} else {
				if( $other )
					$columns .= " ELSE 10";
				
				$columns .= " END ) as match_level";
			}
		} else {
			
			$columns = 'mc.content_id';
		}
		
		
		// tu mam listę idków posortowanych jak należy
		
		if (isset($additionalRestrictions['ACTIVE']) && $additionalRestrictions['ACTIVE'] === false) {
                    $additionalRestrictions['ALL'] = true;
                }
		$select = "
			SELECT {$columns}
			FROM {$this->table()} mcn, {$this->table( 'main_content' )} mc
			LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
			WHERE 
				mc.content_id = mcn.content_id AND mc.lang_id = mcn.lang_id 
				" . ( isset( $additionalRestrictions['CONTENT_OF_THE_DAY'] ) ? ' AND mc.content_of_the_day = true ' : '' )."
				".( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
				".( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
				".( isset($additionalRestrictions[ 'MAIN_SITE_ID' ]) && $additionalRestrictions[ 'MAIN_SITE_ID' ] ? "AND mc.main_site_id = {$additionalRestrictions[ 'MAIN_SITE_ID' ]}" : '' )."
				".( isset( $additionalRestrictions[ 'NEWS_TYPE' ] ) ? "AND mcn.news_type = {$additionalRestrictions[ 'NEWS_TYPE' ]}" : '' )."
				".( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( " . $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' )."
			GROUP BY( mc.content_id )
			ORDER BY {$order} mc.content_id DESC
			" . ( false === $count 
				?
					" LIMIT {$limit}
					  OFFSET {$offset}" 
				: '' ) . "
		";
		
		try {
			
			
			$lastMatched = 0;
			if( isset( $additionalRestrictions[ 'MARK_LAST_MATCHED' ] ) ) {
				
				$lastMatch = "
					SELECT " . preg_replace( '/10/' , '0' , $columns ) . "
					FROM {$this->table()} mce, {$this->table( 'main_content' )} mc
					LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
					WHERE 
						mc.content_id = mce.content_id AND mc.lang_id = mce.lang_id
						AND mce.date_end > '" . date( 'Y-m-d' ) . "'
						" . ( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_TO' ] ) ? "AND mce.date_start < '" . ( date( 'Y-m-d' , (int)$additionalRestrictions[ 'EVENT_TO' ] ) ) . "'" : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_ORG' ] ) && strlen( $additionalRestrictions[ 'EVENT_ORG' ] ) ? "AND mce.org_name like '%{$additionalRestrictions[ 'EVENT_ORG' ]}%'" : '' )."
						" . ( isset( $additionalRestrictions[ 'EVENT_TYPE' ] ) ? "AND mce.event_type = '{$additionalRestrictions[ 'EVENT_TYPE' ]}'" : '' )."
						" . ( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
						" . ( isset( $specs ) ? "AND rcs.spec_code in ( {$specs} )" : '' ) . "
						" . ( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( ". $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' ).
				" GROUP BY mc.content_id , mce.date_start ,  mce.content_id " .
						(isset($additionalRestrictions['ORDER_SPECS']) ?
						" ORDER BY match_level ASC , mce.date_start DESC , mce.content_id DESC " :
						" ORDER BY mce.date_start DESC , mce.content_id DESC ") .
						" LIMIT 1 ";
				
				
				$lastMatchedRow = $this->adapter->createStatement( $lastMatch )->execute();
				if( $lastMatchedRow->count() ) {
					$lastMatchedRow = $lastMatchedRow->current();
					
					
					$lastMatched = $lastMatchedRow[ 'content_id' ];
				}
			}
			
			
			
			$res = $this->adapter->createStatement( $select )->execute();
			$contentList = array();
			
			
			if( $count )
				return $res->count();
			
			
			// jeśli nic nie znalazłem nie póbuje pobierać danych
			if( !$res->count() ) 
				return array();
				
				
			foreach( $res as $row ) {
				
				$contentList[ $row[ 'content_id' ] ] = $row[ 'content_id' ];
			}
			
			$idListSearch = implode( ',' , $contentList );
			
			$select = "
				SELECT 
					* ,
					coalesce( ( SELECT ROUND( AVG( evaluation ) , 1 ) FROM {$this->table( 'main_content_evaluation' )} mce where mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluation ,
					coalesce( ( SELECT count( 1 ) FROM {$this->table( 'main_content_evaluation' )} mce WHERE mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluated
				FROM {$this->table()} mcn, {$this->table( 'main_content' )} mc
				WHERE mc.content_id = mcn.content_id AND mc.lang_id = mcn.lang_id AND mc.content_id in ( {$idListSearch} )
				ORDER BY array_index(array[{$idListSearch}], mc.content_id) --array_index to procedura
			";
			
			$res = $this->adapter->createStatement( $select )->execute();
			foreach( $res as $row ) {
				
				$contentList[ $row[ 'content_id' ] ] = $row;
			}
			
			return $contentList;
			
		} catch( \Exception $e ) {
			
			return array();
		}
	}
	
	
	
	public function countEx( $specTypes,$additionalRestrictions = array() ) {

		return $this->getElementsEx( $specTypes, null , null , $additionalRestrictions , true );
	}
	
	
	
	public function getElements($specTypes,$start,$offset,$additionalRestrictions = array()) {
		
		
		$query = $this->query($specTypes,$additionalRestrictions);
		$res = $this->queryHelper($start,$offset,$query,$additionalRestrictions);
		
		return $this->fetchAll($res);
	}
	
	public function count($specTypes,$additionalRestrictions = array()) {
		
		$query = $this->query( $specTypes , $additionalRestrictions );
		$res = $this->queryHelper(0,1,$query,$additionalRestrictions,true);
		
		$res = $res->current();
		
		return $res['total'];
	}
	
	
	public function addNews( $contentId , $langId , $newsType , $title , $author , $head , $body , $date , $timeout , $copyrights, $keywords = '' ) {
	
		try {
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} ( content_id , lang_id , news_type , title , author , head , body , date , timeout , copyrights, keywords ) VALUES
											 ( {$contentId} , '{$langId}' , {$newsType} , '{$title}' , '{$author}' , '{$head}' , '{$body}' , '{$date}' , {$timeout} , '{$copyrights}', '{$keywords}' )
			")->execute();
			
			$resCheck = $this->adapter->createStatement( "SELECT LASTVAL()" )->execute();
			$resCheck = $resCheck->current();
			$resCheck = $resCheck[ 'lastval' ];
			
			return $resCheck;
			
		} catch( \Exception $e) {
			
			throw new \Exception( "Neiudało sie dodać newsa. " . $e->getMessage() );
		}
	}
	
	
	public function updateNews( $contentId , $langId , $newsType , $title , $author , $head , $body , $date , $timeout , $copyrights , $keywords = '' ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				UPDATE {$this->table()} SET
					lang_id = '{$langId}' , news_type = {$newsType} , title = '{$title}' , author = '{$author}' , head = '{$head}' , body = '{$body}' , date = '{$date}' , timeout = {$timeout} , copyrights = '{$copyrights}', keywords = '{$keywords}'
					WHERE content_id = {$contentId}
			")->execute();
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __NAMESPACE__ . "Błąd nadpisania wiersza z mian_content_news ." . $e->getMessage() );
		}
	}
	
	
	public function isExists( $contntId ) {
		$contntId = (int)$contntId;
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} WHERE content_id = {$contntId}
			")->execute();
			
			if( $res->count() > 0 )
				return true;
			return false;
		
		} catch( \Exceptpion $e ) {
				
			throw new \Exception( __METHOD__ . ". Nieudana próba sparawdzenia czy contnet istieje. " . $e->getMessage() );
		}
	}
}

?>