<?php

namespace Model;

use System\Database\AbstractTable,
	Zend\Db\Sql\Select,
	Zend\Paginator\Adapter\DbSelect as PaginatorAdapter;

class MainContentQuiz extends MainContentHelper {
	protected $table = 'main_content_quiz';
	
	public function getElementsEx( $specTypes , $limit , $offset , $additionalRestrictions = array() , $count = false ) {
		$order = '';
		
		// ustalanie priowytetu dla specek
		if( isset( $additionalRestrictions[ 'ORDER_SPECS' ] ) ) {
			$specsStr = '';
			$order = 'match_level ASC, ';
			$other = false;
			$clearCase = true; // szyści case
			$columns = "mc.content_id , min( CASE";
			
			ksort( $additionalRestrictions[ 'ORDER_SPECS' ] );
			
			
			foreach( $additionalRestrictions[ 'ORDER_SPECS' ] as $priority => $specs ) {
				
				foreach( $specs as $spec ) {
					if( false !== $other )
						$other = true;
					
					$clearCase = false;
					
					
					$columns .= " WHEN rcs.spec_code = '{$spec}' THEN {$priority}";
					
					if( strlen( $specsStr ) )
						$specsStr .= ',';
						
					$specsStr .= "'{$spec}'";
				}
			}
			
			if( $clearCase ) {
				
				$order = '';
				unset( $specsStr );
				$columns = "mc.content_id";
				
			} else {
				if( $other )
					$columns .= " ELSE 10";
				
				$columns .= " END ) as match_level";
			}
		} else {
			
			$columns = 'mc.content_id';
		}
		
		
		// tu mam listę idków posortowanych jak należy
		$select = "
			SELECT {$columns}
			FROM {$this->table()} mcn, {$this->table( 'main_content' )} mc
			LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
			WHERE 
				mc.content_id = mcn.content_id AND mc.lang_id = mcn.lang_id 
				" . ( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
				" . ( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
				" . ( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( " . $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' )."
				" . ( isset( $additionalRestrictions[ 'MAIN_SITE_ID' ] ) ? "AND mc.main_site_id = {$additionalRestrictions[ 'MAIN_SITE_ID' ]}" : '' )."
			GROUP BY( mc.content_id )
			ORDER BY {$order} mc.content_id DESC
			" . ( false === $count 
				?
					" LIMIT {$limit}
					  OFFSET {$offset}" 
				: '' ) . "
		";
		
		try {
			
			$lastMatched = 0;
			if( isset( $additionalRestrictions[ 'MARK_LAST_MATCHED' ] ) ) {
				
				$lastMatch = "
					SELECT " . preg_replace( '/10/' , '0' , $columns ) . "
					FROM {$this->table()} mce, {$this->table( 'main_content' )} mc
					LEFT JOIN {$this->table( 'rel_content_spec' )} AS rcs ON mc.content_id = rcs.content_id AND mc.lang_id = rcs.lang_id
					WHERE 
						mc.content_id = mce.content_id AND mc.lang_id = mce.lang_id
						AND mce.date_end > '" . date( 'Y-m-d' ) . "'
						" . ( !isset( $additionalRestrictions['ALL'] ) ? ' AND mc.visible_in_esculap = true ' : '' )."
						" . ( isset( $additionalRestrictions[ 'CONTENT_ID' ] ) ? "AND mc.content_id = {$additionalRestrictions[ 'CONTENT_ID' ]}" : '' )."
						" . ( isset( $specs ) ? "AND rcs.spec_code in ( {$specs} )" : '' ) . "
						" . ( isset( $additionalRestrictions[ 'NOT_CONTENT_ID' ] ) ? "AND mc.content_id not in ( ". $additionalRestrictions[ 'NOT_CONTENT_ID' ] . " ) " : '' ).
				" GROUP BY mc.content_id , mce.date_start ,  mce.content_id " .
						(isset($additionalRestrictions['ORDER_SPECS']) ?
						" ORDER BY match_level ASC , mce.date_start DESC , mce.content_id DESC " :
						" ORDER BY mce.date_start DESC , mce.content_id DESC ") .
						" LIMIT 1 ";

				
				$lastMatchedRow = $this->adapter->createStatement( $lastMatch )->execute();
				if( $lastMatchedRow->count() ) {
					$lastMatchedRow = $lastMatchedRow->current();
					
					
					$lastMatched = $lastMatchedRow[ 'content_id' ];
				}
			}
			
			
			
			$res = $this->adapter->createStatement( $select )->execute();
			$contentList = array();
			
			if( $count )
				return $res->count();
			
			
			// jeśli nic nie znalazłem nie póbuje pobierać danych
			if( !$res->count() ) 
				return array();
				
				
			foreach( $res as $row ) {
				
				$contentList[ $row[ 'content_id' ] ] = $row[ 'content_id' ];
			}
			
			$idListSearch = implode( ',' , $contentList );
			
			$select = "
				SELECT 
					*,
					coalesce( ( SELECT ROUND( AVG( evaluation ) , 1 ) FROM {$this->table( 'main_content_evaluation' )} mce where mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluation ,
					coalesce( ( SELECT count( 1 ) FROM {$this->table( 'main_content_evaluation' )} mce WHERE mce.content_id = mc.content_id AND mce.lang_id = mc.lang_id ) , 0 ) as evaluated
					FROM {$this->table()} mcq, {$this->table( 'main_content' )} mc
				WHERE mc.content_id = mcq.content_id AND mc.lang_id = mcq.lang_id
				AND mc.content_id in ( {$idListSearch} )
				ORDER BY array_index(array[{$idListSearch}], mc.content_id)
				LIMIT {$limit}
			";
			
			$res = $this->adapter->createStatement( $select )->execute();
			
			$contentList = array();
			
			foreach( $res as $row ) {
				
				$contentList[ $row[ 'content_id' ] ] = $row;
			}
			
			return $contentList;
			
		} catch( \Exception $e ) {
			
			return array();
		}
	}
	
	public function addQuiz( $contentId , $langId , $name , $question , $correctAnswer ) {
		
		try {
			
			$this->insert(array(
				'content_id' => $contentId,
				'lang_id' => strtoupper( $langId ),
				'name' => $name,
				'question' => $question,
				'correct_answers' => $correctAnswer
			));
			
			
			return $this->lastInsertValue;
			
			
		} catch( \Exception $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function updateQuiz( $contentId , $langId , $name , $question , $correctAnswer ) {
		
		try {
			
			$langId = strtoupper( $langId );
			
			$this->update(array(
				'name' => $name,
				'question' => $question,
				'correct_answers' => $correctAnswer
			) , "content_id = $contentId AND lang_id = '$langId'" );
			
			
			return $this->lastInsertValue;
			
			
		} catch( \Exception $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function remove( $contentId , $langId ) {
		
		try {
			
			return $this->delete( array( 'content_id' => $contentId , 'lang_id' => $langId ) );
			
		} catch( \Exception $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function getPaginator( $constraoints = array() , $_order = array( 'content_id' => 'desc' ) ) {
		$orderFireld = key( $_order );
		$order = array( 'content_id' => 'desc' );
		$orderType = current( $_order );
		
		switch( $orderFireld ) {
			case 'content_id':
			case 'id':
				
				$order = array( 'main_content.content_id' => $orderType );
				
				break;
			case 'add_date':
				
				$order = array( 'main_content.add_date' => $orderType );
			
				break;
			case 'title':
				
				$order = array( 'main_content_quiz.name' => $orderType );
			
				break;
                        case 'main_site_name':
                            
                                $order = array( 'main_site.name' => $orderType );
                            
                                break;
		}
		
		$select = new Select;
		$select->from($this->table)
			   ->join('main_content', 'main_content.content_id = main_content_quiz.content_id AND main_content.lang_id = main_content_quiz.lang_id')
			   ->join('main_site', 'main_site.id = main_content.main_site_id', array('main_site_name' => 'name', 'main_site_url' => 'url'))
			   ->order($order);
		
		
		//trigger_error( json_encode( $constraoints ) );
                
		foreach( $constraoints as $field => $value ) {
		
			switch( $field ) {
				case 'content_id':
				case 'id':
					if ($value) {
					$select->where( "main_content.content_id = {$value}" );
                                        }
					
					break;
				case 'title':
					if ($value) {
					$select->where( "main_content_quiz.name like '%{$value}%'" );
                                        }
					break;
                                case 'main_site_name':
                                    if ($value) {
                                        $select->where( "main_content.main_site_id IN ($value)" );
                                    }
                                        break;
                                case 'main_site_id':
                                    if ($value) {
                                        $select->where( "main_content.main_site_id = $value" );
                                    }
                                        break;
				case 'add_date_from':
					
					if ($value) {
					if( preg_match( '/^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$/' , $value ) ) {
						
						$value = explode( '/' , $value );
							
						$value = mktime( 0 , 0 , 0 , $value[ 1 ] , $value[ 0 ] , $value[ 2 ] );
					}		
					
					$select->where( " extract( epoch from main_content.add_date ) >= {$value}" );
                                        }
					break;
				case 'add_date_to':
					if ($value) {
					if( preg_match( '/^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$/' , $value ) ) {
						
						$value = explode( '/' , $value );
						
						$value = mktime( 23 , 59 , 59 , $value[ 1 ] , $value[ 0 ] , $value[ 2 ] );
					}
					
					$select->where( "extract( epoch from main_content.add_date ) <= {$value}" );
                                        }
					break;
			}
		}
                
		return new MainContentQuizPaginator( $select , $this->getAdapter() );
	}


    public function countEx( $specTypes,$additionalRestrictions = array() ) {

        return $this->getElementsEx( $specTypes, null , null , $additionalRestrictions , true );
    }

    public function count( $specTypes , $additionalRestrictions = array() ) {

        $query = $this->query( $specTypes , $additionalRestrictions );
        $res = $this->queryHelper( 0 , 1 , $query , $additionalRestrictions , true );
        $res = $res->current();


        return $res['total'];
    }
}

class MainContentQuizPaginator extends PaginatorAdapter {}


?>