<?php

namespace Model;
use System\Database\AbstractTableContent;

class MainContentRate extends AbstractTableContent {
	protected $table = 'main_content_rate';

	/**
	* Sprawdza czy wiersz dla podanego id contentu istnieje
	* @patam int $contentId - id sprawdzanego contentu
	8 @returns boolen
	* @throws \Exception - w razie rzucenia wyjątku przez silnik
	*/
	public function isRowExists( $contentId ) {
		
		try {
			
			$contentId = (int)$contentId;
			
			$res = $this->adapter->createStatement(
				"SELECT * FROM {$this->table()} WHETE content_id = {$contentId}"
			)->execute();
			
			$res = $res->current();
			
			if( isset( $res[ 'content_id' ] ) )  
				return true;
			return false;
		
		} catch( \Exception $e ) {
			throw new \Exception( __NAMESPACE__ . ". Błąd przy pobieraniu wiersza z bazy. contentId = \"{$contentId}\"" );
		}
	}	
	
	/**
	* Inkrementacja licznika odwiedzin
	* @param int $ocntentId id kontentu 
	* @param str $langId skrót języka kontentu
	* @param int id użytkownika 
	* @returns boole
	* @throws \Exception
	*/
	public function incrementContentCounter( $contentId , $langId , $userId ) {
		
		
		try {
			
			
			$contentId = (int)$contentId;
			$langId = strtoupper( $langId );
			$userId = (int)$userId;
			
			
			$res = $this->adapter->createStatement("
				UPDATE {$this->table()} SET rate = rate + 1 WHERE content_id = {$contentId} AND lang_id = '{$langId}' AND user_id = {$userId}
			")->execute();
			
			
			
			// jeśli wszystko się udało zwracam true
			if( $res->getAffectedRows() == 1 ) return true;
			
			
			// jeśli żaden wiersz nie został updatowany, znaczy, że jeszcze nie został utworzony więc to robimy...
			
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} (content_id , lang_id , user_id , rate ) VALUES ( {$contentId} , '{$langId}' , {$userId} , 1 )
			")->execute();
			
			
			return true;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". Nieudało się dczytać wiersza dla danych wejściowych: contentId = \"{$contentId} \", langId = \"{$langId} \", userId = \"{$userId} \" " . $e->getMessage() );
		}
	}
}

?>