<?php

namespace Model;
use System\Database\AbstractTable;

class MainContentSearchHelper extends AbstractTable {
	protected $table = 'main_content';
	
	
	public function countEx( $specsList , $constraints = array() ) {
		
		return $this->count( $specsList , $constraints );
	}
	
	
	public function count( $specsList , $constraints = array() ) {
		if( !isset( $constraints[ 'SEARCH_QUERY' ] )) $constraints[ 'SEARCH_QUERY' ] = array();
		
		extract( $this->parseQuery( $constraints ) );
		
		try {
			
			$res = $this->adapter->createStatement("
				
				SELECT count(1)
				FROM {$this->table()}
				{$join}
				WHERE {$additionalConstraints}
				
				" . ( strlen( $mainConstraint) ? 
						"AND {$this->table()}.tsearch @@ plainto_tsquery( '" . AbstractTable::getTsearchConfig() ."' , '{$mainConstraint}' )" :
						"" ) 
			)->execute();
			
			$res = $res->current();
			$res = $res[ 'count' ];
			
			return $res;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __NAMESPACE__ . ". Nieudana próba policzenia wierszy." . $e->getMessage() );
		}
	}
	
	
	public function getElementsEx( $specList , $limit , $offset , $constraints = array() ) {
		
		return $this->getElements( $specList , $limit , $offset , $constraints );
	}
	
	
	public function getElements( $specList , $limit , $offset , $constraints = array() ) {
		if( !isset( $constraints[ 'SEARCH_QUERY' ] )) $constraints[ 'SEARCH_QUERY' ] = array();
		
		extract( $this->parseQuery( $constraints ) );
		
		
		
		
		try {
			try {
				$res = $this->adapter->createStatement("
					SELECT *, {$select} , {$this->table()}.content_id , {$this->table()}.lang_id,
						" . ( strlen( $mainConstraint) ? 
								"ts_rank_cd( {$this->table()}.tsearch , plainto_tsquery( '" . AbstractTable::getTsearchConfig() ."' , '{$mainConstraint}' ), 32 ) as \"mathlevel\"" :
								"1 as mathlevel" ) . "
								
					FROM {$this->table()}
					{$join}
					WHERE {$additionalConstraints}
					
					" . ( strlen( $mainConstraint) ? 
							"AND {$this->table()}.tsearch @@ plainto_tsquery( '" . AbstractTable::getTsearchConfig() ."' , '{$mainConstraint}' )" :
							"" ) . "
							
					ORDER BY mathlevel desc, {$this->table( 'main_content' )}.content_id DESC
					
					{$limit} {$offset}
					
				")->execute();
				
			} catch( \Exception $e ) {
				
				
			}	
			
			
			
			$result = array();
			foreach( $res as $row) {
				try {
					
						
						$head = $this->adapter->createStatement("
							SELECT ts_headline( 
								'" . AbstractTable::getTsearchConfig() . "',
								search, 
								plainto_tsquery(
									'" . AbstractTable::getTsearchConfig() . "',
									'{$mainConstraint}'
								), 
								'HighlightAll=TRUE,
								ShortWord=3, 
								MaxWords=10, 
								MinWords=6, 
								MaxFragments=3, 
								FragmentDelimiter=\" ... \"' 
							) as headline
							FROM {$this->table( 'main_content' )}
							WHERE content_id = {$row[ 'content_id' ]} AND lang_id = '{$row[ 'lang_id' ]}'
						")->execute();
						
						$head = $head->current();
						$head = $head[ 'headline' ];
						
					
					
				} catch( \Exception $e ) {
					
					$head = $row[ 'title' ];
				}
				
				
				//if( !strlen( $mainConstraint ) && is_integer( substr( 0 , $head , 1 ) ) ) {
					//$head = substr( 1 , $head );
				//}
				
				
				switch( $row[ 'type' ] ) {
					case 'news':
						
						$row[ 'title' ] = $row[ 'news_title' ];
						//if( strlen( $mainConstraint ) )
							$row[ 'head' ] = $head;
						$row[ 'content_id' ] = $row[ 'news_content_id' ];
						
						break;
					case 'publ':
					
						$row[ 'title' ] = $row[ 'publ_title' ];
						//if( strlen( $mainConstraint ) )
							$row[ 'head' ] = $head;
						$row[ 'content_id' ] = $row[ 'publ_content_id' ];
						
						break;

					case 'event': 
						
						$row[ 'title' ] = $row[ 'event_title' ];
						$row[ 'content_id' ] = $row[ 'event_content_id' ];
						//if( strlen( $mainConstraint ) )
							$row[ 'head' ] = $head;
						
						break;
                                        case 'video': 
                                        case 'movie': 
						
						$row[ 'title' ] = $row[ 'video_title' ];
						$row[ 'content_id' ] = $row[ 'video_content_id' ];
						//if( strlen( $mainConstraint ) )
							$row[ 'head' ] = $head;
						
						break;
					default:
						continue;
				}
				
				$result[] = $row;
			}
			
			return $result;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __NAMESPACE__ . ". Nieudana próba wyszukania wierszy." . $e->getMessage() );
		}
	}
	
	
	public function parseQuery( $constraints ) {
		
		$join = null;
		$select = null;
		$additionalConstraints = "{$this->table()}.active is true and {$this->table()}.searchable is true AND {$this->table( 'main_content' )}.visible_in_esculap = true ";
		$limit = null;
		$offset = null;
		
		if( isset( $constraints[ 'SEARCH_QUERY' ][ 'CATEGORY' ] ) && 
				in_array( $constraints[ 'SEARCH_QUERY' ][ 'CATEGORY' ] , array( 'news' , 'publ' , 'event' ) )
			) {
			
			$type = $constraints[ 'SEARCH_QUERY' ][ 'CATEGORY' ];
			
		} else {
		   
			$type = null;
		}
		
		
		if( isset( $constraints[ 'SEARCH_QUERY' ][ 'MAIN_QUERY' ] ) ) {
			
			$mainConstraint = $constraints[ 'SEARCH_QUERY' ][ 'MAIN_QUERY' ];
			
		} else {
			
			$mainConstraint = '';
		}
		
		$_constraints = $constraints[ 'SEARCH_QUERY' ]; 
		
		if( isset( $_constraints[ 'limit' ] ) ) {
			
			$limit = ' LIMIT ' . $_constraints[ 'limit' ];
		} if( isset( $_constraints[ 'offset' ] ) ) {
			
			$offset = ' OFFSET ' . $_constraints[ 'offset' ];
		}
		
		
		if( null == $type ) {
			
			$join = "
				
				LEFT JOIN {$this->table( 'main_content_news' )} AS news ON {$this->table()}.content_id = news.content_id AND {$this->table()}.lang_id = news.lang_id AND {$this->table()}.type = 'news'
				LEFT JOIN {$this->table( 'main_content_publ' )} AS publ ON {$this->table()}.content_id = publ.content_id AND {$this->table()}.lang_id = publ.lang_id AND {$this->table()}.type = 'publ' 
				LEFT JOIN {$this->table( 'main_content_event' )} AS event ON {$this->table()}.content_id = event.content_id  AND {$this->table()}.lang_id = event.lang_id AND {$this->table()}.type = 'event'
				LEFT JOIN {$this->table( 'main_content_video' )} AS video ON {$this->table()}.content_id = video.content_id  AND {$this->table()}.lang_id = video.lang_id AND {$this->table()}.type = 'video'
				
			";
			
			
			// LEFT JOIN {$this->table( 'ext_content_event' )} AS eventext ON {$this->table()}.content_id = eventext.content_id AND {$this->table()}.lang_id = eventext.lang_id AND {$this->table()}.type = 'event'
			
			
			$select = "
						
					   news.content_id as news_content_id, 
					   news.title as news_title , 
					   
					   publ.content_id as publ_content_id, 
					   publ.title as publ_title, 
					    
					   event.content_id as event_content_id, 
					   event.title as event_title,
                                           
                                           video.content_id as video_content_id, 
					   video.title as video_title";
					
			// najczęściej czytane
			//$additionalConstraints = "{$this->table()}.content_id > 0";
			if( isset( $_constraints[ 'date_start_lt' ] ) && strlen( $_constraints[ 'date_start_lt' ] ) ) {
				$additionalConstraints .= " AND {$this->table()}.add_date > now() - INTERVAL '{$_constraints[ 'date_start_lt' ]}'";
			}	
			
		} else {
			
			$additionalConstraints .= " AND {$this->table()}.type = '{$type}'";
			
			switch( $type ) {
				
				case 'news':
					
					$select = " news.*, news.title as news_title, news.content_id as news_content_id";
								
					$join = "LEFT JOIN {$this->table( 'main_content_news' )} AS news ON {$this->table()}.content_id = news.content_id";
					
					if( isset( $_constraints[ 'news_type' ] ) ) {
						$c = (int)$_constraints['news_type'];
						$additionalConstraints .= " AND news.news_type = {$c}";
					} if( isset( $_constraints[ 'search_title' ] ) ) {
						$additionalConstraints .= " AND lower( news.title ) like '%' || lower( '{$_constraints['search_title']}' ) || '%' ";
					} if( isset( $_constraints[ 'news_spec' ] ) ) {
						if( is_array( $_constraints[ 'news_spec' ] ) ) {
							
							$c = '';
							
							foreach( $_constraints[ 'news_spec' ] as $spec ) {
								if( strlen( $c ) ) $c .= ',';
								
								$c = "'{$spec}'";
							}
							
						} elseif( is_int( $_constraints[ 'news_spec' ] ) || is_string( $_constraints[ 'news_spec' ] ) ) {
							
							$c = "'{$_constraints[ 'news_spec' ]}'";
						}
						
						$additionalConstraints .= " AND rel_spec.spec_code in ( {$c} )";
						
						$join .= " LEFT JOIN {$this->table( 'rel_content_spec' )} AS rel_spec ON {$this->table()}.content_id = rel_spec.content_id";
						
					}
					
					break;
				case 'publ':
					$select = " publ.*, publ.title as publ_title , publ.content_id as publ_content_id";
					
					
					$join = "LEFT JOIN {$this->table( 'main_content_publ' )} AS publ ON {$this->table()}.content_id = publ.content_id
							 LEFT JOIN dict_publ_type2 AS publ_type ON publ.publ_type = publ_type.publ_type_code";
					
					if( isset( $_constraints[ 'publ_author' ] ) ) {
						$additionalConstraints .= " AND lower( publ.author ) like '%' || lower( '{$_constraints['publ_author']}' ) || '%' ";
					} if( isset( $_constraints[ 'publication_type' ] ) ) {
						if( is_array( $_constraints[ 'publication_type' ] ) ) {
							
							$c = '';
							
							foreach( $_constraints[ 'publication_type' ] as $type ) {
								if( strlen( $c ) ) $c .= ',';
								
								$c = "'{$type}'";
							}
							
						} elseif( is_int( $_constraints[ 'publication_type' ] ) || is_string( $_constraints[ 'publication_type' ] ) ) {
							
							$c = "'{$_constraints[ 'publication_type' ]}'";
						}
						
						$additionalConstraints .= " AND publ.publ_type in ( {$c} )";
					} if( isset( $_constraints[ 'publ_journal' ] ) ) {
						if( is_array( $_constraints[ 'publ_journal' ] ) ) {
							
							$c = '';
							
							foreach( $_constraints[ 'publ_journal' ] as $type ) {
								if( strlen( $c ) ) $c .= ',';
								$type = (int)$type;
								
								$c = $type;
							}
							
						} elseif( is_int( $_constraints[ 'publ_journal' ] ) || is_string( $_constraints[ 'publ_journal' ] ) ) {
							
							$c = (int)$_constraints[ 'publ_journal' ];
						}
						
						$additionalConstraints .= " AND publ.journal_id in ( {$c} )";
					} if( isset( $_constraints[ 'publ_spec' ] ) ) {
						if( is_array( $_constraints[ 'publ_spec' ] ) ) {
							
							$c = '';
							
							foreach( $_constraints[ 'publ_spec' ] as $spec ) {
								if( strlen( $c ) ) $c .= ',';
								
								$c = "'{$spec}'";
							}
							
						} elseif( is_int( $_constraints[ 'publ_spec' ] ) || is_string( $_constraints[ 'publ_spec' ] ) ) {
							
							$c = "'{$_constraints[ 'publ_spec' ]}'";
						}
						
						$additionalConstraints .= " AND rel_spec.spec_code in ( {$c} )";
						$join .= " LEFT JOIN {$this->table( 'rel_content_spec' )} AS rel_spec ON {$this->table()}.content_id = rel_spec.content_id";
					}
					
					break;
				case 'event':
					$select = " event.*, event.title as event_title , event.content_id as event_content_id";
								
					$join = "LEFT JOIN {$this->table( 'main_content_event' )} AS event ON {$this->table()}.content_id = event.content_id
							 LEFT JOIN {$this->table( 'ext_content_event' )} AS eventext ON {$this->table()}.content_id = eventext.content_id";
						
					if( isset( $_constraints[ 'event_type' ] ) ) {
						
						$additionalConstraints .= " AND event.event_type = '{$_constraints[ 'event_type' ]}'";
					} if( isset( $_constraints[ 'event_date_from' ] ) && preg_match( '/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/' , $_constraints[ 'event_date_from' ] ) ) {
						
						$additionalConstraints .= " AND event.date_end >= '{$_constraints[ 'event_date_from' ]}'"; 
						
					} if( isset( $_constraints[ 'event_date_to' ] ) && preg_match( '/^[0-9]{4}-[0-9]{2}-[0-9]{2}$/' , $_constraints[ 'event_date_to' ] ) ) {
						
						$additionalConstraints .= " AND event.date_start <= '{$_constraints[ 'event_date_to' ]}' ";
						
					} if( isset( $_constraints[ 'event_spec' ] ) ) {
						if( is_array( $_constraints[ 'event_spec' ] ) ) {
							
							$c = '';
							
							foreach( $_constraints[ 'event_spec' ] as $spec ) {
								if( strlen( $c ) ) $c .= ',';
								
								$c = "'{$spec}'";
							}
							
						} elseif( is_int( $_constraints[ 'event_spec' ] ) || is_string( $_constraints[ 'event_spec' ] ) ) {
							
							$c = "'{$_constraints[ 'event_spec' ]}'";
						}
						
						$additionalConstraints .= " AND rel_spec.spec_code in ( {$c} )";
						$join .= " LEFT JOIN {$this->table( 'rel_content_spec' )} AS rel_spec ON {$this->table()}.content_id = rel_spec.content_id";
					}
					
					break;
			}
		}
		
		return array(
			'join' => $join,
			'select' => $select,
			'additionalConstraints' => $additionalConstraints,
			'mainConstraint' => $mainConstraint,
			'limit' => $limit,
			'offset' => $offset
		);
	}
}


?>