<?php
namespace Model;

use System\Database\AbstractTable;
use System\File\FileDbManagerInterface;

class MainDimages extends AbstractTable implements FileDbManagerInterface {

    protected $table = 'main_dimages';
    protected $charSet = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'R',
        'S', 'T', 'U', 'W', 'X', 'Y', 'Z', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9);

    public function getFileByChecksum($checksum, $codeOnly = false) {

        try {

            $res = $this->get("
				SELECT * FROM {$this->table} WHERE checksum = '{$checksum}'
			");

            if ($res->count() < 1) return false;

            $res = $res->current();

            if (true == $codeOnly) {

                $res = $res['image_name'];
            }

            return $res;
        } catch (\Exception $e) {

            throw new \Exception(__METHOD__ . '' . $e->getMessage());
        }
    }

    public function generateCode($length = 12) {

        try {

            for ($fuse = 0; $fuse < 100; $fuse++) {

                $code = '';

                for ($i = 0; $i < $length; $i++) {

                    $code .= $this->charSet[rand(0, count($this->charSet) - 1)];
                }

                $res = $this->get("
					SELECT * FROM {$this->table} WHERE  image_name = '{$code}'
				");

                if ($res->count() == 0) {

                    return $code;
                }
            }

            throw new \Exception(__METHOD__ . '. Maksymalna liczba prób wygenerowania kodu została przekroczona');
        } catch (\Exception $e) {

            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function registerFile($code, $fileExtendsion, $width, $height, $mimeType, $checksum) {

        try {

            $width = (int)$width;
            $height = (int)$height;

            $res = $this->adapter->createStatement("
				INSERT INTO {$this->table} ( image_name , ext , width , height , data_type , checksum ) VALUES 
										   ( '{$code}' , '{$fileExtendsion}' , {$width} , {$height} , '{$mimeType}' , '{$checksum}' )
			")->execute();

            if ($res->getAffectedRows() !== 1) return false;

            return true;
        } catch (\Exception $e) {

            throw new \Exception(__METHOD__ . '. ' . "
				INSERT INTO {$this->table} ( image_name , ext , width , height , data_type , checksum ) VALUES 
										   ( '{$code}' , '{$fileExtendsion}' , {$width} , {$height} , '{$mimeType}' , '{$checksum}' )
			");
        }
    }

    public function getFile($code) {

        try {

            $res = $this->get("
				SELECT * FROM {$this->table} WHERE image_name = '{$code}'
			");

            if ($res->count() == 0) return false;
            return $res->current();
        } catch (\Exception $e) {

            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function deleteImage($imageName) {
        try {
            $this->adapter->createStatement("DELETE FROM {$this->table} WHERE image_name = '{$imageName}'")->execute();
            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

}

?>