<?php
namespace Model;

use System\Database\AbstractTable;

class MainEditions extends AbstractTable {

    protected $table = 'main_editions';

    public function getEditions($idList) {
        try {
            if (is_array($idList)) {
                $idList = implode(',', $idList);
            }
            $res = $this->get("
                SELECT * FROM {$this->table()} AS edition
                INNER JOIN rel_publ_edition AS publ_edition ON (edition.id_edition = publ_edition.id_edition)
                WHERE publ_edition.id_publ in ( {$idList} )
            ");

            $result = array();

            foreach ($res as $row) {
                $result[$row['id_publ']] = array(
                    'id_edition' => $row['id_edition'],
                    'edition_nr' => $row['edition_nr'],
                    'edition_year' => $row['edition_year'],
                    'edition_book_nr' => $row['edition_book_nr'],
                    'book_nr' => $row['book_nr'],
                    'book_month' => $row['book_month'],
                    'book_year' => $row['book_year'],
                    'subject' => $row['subject'],
                    'chief_nr' => $row['chief_nr'],
                );
            }

            return $result;
        } catch (\Exception $e) {
            throw new \Exception("Błąd odczytu listy z main_editions dla:\"" . $idList . "\"" . $e->getMessage());
        }
    }

    public function addEdition($publicationID, $book_year, $book_month, $subject, $edition_year, $edition_nr, $edition_book_nr, $book_nr, $chief_nr) {
        try {
            if (!$book_year) $book_year = 'null';
            if ($book_month == 0) $book_month = '';
            
            $res = (int) $this->adapter->createStatement("
                INSERT INTO {$this->table()} (
                    edition_year,
                    edition_nr,
                    edition_book_nr,
                    book_nr,
                    book_month,
                    book_year,
                    subject,
                    spec_code,
                    chief_nr,
                    status
                    ) VALUES (
                    '{$edition_year}',
                    '{$edition_nr}',
                    '{$edition_book_nr}',
                    '{$book_nr}',
                    '{$book_month}',
                    {$book_year},
                    '{$subject}',
                    null,
                    '{$chief_nr}',
                    'VIS'
                    ) RETURNING id_edition
	    ")->execute()->current()['id_edition'];
                    
            $this->adapter->createStatement("
                INSERT INTO rel_publ_edition (
                    id_edition,
                    id_publ
                    ) VALUES (
                    {$res},
                    {$publicationID}
                    )
	    ")->execute();
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . 'Nie udało się zapisać edycji czasopisma. ' . $e->getMessage());
        }
    }

    public function updateEdition($editionId, $book_year, $book_month, $subject, $edition_year, $edition_nr, $edition_book_nr, $book_nr, $chief_nr) {
        try {
            if (!$book_year) $book_year = 'null';
            if ($book_month == 0) $book_month = '';
            $res = $this->adapter->createStatement("
				UPDATE {$this->table()} SET 
                                book_year = {$book_year},
                                book_month ='{$book_month}',
                                subject = '{$subject}',
                                edition_year = '{$edition_year}',
                                edition_nr = '{$edition_nr}',
                                edition_book_nr ='{$edition_book_nr}',
                                book_nr = '{$book_nr}',
                                chief_nr = '{$chief_nr}'
				WHERE id_edition = {$editionId}
			")->execute();

            if ($res->getAffectedRows() == 1) return true;
            return false;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . 'Nie udało się nadpisać edycji czasopisma. ' . $e->getMessage());
        }
    }

    public function getEditionIdForPublication($PublicationID) {
        try {
            return (int)$this->get("SELECT id_edition FROM rel_publ_edition WHERE id_publ = {$PublicationID}")->current()['id_edition'];
        } catch (\Exception $e) {
            throw new \Exception("Błąd odczytu id_edition z rel_publ_edition dla publikacji :\"" . $PublicationID . "\"" . $e->getMessage());
        }
    }

    public function getEditionForPublication($PublicationID) {
        $result = $this->getEditions($PublicationID);
        if (isset($result[$PublicationID])) {
            return $result[$PublicationID];
        } else {
            return array(
                'edition_nr' => null,
                'edition_book_nr' => null,
                'book_nr' => null,
                'book_month' => null,
                'book_year' => null,
                'subject' => null,
                'edition_year' => null,
                'chief_nr' => null,
            );
        }
    }

}

?>