<?php

namespace Model;

use System\Database\AbstractTable;

class MainFile extends AbstractTable {

    protected $table = 'main_file';
    protected $tableAlias = 'mf';

    public function getAll() {
        $result = $this->adapter->createStatement("SELECT {$this->tableAlias}.* FROM {$this->table} AS {$this->tableAlias}")->execute();
        return $result->fetchAll();
    }

    public function getRowsForQuery($where = array(), $order = array(), $limit = 1, $page = 0) {
        try {
            $offset = $limit * $page;

            $parsedQuery = $this->parseQuery($where, $order);
            $where = $parsedQuery['where'];
            $order = $parsedQuery['order'];

            $query = "SELECT {$this->tableAlias}.* FROM {$this->table} AS {$this->tableAlias}
				$where
				" . (null !== $order ? 'ORDER BY ' . $order : '' ) . "
				LIMIT $limit OFFSET $offset;";

            $res = $this->adapter->createStatement($query)->execute();

            $result = array();
            foreach ($res as $row) {
                $result[] = $row;
            }

            return $result;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd sql.' . pg_last_error() . '. ' . $e->getMessage());
        }
    }

    public function getRow($ID) {
        try {
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE {$this->table}.id = " . ((int) $ID) . ' LIMIT 1')->execute();

           if ($res->count() > 0) {
                return $res->current();
            } else {
                return null;
            }
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd odczytu pliku "' . $ID . '"');
        }
    }

    public function getRowByFileName($fileName) {
        try {
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE {$this->table}.name = '" . ((string) $fileName) . "' LIMIT 1")->execute();

            if ($res->count() > 0) {
                return $res->current();
            } else {
                return null;
            }
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd odczytu pliku');
        }
    }

    public function count($where = array()) {
        try {
            $parsedQuery = $this->parseQuery($where);
            $where = $parsedQuery['where'];

            $res = $this->adapter->createStatement("SELECT count(1) as total FROM {$this->table} AS {$this->tableAlias} $where")->execute();

            return (int) $res->current()['total'];
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd sql.' . pg_last_error() . '. ' . $e->getMessage());
        }
    }

    protected function parseQuery($whereAbstract = array(), $orderAbstract = array()) {
        $where = '';
        $order = null;

        foreach ($whereAbstract as $col => $cond) {
            if ($col == 'id') {
                $cond = (int) $cond;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.{$col} = $cond ";
            } elseif ($col == 'name') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.{$col} LIKE '%$cond%' ";
            } elseif ($col == 'type') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.{$col} LIKE '%$cond%' ";
            } elseif ($col == 'size_from') {
                $cond = (int) $cond;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.size >= $cond ";
            } elseif ($col == 'size_to') {
                $cond = (int) $cond;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.size <= $cond ";
            } elseif ($col == 'add_date_min') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                if (is_numeric(str_replace('/', '', $cond))) {
                    $where .= " {$this->tableAlias}.add_date >= '" . $cond . " 00:00:00' ";
                } else {
                    $where .= " 1 = 2 ";
                }
            } elseif ($col == 'add_date_max') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                if (is_numeric(str_replace('/', '', $cond))) {
                    $where .= " {$this->tableAlias}.add_date <= '" . $cond . " 23:59:59' ";
                } else {
                    $where .= " 1 = 2 ";
                }
            }
        }

        foreach ($orderAbstract as $col => $cond) {
            if (strlen($order)) {
                $order .= ',';
            }

            $order .= "{$this->tableAlias}.{$col} $cond";
        }

        return array(
            'where' => $where,
            'order' => $order
        );
    }

    public function insertFile($file) {
        try {
            $ID = (int) $this->adapter->createStatement("INSERT INTO {$this->table} (name, type, size, hdd_path, url_path) VALUES ('{$file['name']}', '{$file['type']}', {$file['size']}, '{$file['hddPath']}', '{$file['urlPath']}') RETURNING id")->execute()->current()['id'];

            if ($ID > 0) {
                return $ID;
            } else {
                return null;
            }
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . pg_last_error($this->adapter->getDriver()->getConnection()->getResource()) . '. Błąd przy updacie');
        }
    }

    public function outdateFile($name, $newName, $hddPath, $urlPath) {
        try {
            $this->adapter->createStatement("UPDATE {$this->table} SET name = '{$newName}', hdd_path = '{$hddPath}{$newName}', url_path= '{$urlPath}{$newName}' WHERE name = '{$name}'")->execute();
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . pg_last_error($this->adapter->getDriver()->getConnection()->getResource()) . '. Błąd przy updacie');
        }
    }

}

?>
