<?php

namespace Model;

use System\Database\AbstractTable;

class MainImageAvatar extends AbstractTable
{

    protected $table = 'main_image_avatar';
    protected $tableAlias = 'mia';

    public function getImage($image)
    {
        $res = $this->adapter->createStatement("SELECT * FROM $this->table WHERE image = '$image'")->execute();

        if (is_array($data = $res->current())) {
            return $data;
        }

        return null;
    }

    public function insertFile($name, $type_id, $image_big_id, $im)
    {
        $sql = "INSERT INTO main_image_avatar (avatar_name, type, status, image, from_file) VALUES " .
            "('$name', $type_id, 'VIS', '$image_big_id', '$im') RETURNING avatar_id";

        $res = $this->adapter->createStatement($sql)->execute()->current();

        return (int)$res['avatar_id'];
    }

    public function getImageById($imageId, $allData = false)
    {
        if (12 == strlen($imageId)) {
            $field = 'image';
        } else {
            $field = 'avatar_id';
        }

        $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE $field = '$imageId'")->execute();

        if (is_array($data = $res->current())) {
            return $allData ? $data : $data['image'];
        }

        return null;
    }

    public function getImageByFromFile($fromFile)
    {
        $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE from_file = '{$fromFile}'")->execute();

        if (is_array($data = $res->current())) {
            return $data;
        }

        return null;
    }

    public function activateImage($ID)
    {
        try {
            $this->adapter->createStatement("UPDATE {$this->table} SET status = 'VIS' WHERE avatar_id = {$ID}")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function inactivateImage($ID)
    {
        try {
            $this->adapter->createStatement("UPDATE {$this->table} SET status = 'HID' WHERE avatar_id = {$ID}")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function changeDimage($ID, $dimage)
    {
        try {
            $this->adapter->createStatement("UPDATE {$this->table} SET image = '{$dimage}' WHERE avatar_id = {$ID}")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function changeGroup($ID, $group)
    {
        try {
            $this->adapter->createStatement("UPDATE {$this->table} SET type = {$group} WHERE avatar_id = {$ID}")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function deleteImage($ID)
    {
        try {
            $this->adapter->createStatement("DELETE FROM {$this->table} WHERE avatar_id = {$ID}")->execute();

            return true;
        } catch (\Exception $Exception) {
            return false;
        }
    }

    public function getImagesForType($typeId)
    {
        try {
            $typeId = (int)$typeId;
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE type = $typeId")->execute();
            $result = array();

            foreach ($res as $row) {
                $result[] = $row;
            }

            return $result;
        } catch (\Exception $e) {
            throw new \Exception("Błąd pobierania avatarów dla podanego tytpu. \$typeId = \"{$typeId}\". " . $e->getMessage());
        }
    }

    public function getRowsForQuery($where = array(), $order = array(), $limit = 1, $page = 0)
    {
        try {
            $offset = $limit * $page;

            $parsedQuery = $this->parseQuery($where, $order);
            $where = $parsedQuery['where'];
            $order = $parsedQuery['order'];

            $query = "SELECT {$this->tableAlias}.*, dict_avatar_type.*, dimage.* FROM {$this->table} AS {$this->tableAlias}
                      INNER JOIN dict_image_avatar_type AS dict_avatar_type ON ({$this->tableAlias}.type = dict_avatar_type.id)
                      INNER JOIN main_dimages AS dimage ON ({$this->tableAlias}.image = dimage.image_name)
                $where
                " . (null !== $order ? 'ORDER BY ' . $order : '') . "
                LIMIT $limit OFFSET $offset;";

            $res = $this->getAdapter()->createStatement($query)->execute();

            $result = array();
            foreach ($res as $row) {
                $result[] = $row;
            }

            return $result;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd sql.' . pg_last_error() . '. ' . $e->getMessage());
        }
    }

    public function count($where = array())
    {
        try {
            $parsedQuery = $this->parseQuery($where);
            $where = $parsedQuery['where'];

            $res = $this->adapter->createStatement(
                "SELECT count(1) as total FROM {$this->table} AS {$this->tableAlias}
                      INNER JOIN dict_image_avatar_type AS dict_avatar_type ON ({$this->tableAlias}.type = dict_avatar_type.id)
                      INNER JOIN main_dimages AS dimage ON ({$this->tableAlias}.image = dimage.image_name)
                      $where"
            )->execute();

            return (int)$res->current()['total'];
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd sql.' . pg_last_error() . '. ' . $e->getMessage());
        }
    }

    protected function parseQuery($whereAbstract = array(), $orderAbstract = array())
    {
        $where = '';
        $order = null;

        foreach ($whereAbstract as $col => $cond) {
            if ($col == 'avatar_id') {
                $cond = (int)$cond;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.{$col} = $cond ";
            } elseif ($col == 'avatar_name') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " {$this->tableAlias}.{$col} LIKE '%$cond%' ";
            } elseif ($col == 'status') {
                if ($cond == 'true') {
                    $cond = 'VIS';
                } elseif ($cond == 'false') {
                    $cond = 'HID';
                }

                if ($cond != 'true,false') {
                    if ($where == '') {
                        $where = ' WHERE ';
                    } else {
                        $where .= " AND ";
                    }
                    $where .= " {$this->tableAlias}.status = '$cond' ";
                }
            } elseif ($col == 'group') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " dict_avatar_type.name LIKE '%$cond%' ";
            } elseif ($col == 'add_date_min') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                if (is_numeric(str_replace('/', '', $cond))) {
                    $where .= " dimage.add_date >= '" . $cond . " 00:00:00' ";
                } else {
                    $where .= " 1 = 2 ";
                }
            } elseif ($col == 'add_date_max') {
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                if (is_numeric(str_replace('/', '', $cond))) {
                    $where .= " dimage.add_date <= '" . $cond . " 23:59:59' ";
                } else {
                    $where .= " 1 = 2 ";
                }
            } elseif ($col == 'width_from') {
                $col = (int)$col;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " dimage.width >= " . $cond;
            } elseif ($col == 'width_to') {
                $col = (int)$col;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " dimage.width <= " . $cond;
            } elseif ($col == 'height_from') {
                $col = (int)$col;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " dimage.height >= " . $cond;
            } elseif ($col == 'height_to') {
                $col = (int)$col;
                if ($where == '') {
                    $where = ' WHERE ';
                } else {
                    $where .= " AND ";
                }

                $where .= " dimage.height <= " . $cond;
            }
        }

        foreach ($orderAbstract as $col => $cond) {
            if (strlen($order)) {
                $order .= ',';
            }

            if ($col == 'group') {
                $order .= "dict_avatar_type.name $cond";
            } elseif ($col == 'add_date') {
                $order .= "dimage.add_date $cond";
            } elseif ($col == 'dimensions') {
                $order .= "dimage.width*dimage.height $cond";
            } else {
                $order .= "{$this->tableAlias}.{$col} $cond";
            }
        }

        return array(
            'where' => $where,
            'order' => $order
        );
    }

}
