<?php

namespace Model;

use System\Database\AbstractTable;
use Zend\Db\ResultSet\ResultSet;
use Zend\Paginator\Adapter\DbSelect as PaginatorAdapter;
use Zend\Db\Sql\Select;

class MainMiscForms extends AbstractTable {

    protected $table = 'main_misc_forms';

    public function getByFormName($formName, $order = 'ORDER BY id DESC') {
        try {
            $formName = (string) $formName;
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE form_name = '{$formName}' {$order}")->execute();

            if (!$res->count())
                return false;

            $resultSet = new ResultSet;
            $resultSet->initialize($res);

            return $resultSet;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function isUserFillForm($formName, $userId) {
        try {
            $userId = (int) $userId;
            $res = $this->adapter->createStatement("
				SELECT 1 FROM {$this->table} WHERE form_name = '{$formName}' AND main_user_id = {$userId}
			")->execute();


            if (!$res->count())
                return false;
            return true;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function searchForms($where, $order, $limit) {
        try {
            $query = "SELECT misc_form.*, \"user\".login AS login, user_pl.first_name AS first_name, user_pl.last_name AS last_name, user_pl.pwz AS pwz FROM {$this->table} AS misc_form 
            INNER JOIN main_users AS \"user\" ON (misc_form.main_user_id = \"user\".id)
            INNER JOIN pl_users AS user_pl ON (\"user\".id = user_pl.user_id)";

            if ($where) {
                $query .= " WHERE {$where}";
            }

            $query .= " {$order} {$limit}";

            $res = $this->adapter->createStatement($query)->execute();

            if (!$res->count())
                return false;

            $resultSet = new ResultSet;
            $resultSet->initialize($res);

            return $resultSet;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function count() {
        try {
            $query = "SELECT * FROM {$this->table}";

            if ($where) {
                $query .= " WHERE {$where}";
            }

            $query .= " {$order} {$limit}";
            $count = (int) $this->adapter->createStatement($query)->execute()->count();
            if (!$count || $count < 0) {
                return 0;
            } else {
                return $count;
            }
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function getPaginator($data = array(), $order = array('name' => 'id', 'type' => 'desc')) {
        $select = new Select;
        $select->from($this->table)->order($order['name'] . ' ' . $order['type']);

        return new MainMiscFormsPaginator($select, $this->adapter);
    }

}

class MainMiscFormsPaginator extends PaginatorAdapter {
    
}

?>