<?php

namespace Model;

use System\Database\AbstractTable;
use Zend\Db\ResultSet\ResultSet;
use Zend\Paginator\Adapter\DbSelect as PaginatorAdapter;
use Zend\Db\Sql\Select;

class MainMiscSettings extends AbstractTable {

    protected $table = 'main_misc_settings';
    protected $answersTable = 'main_misc_forms';

    public function getById($id) {
        try {
            $id = (int) $id;
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE int = {$id}")->execute();

            if (!$res->count())
                return false;

            return $res->current();
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function getSettings($name) {
        try {
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE name = '{$name}'")->execute();

            if (!$res->count())
                return false;

            return $res->current();
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function searchSettings($where, $order, $limit) {
        try {
            $query = "SELECT *,
            (
                SELECT COUNT(id) FROM {$this->answersTable} AS form
                WHERE setting.form_name = form.form_name
            ) AS answers_amount 
            FROM {$this->table} AS setting";

            if ($where) {
                $query .= " WHERE {$where}";
            }

            $query .= " {$order} {$limit}";

            $res = $this->adapter->createStatement($query)->execute();

            if (!$res->count())
                return false;

            $resultSet = new ResultSet;
            $resultSet->initialize($res);

            return $resultSet;
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function count() {
        try {
            $query = "SELECT *,
            (
                SELECT COUNT(id) FROM {$this->answersTable} AS form
                WHERE setting.form_name = form.form_name
            ) AS answers_amount 
            FROM {$this->table} AS setting";

            if ($where) {
                $query .= " WHERE {$where}";
            }

            $query .= " {$order} {$limit}";
            $count = (int) $this->adapter->createStatement($query)->execute()->count();
            if (!$count || $count < 0) {
                return 0;
            } else {
                return $count;
            }
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. ' . $e->getMessage());
        }
    }

    public function getPaginator($data = array(), $order = array('name' => 'int', 'type' => 'desc')) {
        $select = new Select;
        $select->from($this->table)->order($order['name'] . ' ' . $order['type']);

        return new MainMiscSettingsPaginator($select, $this->adapter);
    }

}

class MainMiscSettingsPaginator extends PaginatorAdapter {
    
}

?>