<?php

namespace Model;
use Zend\Db\Adapter\Exception\InvalidQueryException,
	Zend\Paginator\Adapter\DbSelect as PaginatorAdapter;

class MainUsers extends \System\Database\AbstractTable {

	protected $table = 'main_users';



	public function isIdExists( $userId ) {

		$userId = (int)$userId;
		try {


			$res = $this->adapter->createStatement("select * from {$this->table} where id = {$userId}")->execute();

			if( !$res->count() )
				return 0;

			return 0;

		} catch( \Exception $e) {
			return -1;
		}
	}

	public function isLoginExists($userLogin) {

		try {


			$res = $this->adapter->createStatement("select * from {$this->table} where login = {$userLogin}")->execute();

			if( !$res->count() )
				return 0;
			$res['login'];

			//$res = $this->fetchRow(array('login' => $userLogin));

		} catch( \Exception $e) {
			return -1;
		}

		if(!count($res))
			return 0;
		return $res['login'];
	}


    public function isEmailExists($email) {

        try {

            $res = $this->adapter->createStatement("select * from {$this->table} where email = '{$email}' ")->execute();
            $cnt = $res->count();

            return (bool)$res->count();


        } catch( \Exception $e) {
            return -1;
        }

    }





	public function getUserData($userLogin) {

		try {

			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table} WHERE login = '{$userLogin}'
			")->execute();

		} catch( \Exception $e) {
			$res = array();
		}

		if( !$res->count() )
			return array();
		return $res->current();
	}

	public static function filterReturnData( $fields , $allowedFileds , $userId ) {

		// pobranie informacji z tabeli mian_users
		foreach($fields as $name => $value) {
			if(!in_array($name,$allowedFileds)) unset($fields[$name]);
		}

		// pobranie informacji z innych table
		foreach($allowedFileds as $field) {
			// pobranie informacji o specjalizacjach
			if(preg_match('/^spec/',$field)) {

				$availableSpecs = preg_replace('/^specs:/','',$field);
				$availableSpecs = explode(':',$availableSpecs);

				$RelUsersSpec = new \Model\RelUsersSpec();
				$userSpecs = $RelUsersSpec->getUserSpec(
					$userId,
					$availableSpecs
				);

				$fields['specs'] = $userSpecs;



			} elseif($field == 'services') {
				// pobranie informacji o zaakceptowanych us�ugach

				$RelUsersServices = new \Model\RelUsersServices();

				$userServices = $RelUsersServices->getUserServicesEx( $userId );
				$fields['services'] = $userServices;
			}
		}

		return $fields;
	}

	public function checkIsOkIdInUse($okId,$userLogin) {

		$res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE ok_id = '$okId' AND user_login no '$userLogin' limit 1")->execute();

		return count($res);
	}

	public function assignOkId($userLogin,$okId) {

		$res = $this->adapter->createStatement("SELECT ok_id FROM {$this->table} WHERE user_login = '$userLogin'")->execute();
		$res = $res->current();

		if($res['ok_id'] == $okId) return true;

		$res = $this->adapter->createStatement("UPDATE {$this->table} SET ok_id = '$okId' WHERE user_login = '$userLogin'")->execute();

		return true;
	}














	////////////////////////////////////////////// metody dla schematu int_esuap

	public function getUsersList( $statusFrom = null, $statusTo = null) {

		try {

			$res = $this->adapter->createStatement( "
				SELECT * FROM {$this->table()}
			" )->execute();

			$result = array();

			foreach( $res as $row ) {

				$result[] = $row;

			}

			return $result;

		} catch(\Exception $e) {
			throw new \Exception( __METHOD__ . '. Nie udalo si� pobra� danych' );
		}
	}

	public function getNewUsers( $count = null ) {

		return $this->getUsersList( 1, 9 );
	}

	public function getChangedUsers( $count = null ) {

		return $this->getUsersList( 10, 20 );
	}

	public function getAllUsers( $count = null ) {

		return $this->getUsersList( 0, null);
	}

	public function serchUsers( $select , $from , $where , $order , $limit ) {

		try {

			$res = $this->adapter->createStatement("SELECT {$select} FROM {$this->table} {$from} WHERE {$where} {$order} {$limit}")->execute();

			$result = array();

			foreach( $res as $row) {

				$result[] = $row;
			}

			return $result;

		} catch(\Exception $e) {

			throw new \Exception(__METHOD__.'. ');
		}
	}


    public function countUsers($from, $where) {
        if (!$where) {
            try {

                $res = $this->adapter->createStatement("SELECT count(main_users.id) as \"count\" FROM {$from}")->execute();
                $res = $res->current();

                return $res['count'];
            } catch (\Exception $e) {

                throw new \Exception(__METHOD__ . '. ');
            }
        } else {
            try {

                $res = $this->adapter->createStatement("SELECT count(main_users.id) as \"count\" FROM {$from} WHERE {$where}")->execute();
                $res = $res->current();

                return $res['count'];
            } catch (\Exception $e) {

                throw new \Exception(__METHOD__ . '. ');
            }
        }
    }


	/**
	* Zmiana
	*/
	public function changeTrustLevelEx( $usersId , $newTlevel ) {

		try {

			$res = $this->adapter->createStatement("
				UPDATE {$this->table} SET trust_level = {$newTlevel} WHERE id = {$usersId}
			")->execute();

			if( $res->getAffectedRows() == 1)
				return true;

			throw new Exception( 'FALSE' );

		} catch( \Exception $e) {

			throw new \Exception( __METHOD__ . '. Zapis niepowi�d� si�. ' . $e->getMessage() );
		}
	}


	/**
	* Sprawdam czy podanyc onekey_id jest ju�u�ywany
	*/
	public function checkIsOkIdInUseEx( $idUser , $onekeyId ) {

		try {

			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table} WHERE id = {$idUser} and onekey_id = '{$onekeyId}'
			")->execute();

		} catch( \Exception $e) {

			throw new \Exception( __METHOD__ . ". Nie uda�o si� odczyta� danych: idUser='{$idUser}', onekeyId='{$onekeyId}'. ". $e->getMEssage() );
		}
	}


	public function assignOkIdEx( $userId , $okId ) {

		$res = $this->adapter->createStatement("SELECT onekey_id FROM {$this->table} WHERE id = '$userId'")->execute();
		$res = $res->current();

		if($res['onekey_id'] == $okId) return true;

		$res = $this->adapter->createStatement("UPDATE {$this->table} SET onekey_id = '$okId' WHERE id = '$userId'")->execute();

		return true;
	}


	public function getUser( $userId , $all = false) {

		try {


			$userId = (int)$userId;
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table} WHERE id = {$userId}
			")->execute();

			$result = $res->current();

			if( $all && $res->count() ) {
				$lang = strtolower( $result[ 'work_country' ] );

				if( !in_array( $lang , array( 'pl' , 'ru' ) ) ) {

					$lang = 'ot';
				}

				$id = $result[ 'id' ];

				try {

					$res = $this->adapter->createStatement("
						SELECT * FROM {$lang}_users WHERE user_id = {$id}
					")->execute();

				} catch( \Exception $e  ) {

					trigger_error( __METHOD__ . '. ' . $e->getMEssage() );
				}


				if( $res->count() )
					$result = array_merge(
						$result,
						$res->current()
					);
			}

			return $result;

		} catch( \Exception $e ) {

			throw new \Exception( __METHOD__ . 'B��d odczytu danych uzytkownika. ' . $e->getMessage() );
		}
	}


	public function getUserByLogin( $userLogin ) {

		try {

			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table} WHERE trim( login ) = trim( '{$userLogin}' )
			")->execute();

			if( !$res->count() )
				return array();
			return $res->current();

		} catch( \Exception $e ) {

			throw new \Exception( __METHOD__ . '. B��d odczytu danych uzytkownika. ' . $e->getMessage() );
		}
	}


	/**
	 * Pobiera informacje czy u�ytkownik zatwierdzi� regulamin
	 * @param int $userId
	 */
	public function getAcceptRegulationsForUser( $userId ) {

		try {

			$res = $this->adapter->createStatement("
				SELECT cast(regulations as integer) FROM {$this->table} WHERE id = {$userId} 
			")->execute();

			$res = $res->current();

			if( isset( $res['regulations'] ) && $res['regulations'] == 1 )
				return true;
			return false;

	 	} catch( \Exception $e) {

			throw new \Exception( "Nieyudana pr�ba pobrania informacji o akceptacji regulaminu esculapa dla usera o id = '{$userId}' ." . $e->getMessage() );
		}
	}

	/**
	 * Akceptacja regulaminu esculapa
	 * @param int $usersId id u�ytkownika
	 * returns bool
	 * @throws \Exception
	 */
	public function acceptRegulations( $userId ) {

		try {

			$res = $this->adapter->createStatement("
				UPDATE {$this->table} SET regulations = true WHERE id = {$userId}
			")->execute();

			if( $res->getAffectedRows() == 1 ) {
				return true;
			}

			throw new \Exception( 'Nieznany b��d. ' . pg_last_error() );

		} catch( \Exception $e ) {

			throw new \Exception( "Nieydana zmiana statusu zatweirdzenia regulaminu. idusers = '{$userId}'. " . $e->getMEssage() );
		}
	}



	public function setEmailEsc( $userId , $email ) {

		try {

			return $this->update( array( 'email_esc' => $email ) , "id = $userId" );

		} catch( \Exception $e ) {

			throw new \Exception( __METHOD__ . ". " . $e->getMessage() );
		}
	}


	public function searchUsers() {


		$select = new \Zend\Db\Sql\Select;

		$select->from( 'main_users' )
			   ->where( 'login like \'%d%\'' )
			   ->order( 'id desc' );


		return new MainUsersPaginator(
			$select,
			$this->adapter
		);
	}

    public function getUserByID($ID) {
        try {
            $ID = (int) $ID;
            $res = $this->adapter->createStatement("SELECT * FROM {$this->table} WHERE id = {$ID}")->execute();

            if (!$res->count())
                return array();
            return $res->current();
        } catch (\Exception $e) {
            throw new \Exception(__METHOD__ . '. Błąd odczytu danych uzytkownika. ' . $e->getMessage());
        }
    }

    public function getUsersAcceptableForCMS() {
        try {
            $res = $this->adapter->createStatement("SELECT id, login FROM esculap_int.main_users AS esculap_users
            LEFT OUTER JOIN cms.main_users AS cms_users ON (esculap_users.id = cms_users.esc_id)
            WHERE cms_users.user_id IS NULL
            AND esculap_users.password IS NOT NULL
            AND esculap_users.retired = false
            AND esculap_users.trust_level >= 10")->execute();

            $result = array();
            foreach ($res as $row) {
                $result[] = $row;
            }

            return $result;
        } catch (\Exception $e) {
            return array();
        }
    }

    public function getUsersForMainSite() {
        try {
            $res = $this->adapter->createStatement("
				SELECT * FROM esculap_int.main_users
			")->execute();

            $result = array();

            foreach($res as $row) {
                $result[] = $row;
            }

            return $result;

        } catch(\Exception $e) {
            throw new \Exception(__METHOD__);
        }
    }

    public function getUsersForAutocomplete($Login, $page, $pageLimit) {
        $SQL = new \Zend\Db\Sql\Sql($this->adapter);
        $esculapUsers = new \Zend\Db\Sql\TableIdentifier('main_users', 'esculap_int');
        $cmsUsers = new \Zend\Db\Sql\TableIdentifier('main_users', 'cms');

        !(--$page < 0) ? : $page = 0;
        $offset = $page * $pageLimit;

        $where = array(
            new \Zend\Db\Sql\Predicate\IsNull('cms_users.user_id'),
            new \Zend\Db\Sql\Predicate\IsNotNull('esculap_users.password'),
            new \Zend\Db\Sql\Predicate\Expression('"retired" = false'),
            new \Zend\Db\Sql\Predicate\Expression('"trust_level" >= 10'),
            new \Zend\Db\Sql\Predicate\Expression("\"login\" ILIKE '{$Login}%'"),
        );

        $select = $SQL->select(array('esculap_users' => $esculapUsers))
            ->columns(array('id', 'login'))
            ->join(array('cms_users' => $cmsUsers), 'esculap_users.id = cms_users.esc_id', array(), 'LEFT OUTER')
            ->where($where)
            ->order('login asc')->offset($offset)->limit($pageLimit);
        $select = $SQL->prepareStatementForSqlObject($select);
        $resultSet = new \Zend\Db\ResultSet\ResultSet();
        $resultSet->initialize($select->execute());

        $users = array();
        foreach ($resultSet as $result) {
            $users[] = $result->getArrayCopy();
        }

        $select = $SQL->select(array('esculap_users' => $esculapUsers))
            ->columns(array('total' => new \Zend\Db\Sql\Expression('COUNT(*)')))
            ->join(array('cms_users' => $cmsUsers), 'esculap_users.id = cms_users.esc_id', array(), 'LEFT OUTER')
            ->where($where);
        $select = $SQL->prepareStatementForSqlObject($select);

        $resultSet = new \Zend\Db\ResultSet\ResultSet();
        $resultSet->initialize($select->execute());
        $total = (int) $resultSet->current()['total'];

        return array($users, $total);
    }

    public function getMainSiteUsersForAutocomplete($Login, $page, $pageLimit, $mainSiteId) {
        $SQL = new \Zend\Db\Sql\Sql($this->adapter);
        $esculapUsers = new \Zend\Db\Sql\TableIdentifier('main_users', 'esculap_int');
        $mainSiteUsers = new \Zend\Db\Sql\TableIdentifier('main_site_user_access', 'pl_content');

        !(--$page < 0) ? : $page = 0;
        $offset = $page * $pageLimit;

        $where = array(
            new \Zend\Db\Sql\Predicate\Expression('("main_site_users"."main_site_id" != '.$mainSiteId.' OR "main_site_users"."main_site_id" IS NULL)'),
            new \Zend\Db\Sql\Predicate\Expression("\"login\" ILIKE '{$Login}%'"),
        );

        $select = $SQL->select(array('esculap_users' => $esculapUsers))
            ->columns(array('id', 'login'))
            ->join(array('main_site_users' => $mainSiteUsers), 'esculap_users.id = main_site_users.main_user_id', array(), 'LEFT OUTER')
            ->where($where)
            ->order('login asc')->offset($offset)->limit($pageLimit);
        $select = $SQL->prepareStatementForSqlObject($select);
        $resultSet = new \Zend\Db\ResultSet\ResultSet();
        $resultSet->initialize($select->execute());

        $users = array();
        foreach ($resultSet as $result) {
            $users[] = $result->getArrayCopy();
        }

        $select = $SQL->select(array('esculap_users' => $esculapUsers))
            ->columns(array('total' => new \Zend\Db\Sql\Expression('COUNT(*)')))
            ->join(array('main_site_users' => $mainSiteUsers), 'esculap_users.id = main_site_users.main_user_id', array(), 'LEFT OUTER')
            ->where($where);
        $select = $SQL->prepareStatementForSqlObject($select);

        $resultSet = new \Zend\Db\ResultSet\ResultSet();
        $resultSet->initialize($select->execute());
        $total = (int) $resultSet->current()['total'];

        return array($users, $total);
    }

}

class MainUsersPaginator extends PaginatorAdapter {}


?>