<?php

namespace Model;

use System\Database\AbstractTable;

class MainUsersLog extends AbstractTable
{

    protected $table = 'main_users_log';

    public function appendRow($userId, $host, $uri, $referer, $isLoggedIn, $code, $auth_type = 'full')
    {
        try {
            $isLoggedIn = (int)$isLoggedIn ? 'true' : 'false';

            $adapter = $this->adapter;
            $qi = function ($name) use ($adapter) {
                return $adapter->platform->quoteIdentifier($name);
            };
            $fp = function ($name) use ($adapter) {
                return $adapter->driver->formatParameterName($name);
            };

            $sql = 'INSERT INTO ' . $qi($this->table) . ' ( ' .
                $qi('user_id') . ' , ' .
                $qi('host') . ' , ' .
                $qi('uri') . ' , ' .
                $qi('referer') . ' , ' .
                $qi('is_logged') . ' , ' .
                $qi('code') . ' , ' .
                $qi('auth_type') .
                ' ) VALUES (' .
                $fp('userId') . ' , ' .
                $fp('host') . ' , ' .
                $fp('uri') . ' , ' .
                $fp('referer') . ' , ' .
                $fp('isLoggedIn') . ' , ' .
                $fp('code') . ' , ' .
                $fp('auth_type') . ' ) ';

            $statement = $adapter->query($sql);
            $parameters = [
                'userId'     => $userId,
                'host'       => $host,
                'uri'        => $uri,
                'referer'    => $referer,
                'isLoggedIn' => $isLoggedIn,
                'code'       => $code,
                'auth_type'  => $auth_type
            ];

            $res = $statement->execute($parameters);

            if (!$res->getAffectedRows()) {
                return false;
            }

            return true;

        } catch (\Exception $e) {
            trigger_error($e->getMessage());

            return -1;
        }
    }
}
