<?php

namespace Model;

use System\Database\AbstractTable;

class PostfixMailbox extends AbstractTable {
    protected $table = 'mailbox';

    public function hasMailbox( $userId ) {
		
		try {
			
			$res = $this->select( array( 'user_id' => (int)$userId ) );
			if( $res->count() )
				return true;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
    } 
	
	public function createMailBox( $username , $userlogin , $password , $name , $maildir , $quota , $domain , $userId ) {		
		
		try {
			
			$res = $this->insert( array(
				'username' => $username, 	
				'userlogin' => $userlogin, 	
				'password' => $password,
				'name' => $name,
				'maildir' => $maildir,
				'quota' => $quota,
				'domain' => $domain,
				'created' => 'now()',
				'active' => 'true',
				'user_id' => $userId
			));
			
			if( $res )
				return true;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function deleteMailbox( $userId ) {
		
		try {
			
			return $this->delete( array( 'user_id' => (int)$userId ) );
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function isEmailUnique( $email ) {
		
		try {
			
			$res = $this->select( array( 'username' => $email ) );
			
			if( 0 == (int)$res->count() )
				return true;
			return false;
			
		} catch( \Exception $e ) { 
			
			throw new \Exception( 'Nieudało się sprawdzić unikalności adresu email. ' . $e->getMessage() );
		}
	}
}

?>