<?php

namespace Model;

use System\Database\AbstractTable;

class RelBcElementTarget extends AbstractTable {
	protected $table = 'rel_bc_element_target';
	
	protected $rules = array(
		'main_bc_element_id' => 'elementid',
		'dict_bc_element_target_type_id' => 'target_type'
	);

	public function setTarget( $elementId , $targetTypeId , array $target , $delete = true ) {
		
		try {
			
			if( $delete ) { 
				$res = $this->adapter->createStatement("
					DELETE FROM {$this->table()} where main_bc_element_id = {$elementId}
					
				")->execute();
			}
			
			$insertStr = '';
			foreach( $target as $t ) {
				
				if( strlen( $insertStr ) ) {
					$insertStr .= ',';
				}
				$insertStr .= $t;
			}
			
			$insertStr = "'{{$insertStr}}'";
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} ( main_bc_element_id , dict_bc_element_target_type_id , code ) VALUES ( {$elementId} , {$targetTypeId} , {$insertStr} )
			")->execute();
			
			if( 1 == $res->getAffectedRows() )
				return true;
			return false;
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function setTargetArr( $data ) {
		
		try {
			
			$idList = array();
			
			foreach( $data as $data_ ) {
				$idList[] = (int)$data_[ 'elementid' ];
			}
			
			$idList = implode( ',' , $idList );
			
			$res = $this->adapter->createStatement("
				DELETE FROM {$this->table()} where main_bc_element_id in ( {$idList} )
			")->execute();
			
			foreach( $data as $targetData ) {
				
				$this->setTarget(
					$targetData[ 'elementid' ],
					$targetData[ 'targetid' ],
					$targetData[ 'target' ],
					false
				);
				
			}
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function getTarget( $elementId ) {
		
		try {
			
			if( is_array( $elementId ) ) {
				foreach( $elementId as $k => $v ) {
					
					$elementId[ $k ] = (int)$v;
				}
				
				$elementId = implode( ',' , $elementId );
			} else {
			
				$elementId = (int)$elementId;
			}
			
			$res = $this->get("
				SELECT main_bc_element_id , dict_bc_element_target_type_id , array_to_string( code , ',' ) as code FROM {$this->table()} WHERE main_bc_element_id in ( {$elementId} )
			");
			
			return $this->translate( $res );
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __method__ . '. ' . $e->getMessage() );
		}	
	}
}

?>