<?php

namespace Model;

use System\Database\AbstractTable;

class RelContentCollection extends AbstractTable {
	protected $table = 'rel_content_collection';
	
	protected $rules = array(
		'main_content_id' => 'content_id',
		'main_collection_id' => 'collection_id',
		'lang_id' => 'lang'
	);
	
	public function getAll() {
		
		try {
			
			$res = $this->get("
				SELECT * FROM {$this->table()} ORDER BY name ASC
			");
			
			return $this->translate( $res );
			
		} catch( \Eexception $e ) {
			
			throw new \Exception( __METHOD__ .  '. ' . $e->getMessage() );
		}
	}
	
	
	public function getCollections( $idList ) {
		
		try {
			
			if( !is_array( $idList ) || !count( $idList ) ) {
				$idList = array( 0 );
			}
			
			$_idList = implode( ',' , $idList );
			$res = $this->get("
				SELECT * FROM {$this->table()} WHERE main_content_id in ( {$_idList})
			");
			
			$result = array();
			foreach( $idList as $key => $val ) {
				
				$result[ $val ] = array();
			}
			
			foreach( $res as $row ) {
				
				$result[ $row[ 'main_content_id' ] ][] = $row[ 'main_collection_id' ];
			}
			
			return $result;
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function setContentCollection( $contentId , $lang , $collectionsIdList = array() ) {
		
		try {
			
			$this->adapter->createStatement("
				DELETE FROM {$this->table()} WHERE main_content_id = {$contentId} AND lang_id = '{$lang}'
			")->execute();
			
			$insertData = "";
			
			foreach( $collectionsIdList as $collectionId ) {
				if( 1 > (int)$collectionId ) continue;
				
				if( strlen( $insertData ) ) 
					$insertData .= ', '; 
				
				$insertData .= "( {$contentId} , '{$lang}' , {$collectionId} )";
			}
			
			
			if( !strlen( $insertData ) )
				return;
			
			$this->adapter->createStatement("
				INSERT INTO {$this->table()} ( main_content_id , lang_id , main_collection_id ) VALUES {$insertData}
			")->execute();
			
		} catch( \Exception $e ) {
			
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		} 
	}
}	


?>