<?php

namespace Model;

use System\Database\AbstractTable,
	Zend\Db\Sql\Select,
	Zend\Db\Sql\Expression;

class RelContentQuizAnswer extends AbstractTable {
	protected $table = 'rel_content_quiz_answer';

	public function getUserAnswer( $contentId , $langId  , $userId = null ) {
		
		try {
			
			$langId = strtoupper( $langId );
			
			$select = new Select;
			$select->from( $this->table )
				   ->join( 'ext_content_quiz' , 'ext_content_quiz.answer_no = rel_content_quiz_answer.answer_no' , array( 'answer_description' => 'description' ) )
				   ->where( array( $this->table.'.content_id' => (int)$contentId , $this->table.'.lang_id' => $langId ) );
			
			if( null !== $userId )
				$select->where( array( $this->table.'.main_users_id' => (int)$userId ) );
			
			$res = $this->selectWith( $select );
			if( !$res->count() )
				return false;
				
			return $res->current()->getArrayCopy();
		
		} catch( \Exceptoin $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function registerAnswer( $contentId , $langId , $userId , $answerNo ) {
		
		try {
		
			$res = $this->insert(array(
				'content_id' => $contentId,
				'lang_id' => $langId,
				'main_users_id' => $userId,
				'answer_no' => $answerNo
			));
			
			if( 0 < $this->lastInsertValue )
				return false;
			return true;
			
		} catch( \Exceptoin $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function getUserAnswers( $answerNo , $order = array( 'date' => 'asc' ) ) {
	
		try {
			
			$select = new Select;
			$select->from( $this->table )
				   ->join(  array( 'mu' => 'esculap_int.main_users' ) , "mu.id = {$this->table}.main_users_id" , array( 'login' ) )
				   ->where( array( "answer_no" => $answerNo ) )
				   ->order( $order );
			
			$res = $this->selectWith( $select );
			return $res->toArray();
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
}

?>