<?php

namespace Model;

use System\Database\AbstractTable,
	Zend\Db\Sql\Select;

class RelContentQuizAnswerUser extends AbstractTable {
	protected $table = "rel_content_quiz_answer_user";
	
	public function getUserAnswers( $answerNo , $limit = null , $order = array( 'date' => 'asc' ) ) {
	
		try {
			
			$select = new Select;
			$select->from( $this->table )
				   ->where( array( "answer_no" => $answerNo ) )
				   ->order( $order );
			
			if( null !== $limit )
				$select->limit( (int)$limit );
			
			$res = $this->selectWith( $select );
			return $res->toArray();
		
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
}

?>