<?php

namespace Model;

use System\Database\AbstractTableContent;

class RelContentSpec extends AbstractTableContent {
	
	
	protected $table = 'rel_content_spec';
	
	public function addSpecsFotrContent($contentId,$specList) {
		
		try {
			
			if(!is_array($specList) && !strlen($specList)) {
				throw new \Exception("Brak listy specList");
			} elseif(!is_array($specList)) {
				$specList = array($specList);
			}
			
			$q = "INSERT INTO {$this->table()} (content_id,spec_code) VALUES ";
			
			$i = 0;
			foreach($specList as $specRow) {
				
				if($i++ > 0) {
					$q .= ', ';
				}
				$q .= "($contentId,'{$specRow}')";
			}
			
			$res = $this->adapter->createStatement($q)->execute();
			
			return true;
		
		} catch(\Exception $e) {
			throw new \Exception(__METHOD__.'. '.$e->getMessage());
		}
	}
	
	public function getSpecsForContent( $id ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} WHERE content_id = {$id}
			")->execute();
			
			$result = array();
			
			foreach( $res as $row) {
				$result[] = $row[ 'spec_code' ];
			}
			
			return $result;
			
		} catch( \Exception $e) {
			
			throw new \Exception( __METHOD__ . '. Nieudało się wybrać specializacji dla in = "' . $id . '"' );
		}	
	}
	
	public function getSpecsForContentEx( $id ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()}, {$this->table( 'dict_spec' )} 
				WHERE content_id = {$id} AND {$this->table()}.spec_code = {$this->table( 'dict_spec' )}.spec_code
			")->execute();
			
			$result = array();
			
			foreach( $res as $row) {
				$result[] = array(
					'code' => $row[ 'spec_code' ],
					'name' => $row[ 'mdm_name' ]
 				);
			}
			
			return $result;
			
		} catch( \Exception $e) {
			
			throw new \Exception( __METHOD__ . '. Nieudało się wybrać specializacji dla in = "' . $id . '"' );
		}	
	}
	
	
	
	
	
	
	public function setSpecsForContent( $contentId , $specsList , $langId ) {
		
		try {
			
			if( !is_array( $specsList ) ) {
				$specsList = array();
				
				//throw new \Exception( 'argument specsList musi być tablicą' );
			}
			
			foreach( $specsList as $k => $test) {
				if( !is_string( $test ) ) {
					throw new \Exception( 'wartości tablicy argumentu specsList puszą być stringami' );
				}
				
				$specsList[ $k ] = strtoupper( $test );
			}
			
			$contentid = (int)$contentId;
			
			// usówam specializacje przypisane aktualnie jeśli istnieją
			$res = $this->adapter->createStatement("
				DELETE FROM {$this->table()} WHERE content_id = {$contentId} AND LOWER( lang_id ) = LOWER( '{$langId}' )
			")->execute();
			
			foreach( $specsList as $spec ) {
				
				if( !strlen( $spec ) ) continue;
				
				$this->adapter->createStatement("
					INSERT INTO {$this->table()} ( content_id , spec_code , lang_id ) VALUES ( {$contentId} , '{$spec}' , '{$langId}' )
				")->execute();
			}
			
		} catch( \Exception $e) {
			throw new \Exception( __METHOD__ . ". Przypisywanie specializacji do kontentu niepowiodło się. contentId =\"{$contentId}\" , specsList = \" " . implode( ',' , $specsList ) . "\". " . $e->getMessage() );
		}	
	}
	
	
	public function getSpecsNamesForContent( $contentId ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} rcs , {$this->table( 'dict_spec' )} dc
				WHERE rcs.spec_code = dc.spec_code AND rcs.content_id = {$contentId}
			")->execute();
			
			$result = array();
			foreach( $res as $row ) {
				
				$result[] = $row[ 'mdm_name' ];
			}
			
			return $result;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. Nieudana próba pobrania specializacji. ' . $e->getMessage() );
		}
	}
}

?>