<?php

namespace Model;
use \Zend\Db\Adapter\Exception\InvalidQueryException;
use \Zend\Db\Sql\Where;

class RelUsersSpec extends \System\Database\AbstractTable {
	
	protected $table = 'rel_users_spec';
	
	/**
	* Zwraca tablicę asocjacyjną specializacji uzytkownika
	*/
	public function getUserSpec( $userId , $specTypes = null ) {
		if(!is_array($specTypes)) $specTypes = null; 
		if(is_null($specTypes)) {
			$specTypes  = array(null);
		}
			
		try {
			
			
			$res = $this->adapter->createStatement("
				SELECT * 
				FROM {$this->table} 
				WHERE user_id = {$userId} " . ( count( $specTypes ) && null !== $specTypes[ 0 ] ? "AND spec_type in( " . preg_replace( '/([a-zA-Z_0-9]+)/' , "'$1'" , implode( "," , $specTypes ) ). " ) " : "" ) . "
			")->execute();
			
			//$res = $res->current();
			
			//$res = $this->fetchAll(array('user_login' => $,$Where->in('spec_type',$specTypes)));		
			
			
			if( !$res->count() ) return null;
			
			$result = array_flip($specTypes);
			
			foreach($result as $k => $v) { $result[$k] = array(); }
			
			foreach($res as $value) {
			
				
				$result[$value['spec_type']][] = $value['spec_code'];
			}
			
			return $result;
			
		} catch( \Exception $e) {
			
			return -1;
		}
	}
	
	
	public function getSpecsForUser($userLogin) {
		
		$res = $this->adapter->createStatement("
			SELECT ds.mdm_name as spec_code,rus.spec_type 
			FROM {$this->table} rus, dict_spec ds
			WHERE rus.user_login = '$userLogin' AND rus.spec_code = ds.spec_code");
		
		try {
			$res = $res->execute();
			$result = array();
			
			foreach($res as $row) {
				$result[] = $row;
			}
			
			return $result;
			
		} catch(\Exception $e) {
			throw new \Exception(__METHOD__.'. '.$e->getMEssage());
		}
	}
	
	
	public function getSpecsForUserById( $userId ) {
		
		$res = $this->adapter->createStatement("
			SELECT spec_code , spec_type
			FROM {$this->table}
			WHERE user_id  = {$userId}");
		
		try {
			$res = $res->execute();
			$result = array();
			
			foreach($res as $row) {
				$result[] = $row;
			}
			
			return $result;
			
		} catch(\Exception $e) {
			throw new \Exception( __METHOD__ . '. ' . $e->getMEssage() );
		}
	}
}

?>