<?php
namespace Model\TableGateway;

use System\Database\AbstractTable;
use Zend\Db\Sql\TableIdentifier;
use Zend\Stdlib\Hydrator\ClassMethods as ClassMethodsHydrator;
use Zend\Db\ResultSet\HydratingResultSet;
use Model\Entity\ImportantLink as Entity;
use Zend\Db\Sql\Where as Where;
use Zend\Db\Sql\Expression as Expression;
use Zend\Db\ResultSet\ResultSet as ResultSet;

class ImportantLink extends AbstractTable
{

    protected static $tableName = 'rel_collection';
    protected static $schema = 'esculap';
    protected static $alias = 'rel_collection';
    protected static $tableColumns = array();

    public function getAll(array $queryConfig = array())
    {

        $select = $this->sql->select()
            ->join(new TableIdentifier('main_links', 'esculap'), 'rel_collection.id_elementu = main_links.id_link', ['name', 'url', 'descr'])
            ->join(new TableIdentifier('dict_link_type', 'esculap'), 'dict_link_type.link_type_code = main_links.link_type_code', ['link_type_name'])
            ->order('main_links.name ASC');

        $where = new Where();
        $where->equalTo('rel_collection.id_kolekcji', 1158)->equalTo('main_links.status', 'VIS');
        $select->where($where);

        if (isset($queryConfig['limit'])) {
            $select->limit((int)$queryConfig['limit']);
        }

        if (isset($queryConfig['page']) && isset($queryConfig['limit'])) {
            $queryConfig['page'] < 1 ? $page = 0 : $page = (int)$queryConfig['page'] - 1;
            $offset = $page * $queryConfig['limit'];
            $select->offset($offset);
        }

        $this->resultSetPrototype = new HydratingResultSet(new ClassMethodsHydrator(), new Entity());
        $results = $this->selectWith($select);

        return $results;
    }

    public function countAll()
    {
        $select = $this->sql->select()
            ->join(new TableIdentifier('main_links', 'esculap'), 'rel_collection.id_elementu= main_links.id_link', [])
            ->join(new TableIdentifier('dict_link_type', 'esculap'), 'dict_link_type.link_type_code = main_links.link_type_code', []);

        $where = new Where();
        $where->equalTo('rel_collection.id_kolekcji', 1158)->equalTo('main_links.status', 'VIS');
        $select->where($where);

        $select->columns(array('count' => new Expression("COUNT(*)")));

        $this->resultSetPrototype = new ResultSet();
        $result = $this->selectWith($select)->current();
        $result = (int)$result['count'];

        return $result;
    }

}