<?php

namespace Model;
use System\Database\AbstractTable;

class Tsearch extends AbstractTable {
	protected $table = '';
	
	/**
	 * Tworzy wektor tsearch-a z podanego argumentu
	 * @param string $data dane wejściowe - tekst bez znaczników html
	 * @param string nazwa konfigyracji, która ma zostć wykożystana do parsowania $data
	 * @returns tsvector vektor dla tsearcha
	 */
	public function getVector( $configLanguage , $data ) {
		
		try {
			
			// sprawdzam czy słownik istnieje
			$res = $this->adapter->createStatement("
				SELECT count( 1 ) FROM pg_ts_config WHERE cfgname = '{$configLanguage}'
			")->execute();
			$res = $res->current();
			if( !isset( $res[ 'count' ] ) ) {
				throw new \Exception( "Brak konfiguracji dla configLanguage=\"{$configLanguage}\"" );
			}	
			
			$res = $this->adapter->createStatement("
				SELECT to_tsvector( '{$configLanguage}' , '{$data}' ) as \"tsvector\"
			")->execute();
			$res = $res->current();
			
			$res = $res[ 'tsvector' ];
			
			return $res;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __NAMESPACE__ . ". Nieudało się pobrać wektora dla słownika tsearch. " . $e->getMessage() );
		}
	}
}


?>
