<?php

namespace Model;

use System\Database\AbstractTable,
	Zend\Db\Sql\Where;

class CmsMainUsersSession extends AbstractTable {
	
	protected $table = 'cms.main_users_session';
	
	public function getSession( $code , $timeout ) {
		$this->gc();
		
		try {
			
			$res = $this->get("
				SELECT * FROM {$this->table} WHERE code = '{$code}' AND timeout > NOW()
			");
			
			
			if( $res->count() == 1 ) {
				$data = $res->current();
				
				$timeout = (int)$timeout;
				
				$res = $this->adapter->createStatement("
					UPDATE {$this->table} SET timeout = now() + INTERVAL '1 second' * {$timeout} , refresh = refresh + 1  WHERE code = '{$code}'
				")->execute();
				
				
				return $data;
			}
			
			return false;
			
		} catch( \Exception $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function startSession( $login , $password , $timeout ) {
		
		try {
			
			$CmsMainUsers = new CmsMainUsers;
			 
			if( false !== ( $userData = $CmsMainUsers->login( $login , $password ) ) ) {
				
				$id = (int)$userData[ 'user_id' ];
				$res = $this->adapter->createStatement("
					DELETE FROM {$this->table} WHERE main_users_user_id = {$id}
				")->execute();
				
				$data = serialize( $userData );
				$code = $this->generateCode();
				
				
				
				$res = $this->adapter->createStatement("
					INSERT INTO {$this->table} ( main_users_user_id , start , timeout , code , data ) VALUES
											   ( {$id} , now() , now() + INTERVAL '1 second' * {$timeout} , '{$code}' , '{$data}' )
				")->execute();
				
				
				
				if( $res->getAffectedRows() == 1 ) {
					
					return array(
						'code' => $code,
						'data' => $userData
					);
				}
				
			}
			
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	public function endSession( $code ) {
		
		try { 
			
			$res = $this->adapter->createStatement("
				DELETE FROM {$this->table} WHERE code = '{$code}'
			")->execute();
			
			if( $res->getAffectedRows() == 1 )
				return true;
			return false;
			
		} catch( \Exception $e ) {
		
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	public function regenerateCode( $code ) {
		
		try {
			
			$newCode = $this->generateCode();
			
			$res = $this->adapter->createStatement("
				UPDATE {$this->table} SET code = '{$newCode}' WHERE code = '{$code}'
			")->execute();
			
			if( $res->getAffectedRows() == 1 )
				return $newCode;
			return false;
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	protected function generateCode() {
		
		$charset = array(
			'A' , 'B' , 'C' , 'D' , 'E' , 'F' , 'G' , 'H' , 'I' , 'J' , 'K' , 'L' , 'M' , 'N' , 'O' , 'P' , 'R' , 'S' , 'T' , 'U' , 'W' , 'X' , 'Y' , 'Z' , 
			0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9
		);
		
		try {
			
			for( $i = 0; $i < 10; $i++ ) {
				$code = '';
				
				for( $j = 0; $j < 15; $j++ ) {
					
					$no = rand( 1 , count( $charset ) );
					$code .= $charset[ $no - 1 ];
				}
				
				$res = $this->get("
					SELECT * FROM {$this->table} WHERE code = '{$code}'
				");
				
				
				
				
				if( $res->count() == 0 ) return $code;
			}
			
			throw new \Exception( "Przekroczono limit prób utworzenia kodu" );
		
		} catch( \Exception $e ) {
			
			throw new \Exception(__METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	protected function gc() {
		
		try {
			
			$this->adapter->createStatement("
				DELETE FROM {$this->table} WHERE timeout < now()
			")->execute();
		
		} catch( \Exception $e ) {
			
			//throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
}


?>