<?php

namespace System\Admin\Product;

use System\Admin\Product\AdminProductInterface;

class AdminLGroupProduct implements AdminProductInterface {

    protected $groupId;
    protected $groupName;
    protected $groupDescr = null;
    protected $isActive;

    public function __construct(array $data = array()) {
        $this->setGroupId($data['group_id']);
        $this->setGroupName($data['group_name']);
        $this->setGroupDescr($data['group_descr']);
        $this->setIsActive($data['is_active']);
    }

    public function setGroupId($groupId) {
        $this->groupId = (int) $groupId;
    }

    public function setGroupName($groupName) {
        $this->groupName = (string) $groupName;
    }

    public function setGroupDescr($groupDescr) {
        if (!empty($groupDescr)) {
            $this->groupDescr = (string) $groupDescr;
        } else {
            $this->groupDescr = null;
        }
    }

    public function setIsActive($isActive) {
        $this->isActive = (bool) $isActive;
    }

    public function getGroupId() {
        return (int) $this->groupId;
    }

    public function getGroupName() {
        return (string) $this->groupName;
    }

    public function getGroupDescr() {
        if (!empty($this->groupDescr)) {
            return (string) $this->groupDescr;
        } else {
            return null;
        }
    }

    public function getIsActive() {
        return (bool) $this->isActive;
    }

}

?>
