<?php

namespace System\Admin\Product;

use System\Admin\Product\AdminProductInterface;

class AdminUserProduct implements AdminProductInterface {

    protected $userId;
    protected $userLogin;
    protected $name = null;
    protected $lastname = null;
    protected $escId = null;

    public function __construct(array $data = array()) {
        $this->setUserId($data['user_id']);
        $this->setUserLogin($data['user_login']);
        $this->setName($data['name']);
        $this->setLastname($data['lastname']);
        $this->setEscId($data['esc_id']);
    }

    public function setUserId($userId) {
        $this->userId = (int) $userId;
    }

    public function setUserLogin($userLogin) {
        $this->userLogin = (string) $userLogin;
    }

    public function setName($name) {
        if (!empty($name)) {
            $this->name = (string) $name;
        } else {
            $this->name = null;
        }
    }

    public function setLastname($lastname) {
        if (!empty($lastname)) {
            $this->lastname = (string) $lastname;
        } else {
            $this->lastname = null;
        }
    }

    public function setEscId($escId) {
        if (!empty($escId) && is_numeric($escId)) {
            $this->escId = (int) $escId;
        } else {
            $this->escId = null;
        }
    }

    public function getUserId() {
        return (int) $this->userId;
    }

    public function getUserLogin() {
        return (string) $this->userLogin;
    }

    public function getName() {
        if (!empty($this->name)) {
            return (string) $this->name;
        } else {
            return null;
        }
    }

    public function getLastname() {
        if (!empty($this->lastname)) {
            return (string) $this->lastname;
        } else {
            return null;
        }
    }

    public function getEscId() {
        if (!empty($this->escId) && is_numeric($this->escId)) {
            return (int) $this->escId;
        } else {
            return null;
        }
    }

}

?>
