<?php

namespace System\Authentication;
use System\User\CookieStorage;

class AuthenticationIdentity {
	protected $_data;
	protected $_cookie;
	protected $_login;
	
	public function __construct($data = null) {
		
		if(null !== $data) {
			$this->init($data);
		}
	}
	
	public function init($data) {
		if(is_array($data)) {
			$this->_data = $data;
		}
			
		$this->_login = $this->user_login;
		$this->_cookie = new CookieStorage( $this->_login );
	}
	
	public function setData($data) {
		$this->init($data);
	}
	
	public function setProperty( $propertyName , $propertyValue ) {
		
		$this->_data[ $propertyName ] = $propertyValue;
	}
	
	public function cookie() {
		return $this->_cookie;
	}
	
	public function __get($name) {
		if(isset($this->_data[$name]))
			return $this->_data[$name];
		return null;
	}
	
	public function __set($name, $value) {
		throw new Exception('Obiekt AuthenticationIdentity jest tylko do odczytu!');
	}
}
