<?php

namespace System\Authentication;

use Zend\Authentication\Storage\StorageInterface;

class AuthenticationStorage implements StorageInterface {
	
	protected static $_dbh;
	protected $_data;
	protected $_obj;
	protected $session;
	protected $expiration;
	
	public function __construct( $expiration ) {
		$this->expiration = $expiration;
		
		$this->createObject();
	}
	
	protected function createObject() {
	
		if( !isset( $this->session ) ) {
			
			$this->session = new \Zend\Session\Container( 'AUTH' );
			$this->session->setExpirationSeconds( $this->expiration );
			$this->session->exchangeArray( $_SESSION[ 'AUTH' ] );
		}
		
	}	
	
	public function isEmpty() {
		
		if( !isset( $this->session ) )
			return true;
		return false;
	}
	
	public function read() {
		$this->createObject();
		
		return isset( $this->session ) && 0 < $this->session->count() ? $this->session->getArrayCopy() : array();
	}
	
	public function write( $contents ) {
		$this->createObject();
		
		
		$this->session->exchangeArray( $contents );
	}
	
	public function clear() {
		
		//if( isset( $this->session ) )
			//unset( $this->session );
	}
}
?>