<?php

namespace System\BannerCampaign\Element;

class Banner extends ElementAbstract {
	
	protected $bannerUrl = null;
	protected $url = null;
	protected $name = 'banner';
	protected $bannerMime = null;
	
	protected $functionsToCompare = array( 'banner' , 'url' );
	
	protected $fullFilled = array(
		'bannerUrl',
		'url'
	);
	
	public function parseData( $data ) {
		
		if( isset( $data[ 'bannerUrl' ] ) ) {
			$this->bannerUrl = $data[ 'bannerUrl' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'bannerMime' ] ) ) {
			$this->bannerMime = $data[ 'bannerMime' ];
		}
		
		parent::parseData( $data );
	}
	
	public function getTypeData() {
		return array(
			'bannerUrl' => $this->bannerUrl,
			'url' => $this->url,
			'bannerMime' => $this->bannerMime
		);
	}
	public function setTypeData( $jsonData ) {
		$data = json_decode( $jsonData , true );
		
		if( isset( $data[ 'bannerUrl' ] ) ) {
			$this->bannerUrl = $data[ 'bannerUrl' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'bannerMime' ] ) ) {
			$this->bannerMime = $data[ 'bannerMime' ];
		}
	}
	
	public function setBannerMime( $bannerMime ) {
		
		$this->bannerMime = $bannerMime;
	}
	
	public function getBannerMime() {
		
		return $this->bannerMime;
	}
	
	public function getUrl() {
		return $this->url;
	}
	
	public function getBanner() {
	
		return $this->bannerUrl;
	}
	
	public function toArray() {
		
		return array_merge(
			parent::toArray(),
			array(
				'bannerUrl' => $this->getBanner(),
				'bannerMime' => $this->getBannerMime(),
				'url' => $this->getUrl()
			)
		);
	}	
}


?>