<?php

namespace System\BannerCampaign\Element;

class Billboard extends ElementAbstract {
	
	protected $bannerUrl = null;
	protected $bannerMime = null;
	protected $billboardUrl = null;
	protected $billboardMime = null;
	protected $url = null;
	protected $name = 'billboard';
	
	protected $functionsToCompare = array( 'url' , 'banner' , 'billboard' );
	
	protected $fullFilled = array(
		'bannerUrl',
		'billboardUrl',
		'url'
	);
	
	public function parseData( $data ) {
		
		if( isset( $data[ 'bannerUrl' ] ) ) {
			$this->bannerUrl = $data[ 'bannerUrl' ];
		} if( isset( $data[ 'billboardUrl' ] ) ) {
			$this->billboardUrl = $data[ 'billboardUrl' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'bannerMime' ] ) ) {
			$this->bannerMime = $data[ 'bannerMime' ];
		} if( isset( $data[ 'billboardMime' ] ) ) {
			$this->billboardMime = $data[ 'billboardMime' ];
		}
		
		parent::parseData( $data );
	}
	
	public function getTypeData() {
		
		return array(
			'bannerUrl' => $this->bannerUrl,
			'bannerMime' => $this->bannerMime,
			'billboardUrl' => $this->billboardUrl,
			'billboardMime' => $this->billboardMime,
			'url' => $this->url
		);
	}
	public function setTypeData( $jsonData ) {
		$data = json_decode( $jsonData , true );
		
		if( isset( $data[ 'bannerUrl' ] ) ) {
			$this->bannerUrl = $data[ 'bannerUrl' ];
		} if( isset( $data[ 'billboardUrl' ] ) ) {
			$this->billboardUrl = $data[ 'billboardUrl' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'bannerMime' ] ) ) {
			$this->bannerMime = $data[ 'bannerMime' ];
		} if( isset( $data[ 'billboardMime' ] ) ) {
			$this->billboardMime = $data[ 'billboardMime' ];
		}
	}
	
	public function setBannerMime( $bannerMime ) {
	
		$this->bannerMime = $bannerMime;
	}
	
	public function getBannerMime() {
		
		return $this->bannerMime;
	}
	
	public function getBanner() {
	
		return $this->bannerUrl;
	}
	
	
	public function setBillboardMime( $billboardMime ) {
		
		$this->billboardMime = $billboardMime;
	}
	
	
	public function getBillboardMime() {
		
		return $this->billboardMime;
	}
	
	public function getBillboard() {
	
		return $this->billboardUrl;
	}
	
	public function getUrl() {
		return $this->url;
	}
	
	public function toArray() {
		
		return array_merge(
			parent::toArray(),
			array( 
				'bannerUrl' => $this->getBanner(),
				'bannerMime' => $this->getBannerMime(),
				'billboardUrl' => $this->getBillboard(),
				'billboardMime' => $this->getBillboardMime(),
				'url' => $this->getUrl(),
			)
		);
	}
}

?>