<?php

namespace System\BannerCampaign\Element;

class Content extends ElementAbstract {

	protected $contentId;
	protected $name = 'content';
	
	protected $functionsToCompare = array( 'contentid' );
	
	/**
	 * Właściwości będące wypełniane wyłącznie w przypadku wypełniania przez elementy wyświetlające pobrane z wbserw-a elementów do wyświetlenia 
	 */
	protected $description;
	protected $title;
	protected $image;
	protected $date;
	
	protected $fullFilled = array(
		'contentId'
	);
	
	public function parseData( $data ) {
		
		if( isset( $data[ 'contentId' ] ) ) {
			
			$this->contentId = $data[ 'contentId' ];
			
		} if( isset( $data[ 'description' ] ) ) {
			
			$this->description = $data[ 'description' ];
			
		} if( isset( $data[ 'title' ] ) ) {
			
			$this->title = $data[ 'title' ];
			
		} if( isset( $data[ 'image' ] ) ) {
			
			$this->image = $data[ 'image' ];
		} if( isset( $data[ 'date' ] ) ) {
			
			$this->date = $data[ 'date' ];
		}
		
		parent::parseData( $data );
	}
	
	public function getTypeData() {
	
		return array(
			'contentId' => $this->contentId
		);
	}
	
	
	public function setTypeData( $jsonData ) {
		$data = json_decode( $jsonData , true );
		
		if( isset( $data[ 'contentId' ] ) ) {
			$this->contentId = $data[ 'contentId' ];
		}
	}
	
	public function getDate() {
		
		return $this->date;
	}
	
	
	public function setDate( $date ) {
	
		$this->date = $date;
	}
	
	
	public function getDescription() {
	
		return $this->description;
	}
	
	
	public function getTitle() {
		
		return $this->title;
	}
	
	
	public function getContentId() {
		
		return $this->contentId;
	}
	
	
	public function getImage() {
		
		return $this->image;
	}
	
	
	public function toArray() {
		
		return array_merge(
			parent::toArray(),
			array(
				'content_id' => $this->getContentId()
			)
		);
	}	
}
