<?php

namespace System\BannerCampaign\Element;

class ContentData extends ElementAbstract {

	protected $title;
	protected $content;
	protected $url;
	protected $image;
	protected $name = 'content_data';
	
	
	protected $functionToCompare = array( 'title' , 'content' , 'url' , 'image' );
	
	protected $fullFilled = array(
		'title',
		'content',
		'url',
		'image'
	);
	
	public function parseData( $data ) {
		
		if( isset( $data[ 'title' ] ) ) {
			$this->title = $data[ 'title' ];
		} if( isset( $data[ 'content' ] ) ) {
			$this->content = $data[ 'content' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'image' ] ) ) {
			$this->image = $data[ 'image' ];
		}
		
		parent::parseData( $data );
	}
	
	public function getTypeData() {
	
		return array(
			'title' => $this->title,
			'content' => $this->content,
			'url' => $this->url,
			'image' => $this->image
		);
	}
	public function setTypeData( $jsonData ) {
	
		$data = json_decode( $jsonData , true );
		
		if( isset( $data[ 'title' ] ) ) {
			$this->title = $data[ 'title' ];
		} if( isset( $data[ 'content' ] ) ) {
			$this->content = $data[ 'content' ];
		} if( isset( $data[ 'url' ] ) ) {
			$this->url = $data[ 'url' ];
		} if( isset( $data[ 'image' ] ) ) {
			$this->image = $data[ 'image' ];
		}
	}
	
	public function getTitle() {
		
		return $this->title;
	}
	
	public function getImage() {
		return $this->image;
	}
	
	public function getUrl() {
		return $this->url;
	}
	
	public function getContent() {
		return $this->content;
	}
	
	public function toArray() {
	
		return array_merge(
			parent::toArray(),
			array( 
				'title' => $this->getTitle(),
				'content' => $this->getContent(),
				'url' => $this->getUrl(),
				'image' => $this->getImage()
			)
		);
	}
}
