<?php

namespace System\BannerCampaign\Element;

class DecisionSystem {
	
	public static function decide( $elementsSetCode , $elementsList , $userSpec , &$cookieData = null ) {
		
		if( null == $cookieData ) $cookieData = array();
		 
		
		$_elementsList = array();
		foreach( $elementsList as $element ) {
			if( is_a( $element , 'System\BannerCampaign\Element\ElementAbstract' ) ) {
				
				$_elementsList[] = $element;
			} 
		}
		$elementsList = $_elementsList;
		
		
		// układania elementów
		
		
		$elementsByPlaces = array();
		foreach( $elementsList as $element ) {
			
			
			$elementsByPlaces[ $element->getPlace()->getId() ][] = $element;
		}
		
		/*foreach( $elementsByPlaces as $elemPlace => $elem ) {
			$e =array();
			foreach( $elem as $el )
				$e[] = $el->getElementId();
			
			trigger_error( $elemPlace . ' ' . implode( ',' , $e ) );
		}*/
		
		
		
		
		
		$DictBcElementPlace = new \Model\DictBcElementPlace;
		$placesData = $DictBcElementPlace->getAll();
		
		$placesMaxCollisions = array();
		foreach( $placesData as $elementPlace ) {
			
			$placesMaxCollisions[ $elementPlace[ 'id' ] ] = $elementPlace[ 'max_collisions' ];
		}
		
		try {
			
			$DictBcElementSet = new \Model\DictBcElementSet;
			$placesCfg = $DictBcElementSet->getSetsDescriptions();
			
			\System\BannerCampaign\Element\Extender::setConfigs( $placesCfg );
			
			if( isset( $placesCfg[ $elementsSetCode ] ) ) {
				
				$placesCfg = $placesCfg[ $elementsSetCode ];
			
			} else {
					
				$placesCfg = array();	
			}
			
		} catch( \Exception $e ) {
			
			$placesCfg = array();
		}
		
		
		$elementsList = array();
		foreach( $elementsByPlaces as $placeId => $elementsInPlace ) {
			
			
			/*$e = array();
			foreach( $elementsInPlace as $elem ) 
				$e[] = $elem->getElementId();
			trigger_error( $placeId . ' ' . implode( ',' , $e ) );*/
			
			 
			if( isset( $placesCfg[ $placeId ] ) ) {
				
				$maxCount = $placesCfg[ $placeId ];
				
			} else {
				
				$maxCount = 1;
			}
			
			
			if( count( $elementsInPlace ) > 1 ) {
				
				
				
				$elementsInPlace = self::chooseElement( $elementsInPlace , $userSpec , $maxCount /*$placesMaxCollisions[ $placeId ]*/ , $cookieData );
			}
			
			/*$a = array();
			foreach( $elementsInPlace as $element ) 
				$e[] = $element->getElementId();
			trigger_error( $placeId . ' ' . implode( ',' , $e ) );*/
			
			foreach( $elementsInPlace as $placeElement ) {
			
				if( !isset( $cookieData[ $placeElement->getElementId() ] ) ) {
					
					$cookieData[ $placeElement->getElementId() ] = 1;
					
				} else {
				
					$cookieData[ $placeElement->getElementId() ]++;
				}
				
				$elementsList[] = $placeElement;
			}
		}
		
		
		
		// wypełnienie pustych luk
		foreach( $placesCfg as $elementPlaceId => $neaded ) {
			
			$foundedElements = 0;
			
			// liczę elementy wybrane dla danego miejsca
			foreach( $elementsList as $element ) {
				
				if( $elementPlaceId== $element->getPlace()->getId() )
					$foundedElements++;
			}
			
			
			// jeśli liczba wybranych elementów jest mniejsza niż wymagana liczba do wyświetlenia na stronie to szukam wypełnień
			if( $neaded < $foundedElements )
				continue;
			
			try {
				
				
				$ElementExtender = new \System\BannerCampaign\Element\Extender( $elementsSetCode );
				$ElementExtender->check( $elementPlaceId , $elementsList , $neaded - $foundedElements );
				
				
			} catch( \Exception $e ) {
					
				trugger_error( $e->getMEssage() );
				$this->log( $e->getMessage() );
			}
			
		}
		
		
		
		//var_dump($elementsList);
			
		return $elementsList;
	}
	
	
	protected static function chooseElement( $elements , $userSpecs , $max = 1 , $cookieData = array() ) {
		
		
		// ogromny i niezwykle skomplikowany system decyzyjny...
		// rotacja na zasadzie wyświetlenia elementu o mniejszej liczbie wyświetleń
		
	
		
		/*$e = array();
		foreach( $elements as $element )
			$e[] = $element->getElementId();
		trigger_error( implode( ',' , $e ) );*/
		
		$dataToSort = array();
		
		$SortHelper = new SortHelper();
		
		foreach( $elements as $element ) {
			
			$SortHelper->add(
				new SortObj( 
					isset( $cookieData[ $element->getElementId() ] ) ? $cookieData[ $element->getElementId() ] : 0,
					$element
				)
			);
			
			/*if( isset( $cookieData[ $element->getElementId() ] ) ) {
				
				//trigger_error( $element->getElementId() . ' - ' . $cookieData[ $element->getElementId() ] );
				
				$dataToSort[ $cookieData[ $element->getElementId() ] . '_' . $element->getElementId() ] = $element;
				
			} else {
				
				$dataToSort[ 0 . $element->getElementId() ] = $element;
			}*/
		}
		
		//trigger_error( key( $dataToSort ) );
		
		$dataToSort = $SortHelper->sort();
		
		//ksort( $dataToSort );
		
		//trigger_error( implode( ',' , $cookieData ) );
		
		$choosens = array();
		
		foreach( $dataToSort as $element ) {
			
			if( $max > count( $choosens ) ) {
				
				$choosens[] = $element;
				
			} else {
				
				break;
			}
		}
		
		return $choosens;
	}
	
	
	/**
	 * Przetwarza tablicę otrzymaną z cookie lub gry jest to potrzebne tworzy nową jeśli nie otrzymał nic i jeśli otrzymał cookie a jest już nieaktualne tworzy go od nowa
	 * @param array $data
	 * @return array
	 */
	protected static function cookieDataDecode( $data = null ) {
		
		if( !is_array( $data ) ) {
			$data = array();
		}
	}
}

class SortObj {
	
	protected $val;
	protected $element;
	
	public function __construct( $val , $element ) {
		
		$this->val = $val;
		$this->element = $element;
	}
	
	public function getVal() {
		return $this->val;
	}
	
	public function getElement() {
		return $this->element;
	}
}

class SortHelper {
	
	protected $elements = array();
	
	public function add( SortObj $obj ) {
		
		$this->elements[] = $obj;
		
	}
	
	public function sort() {
		
		$result = $this->elements;
		$i = 0;
		$a = 0;
		
		$list = $this->elements;
		$sortedList = array();
		while( $i < count( $list ) ) {
			if( $a++ > 1000 ) 
				break;
			
			if( !isset( $list[ $i + 1 ] ) )
				break;
			
			if( $list[ $i ]->getVal() > $list[ $i + 1 ]->getVal() ) {
				
				
				$forward = $list[ $i ];
				$backward = $list[ $i + 1];
				
				$list[ $i ] = $backward;
				$list[ $i + 1 ] = $forward;
				
				if( $i > 0 ) {
					
					$i--;
					continue;
				}
			}
			
			$i++;
		}
		
		foreach( $list as $key => $val ) {
			$list[ $key ] = $val->getElement();
			//trigger_error( $key . ' ' . $val->getElement()->getElementId() . ' ' . $val->getVal() );
		}
		
		return $list;
		/*
		$i = 0;
		$a = 0;
		
		while( $i < count( $result ) ) {
			
			if( $a++ > 1000 ) 
				break;
			
			if( $i > 0 ) {
				
				
				if( !isset( $result[ $i + 1 ] ) ) {
					break;
				}
				
				
				if( $result[ $i ]->getVal() > $result[ $i + 1 ]->getVal() ) {
					
					
					$backward = $result[ $i + 1 ];
					$forward = $result[ $i ];
					
					$result[ $i ] = $backward;
					$result[ $i + 1 ] = $forward;
					
					$i--;
					continue;
				}
			}
			
			$i++;
		}
		
		
		
		foreach( $result as $key => $val ) {
				
			trigger_error( $key . ' ' . $val->getElement()->getElementId() . ' ' . $val->getVal() );
			$result[ $key ] = $val->getElement();
		}
		*/
		
		
		return $result;
	}
}


?>