<?php

namespace System\BannerCampaign\Element;

use System\Observer,
	Model\MainBcElementHistory;

class ElementObserver implements Observer {
	
	protected static $dbElement;
	
	protected static function getDbElement() {
		
		if( null == self::$dbElement ) {
			
			self::$dbElement = new MainBcElementHistory;
		}
		
		return self::$dbElement;
	}
	
	public function update( $action , $data ) { 
		
		switch( strtolower( $action ) ) {
			case 'statucchange':
				
				$this->onStatusChange( $data );
				
				break;
			case 'update':
			
				$this->onUpdate( $data );
				
				break;
		}
	}


	protected function onStatusChange( $data ) {
		
		$mbeh = self::getDbElement();
			
		if( empty( $data[ 'element' ] ) ||
			!is_subclass_of( $data[ 'element' ] , 'System\BannerCampaign\Element\ElementAbstract' ) ||
			empty( $data[ 'from' ] ) || 
			empty( $data[ 'to' ] ) ||
			empty( $data[ 'user' ] ) ) {
			
			return false;
		}
		
		// addHistoryEntity( $mainBcElementId , $mainUserId , $data , $description )
		
		$mbeh->addHistoryEntity( 
			$data[ 'element' ]->getElementId(),
			$data[ 'user' ],
			json_encode( array( 'status_change' => array( 'from' => $data[ 'from' ] , 'to' => $data[ 'to' ] ) )  , true ),
			@$data[ 'user' ]
		);
	}
	
	
	public function onUpdate( $data ) {
		
		if( empty( $data[ 'user' ] ) ||
			empty( $data[ 'element' ] ) ||
			empty( $data[ 'data' ] ) ) {
			
			return false;
		}
		
		$mbeh = self::getDbElement();
		
		$mbeh->addHistoryEntity(
			$data[ 'element' ]->getElementId(),
			$data[ 'user' ],
			json_encode( $data[ 'data' ] , true ),
			@$data[ 'description' ]
		);
	}
}

?>