<?php

namespace System\BannerCampaign\Element;

class Extender {
	
	
	protected static $allConfigs;
	protected $inited = false;
	protected $setCode;
	protected $setConfig = array();
	
	
	public function __construct( $setCode ) {
		
		$this->setCode = $setCode;
	}
	
	
	public static function setConfigs( $configsList ) {
		
		if( is_array( $configsList ) )
			self::$allConfigs = $configsList;
	}	
	
	
	protected function init() {
		
		if( false !== $this->init )
			return;
		
		if( null == self::$allConfigs ) {
		
			$DictBcElementSet = new \Mode\DictBcElementSet;
			$setsList = $DictBcElementSet->getSetsDescriptions();
			self::$allConfigs = $setsList;
			
		} else {
			
			$setsList = self::$allConfigs;
		}
		
		if( !isset( $setsList[ $this->setCode ] ) )
			throw new \Exception( __METHOD__ . ". Dla kodu \"{$this->setCode}\" nieznaleziono danych o zestawie elementów" );
		
		$this->setCoifig = $setsList[ $this->setCode ];
	}
	
	
	public function check( $elementPlaceId , &$elements , $freePlaces ) {
		
		// sprawdzam kod zestawu 
		if( 'esc.com.main' == $this->setCode ||
			'esc.com.unsec' == $this->setCode ) {
			
			if( 3 === $elementPlaceId ) {
				
				if( 1 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Zostań użytkownikiem Platformy Edukacyjnej portalu Esculap.com',
						'content' => 'Portal Edukacja zapewnia bezpłatny dostęp do szerokiej wiedzy medycznej. Programy edukacyjne dedykowane są lekarzom konkretnej specjalizacji. Znajdziesz tu certyfikowane kursy realizowane w formie e-learningu, zakończone możliwością zdobycia punktów edukacyjnych, honorowanych przez Naczelną Izbę Lekarską oraz prezentacje e-detailingowe nagradzane publikacjami naukowymi.<br/>Zapraszamy!',
						'url' => 'http://edu.esculap.com',
						'image' => 'PCETRY61TOSG',
						'place' => 3,
						'fake' => true
					));
				
				if( 2 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Zapraszamy na multimedialną platformę esculap.tv',
						'content' => 'Oglądaj filmy medyczne, sprawdź najnowsze wydarzenia, weź udział w szkoleniach.',
						'url' => 'http://esculap.tv',
						'image' => '1MWPOCX4ZN6C',
						'place' => 3,
						'fake' => true
					));
					
			} elseif( 4 === $elementPlaceId ) {
				
				
				/*if( 1 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Odbiór odpadów zgodnie z nową ustawą „śmieciową”',
						'content' => 'Gmina, na której terenie położony jest podmiot leczniczy, nie jest zobowiązana do objęcia go gminnym systemem odbierania odpadów. Tym niemniej rada gminy może, w drodze uchwały stanowiącej akt prawa miejscowego, postanowić o odbieraniu odpadów komunalnych od właścicieli nieruchomości, na których nie zamieszkują mieszkańcy, a powstają odpady komunalne, tj. m.in. przychodni, szpitali, laboratoriów itd.',
						'url' => '/publication/130628/Odbi%C3%B3r_odpad%C3%B3w_zgodnie_z_now%C4%85_ustaw%C4%85_%E2%80%9E%C5%9Bmieciow%C4%85%E2%80%9D',
						'image' => '254',
						'place' => 4,
						'fake' => true
					));
				
				
				if( 2 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Zasady informowania przez lekarzy organów ścigania o możliwości popełnienia przestępstwa „na pacjencie”',
						'content' => 'Na gruncie obowiązujących przepisów prawnych może powstać wątpliwość, czy lekarz jest zobowiązany do poinformowania organów ścigania o zaistniałym przestępstwie, czy powinien uzyskać zgodę na informowanie o możliwości popełnienia przestępstwa, a także czy np. poradnia ginekologiczna jest zobowiązana zawiadomić prokuraturę o ciąży osoby nieletniej? ',
						'url' => '/publication/130631/Zasady_informowania_przez_lekarzy_organ%C3%B3w_%C5%9Bcigania_o_mo%C5%BCliwo%C5%9Bci_pope%C5%82nienia_przest%C4%99pstwa_%E2%80%9Ena_pacjencie%E2%80%9D',
						'image' => '245',
						'place' => 4,
						'fake' => true
					));
				
				
				if( 3 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Szczepienie jako warunek przyjęcia do szpitala lub wykonania zabiegu ',
						'content' => 'Przedsiębiorstwo podmiotu leczniczego, jakim jest szpital, co do zasady nie może uzależniać przeprowadzenia planowego zabiegu operacyjnego od wcześniejszego wykonania przez pacjenta szczepienia innego niż szczepienie obowiązkowe, np.: przeciwko wirusowemu zapaleniu wątroby. Szpital nie dysponuje tutaj również uprawnieniem, by w sposób skuteczny żądać od chorego poddania się szczepieniu przeciwko WZW, a odmowa wykonania zabiegu lub przyjęcia do szpitala jest bezprawna…',
						'url' => '/publication/130629/Szczepienie_jako_warunek_przyj%C4%99cia_do_szpitala_lub_wykonania_zabiegu',
						'image' => '485',
						'place' => 4,
						'fake' => true
					));
				
				
				if( 4 <= $freePlaces ) 
					$elements[] = new ContentData(array(
						'bcId' => 0,
						'id' => 4,
						'title' => 'Nowe obowiązki podmiotów leczniczych w zakresie bhp przy udzielaniu świadczeń zdrowotnych',
						'content' => 'Na podstawie art. 23715 § 2 ustawy z dnia 26 czerwca 1974 r. Kodeksu Pracy, Minister Zdrowia w dniu 6 czerwca 2013 r. wydał rozporządzenie w sprawie bezpieczeństwa i higieny pracy przy wykonywaniu prac związanych z narażeniem na zranienie ostrymi narzędziami, używanymi przy udzielaniu świadczeń zdrowotnych. Minister wskazał, iż ostrymi narzędziami w rozumieniu rozporządzenia są…',
						'url' => '/publication/130621/Nowe_obowi%C4%85zki_podmiot%C3%B3w_leczniczych_w_zakresie_bhp_przy_udzielaniu_%C5%9Bwiadcze%C5%84_zdrowotnych',
						'image' => '462',
						'place' => 4,
						'fake' => true
					));*/
					
			} elseif( 1 === $elementPlaceId ) {
				
				if( 1 <= $freePlaces )
				$elements[] = new Billboard(array(
						'bcId' => 0,
						'id' => 3,
						'bannerUrl' => 'ZCHL8FN6EHEM',
						'bannerMime' => 'image/png',
						'billboardUrl' => '22KPJZYIX8CP',
						'billboardMime' => 'image/png',
						'url' => '//esculap.com/?utm_source=esculap&utm_medium=billboard&utm_campaign=defcamp',
						'place' => 1,
						'fake' => true
				));
			}			
		} if( 'esc.com.sub' == $this->setCode ) {
			
			if( 1 === $elementPlaceId ) {
				
				if( 1 <= $freePlaces ) 
					$elements[] = new Billboard(array(
						'bcId' => 0,
						'id' => 3,
						'bannerUrl' => 'ZCHL8FN6EHEM',
						'bannerMime' => 'image/png',
						'billboardUrl' => '22KPJZYIX8CP',
						'billboardMime' => 'image/png',
						'url' => '//esculap.com?utm_source=esculap&utm_medium=billboard&utm_campaign=defcamp',
						'place' => 1,
						'fake' => true
					));
			}	
		}
		
	}
}
