<?php

namespace System\BannerCampaign\Element\Place;

use Model\RelBcElementSet;
use Model\DictBcElementPlace;

class PlaceFactory {
	
	public static function createPlace( $id ) {
		
		switch( strtolower ( trim ( $id ) ) ) {
			case 1:
			case 'billboard':
				
				return new Billboard( 1 );
				
				break;
			case 'banner' :
			case 2 :
				
				return new Banner( 2 );
				
				break;
			case 'slider' :
			case 3 :
				
				return new Slider( 3 );
				
				break;
			case 'sponsored' :
			case 4 :
				
				return new Sponsored( 4 );
				
				break;
			case 'special_for_you' :
			case 5 :
				
				return new SpecialForYou( 5 );
				
				break;
			case 'in_contnet' :
			case 6 :
				
				return new InContent( 6 );
				
				break;
			case 7 :
			case 'tv_billboard':
				return new TvBillboard( 7 );
				
				break;
			case 8 :
			case 'tv_main':
				return new TvMain( 8 );
				
				break;
			case 9 :
			case 'tv_sub':
				
				return new TvSub( 9 );
				
				break;
			case 31 :
			case 'billboard_dobry_sen':
				
				return new BillboardDobrySen( 31 );
				
				break;
			default:
                            $DictBcElementPlace = new DictBcElementPlace();
                            $PlaceData = $DictBcElementPlace->getPlaceData($id);
                            //var_dump($PlaceData); die();
                            return new PlaceGeneral($id, $PlaceData[0]['name']);
		}
	}
	
	public static function getPlacesForCode( $placeSetCode ) {
		
		$RelBcElementSet = new RelBcElementSet;
		$codes = $RelBcElementSet->getPlacesForCode( $placeSetCode );
		
		return (array)$codes;
	}
	
}

?>