<?php
namespace System\BannerCampaign\Element\Target;

use System\BannerCampaign\Element\Target\TargetAbstract;

class CompositeTarget extends TargetAbstract {

    public function __construct() {
        
    }

    public function toArray() {

        $res = array();

        foreach ($this->target as $targetElement) {

            $res = array_merge_recursive(
                    $res, $targetElement->toArray()
            );
        }

        return $res;
    }

    public function setTarget($target) {

        if (!is_a($target, 'System\BannerCampaign\Element\Target\TargetAbstract')) {

            throw new \Exception(__METHOD__ . ". Target musi być typu System\BannerCampaign\Element\Target\TargetAbstract ");
        }

        $this->target[] = $target;
    }

    public function getId() {

        $res = array();

        foreach ($this->target as $target) {

            $res[] = $target->getId();
        }

        return $res;
    }

    public function __toString() {

        $res = array();

        foreach ($this->target as $target) {

            $res[] = $target->__toString();
        }

        return implode(',', $res);
    }

    /**
     * $matched szawiera true jeśłi porównanie odbyło się, porównanie może się nieodbyć jeśli dargety są różnych typów
     */
    public function isCollision(TargetAbstract $targetToCompare, &$matched = null) {
        $conflicts = array();
        if (is_a($targetToCompare, 'System\BannerCampaign\Element\Target\CompositeTarget')) {

            foreach ($targetToCompare->getTarget() as $targetToCompare_) {


                if (false !== ( $conflict = $this->isCollision($targetToCompare_, $matched) )) {

                    $conflicts = array_merge($conflict, $conflicts);
                }
            }
        } else {


            foreach ($this->target as $target) {

                if ($targetToCompare->getId() !== $target->getId()) continue;


                if (false !== ( $conflict = $target->isCollision($targetToCompare, $matched, true) )) {

                    $conflicts[] = $conflict;
                }
            }
        }

        return count($conflicts) > 0 ? $conflicts : false;
    }

    public function isCollisionEx(TargetAbstract $targetToCompare, &$matched = null) {
        $matched = false;
        if (is_a($targetToCompare, 'System\BannerCampaign\Element\Target\CompositeTarget')) {
            $testElementTarget = $targetToCompare->getTarget();
            $toConfirm = count($testElementTarget);
            
            $conflicts = array();
            foreach ($testElementTarget as $testTargetEntity) {
                foreach ($this->getTarget() as $selfTarget) {
                    $_partialMatch = false;
                    if ($selfTarget->getId() == $testTargetEntity->getId()) {
                        if (($collision = $selfTarget->isCollisionEx($testTargetEntity, $_partialMatch)) !== false && $_partialMatch == true) {
                            $toConfirm--;
                            $conflicts[] = $collision;
                        }
                    }
                }
            }

            if (0 !== $toConfirm) {
                $matched = false;
            } else {
                $matched = true;
            }
            return count($conflicts) > 0 ? $conflicts : false;
        } else {
            $matched = false;
            return false;
        }
    }

}

?>