<?php

namespace System\BannerCampaign\Element\Target;

class TargetDecorator {
	
	protected $target;
	protected static $types;
	protected static $valuesTranslations = array();
	protected $translator;
	protected static $translated = false;
	
	public function __construct( TargetAbstract $target , \System\Translator\TranslatorStorageEx $translator = null ) {
		
		$this->target = $target;
		$this->translator = $translator;
	}
	
	public function save( $elementId ) {
		
		try {
			
			$RelBcElementTarget = new \Model\RelBcElementTarget;
			
			if( is_a( $this->target , 'System\Bannercampaign\Element\Target\CompositeTarget' ) ) {
				
				$res = false;
				
				$data = array();
				
				foreach( $this->target->getTarget() as $target_ ) {
					
					$data[] = array(
						'elementid' => $elementId,
						'targetid' => $target_->getId(),
						'target' => $target_->getTarget()
					);
				}
				
				if( !(bool)$RelBcElementTarget->setTargetArr(
					
					$data
					
				)) {
					
					$res = false;
				}
				
				
				return $res;
				
			} else {
				
				return (bool)$RelBcElementTarget->setTarget(
					$elementId,
					$this->target->getId(),
					$this->target->getTarget()
				);
				
			}
			
			
			
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . '. ' . $e->getMessage() );
		}
	}
	
	
	protected function translateObject() {
		if( null == self::$types ) {
			
			$DictBcElementTargetType = new \Model\DictBcElementTargetType;
			self::$types = $DictBcElementTargetType->getNames();
		}
		
		$targets = array();
		if( !is_array( $this->target->getId() ) ) {
			
			$targets[ $this->target->getId() ] = $this->target;
		
		} else {
			
			foreach( $this->target as $target ) {
				
				$targets[ $target->getId ] = $target;
			}
		}
		
		
		//if( !isset( self::$valuesTranslations[ $this->target->getId() ] ) ) {
		foreach( $targets as $targetId => $target ) {
			
			switch( $targetId ) {
				case 1:
					
					$DictSpec = new \Model\DictSpec;
					
					$tmp = array();
					
					foreach( $DictSpec->getNames() as $code => $name ) {
						
						$tmp[ 'l_' . $code ] = $name;
						$tmp[ 'p_' . $code ] = $name;
						$tmp[ 'i_' . $code ] = $name;
					}
					
					self::$valuesTranslations[ $this->target->getId() ] = $tmp;
					
					break;
				case 2:
					
					$DictUserType = new \Model\DictUserType;
					self::$valuesTranslations[ $this->target->getId() ] = $DictUserType->getAll();
					
					break;
			}
		}
	}
	
	public function getName() {
		
		$this->translateObject();
		
		// tłumaczneie nazw specek, typów i innych w zależności od typu elementu
	}
	
	
	
	public function describe() {
		$this->translateObject();
		
		if( is_a( $this->target , 'System\BannerCampaign\Element\Target\CompositeTarget' ) ) {
			
			$result = '';
			
			foreach( $this->target->getTarget() as $target ) {
				
				$result .= new self( $target , $this->translator );
			}
			
			return $result;
			
		} else {
			
			
			$res = "
				<div>
					<u><i>" . ucfirst( $this->translator->translate( 'dict_bc_target_type_' . self::$types[ $this->target->getId() ] ) ) . "</i></u>: 
					<span class='target_elements'>";
						
						
						$interests = array();
						$learned = array();
						$performed = array();
						$userTypes = array();
						
						foreach( $this->target->getTarget() as $k => $target ) {
							
							$targetType = substr( $target , 0 , 1 );
							$tTarget = substr( $target , 2 );
							
							if( 'i' == $targetType ) {
								
								$interests[] = $tTarget;
								
							} elseif( 'l' == $targetType ) {
							
								$learned[] = $tTarget;
							
							} elseif( 'p' == $targetType ) {
								
								$performed[] = $tTarget;
								
							} else {
								
								$userTypes[] = $target;
							}
						}	
						
                                                
						foreach ($interests as $key => $interest) {
                                                    if ($interest == '*') {
                                                        unset($interests[$key]);
                                                    }
                                                }
                                                
                                                foreach ($learned as $key => $learn) {
                                                    if ($learn == '*') {
                                                        unset($learned[$key]);
                                                    }
                                                }
                                                
                                                foreach ($performed as $key => $perform) {
                                                    if ($perform == '*') {
                                                        unset($performed[$key]);
                                                    }
                                                }
                                                
                                                foreach ($userTypes as $key => $userType) {
                                                    if ($userType == '*') {
                                                        unset($userTypes[$key]);
                                                    }
                                                }
                                                
                                                
						if( count( $userTypes ) ) {
							$res .= "<br/>";
							
							foreach( $userTypes as $k => $target ) {
								
								$res .= "<span>" . ( $k > 0 ? ', ' : '' ) . @self::$valuesTranslations[ $this->target->getId() ][ trim( $target ) ] . "</span>";
							}
						}
						
					
						if( count( $interests ) ) {
							
							$res .= "<div><b>Zainteresowania</b>:</div>";
							
							foreach( $interests as $k => $target ) {
								
								$res .= "<span>" . ( $k > 0 ? ', ' : '' ) . @self::$valuesTranslations[ $this->target->getId() ][ trim( 'i_' . $target ) ] . "</span>";
							}
						}
						
						
						if( count( $learned ) ) {
							
							$res .= "<div><b>Wyuczone</b>:</div>";
							
							foreach( $learned as $k => $target ) {
								
								$res .= "<span>" . ( $k > 0 ? ', ' : '' ) . @self::$valuesTranslations[ $this->target->getId() ][ trim( 'l_' . $target ) ] . "</span>";
							}
						}
						
						if( count( $performed ) ) {
							
							$res .= "<div><b>Wykonywane</b>:</div>";
							
							foreach( $performed as $k => $target ) {
								
								$res .= "<span>" . ( $k > 0 ? ', ' : '' ) . @self::$valuesTranslations[ $this->target->getId() ][ trim( 'p_' . $target ) ] . "</span>";
							}
						}
						
						
						
						
						
						
						
						//
			
			$res .= "</span>
				</div>
			";
                        
                        if (count($interests) == 0 && count($learned) == 0 && count($performed) == 0 && $this->target->getId() == 1) {
                            return '';
                        } elseif (count($userTypes) == 0 && $this->target->getId() == 2) {
                            return '';
                        } else {
                            return $res;
                        }
		}
	}
	
	public function __toString() {
		return $this->describe();
	}
	
}

?>