<?php

namespace System\BannerCampaign\Element\Target;

class TargetFactory {
	
	/**
	 * Tworzy instancję elementu targetu na podstawie danych z parametru data
	 * @param array $data tablica inicializacyjna obiekty array( main_bc_element_target_type_id => dane )
	 */
	public static function createElement( $data ) {
		
		if( !is_array( $data ) ) {
			
			throw new \Exception( __METHOD__ . ". Parametr data musi być tablicą" );
		}
		
		if( count( $data ) > 1 ) {
			
			$target = new CompositeTarget();
			
			foreach( $data as $k => $v ) {
				
				$preparedTarget = null;
				
				if( null !== ( $preparedTarget = self::createElement( array( $k => (array)$v ) ) ) ) {
					
					
					$target->setTarget( $preparedTarget );
				}
			}
			
			return $target;
			
		} else {
			
			$id = key( $data );
			$data = current( $data );
			
			switch( strtolower( trim ( $id ) ) ) {
				case 1:
				case 'specialization':
					
					return new BySpecialization( 1 , $data );
					
				case 2:
				case 'user_type':
					
					return new ByUserType( 2 , $data );
				case 3:
				case 'unlogged':
					
					
					return new Unlogged( 3 , $data );
					break;
				default:
					
					return null;
			}
		}
		
	}
}


?>