<?php

namespace System\BannerCampaign\Element;

class Video extends ElementAbstract {
	
	protected $contentId = null;
	protected $name = 'video';
	
	protected $functionsToCompare = array( 'contentId' );
	
	protected $fullFilled = array(
		'contentId'
	);
	
	public function parseData( $data ) {
		
		if( isset( $data[ 'contentId' ] ) ) {
			$this->contentId = $data[ 'contentId' ];
		}
		
		parent::parseData( $data );
	}
	
	
	public function getTypeData() {
	
		return array(
			'contentId' => $this->contentId
		);
	}
	
	
	public function setTypeData( $jsonData ) {
		$data = json_decode( $jsonData , true );
		
		if( isset( $data[ 'contentId' ] ) ) {
			$this->contentId = (int) $data[ 'contentId' ];
		}
	}
	
	
	public function setContentId( $contentId ) {
		
		$this->contentId = (int)$contentId;
	}	
	
	public function getContentId() { return $this->contentId; }
	
	public function toArray() {
	
		return array_merge(
			parent::toArray(),
			array( 
				'contentId' => $this->getContentId()
			)
		);
	}
}

?>