<?php

namespace System\Content;

abstract class AbstractConfig {

	protected $cms;

	protected $_options = array(
		'ROWS_NUMBER' => 10,
		'ROWS_START' => 0,
		'SPEC_TYPES' => array(),
		'GET_COMMENTS' => 0,
		'GET_MAIN_SITE' => false,
		'CONTENT_ID' => null,
		'NOT_CONTENT_ID' => null
	);


	public function __construct($options) {
		//if(!isset($options['SPEC_TYPES']) || !is_array($options['SPEC_TYPES'])) {
		//	throw new \Exception(__METHOD__.'.Klucz SPEC_TYPES jest wymagany!');
		//}
		// Obecnie niewymagane

		if( isset( $options['SPEC_TYPES'] ) && is_array( $options[ 'SPEC_TYPES' ] ) ) {
			$this->_options['SPEC_TYPES'] = $options['SPEC_TYPES'];
			unset($options['SPEC_TYPES']);
		};



		if( isset( $options[ 'ALL' ] ) ) {
			$this->_options['ALL'] = (bool)$options['ALL'];
			unset($options['ALL']);
		}


		if( isset( $options['ORDER_SPECS'] ) && is_array( $options[ 'ORDER_SPECS' ] ) ) {
			$this->_options['ORDER_SPECS'] = $options['ORDER_SPECS'];
			unset($options['ORDER_SPECS']);
		};

		if( isset( $options['CONTENT_OF_THE_DAY'] ) ) {
			$this->_options['CONTENT_OF_THE_DAY'] = (bool)$options['CONTENT_OF_THE_DAY'];
			unset($options['CONTENT_OF_THE_DAY']);
		};

		if(isset($options['ROWS_START'])) {
			$this->_options['ROWS_START'] = (int)$options['ROWS_START'];
			unset($options['ROWS_START']);
		};


		if( isset( $options[ 'ROWS_NUMBER' ] ) ) {
			$this->_options['ROWS_NUMBER'] = (int)$options['ROWS_NUMBER'];
			unset($options['ROWS_NUMBER']);
		}

		if( isset( $options[ 'MARK_LAST_MATCHED' ] ) ) {
			$this->_options['MARK_LAST_MATCHED'] = (bool)$options['MARK_LAST_MATCHED'];
			unset($options['MARK_LAST_MATCHED']);
		}

        if( isset( $options[ 'LAYOUT' ] ) ) {
            $this->_options['LAYOUT'] = (bool)$options['LAYOUT'];
            unset($options['LAYOUT']);
        }

		if(isset($options['GET_COMMENTS'])) {
			$this->_options['GET_COMMENTS'] = (int)$options['GET_COMMENTS'];
			unset($options['GET_COMMENTS']);
		}


                if(isset($options['GET_MAIN_SITE'])) {
			$this->_options['GET_MAIN_SITE'] = (bool)$options['GET_MAIN_SITE'];
			unset($options['GET_MAIN_SITE']);
		}

        if(isset($options['SUGGESTED_VIDEOS'])) {
            $this->_options['SUGGESTED_VIDEOS'] = (integer)$options['SUGGESTED_VIDEOS'];
            unset($options['SUGGESTED_VIDEOS']);
        } else {
            $this->_options['SUGGESTED_VIDEOS'] = 0;
        }

                if(isset($options['MAIN_SITE_ID'])) {
			$this->_options['MAIN_SITE_ID'] = (int)$options['MAIN_SITE_ID'];
			unset($options['MAIN_SITE_ID']);
		}

        if(isset($options['UPCOMING_EVENTS'])) {
            $this->_options['UPCOMING_EVENTS'] = (bool)$options['UPCOMING_EVENTS'];
            unset($options['UPCOMING_EVENTS']);
        }

		if(isset($options['CONTENT_ID'])) {
			$this->_options['CONTENT_ID'] = (int)$options['CONTENT_ID'];
			unset($options['CONTENT_ID']);
		}


		if(isset($options['NOT_CONTENT_ID'])) {
			//$this->_options['NOT_CONTENT_ID'] = (int)$options['NOT_CONTENT_ID'];
			if( is_array( $options['NOT_CONTENT_ID'] ) ) {

				$tmp = $options['NOT_CONTENT_ID'];
				foreach( $tmp as $key => $val) {
					$tmp[ $key ] = (int) $val;
				}

				$options['NOT_CONTENT_ID'] = implode( ',' , $tmp );

			} else {

				$options['NOT_CONTENT_ID'] = (int) $options['NOT_CONTENT_ID'];
			}

			$this->_options['NOT_CONTENT_ID'] = $options['NOT_CONTENT_ID'];
			unset($options['NOT_CONTENT_ID']);
		}


		if(isset($options['EVENT_TYPE']) && null !== $options['EVENT_TYPE']) {
			$this->_options['EVENT_TYPE'] = $options['EVENT_TYPE'];
			unset($options['EVENT_TYPE']);
		}


		if(isset($options['EVENT_ORG']) && null !== $options['EVENT_ORG']) {
			$this->_options['EVENT_ORG'] = $options['EVENT_ORG'];
			unset($options['EVENT_ORG']);
		}


		if(isset($options['EVENT_FROM']) && null !== $options['EVENT_FROM']) {
			$this->_options['EVENT_FROM'] = (int)$options['EVENT_FROM'];
			unset($options['EVENT_FROM']);
		}


		if(isset($options['EVENT_TO']) && null !== $options['EVENT_TO']) {
			$this->_options['EVENT_TO'] = $options['EVENT_TO'];
			unset($options['EVENT_TO']);
		}


		if(isset($options['ID_LIST']) && null !== $options['ID_LIST']) {
			$this->_options['ID_LIST'] = $options['ID_LIST'];
			unset($options['ID_LIST']);
		}


		// wykożystywane przez cms, niezalecam wykożystywania ich w Esculapie
		if( isset( $options[ 'CMS_WHERE' ] )) {
			$this->_options[ 'CMS_WHERE' ] = $options[ 'CMS_WHERE' ];
			unset( $options[ 'CMS_WHERE' ] );
		}


		if( isset( $options[ 'CMS_LIMIT' ] )) {
			$this->_options[ 'CMS_LIMIT' ] = $options[ 'CMS_LIMIT' ];
			unset( $options[ 'CMS_LIMIT' ] );
		}


		if( isset( $options[ 'CMS_ORDER' ] )) {
			$this->_options[ 'CMS_ORDER' ] = $options[ 'CMS_ORDER' ];
			unset( $options[ 'CMS_ORDER' ] );
		}

		if( isset( $options[ 'ESCULAP_ORDER' ] )) {
			$this->_options[ 'ESCULAP_ORDER' ] = $options[ 'ESCULAP_ORDER' ];
			unset( $options[ 'ESCULAP_ORDER' ] );
		}

		if( isset( $options[ 'ACTIVE' ] )) {
			$this->_options[ 'ACTIVE' ] = $options[ 'ACTIVE' ];
			unset( $options[ 'ACTIVE' ] );
		}

		if( isset( $options[ 'SEARCH_QUERY' ] ) ) {
			$this->_options[ 'SEARCH_QUERY' ] = $options[ 'SEARCH_QUERY' ];
			unset( $options[ 'SEARCH_QUERY' ]);
		}

		if( isset( $options[ 'EVALUATION_CHECK' ] ) ) {
			$this->_options[ 'EVALUATION_CHECK' ] = (int)$options[ 'EVALUATION_CHECK' ];
			unset( $options[ 'EVALUATION_CHECK' ]);
		}

		if( isset( $options[ 'LOAD_COLLECTIONS' ] ) ) {
			$this->_options[ 'LOAD_COLLECTIONS' ] = (bool)$options[ 'LOAD_COLLECTIONS' ];
			unset( $options[ 'LOAD_COLLECTIONS' ]);
		}


		if( isset( $options[ 'COLLECTIONS' ] ) ) {
			$this->_options[ 'COLLECTIONS' ] = (array)$options[ 'COLLECTIONS'];
			unset( $options[ 'COLLECTIONS'] );
		}

	}


	public function isCms() {

		if( null !== $this->cms )
			return $this->cms;


		foreach( $this->_options as $name => $value ) {

			if( preg_match( '/(cms|CMS)/' , $name ) ) {

				$this->cms = true;
				return true;
			}
		}

		$this->cms = false;
	}


	public function setOption($optionName,$optionValue) {
		if(!isset($this->_options[$optionName]))
			throw new \Exception("Brak klycz \"$optionName\"");
		$this->_options[$optionName] = $optionValue;
	}


	public function getOption($optionName) {
		if(!isset($this->_options[$optionName]))
			return null;
		return $this->_options[$optionName];
	}

	public function __get($optionName) {
		return $this->getOption($optionName);
	}

	public function __set($optionName,$optionValue) {
		return $this->setOption($optionName,$optionValue);
	}

	public function getOptions() {
		return $this->_options;
	}
}

?>