<?php

namespace System\Content\Element;

class Quiz extends AbstractContentElement {

	protected $id,
			  $langId,
			  $name,
			  $questionShort,
			  $question,
			  $correctAnswers,
			  $fillings,
			  $answers,
			  $collections,
                          $mainSiteId;
	
	protected $_needed = array(
		'content_id' => 'id',
		'lang_id' => 'langId',
		'name' => 'name',
		'creator' => 'creator',
		'created' => 'created',
		'modifier' => 'modifier',
		'modified' => 'modified',
		'question_short' => 'questionShort',
		'question' => 'question',
		'fillings' => 'fillings',
		'visible_in_esculap' => 'inEsculap',
		'collections' => 'collections',
                'main_site_id' => 'mainSiteId',
	);
	
	public function __construct( $data ) {
		parent::__construct( $data );
		
		$answers = array();
		foreach( (array)$data[ 'answers' ] as $answer ) {
		
			$answers[] = new Quiz\Answer( $answer );
		}
		
		
		
		$this->answers = $answers;
	}
}


?>