<?php

namespace System\Content;

class ElementComment {
	
	protected $commentId,$contentId,$langId,$title,$body,$nick,$userLogin,$addDate,$parentCommentId,$level;
	protected $childrens = array();
	
	protected $_needed = array (
		'comment_id' => 'commentId',
		'content_id' => 'contentId',
		'lang_id' => 'langId',
		'title' => 'title',
		'body' => 'body',
		'nick' => 'nick',
		'user_login' => 'userLogin',
		'add_date' => 'addDate',
		'parent_comment_id' => 'parentCommentId',
		'level' => 'level'
	);
		
	public function __construct($data) {
		
		$missing = array();
		
		foreach($this->_needed as $column => $variable) {
			
			if(!array_key_exists($column,$data)) {
				$missing[] = $column;
				continue;
			}
			
			$this->$variable = $data[$column];
		}
		
		if(count($missing)) {
			throw new \Exception(__METHOD__.'. Brak wymaganych kluczy w tablicy inicializacyjnej: '.implode(',',$missing));
		}
	}
	
	public function setChildrens($commentsList) {
		$this->childrens = $commentsList;
	}
	
	public function appendComment(ElementComment $comment) {
		$this->childrens[] = $comment;
	}
	
	public function childrens() {
		return $this->childrens;
	}
	
	public function countResponses() {
		$arr = $this->childrens();
		
		$result = count($arr);
		
		foreach($arr as $children) {
			$result += $children->countResponses();
		}
		
		return $result;
	}
	
	public function __get($name) {
		if(isset($this->$name))
			return $this->$name;
		return null;
	}
}

?>