<?php
namespace System\Controller\Plugin;

use Zend\Mvc\Controller\Plugin\AbstractPlugin;
use Zend\View\Model\ViewModel;
use Zend\Escaper\Escaper;

class ListChildViewCreator extends AbstractPlugin
{

    public function create($translator, $acl, $identity, $template)
    {
        $childView = new ViewModel();
        $childView->translator = $translator;
        $childView->acl = $acl;
        $childView->identity = $identity;
        $childView->escaper = new Escaper();
        $childView->setTemplate($template);

        return $childView;
    }

    /**
     * @param $controller
     * @param $template
     * @return ViewModel
     */
    public function createFromController($controller, $template)
    {
        $childView = new ViewModel();
        $childView->translator = \System\Translator\TranslatorEx::get();
        $childView->acl = $controller->getView()->acl;
        $childView->identity = $controller->identity;
        $childView->escaper = new Escaper();
        $childView->request = $controller->getView()->request;
        $childView->setTemplate($template);

        return $childView;
    }

}
