<?php

namespace  System\Form;

use System\Validator\RegexBase;

class CmsAddEditEvent extends AbstractForm implements DrawableInterface {
	
	protected $translations;
	protected $name = 'add_edit_news';
	protected $graphics = array();
	
	// lista błędów przekazanych domyślnie do widoku, w celu użycia ich do walidacji js-em
	protected $messages = array();
	
	// czy formularz odpalony jest do edycji
	protected $edit = false;
	
	protected $filterExceptions = array('content');
	
	public static function neadedTranslations() {
		return array(
			'main_title' , 'main_content' , 'error_value_is_required' , 'error_value_less_than_5' , 'main_content_and_graphics' , 'main_additional_informations' , 'main_content_general_informations' ,
			'main_content_contact_data' , 'main_from' , 'main_to' , 'main_active' , 'main_serchable' , 'main_lang' , 'main_country' , 'main_next' , 'main_prev' , 'main_save' , 'error_date_format_slashes',
			'error_select_value' , 'main_type' , 'main_address_city' , 'main_address_zip' , 'main_address' , 'main_website' , 'main_fax' , 'main_email' , 'main_phone' , 'main_zip_incorrect' ,
			'error_phone_incorrent' , 'error_zip_incorrect' , 'error_fax_incorrent' , 'error_url_incorrect' , 'error_email_incorrect' , 'main_select' , 'main_specializations' , 'error_country_incorrect',
			'main_organizator_name' , 'main_organizator_address' , 'main_paid' , 'main_pointed' , 'main_cost' , 'main_points' , 'error_value_must_be_numeric' , 'error_value_must_be_grater_than_zero',
			'main_additional_file' , 'main_select' , 'main_set_location' , 'main_set' , 'error_date_too_early' , 'main_collections' , 'main_global_collection' , 'main_content_of_the_day' , 'main_content_of_the_day_eror',
                        'main_site',
		);
	}
	
	
	public function __construct( array $translations , $eventsTypesList , $languages , $countryies , $specNames , $mainSiteSelect , $edit ) {
		$this->translations = $translations;
		
		$this->edit = (bool)$edit;
		
		$eventsTypes = array();
		$_eventsTypesValidate = array();
		foreach( $eventsTypesList as $val => $label ) {
			$_eventsTypesValidate[] = $val;
		
			$eventsTypes[ $val ] = array(
				'value' => $val,
				'label' => $label
			);
		}
		
		$_languages = array();
		$_languageValidate = array();
		foreach( $languages as $val => $label ) {
			$_languageValidate[] = $val;
			
			$_languages[ $val ] = array(
				'value' => $val,
				'label' => $label
			);
		}
		
		$_countryies = array();
		$_countriesValidation = array();
		foreach( $countryies as $val => $country ) {
			$_countriesValidation[] = $val;
			
			$_countryies[ $val ] = array(
				'value' => $val,
				'label' => $country
 			);
		}
		
		$mainSiteSelectOptions = array('' => '');
                $mainSiteSelectValidation = array();
                foreach ($mainSiteSelect as $mainSiteSelectOption) {
                    $mainSiteSelectOptions[] = array(
                        'value' => (int)$mainSiteSelectOption->getId(),
                        'label' => (string)$mainSiteSelectOption->getName(),
                    );
                    $mainSiteSelectValidation[] = (int)$mainSiteSelectOption->getId();
                }
		
		$fields = array(
			array( 'name' => 'title' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form-long' , 'req' => '' , 'val' => 'min5chars' ) , 'options' => array( 'label' => $this->translations[ 'main_title' ]) ),
			array( 'name' => 'content' , 'type' => 'Zend\Form\Element\Textarea' , 'attributes' => array( 'req' => 'document_value:minlength:1' , 'val' => 'textarea' , 'class' => 'form-textarea ckeditor ckeditor_basic' ) , 'options' => array( 'label' => $this->translations[ 'main_content' ] ) ),
			array( 'name' => 'city' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'title' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_address_city' ] ) ),
			array( 'name' => 'zip' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'zip', 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_address_zip' ] ) ),
			array( 'name' => 'address' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_address' ] ) ),
			array( 'name' => 'website' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'val' => 'website' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_website' ] ) ),
			array( 'name' => 'phone' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'phone' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_phone' ] ) ),
			array( 'name' => 'fax' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'val' => 'phone' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_fax' ] ) ),
			array( 'name' => 'email' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'email' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_email' ] ) ),
			array( 'name' => 'dateStart' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'class' => 'inp-form-date date_picker depminsrc_1 depmaxtarget_1' ) , 'options' => array( 'label' => $this->translations[ 'main_from' ] ) ),
			array( 'name' => 'dateEnd' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'class' => 'inp-form-date date_picker depmaxsrc_1 depmintarget_1' ) , 'options' => array( 'label' => $this->translations[ 'main_to' ] ) ),
			array( 'name' => 'country' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'class' => 'styledselect_form_1' ) , 'options' => array( 'label' => $this->translations[ 'main_country' ] , 'value_options' => $_countryies ) ),
			array( 'name' => 'type' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'req' => '' , 'class' => 'styledselect_form_1' ) , 'options' => array( 'label' => $this->translations[ 'main_type' ] , 'value_options' => $eventsTypes ) ),
			array( 'name' => 'language' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'req' => '' , 'class' => 'styledselect_form_1' ) , 'options' => array( 'label' => $this->translations[ 'main_lang' ] , 'value_options' => $languages ) ),
			array( 'name' => 'organizator_name' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_organizator_name' ] ) ),
			array( 'name' => 'organizator_address' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'class' => 'inp-form' ) , 'options' => array( 'label' => $this->translations[ 'main_organizator_address' ] ) ),
			array( 'name' => 'pointed' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'class' => 'event_pointed_checkbox' , 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_pointed' ] ) ),
			array( 'name' => 'pointed_value' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'event_pointed_value input-dissabled inp-form' , 'req' => 'pointed:is:checked' , 'val' => 'num' , 'value' => '' ) , 'options' => array( 'label' => $this->translations[ 'main_points' ] ) ),
			array( 'name' => 'paid' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'class' => 'event_paid_checkbox' , 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_paid' ] ) ),
			array( 'name' => 'paid_value' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => 'paid:is:checked', 'val' => 'float' , 'disabled' => 'disabled' , 'class' => 'input-dissabled event_paid_cost inp-form') , 'options' => array( 'label' => $this->translations[ 'main_cost' ] ) ),
			array( 'name' => 'active' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_active' ] ) ),
			array( 'name' => 'searchable' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_serchable' ] ) ),
			array( 'name' => 'specs' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'content_news_add_edit_specs form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_specializations' ] ) ),
			array( 'name' => 'specs_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height content_news_add_edit_specs_value') , 'options' => array() ),
			array( 'name' => 'spec_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height content_spec_names' ) ),
			array( 'name' => 'nextStep', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_next'] , 'class' => 'info-tooltip next_button submitStep' ) ),
			array( 'name' => 'prevStep', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_prev'] , 'class' => 'info-tooltip prev_button prevStep' ) ),
			array( 'name' => 'save', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_save'] ,'class' => 'info-tooltip save_button submitStep' ) ),
			array( 'name' => 'document' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'form-submit main_file_load_list event' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_additional_file' ] ) ),
			array( 'name' => 'document_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height main_file_value' ) , 'options' => array( 'label' => '' ) ),
			array( 'name' => 'google_localization' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'value' => $this->translations[ 'main_set' ], 'class' => 'form-submit event_google_map_window' ) , 'options' => array( 'label' => $this->translations[ 'main_set_location' ] ) ),
			
			array( 'name' => 'esculap_collection' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_global_collection' ] ) ),
			array( 'name' => 'content_of_the_day' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_content_of_the_day' ] ) ),
			
			// kolekcje
			array( 'name' => 'collection' , 'type' => 'Zend\Form\Element\Hidden' , 'options' => array() , 'attributes' => array( 'class' => 'no_height' ) ),
			array( 'name' => 'collection_button' , 'type' => 'Zend\Form\Element\Button' , 'options' => array( 'label' => $this->translations[ 'main_collections' ] ) , 'attributes' => array( 'value' => $this->translations[ 'main_set' ] , 'class' => 'collection_button event form-submit' ) ),
                        
                        array( 'name' => 'main_site_id', 'type' => 'Zend\Form\Element\Select', 'attributes' => array('id' => 'main_site_select', 'req' => '', 'val' => 'num'), 'options' => array('value_options' => $mainSiteSelectOptions, 'label' => $this->translations['main_site'])),
		);
		
		
		$this->validation = array(
			'title' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'string_length' , 'options' => array( 'min' => 5 , 'messages' => array( \Zend\Validator\StringLength::TOO_SHORT => $this->translations[ 'error_value_less_than_5' ] ) ) )
				),
			),
			'dateEnd' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_date_format_slashes' ] ) ) ),
					array('name' => 'System\Validator\ComparisonGreaterThan' , 'options' => array('messages' => array(\System\Validator\ComparisonGreaterThan::INVALID_VALUE => $this->translations['error_date_too_early'])))
				),
			),
			'dateStart' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_date_format_slashes' ] ) ) ),
					array('name' => 'System\Validator\ComparisonGreaterThan')
				),
			),
			'content' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'string_length' , 'options' => array( 'min' => '5' , 'messages' => array( \Zend\Validator\StringLength::TOO_SHORT => $this->translations[ 'error_value_less_than_5' ] ) ) )
				),
				'filters' => array(
					array( 'name' => 'strip_tags' , 'options' => array( 'allowTags' => 'p,br,b,i,a,ol,li,ul,a' , 'allowAttributes' => 'href' ) )
				)
			),
			'language' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'in_array' , 'options' => array( 'haystack' => $_languageValidate , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'error_select_value' ] ) ) )
				),
			),
			'city' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
				),
			),
			'zip' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'zip' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_zip_incorrect' ] ) ) )
				),
			),
			'address' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
				),
			),
			'phone' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'phone2' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_phone_incorrent' ] ) ) )
				),
			),
			'website' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'website' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_url_incorrect' ] ) ) )
				),
			),
			'email' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					//array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'email' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_email_incorrect' ] ) ) )
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'email' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_email_incorrect' ] ) ) )
				),
			),
			'fax' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					//array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'phone' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_fax_incorrent' ] ) ) )
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'phone2' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_fax_incorrent' ] ) ) )
				),
			),
			'country' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'in_array' , 'options' => array( 'haystack' => $_countriesValidation , 'messages' => array( \Zend\validator\InArray::NOT_IN_ARRAY => $this->translations[ 'error_country_incorrect' ] )  ) )
				),
			),
			'organizator_name' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
				),
			), 
			'organizator_address' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
				),
			),
			'paid_value' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'greater_than' , 'options' => array( 'min' => 1 , 'messages' => array( \Zend\Validator\GreaterThan::NOT_GREATER => $this->translations[ 'error_value_must_be_grater_than_zero' ] ) ) )
				),
				'filters' => array(
					array( 'name' => 'preg_replace' , 'options' => array( 'pattern' => '/,/' , 'replacement' => '.' ) )
				)
			),
			'pointed_value' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'greater_than' , 'options' => array( 'min' => 1 , 'messages' => array( \Zend\Validator\GreaterThan::NOT_GREATER => $this->translations[ 'error_value_must_be_grater_than_zero' ] ) ) )
				),
			),
			'content_of_the_day' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'in_array' , 'options' => array( 'haystack' => array( 0 , 1 ) ) , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'main_content_of_the_day_eror' ] ) )
				)
			),
			'esculap_collection' => array( 'required' => false ),
			'document_value' => array( 'required' => false),
			'paid' => array( 'required' => false ),
			'pointed' => array( 'required' => false ),
			'active' => array( 'required' => false ),
			'searchable' => array( 'required' => false ),
			'specs' => array( 'required' => false ),
			'specs_value' => array( 'required' => false ),
			'spec_names' => array( 'required' => false ),
			'google_localization' => array( 'required' => false ),
                        
                        'main_site_id' => array(
                            'required' => true,
                            'validators' => array(
                                array('name' => 'not_empty', 'break_chain_on_failure' => true, 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->translations['error_value_is_required']))),
                                array('name' => 'in_array', 'options' => array('haystack' => $mainSiteSelectValidation, 'messages' => array(\Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations['error_select_value']))),
                            )
                        ),
		);
			
		
		parent::init( $fields );
		
		
		$this->_messages = array(
			'title' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_less_than_5' ],
			),
			'dateStart' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_date_format_slashes' ],
			),
			'dateEnd' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_date_format_slashes' ],
				$this->translations[ 'error_date_too_early' ]
			),
			'content' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_less_than_5' ],
			),
			'language' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_select_value' ],
			),
			'city' => array(
				$this->translations[ 'error_value_is_required' ],
			),
			'zip' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_zip_incorrect' ],
			),
			'address' => array(
				$this->translations[ 'error_value_is_required' ],
			),
			'phone' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_phone_incorrent' ],
			),
			'fax' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_fax_incorrent' ],
			),
			'website' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_url_incorrect' ]
			),
			'email' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_email_incorrect' ]
			),
			'country' => array(
				$this->translations[ 'error_country_incorrect' ]
			),
			'organizator_name' => array(
				$this->translations[ 'error_value_is_required' ],
			),
			'organizator_address' => array(
				$this->translations[ 'error_value_is_required' ],
			),
			'paid_value' =>array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_must_be_numeric' ],
				$this->translations[ 'error_value_must_be_grater_than_zero' ],
			),
			'pointed_value' =>array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_must_be_numeric' ],
				$this->translations[ 'error_value_must_be_grater_than_zero' ],
			),
                        'main_site_id' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_select_value' ],
			),
		);
	}
	
	public function getElementMessages( $name ) {
		if( isset( $this->_messages[ trim( $name ) ] ) ) {
			return $this->_messages[ trim( $name ) ];
		}
		
		return array();
	}
	
	public function getData() {
                $data = $this->form->getData();
                if (isset($data['document_value']) && trim($data['document_value']) == '') {
                    $data['document_value'] = null;
                }
                if (isset($data['info']) && trim($data['info']) == '') {
                    $data['info'] = null;
                }
		return $data;
	}
	
	public function draw() {
		
		$queue = array(
			
			1 => array(
				'name' => $this->translations[ 'main_content_general_informations' ],
				'lock' => 0,
				'elements' => array(
					'title',
					'content',
					'dateStart',
					'dateEnd',
					'type',
					'language',
					'country',
					'paid',
					'paid_value',
					'pointed',
					'pointed_value',
                                        'main_site_id',
					'active',
					'searchable',
					'esculap_collection',
					'content_of_the_day',
					'document',
					'document_value',
					'collection',
					'collection_button',
				),	
				'navigation' => array(
					'nextStep',				
				)
			),
			2 => array(
				'name' => $this->translations[ 'main_content_contact_data' ],
				'lock' => true == $this->edit ? 0 : 1 ,
				'elements' => array(
					'city',
					'zip',
					'address',
					'phone',
					'fax',
					'website',
					'email',
					'organizator_name',
					'organizator_address',
					//'google_localization',
					'specs',
					'specs_value',
					'spec_names',
				),
				'navigation' => array(
					'prevStep',
					'save'
				)
			)
		);
		
		$this->form->queue = $queue;
			
		return $this->form;
	}
	
	public function setData( $data ) {
		
		foreach( $data as $name => $value ) {
			
			if( ( $name == 'active' || $name == 'searchable' || $name == 'esculap_collection' || $name == 'paid' || $name == 'pointed' || $name == 'content_of_the_day' ) && $value == 1 ) {
				
				$this->form->get( $name )->setAttribute( 'checked' , 'checked' );
				
			} else {
				
				$value = 0;
			}
		 	
			if( $name == 'paid' && $value == 1 ) {
				$this->validation[ 'paid_value' ][ 'required' ] = true;
				
				$this->getForm()->get( 'paid_value' )->setAttribute( 'disabled' , '' );
				$this->getForm()->get( 'paid_value' )->setAttribute( 'class' , preg_replace( "/input-dissabled/" , '' , $this->getForm()->get( 'paid_value' )->getAttribute( 'class' ) ) );
			}
			
                        /*if( $name == 'scored' ) {
                            var_dump($name);
                            var_dump($value);
                            die();
                        }*/
			
			if( $name == 'pointed' && ($value == 1 || $value == true) ) {
				$this->validation[ 'pointed_value' ][ 'required' ] = true;
				
				$this->getForm()->get( 'pointed_value' )->setAttribute( 'disabled' , '' );
				$this->getForm()->get( 'pointed_value' )->setAttribute( 'class' , preg_replace( "/input-dissabled/" , '' , $this->getForm()->get( 'pointed_value' )->getAttribute( 'class' ) ) );
			}
			
			
			if( $name == 'document_value' && strlen( $value ) > 1 ) {
				
				$this->validation[ 'content' ][ 'required' ] = false;
			}
		}
		
		parent::setData( $data );
	}
}


?>