<?php

namespace  System\Form;

use System\Validator\RegexBase;

class CmsAddEditNews extends AbstractForm implements DrawableInterface {
	
	protected $translations;
	protected $name = 'add_edit_news';
	protected $graphics = array();
	
	// lista błędów przekazanych domyślnie do widoku, w celu użycia ich do walidacji js-em
	protected $messages = array();
	
	// czy formularz odpalony jest do edycji
	protected $edit = false;
	
	protected $filterExceptions = array( 'content' );
	
	public static function neadedTranslations() {
		return array(
			'main_save' , 'main_next' , 'main_prev' , 'main_title' , 'main_headers' , 'main_content' , 'main_avatar' , 'main_additional_graphics' , 'main_add' , 'main_set' , 'main_content_and_graphics' ,
			'main_additional_informations' , 'main_specialityies_and_collections' , 'main_specializations' , 'main_collections' , 'main_copytight' , 'main_author' , 'main_type' , 'main_active' , 'main_serchable',
			'main_active_for' , 'main_date' , 'main_language' , 'error_value_is_required' , 'error_select_value' , 'error_value_less_than_5' , 'error_value_is_not_numeric' , 'error_date_format_slashes' ,
			'main_select' , 'main_view' , 'main_global_collection' , 'main_content_of_the_day' , 'main_content_of_the_day_eror', 'main_site', 'main_keywords'
		);
	}
	
	public function __construct( array $translations , $newsTypes , $languages , $specNames , $mainSiteSelect, $edit ) {
		$this->translations = $translations;
		
		
		$this->edit = (bool)$edit;
		
		
		
		$_newsTypes = array();
		$_newsTypesValidate = array();
		foreach( $newsTypes as $val => $label ) {
			$_newsTypesValidate[] = $val;
		
			$_newsTypes[ $val ] = array(
				'value' => $val,
				'label' => $label
			);
		}
		
		$_languages = array();
		$_languageValidate = array();
		foreach( $languages as $val => $label ) {
			$_languageValidate[] = $val;
			
			$_languages[ $val ] = array(
				'value' => $val,
				'label' => $label
			);
		}
		
		$mainSiteSelectOptions = array('' => '');
                $mainSiteSelectValidation = array();
                foreach ($mainSiteSelect as $mainSiteSelectOption) {
                    $mainSiteSelectOptions[] = array(
                        'value' => (int)$mainSiteSelectOption->getId(),
                        'label' => (string)$mainSiteSelectOption->getName(),
                    );
                    $mainSiteSelectValidation[] = (int)$mainSiteSelectOption->getId();
                }
		
		$fields = array(
			array( 'name' => 'title' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form-long' , 'req' => '' , 'val' => 'min5chars' ) , 'options' => array( 'label' => $this->translations[ 'main_title' ]) ),
			array( 'name' => 'headers' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form-long' , 'req' => '' , 'val' => 'min5chars' ) , 'options' => array( 'label' => $this->translations[ 'main_headers' ] ) ),
			array( 'name' => 'content' , 'type' => 'Zend\Form\Element\Textarea' , 'attributes' => array( 'class' => 'form-textarea long middle ckeditor ' ) , 'options' => array( 'label' => $this->translations[ 'main_content' ] ) ),
			//array( 'name' => 'content_view' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'main_content_view_news_content form-submit' , 'value' => $this->translations[ 'main_view' ] ) , 'options' => array( 'label' => $this->translations[ 'main_view' ] ) ),
			array( 'name' => 'copyrights' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form' , 'req' => '' ) , 'options' => array( 'label' => $this->translations[ 'main_copytight' ] ) ) ,
			array( 'name' => 'author' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form' , 'req' => '' ) , 'options' => array( 'label' => $this->translations[ 'main_author' ] ) ) ,
			array( 'name' => 'type' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'class' => 'styledselect_form_1 news_type') , 'options' => array( 'req' => '' , 'val' => 'num' , 'value_options' => $_newsTypes , 'label' => $this->translations[ 'main_type' ] ) ) ,
			array( 'name' => 'date' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'maxlength' => '10', 'req' => '' , 'val' => 'dateSlash' , 'class' => 'date-pick inp-form-date date-pick-max-date-set' , 'maxdate' => date( 'Y/m/d' , strtotime( '+1 days' ) ) ) , 'options' => array( 'label' => $this->translations[ 'main_date' ] ) ),
			array( 'name' => 'active_in' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'maxlength' => 3 , 'req' => '' , 'val' => 'num' , 'class' => 'inp-form') , 'options' => array( 'label' => $this->translations[ 'main_active_for' ] ) ),
			array( 'name' => 'language' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'class' => 'styledselect_form_1' ) , 'options' => array( 'label' => $this->translations[ 'main_language' ] , 'value_options' => $_languages ) ),
			array( 'name' => 'active' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_active' ] ) ),
			array( 'name' => 'searchable' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_serchable' ] ) ),
			array( 'name' => 'avatar' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'content_add_edit_avatar form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_avatar' ] ) ),
			array( 'name' => 'avatar_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'avatar' , 'req' => '' , 'val' => 'avatar' , 'class' => 'off_site_error no_height content_add_edit_avatar_value') , 'options' => array() ),
				array( 'name' => 'keywords' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'val' => 'keywords' , 'class' => 'inp-form-long' ) , 'options' => array( 'label' => $this->translations[ 'main_keywords' ] ) ),
			
			// kolekcje
			array( 'name' => 'collection' , 'type' => 'Zend\Form\Element\Hidden' , 'options' => array() , 'attributes' => array( 'class' => 'no_height' ) ),
			array( 'name' => 'collection_button' , 'type' => 'Zend\Form\Element\Button' , 'options' => array( 'label' => $this->translations[ 'main_collections' ] ) , 'attributes' => array( 'value' => $this->translations[ 'main_set' ] , 'class' => 'collection_button news form-submit' ) ),
			
			
			array( 'name' => 'esculap_collection' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_global_collection' ] ) ),
			array( 'name' => 'content_of_the_day' , 'type' => 'Zend\Form\Element\Checkbox' , 'attributes' => array( 'value' => '1' ) , 'options' => array( 'label' => $this->translations[ 'main_content_of_the_day' ] ) ),
			
			array( 'name' => 'specs' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'content_news_add_edit_specs form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_specializations' ] ) ),
			array( 'name' => 'specs_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height content_news_add_edit_specs_value') , 'options' => array() ),
			
			array( 'name' => 'nextStep', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_next'] , 'class' => 'info-tooltip next_button submitStep' ) ),
			array( 'name' => 'prevStep', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_prev'] , 'class' => 'info-tooltip prev_button prevStep' ) ),
			array( 'name' => 'save', 'type' => 'Zend\Form\Element\Button','attributes' => array( 'title' => $this->translations['main_save'] ,'class' => 'info-tooltip save_button submitStep' ) ),
			array( 'name' => 'spec_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height content_spec_names' ) ),
			array( 'name' => 'graphics' , 'type' => 'Zend\Form\Element\File' , 'attributes' => array( 'id' => 'new_image' , 'class' => 'content_add_edit_graphics' , 'value' => $this->translations[ 'main_add' ] ) , 'options' => array( 'label' => $this->translations[ 'main_additional_graphics' ] ) ),
			array( 'name' => 'graphics_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height content_add_edit_graphic_value') , 'options' => array() ),
                    
                        array( 'name' => 'main_site_id', 'type' => 'Zend\Form\Element\Select', 'attributes' => array('id' => 'main_site_select', 'req' => '', 'val' => 'num'), 'options' => array('value_options' => $mainSiteSelectOptions, 'label' => $this->translations['main_site'])),
		);
			
			$this->validation = array(
				'title' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
						array( 'name' => 'string_length' , 'options' => array( 'min' => 5 , 'messages' => array( \Zend\Validator\StringLength::TOO_SHORT => $this->translations[ 'error_value_less_than_5' ] ) ) )
					)
				),
				'headers' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
						array( 'name' => 'string_length' , 'options' => array( 'min' => 5 , 'messages' => array( \Zend\Validator\StringLength::TOO_SHORT => $this->translations[ 'error_value_less_than_5' ] ) ) )
					)
				),
				'name' => array(
					'required' => false,
					'validators' => array()
				),
				'copyrights' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
					)
				),
				'keywords' => array(
						'required' => true,
						'validators' => array(
								array( 'name' => 'regex' , 'options' => array( 'pattern' => '/' . RegexBase::get( 'keywords' ) . '/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => 'niepasuje' ) ) ),
						)
				),
				'author' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
					)
				),
				'type' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'in_array' , 'options' => array( 'haystack' => $_newsTypesValidate , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'error_select_value' ] ) ) )
					)
				),
				'language' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'in_array' , 'options' => array( 'haystack' => $_languageValidate , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'error_select_value' ] ) ) ) 
					)
				),
				'date' => array(
					'required' => true,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
						array( 'name' => 'regex' , 'options' => array( 'pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_date_format_slashes' ] ) ) )
					)
				),
				'active_in' => array(
					'required' => false,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
						array( 'name' => 'greater_than' , 'options' => array( 'min' => 0 , 'messages' => array( \Zend\Validator\GreaterThan::NOT_GREATER => $this->translations[ 'error_value_is_not_numeric' ] )) )
					)
				),
				'avatar' => array( 
					'required' => false,
					'validators' => array(
						array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) )
					)
				),
				'content_of_the_day' => array(
					'required' => false,
					'validators' => array(
						array( 'name' => 'in_array' , 'options' => array( 'haystack' => array( 0 , 1 ) ) , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'main_content_of_the_day_eror' ] ) )
					)
				),
				'esculap_collection' => array( 'required' => false ),
				'active' => array( 'required' => false ),
				'searchable' => array( 'required' => false ),
				'specs' => array( 'required' => false ),
				'specs_value' => array( 'required' => false ),
				'avatar_value' => array( 'required' => false ),
				'graphics' => array( 'required' => false ),
				'graphics_value' => array( 'required' => false ),
				'spec_names' => array( 'required' => false ),
                            
                            'main_site_id' => array(
                                'required' => true,
                                'validators' => array(
                                    array('name' => 'not_empty', 'break_chain_on_failure' => true, 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->translations['error_value_is_required']))),
                                    array('name' => 'in_array', 'options' => array('haystack' => $mainSiteSelectValidation, 'messages' => array(\Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations['error_select_value']))),
                                )
                            ),
			);
			
		
		parent::init( $fields );
		
		$this->_messages = array(
			'title' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_less_than_5' ]
			),
			'headers' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_value_less_than_5' ]
			),
			'author' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'copyrights' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'keywords' => array(
					'Niepoprawna wartość',
			),
			'type' => array(
				$this->translations[ 'error_select_value' ]
			),
			'date' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_date_format_slashes' ]
			),
			'active_in' => array(
				$this->translations[ 'error_value_is_not_numeric' ]
			),
			'language' => array(
				$this->translations[ 'error_select_value' ]
			),
			'avatar' => array(
				$this->translations[ 'error_value_is_required' ]
			),
                        'main_site_id' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_select_value' ],
			)
		);
		
	}
	
	public function getData() {
		return $this->form->getData();
	}
	
	public function draw() {
		// zrobione w ten sposób bo zdjęcia dodatkowe oraz awatar dodawane są dynamicznie i niemożna określić ich ilości
		$firstStepFields = array(
			'title',
			'headers',
			'keywords',
			'content',
			'avatar',
			'avatar_value',
			'graphics',
			'graphics_value',
			'collection',
			'collection_button'
		);
		
		$queue = array(
			1 => array(
				'name' => $this->translations[ 'main_content_and_graphics' ],
				'lock' => 0,
				'elements' => $firstStepFields,
				'navigation' => array(
					'nextStep'
				)
			),
			2 => array(
				'name' => $this->translations[ 'main_additional_informations' ],
				'lock' => true == $this->edit ? 0 : 1 ,
				'elements' => array(
					'author',
					'copyrights',
					'type',
					'date',
					'active_in',
					'language',
                                        'main_site_id',
					'active',
					'searchable',
					'esculap_collection',
					'content_of_the_day',
					'specs',
					'specs_value',
					'spec_names',
				),
				'navigation' => array(
					'prevStep',
					'save'
				)
			)
		);
		
		
		$this->form->queue = $queue;
			
		return $this->form;
	}
	
	public function setData( $data ) {
		
		foreach( $data as $name => $value ) {
			$value = (int)$value;
			if( ( $name == 'active' || $name == 'searchable' || $name == 'esculap_collection' || $name == 'content_of_the_day' ) && $value == 1 ) {
				
				$this->form->get( $name )->setAttribute( 'checked' , 'checked' );
				
			} else {
				
				$value = 0;
			}
		}
		
		parent::setData( $data );
	}
}


?>