<?php
namespace System\Form;
use Zend\Filter;

use System\Validator\RegexBase;

class CmsAddEditVideo extends AbstractForm implements DrawableInterface {

    protected $name = 'add_edit_video';

    public static function neadedTranslations() {
        return array(
            'main_video_title', 'main_video_description', 'error_value_is_required', 'main_basic_information', 'main_set', 'main_save', 'main_site',
            'error_value_less_than_5', 'error_select_value', 'main_active', 'main_global_collection', 'main_language', 'main_next', 'main_prev', 'main_additional_informations',
            'main_serchable', 'main_keywords', 'main_content_of_the_day', 'main_content_of_the_day_eror', 'main_copytight', 'main_author', 'main_date', 'error_date_format_slashes',
            'main_select', 'main_specializations', 'main_collections', 'main_avatar', 'main_protocol', 'main_stream', 'main_bitrate', 'main_dimension', 'main_main_stream', 'main_thumb_stream',
            'error_value_must_be_integer',
        );
    }

    public function __construct($translations, $languages, $specNames, $mainSiteSelect, $edit = false) {
        $this->_translations = $translations;
        $this->edit = $edit;

        $_languages = array();
        $_languageValidate = array();
        foreach ($languages as $val => $label) {
            $_languageValidate[] = $val;

            $_languages[$val] = array(
                'value' => $val,
                'label' => $label
            );
        }

        $mainSiteSelectOptions = array('' => '');
        $mainSiteSelectValidation = array();
        foreach ($mainSiteSelect as $mainSiteSelectOption) {
            $mainSiteSelectOptions[] = array(
                'value' => (int)$mainSiteSelectOption->getId(),
                'label' => (string)$mainSiteSelectOption->getName(),
            );
            $mainSiteSelectValidation[] = (int)$mainSiteSelectOption->getId();
        }

        $this->elements = array(
            array('name' => 'title', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => '', 'val' => ''), 'options' => array('label' => $this->_translations['main_video_title'])),
            array('name' => 'description' , 'type' => 'Zend\Form\Element\Textarea' , 'attributes' => array( 'class' => 'form-textarea long middle ckeditor '), 'options' => array( 'label' => 'Opis') ),
            array('name' => 'head', 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'class' => 'inp-form-long') , 'options' => array( 'label' => 'Krótki opis') ),
            //array('name' => 'description', 'type' => 'Zend\Form\Element\Textarea', 'attributes' => array('class' => 'form-textarea', 'val' => ''), 'options' => array('label' => 'Opis')),
            array('name' => 'keywords', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('req' => '', 'val' => 'keywords', 'class' => 'inp-form-long'), 'options' => array('label' => $this->_translations['main_keywords'])),
            array('name' => 'language', 'type' => 'Zend\Form\Element\Select', 'attributes' => array('class' => 'styledselect_form_1'), 'options' => array('label' => $this->_translations['main_language'], 'value_options' => $_languages)),
            array('name' => 'main_site_id', 'type' => 'Zend\Form\Element\Select', 'attributes' => array('id' => 'main_site_select', 'req' => '', 'val' => 'num'), 'options' => array('value_options' => $mainSiteSelectOptions, 'label' => $this->_translations['main_site'])),
            array('name' => 'active', 'type' => 'Zend\Form\Element\Checkbox', 'attributes' => array('value' => '1'), 'options' => array('label' => 'Widoczny')),
            array('name' => 'esculap_collection', 'type' => 'Zend\Form\Element\Checkbox', 'attributes' => array('value' => '1'), 'options' => array('label' => $this->_translations['main_global_collection'])),
            array('name' => 'searchable', 'type' => 'Zend\Form\Element\Checkbox', 'attributes' => array('value' => '1'), 'options' => array('label' => $this->_translations['main_serchable'])),
            array('name' => 'content_of_the_day', 'type' => 'Zend\Form\Element\Checkbox', 'attributes' => array('value' => '0'), 'options' => array('label' => $this->_translations['main_content_of_the_day'])),
            array('name' => 'copyrights', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_copytight'])),
            array('name' => 'author', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_author'])),
            array('name' => 'date', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('maxlength' => '10', 'req' => '', 'val' => 'dateSlash', 'class' => 'date-pick inp-form-date date-pick-max-date-set', 'maxdate' => date('d/m/Y', strtotime('+1 days'))), 'options' => array('label' => $this->_translations['main_date'])),
            array('name' => 'specs', 'type' => 'Zend\Form\Element\Button', 'attributes' => array('class' => 'content_news_add_edit_specs form-submit', 'value' => $this->_translations['main_select']), 'options' => array('label' => $this->_translations['main_specializations'])),
            array('name' => 'specs_value', 'type' => 'Zend\Form\Element\Hidden', 'attributes' => array('class' => 'no_height content_news_add_edit_specs_value'), 'options' => array()),
            array('name' => 'spec_names', 'type' => 'Zend\Form\Element\Hidden', 'attributes' => array('class' => 'no_height content_spec_names')),
            array('name' => 'avatar', 'type' => 'Zend\Form\Element\Button', 'attributes' => array('class' => 'content_add_edit_avatar form-submit', 'value' => $this->_translations['main_select']), 'options' => array('label' => $this->_translations['main_avatar'])),
            array('name' => 'avatar_value', 'type' => 'Zend\Form\Element\Hidden', 'attributes' => array('id' => 'avatar', 'req' => '', 'val' => 'avatar', 'class' => 'off_site_error no_height content_add_edit_avatar_value'), 'options' => array()),
            array('name' => 'collection', 'type' => 'Zend\Form\Element\Hidden', 'options' => array(), 'attributes' => array('class' => 'no_height')),
            array('name' => 'collection_button', 'type' => 'Zend\Form\Element\Button', 'options' => array('label' => $this->_translations['main_collections']), 'attributes' => array('value' => $this->_translations['main_set'], 'class' => 'collection_button news form-submit')),
            array('name' => 'nextStep', 'type' => 'Zend\Form\Element\Button', 'attributes' => array('title' => $this->_translations['main_next'], 'class' => 'info-tooltip next_button submitStep')),
            array('name' => 'prevStep', 'type' => 'Zend\Form\Element\Button', 'attributes' => array('title' => $this->_translations['main_prev'], 'class' => 'info-tooltip prev_button prevStep')),
            array('name' => 'save', 'type' => 'Zend\Form\Element\Button', 'attributes' => array('title' => $this->_translations['main_save'], 'class' => 'info-tooltip save_button submitStep')),
            array('name' => 'main_protocol', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_protocol'])),
            array('name' => 'main_stream', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => 'Ścieżka do pliku')),
            array('name' => 'main_bitrate', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => '', 'val' => 'num'), 'options' => array('label' => $this->_translations['main_bitrate'])),
            array('name' => 'main_dimension', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_dimension'])),
            array('name' => 'thumb_protocol', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_protocol'])),
            array('name' => 'thumb_stream', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_stream'])),
            array('name' => 'thumb_bitrate', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => '', 'val' => 'num'), 'options' => array('label' => $this->_translations['main_bitrate'])),
            array('name' => 'thumb_dimension', 'type' => 'Zend\Form\Element\Text', 'attributes' => array('class' => 'inp-form', 'req' => ''), 'options' => array('label' => $this->_translations['main_dimension'])),
        );

        $this->validation = array(
            'title' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                ),
                'filters' => array(
                    array('name' => '\Zend\Filter\StripTags'),
                ),
            ),
            'main_site_id' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'break_chain_on_failure' => true, 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required']))),
                    array('name' => 'in_array', 'options' => array('haystack' => $mainSiteSelectValidation, 'messages' => array(\Zend\Validator\InArray::NOT_IN_ARRAY => $this->_translations['error_select_value']))),
                )
            ),
            'esculap_collection' => array('required' => false),
            'active' => array('required' => false),
            'searchable' => array('required' => false),
            'language' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'in_array', 'options' => array('haystack' => $_languageValidate, 'messages' => array(\Zend\Validator\InArray::NOT_IN_ARRAY => $this->_translations['error_select_value'])))
                )
            ),
            'keywords' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'regex', 'options' => array('pattern' => '/' . RegexBase::get('keywords') . '/', 'messages' => array(\Zend\Validator\Regex::NOT_MATCH => 'niepasuje'))),
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'content_of_the_day' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'in_array', 'options' => array('haystack' => array(0, 1)), 'messages' => array(\Zend\Validator\InArray::NOT_IN_ARRAY => $this->_translations['main_content_of_the_day_eror']))
                )
            ),
            'copyrights' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'author' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'date' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required']))),
                    array('name' => 'regex', 'options' => array('pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/', 'messages' => array(\Zend\Validator\Regex::NOT_MATCH => $this->_translations['error_date_format_slashes'])))
                )
            ),
            'specs' => array('required' => false),
            'specs_value' => array('required' => false),
            'spec_names' => array('required' => false),
            'avatar' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'main_protocol' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'main_stream' => array(
                'required' => true,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'main_bitrate' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required']))),
                    array('name' => 'regex', 'options' => array('pattern' => '/' . RegexBase::get('num') . '/D', 'messages' => array(\Zend\Validator\Regex::NOT_MATCH => $this->_translations['error_value_must_be_integer']))),
                )
            ),
            'main_dimension' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'thumb_protocol' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'thumb_stream' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
            'thumb_bitrate' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required']))),
                    array('name' => 'regex', 'options' => array('pattern' => '/' . RegexBase::get('num') . '/D', 'messages' => array(\Zend\Validator\Regex::NOT_MATCH => $this->_translations['error_value_must_be_integer']))),
                )
            ),
            'thumb_dimension' => array(
                'required' => false,
                'validators' => array(
                    array('name' => 'not_empty', 'options' => array('messages' => array(\Zend\Validator\NotEmpty::IS_EMPTY => $this->_translations['error_value_is_required'])))
                )
            ),
        );

        $this->_messages = array(
            'title' => array(
                $this->_translations['error_value_is_required'],
            ),
            'description' => array(
            ),
            'head' => array(
            ),
            'main_site_id' => array(
                $this->_translations['error_value_is_required'],
                $this->_translations['error_select_value'],
            ),
            'language' => array(
                $this->_translations['error_select_value']
            ),
            'keywords' => array(
                'niepasuje',
                $this->_translations['error_value_is_required']
            ),
            'author' => array(
                $this->_translations['error_value_is_required']
            ),
            'copyrights' => array(
                $this->_translations['error_value_is_required']
            ),
            'date' => array(
                $this->_translations['error_value_is_required'],
                $this->_translations['error_date_format_slashes']
            ),
            'avatar' => array(
                $this->_translations['error_value_is_required']
            ),
            'main_protocol' => array(
                $this->_translations['error_value_is_required']
            ),
            'main_stream' => array(
                $this->_translations['error_value_is_required']
            ),
            'main_bitrate' => array(
                $this->_translations['error_value_is_required'],
                $this->_translations['error_value_must_be_integer'],
            ),
            'main_dimension' => array(
                $this->_translations['error_value_is_required']
            ),
            'thumb_protocol' => array(
                $this->_translations['error_value_is_required']
            ),
            'thumb_stream' => array(
                $this->_translations['error_value_is_required']
            ),
            'thumb_bitrate' => array(
                $this->_translations['error_value_is_required'],
                $this->_translations['error_value_must_be_integer'],
            ),
            'thumb_dimension' => array(
                $this->_translations['error_value_is_required']
            ),
        );

        parent::init($this->elements);
    }

    public function draw() {

        $queue = array(
            1 => array(
                'name' => $this->_translations['main_basic_information'],
                'lock' => false,
                'elements' => array(
                    'avatar',
                    'avatar_value',
                    'title',
                    'head',
                    'description',
                    //'keywords',
                    //'collection',
                    //'collection_button',
                ),
                'navigation' => array(
                    'nextStep',
                ),
            ),
            2 => array(
                'name' => 'Plik wideo',
                'lock' => true == $this->edit ? 0 : 1,
                'elements' => array(
                    //'main_protocol',
                    'main_stream',
                    //'main_bitrate',
                    //'main_dimension',
                ),
                'navigation' => array(
                    'prevStep',
                    'nextStep',
                ),
            ),
            /*3 => array(
                'name' => $this->_translations['main_thumb_stream'],
                'lock' => true == $this->edit ? 0 : 1,
                'elements' => array(
                    'thumb_protocol',
                    'thumb_stream',
                    'thumb_bitrate',
                    'thumb_dimension',
                ),
                'navigation' => array(
                    'prevStep',
                    'nextStep',
                ),
            ),*/
            3 => array(
                'name' => $this->_translations['main_additional_informations'],
                'lock' => true == $this->edit ? 0 : 1,
                'elements' => array(
                    'author',
                    'copyrights',
                    'date',
                    //'language',
                    'main_site_id',
                    'active',
                    'searchable',
                    'esculap_collection',
                    //'content_of_the_day',
                    //'specs',
                    //'specs_value',
                    //'spec_names',
                ),
                'navigation' => array(
                    'prevStep',
                    'save',
                ),
            ),
        );

        $this->form->queue = $queue;

        return $this->form;
    }

    public function addachDefaultFilters() {
        if (null !== $this->filterChain) return;

        //$this->filtersForAll[] = new Filter\StripTags;
        $this->filtersForAll[] = new Filter\StringTrim;
        $this->filtersForAll[] = new \System\Filter\PregReplaceEx(array('match' => "/'/", 'replace' => "''"));
    }

    public function setData($data) {
        foreach($data as $name => $value) {
            $value = (int)$value;

            if (($name == 'active' || $name == 'searchable' || $name == 'esculap_collection' || $name == 'content_of_the_day') && $value == 1) {
                $this->form->get($name)->setAttribute('checked' , 'checked');
            } elseif ($name == 'active' || $name == 'searchable' || $name == 'esculap_collection' || $name == 'content_of_the_day') {
                /** @var \Zend\Form\Form $form */
                $form = $this->form;
                $form->get($name)->setValue(0);
                $data[$name] = $value = 0;
            }
        }

        if (!isset($data['active'])) {
            $data['active'] = 0;
        }
        if (!isset($data['searchable'])) {
            $data['searchable'] = 0;
        }
        if (!isset($data['esculap_collection'])) {
            $data['esculap_collection'] = 0;
        }
        if (!isset($data['content_of_the_day'])) {
            $data['content_of_the_day'] = 0;
        }

        parent::setData($data);
    }

}

?>