<?php

namespace System\Form;

class CmsBcCampaign extends AbstractForm implements DrawableInterface {
	
	
	protected $translations;
	protected $name = 'add_edit_bc_campaign';
	
	
	protected $_messages = array();
	
	
	protected $filterExceptions = array();
	
	
	public static function neadedTranslations() {
		return array(
			'main_name' , 'main_save' , 'main_client' , 'main_campaign_info' , 'error_value_is_required' , 'error_select_client'
		);
	}
	
	
	public function __construct( array $translations , $cliets ) {
		$this->translations = $translations;
		
		
		if( !is_array( $cliets ) ) {
			throw new \Exception( __METHOD__ . '. Lista klientów musi być tablicą' );
		}
		
		
		$clientsList = array();
		$clientsListValidation = array();
		foreach( $cliets as $clientId => $clientName ) {
			
			$clientsList[] = array(
				'value' => $clientId,
				'label' => $clientName
			);
			
			$clientsListValidation[] = $clientId;
		}
		
		
		$this->fields = array(
			array( 'name' => 'title' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'min5chars' , 'class' => 'inp-form-long' ) , 'options' => array( 'label' => $this->translations[ 'main_name' ] ) ),
			array( 'name' => 'client' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'req' => '' , 'val' => 'num' , 'class' => 'styledselect_form_1' ) , 'options' => array( 'value_options' => $clientsList , 'label' => $this->translations[ 'main_client' ] ) ),
			array( 'name' => 'save', 'type' => 'Zend\Form\Element\Button', 'attributes' => array( 'title' => $this->translations['main_save'] ,'class' => 'info-tooltip save_button submitStep' ) ),
		);
		
		
		$this->validation = array(
			'title' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
				)
			),
			'client' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'options' => array( 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ) ),
					array( 'name' => 'in_array' , 'options' => array( 'haystack' => $clientsListValidation , 'messages' => array( \Zend\Validator\InArray::NOT_IN_ARRAY => $this->translations[ 'error_select_client' ] ) ) )
				),
			),
		);
		
		
		parent::init( $this->fields );
		
		$this->_messages = array(
			'title' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'client' => array(
				$this->translations[ 'error_select_client' ]
			)
		);
	}
	
	
	public function getData() {
		
		return $this->form->getData();
	}
	
	
	public function draw() {
		
		$queue = array(
			1 => array(
				'name' => $this->translations[ 'main_campaign_info' ],
				'lock' => 0,
				'elements' => array(
					'title',
					'client',
				),
				'navigation' => array(
					'save'
				),
			),
		);
		
		$this->form->queue = $queue;
			
		return $this->form;
	}
	
	
}


?>