<?php

namespace System\Form;

class CmsBcElement extends AbstractForm implements DrawableInterface {
	
	protected $name = 'bc_element';
	protected $edit = false;
	
	protected $filterExceptions = array( 'target_type' , 'additional_stats' , 'content_title' );
	
	public static function neadedTranslations() {
		return array(
			'main_from' , 'main_to' , 'main_target_type' , 'main_next' , 'main_prev' , 'main_save' , 'main_select' , 'main_specializations' , 'main_user_type' , 'main_element_type' , 'main_place' ,
			'main_banner' , 'main_billboard' , 'main_avatar' , 'main_title' , 'main_content' , 'main_basic_information' , 'msin_element_target_type' , 'error_value_is_required' , 'error_date_format_slashes' ,
			'main_select' , 'content_id' , 'main_url' , 'error_value_must_be_url' , 'error_conten_id_is_invalid' , 'error_dimage_not_exists' , 'main_video_title' , 'main_video_description' , 'main_video_file',
			'main_bc_element_invalid_place_form_element' , 'main_additional_stats'
		);
	}
	
	public function __construct( array $translations , $targetTypes , $elementTypes , $edit = false , $book = false , $disabled = false ) {
		$this->translations = $translations;
		$this->edit = (bool)$edit;
		$this->book = (bool)$book;
		
		$targetTypesValues = array();
		$targetTypesValidation = array();
		
		foreach( $targetTypes as $elementTypeId => $targetTypeName ) {
			
			$targetTypesValidation[] = $elementTypeId;
			
			$targetTypesValues[] = array(
				'label' => $targetTypeName,
				'value' => $elementTypeId
			);
		}
		
		
		$elementTypeValues = array();
		$elementTypeValidation = array();
		foreach( $elementTypes as $elementTypeId => $elementTypeName ) {
			
			$elementTypeValues[] = array(
				'value' => $elementTypeId,
				'label' => $elementTypeName
			);
			
			$elementTypeValidation[] = $elementTypeId;
		}
		
		
		$fields = array(
			array( 'name' => 'from' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'maxlength' => '10' , 'class' => 'date-pick inp-form-date datepicker depminsrc_1 depmaxtarget_1' ) , 'options' => array( 'label' => $this->translations[ 'main_from' ] ) ),
			array( 'name' => 'to' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'maxlength' => '10' , 'class' => 'date-pick inp-form-date datepicker depmaxsrc_1 depmintarget_1 ' ) , 'options' => array( 'label' => $this->translations[ 'main_to' ] ) ),
			array( 'name' => 'target_type' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'req' => '' , 'val' => 'mnumeric' , 'multiple' => 'multiple' , 'class' => 'styledselect_form_1 bc_target_type' ) , 'options' => array( 'label' => $this->translations[ 'main_target_type' ] , 'value_options' => $targetTypesValues ) ),
			array( 'name' => 'element_type' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'req' => '' , 'val' => 'numeric' , 'class' => 'styledselect_form_1 bc_element_type') , 'options' => array( 'label' => $this->translations[ 'main_element_type' ] , 'value_options' => $elementTypeValues ) ),
			array( 'name' => 'specs' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'banner_spec_choose target_type target_type_1 form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_specializations' ] ) ),
			array( 'name' => 'specs_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'specs' , 'req' => 'target_type[]:reg:1' , 'class' => 'off_site_error target_type  target_type_1 no_height content_news_add_edit_specs_value') , 'options' => array() ),
			array( 'name' => 'spec_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => ' target_type target_type_1 no_height content_spec_names' ) ),
			array( 'name' => 'user_types' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'user_type_values_set target_type target_type_2 content_add_edit_use_types form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_user_type' ] ) ),
			array( 'name' => 'user_types_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'user_types' , 'req' => 'target_type[]:reg:2' , 'class' => 'off_site_error target_type target_type_2 no_height user_type_values') , 'options' => array() ),
			array( 'name' => 'user_types_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'target_type target_type_2 no_height content_spec_names' ) ),
			array( 'name' => 'element_place' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'bc_element_place_choose form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_place' ] ) ),
			array( 'name' => 'element_place_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'element_place' , 'req' => '' , 'class' => 'off_site_error no_height element_place_value' ) ),
			array( 'name' => 'element_place_name' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'element_place_name no_height' ) ),
			
			
			array( 'name' => 'banner_url' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'banner_url_btn' , 'req' => 'element_type:reg:(2|3|4)' , 'class' => 'off_site_error no_height element_type element_type_2 element_type_3 element_type_4' )),
			array( 'name' => 'banner_name' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height element_type element_type_2 element_type_3 element_type_4' )),
			array( 'name' => 'banner_url_btn' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'load_client_banners form-submit off_site_error form-submit element_type element_type_2 element_type_3 element_type_4' , 'value' => $this->translations[ 'main_select' ]	) , 'options' => array( 'label' => $this->translations[ 'main_banner' ] ) ),
			
			
			array( 'name' => 'billboard_url' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'billboard_url_btn' , 'req' => 'element_type:val:3' , 'class' => 'off_site_error no_height element_type element_type_3' ) ),
			array( 'name' => 'billboard_name' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height element_type element_type_3' ) ),
			array( 'name' => 'billboard_url_btn' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'load_client_banners form-submit element_type element_type_3' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => 'Tło strony' ) ),
			
			array( 'name' => 'video_file' , 'type' => 'Zend\Form\Element\Text' , 'options' => array( 'label' => $this->translations[ 'main_video_file' ] ) , 'attributes' => array( 'req' => 'element_type:reg:(7)' , 'val' => '' , 'class' => 'inp-form element_type element_type_7' ) ),
			array( 'name' => 'video_title' , 'type' => 'Zend\Form\Element\Text' , 'options' => array( 'label' => $this->translations[ 'main_video_title' ] ) , 'attributes' => array( 'req' => 'element_type:reg:(7)' , 'val' => '' , 'class' => 'inp-form element_type element_type_7') ),
			array( 'name' => 'video_description' , 'type' => 'Zend\Form\Element\Textarea' , 'options' => array( 'label' => $this->translations[ 'main_video_description' ] ) , 'attributes' => array( 'req' => 'element_type:reg:(7)' , 'val' => '' , 'class' => 'form-textarea element_type element_type_7' ) ),
			
			array( 'name' => 'url' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => 'element_type:reg:(2|3|4)' , 'val' => 'website' , 'class' => 'inp-form element_type element_type_2 element_type_3 element_type_4' ) , 'options' => array( 'label' => $this->translations[ 'main_url' ] ) ),
			
			array( 'name' => 'contnt_id' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => 'element_type:val:1' , 'class' => 'inp-form element_type element_type_1 content_id' ) , 'options' => array( 'label' => $this->translations[ 'content_id' ] ) ),
			array( 'name' => 'unlogged_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'no_height target_type target_type_3' , 'value' => 1 , 'checked' => 'checked' ) , 'options' => array( 'checked' => 'checked' , 'label' => '' ) ),
			/*array( 'name' => 'content_image' , 'type' => 'Zend\Form\Element\File' , 'attributes' => array( 'req' => 'element_type:val:4' , 'class' => 'inp-form element_type element_type_4' ) , 'options' => array( 'label' => $this->translations[ 'main_avatar' ] ) ),*/
			array( 'name' => 'content_title' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => 'element_type:val:4' , 'class' => 'inp-form element_type element_type_4' ) , 'options' => array( 'label' => $this->translations[ 'main_title' ] ) ),  
			array( 'name' => 'content_data' , 'type' => 'Zend\Form\Element\Textarea' , 'attributes' => array( 'req' => 'element_type:val:4' , 'class' => 'form-textarea element_type element_type_4' ) , 'options' => array( 'label' => $this->translations[ 'main_content' ] ) ),
			
			array( 'name' => 'additional_stats' , 'type' => 'Zend\Form\Element\Textarea' , 'attributes' => array( 'class' => 'form-textarea bc_additional_statistics' ) , 'options' => array( 'label' => $this->translations[ 'main_additional_stats' ] ) ),
			
			array( 'name' => 'nextStep', 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'next_button submitStep' , 'title' => $this->translations['main_next'] , 'class' => 'info-tooltip next_button submitStep' ) ),
			array( 'name' => 'prevStep', 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'prev_button prevStep' , 'title' => $this->translations['main_prev'] , 'class' => 'info-tooltip prev_button prevStep' ) ),
			array( 'name' => 'save', 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'save_button submitStep' , 'title' => $this->translations['main_save'] ,'class' => 'info-tooltip save_button submitStep' ) ),
		);
		
		
		if( true == $this->book ) { // jeśli mamy do czynienia z rezerwacją to nie wymagam (przez js) wypełnienia pól dla wybranego typu
			
			$list = array(
				'banner_url',
				'billboard_url',
				'url',
				'contnt_id',
				'content_title',
				'content_data'
			);
			
			foreach( $fields as $k => $v ) {
				if( in_array( $v[ 'name' ] , $list ) ) {
					
					unset( $fields[ $k ][ 'attributes' ][ 'req' ] );
				}
			}
		}
		
		
		
		$this->validation = array(
			'from' => array(
				'require' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_date_format_slashes' ] ) ) )
				),
			),
			'to' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ),
					array( 'name' => 'regex' , 'options' => array( 'pattern' => '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , 'messages' => array( \Zend\Validator\Regex::NOT_MATCH => $this->translations[ 'error_date_format_slashes' ] ) ) )
				),
			),
			'target_type' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'element_type' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'element_place_value' => array(
				'required' => true,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ),
					array( 'name' => 'System\Validator\BcElementPlaceForElement' , 'messages' => array( \System\Validator\BcElementPlaceForElement::INVALID_PLACE => $this->translations[ 'main_bc_element_invalid_place_form_element' ] ) )
				),
			),
			'user_types_value' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'banner_url' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ),
					array( 'name' => 'System\Validator\Dimage' , 'options' => array( 'messages' => array( \System\Validator\Dimage::INVALID_DIMAGE => $this->translations[ 'error_dimage_not_exists' ] ) ) )
				),
			),
			'billboard_url' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'contnt_id' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) ),
					array( 'name' => 'System\Validator\ContentId' , 'options' => array( 'messages' => array( \System\Validator\ContentId::INVALID_CONTENT_ID => $this->translations[ 'error_conten_id_is_invalid' ] ) ) )
					
				),
			),
			'content_image' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'content_title' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
				'filters' => array(
					array( 'name' => 'strip_tags' , 'options' => array( 'allowTags' => array( 'br,b,u,i,sup,sub' ) ) )
				)
			),
			'content_data' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'not_empty' , 'messages' => array( \Zend\Validator\NotEmpty::IS_EMPTY => $this->translations[ 'error_value_is_required' ] ) )
				),
			),
			'url' => array(
				'required' => false,
				'validators' => array(
					array( 'name' => 'System\Validator\WebAddress' , 'options' => array( 'messages' => array( \System\Validator\WebAddress::INVALID_ADDRESS => $this->translations[ 'error_value_must_be_url' ] ) ) )
				),
			),
			'billboard_name' => array( 'required' => false ),
			'banner_name' => array( 'required' => false ),
			'user_types_value' => array( 'required' => false ),
			'specs' => array( 'required' => false ),
			'spec_names' => array( 'required' => false ),
			'user_types' => array( 'required' => false ),
			'user_types_names' => array( 'required' => false ),
			'element_place_name' => array( 'required' => false )
		);
		
		
		parent::init( $fields );
		
		
		if( true === $disabled ) {
			
			$this->getForm()->get( 'from' )->setAttribute( 'disabled' , 'disabled' );
			$this->getForm()->get( 'to' )->setAttribute( 'disabled' , 'disabled' );
			$this->getForm()->get( 'target_type' )->setAttribute( 'disabled' , 'disabled' );
			$this->getForm()->get( 'element_type' )->setAttribute( 'disabled' , 'disabled' );
			$this->getForm()->get( 'specs' )->setAttribute( 'disabled' , 'disable' );
			$this->getForm()->get( 'element_place' )->setAttribute( 'disabled' , 'disabled' );
			$this->getForm()->get( 'user_types' )->setAttribute( 'disabled' , 'disabled' );
			
		}
		
		$this->_messages = array(
			'from' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_date_format_slashes' ]
			),
			'to' => array(
				$this->translations[ 'error_value_is_required' ],
				$this->translations[ 'error_date_format_slashes' ]
			),
			'target_type' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'element_type' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'specs' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'user_types' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'element_place' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'banner_url' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'billboard_url' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'contnt_id' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'content_image' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'content_title' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'content_data' => array(
				$this->translations[ 'error_value_is_required' ]
			),
			'url' => array(
				$this->translations[ 'error_value_must_be_url' ]
			)
		);
	}
	
	
	
	public function draw() {
		$this->replaceErrors( array( 'element_place_value' => 'element_place' ) );
		
		$queue = array(
			1 => array(
				'name' => $this->translations[ 'main_basic_information' ],
				'lock' => false,
				'elements' => array(
					'from',
					'to',
					'target_type',
					'element_type',
				),
				'navigation' => array(
					'nextStep'
				),
			),
			2 => array(
				'name' => $this->translations[ 'msin_element_target_type' ],
				'lock' => !$this->edit,
				'elements' => array(
					'specs',
					'specs_value',
					'spec_names',
					'user_types',
					'user_types_value',
					'user_types_names',
					'element_place',
					'element_place_name',
					'element_place_value',
					'billboard_url',
					'billboard_url_btn',
					'billboard_name',
					'banner_url',
					'banner_url_btn',
					'banner_name',
					'contnt_id',
					'unlogged_value',
					/*'content_image',*/
					'content_title',
					'content_data',
					'video_file',
					'video_title',
					'video_description',
					'url',
					'additional_stats',
				),
				'navigation' => array(
					'prevStep',
					'save'
				),
			),
		);
		
		
		$this->form->queue = $queue;
		
		
		return $this->form;
	}
	
	
	public function setData( $data ) { 
		
		parent::setData( $data );
	}
	
	public function getData() {
		
		return $this->form->getData();
	}
	
	public function isValid( $data ) {
		
		$elementType = (int)$data[ 'element_type' ];
		$targetTypeValue = (array)$data[ 'target_type' ];
		
		
		if( in_array( 1 , $targetTypeValue ) ) {
		
			$this->validation[ 'specs_value' ][ 'required' ] = true;
			
		} if( in_array( 2 , $targetTypeValue ) ) {
			
			$this->validation[ 'user_types_value' ][ 'required' ] = true;
		}
		
		
		// jeśli mamy do czynienia z rezerwacją elementu to wypełnianie jego pól jest niewymagane należy wypełnić jedynie dane podstawowe.
		if( false == $this->book ) {
			
			if( $elementType == 1 ) {
				$this->validation[ 'contnt_id' ][ 'required' ] = true;
			} elseif( $elementType == 2 ) {
				$this->validation[ 'banner_url' ][ 'required' ] = true;
				$this->validation[ 'url' ][ 'required' ] = true;
			} elseif( $elementType == 3) {
				$this->validation[ 'banner_url' ][ 'required' ] = true;
				$this->validation[ 'billboard_url' ][ 'required' ] = true;
				$this->validation[ 'url' ][ 'required' ] = true;
			} elseif( $elementType == 4 ){
				$this->validation[ 'content_title' ][ 'required' ] = true;
				$this->validation[ 'content_data' ][ 'required' ] = true;
				$this->validation[ 'url' ][ 'required' ] = true;
			}
			
		}
		
		$validationResult = parent::isValid( $data );
		
		
		if( count( ( $messages = $this->getMessages() ) ) ) {
			
			if( isset( $messages[ 'element_place_value' ] ) ) {
				
				$this->getForm()->get( 'element_place' )->setMessages( $this->getForm()->get( 'element_place_value' )->getMessages() );
				$this->getForm()->get( 'element_place_value' )->setMessages( array() );
			}
		}	
		
		return $validationResult;
	}
}

?>