<?php

namespace System\Form;

class CmsBcElementCheckAvailability extends AbstractForm implements DrawableInterface  {
	
	protected $name = 'bc_element_availability_check';
	protected $edit = false;
	
	protected $filterExceptions = array( 'target_type' , 'element_place_value' );
	
	public static function neadedTranslations() {
		return array(
			'main_from' , 'main_to' , 'main_target_type' , 'main_next' , 'main_prev' , 'main_save' , 'main_select' , 'main_specializations' , 'main_user_type' , 'main_element_type' , 'main_place' ,
			'main_banner' , 'main_billboard' , 'main_avatar' , 'main_title' , 'main_content' , 'main_basic_information' , 'msin_element_target_type' , 'error_value_is_required' , 'error_date_format_slashes' ,
			'main_select' , 'content_id' , 'main_url' , 'error_value_must_be_url' , 'error_conten_id_is_invalid' , 'error_dimage_not_exists'
		);
	}
	
	public function __construct( array $translations , $targetTypes , $elementPlaces = array() , $edit = false ) {
		$this->translations = $translations;
		
		
		$targetTypesValues = array();
		$targetTypesValidation = array();
		
		foreach( $targetTypes as $elementTypeId => $targetTypeName ) {
			
			$targetTypesValidation[] = $elementTypeId;
			
			$targetTypesValues[] = array(
				'label' => $targetTypeName,
				'value' => $elementTypeId
			);
		}
		
		$targetPlaceValues = array();
		$targetPlaceValidation = array();
		foreach( $elementPlaces as $elementPlaceId => $targetPlaceName ) {
			
			$targetPlaceValidation[] = $elementPlaceId;
			
			$targetPlaceValues[] = array(
				'label' => $targetPlaceName,
				'value' => $elementPlaceId
			);
		}
		
		
		
		
		$fields = array(
			array( 'name' => 'from' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'maxlength' => '10' , 'class' => 'date-pick inp-form-date datepicker depminsrc_10 depmaxtarget_10' ) , 'options' => array( 'label' => $this->translations[ 'main_from' ] ) ),
			array( 'name' => 'to' , 'type' => 'Zend\Form\Element\Text' , 'attributes' => array( 'req' => '' , 'val' => 'dateSlash' , 'mindate' => date( 'd-m-Y' ) , 'maxlength' => '10' , 'class' => 'date-pick inp-form-date datepicker depmaxsrc_10 depmintarget_10 ' ) , 'options' => array( 'label' => $this->translations[ 'main_to' ] ) ),
			//array( 'name' => 'element_place' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'bc_element_place_choose form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_place' ] ) ),
			//array( 'name' => 'element_place_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'element_place' , 'req' => '' , 'class' => 'off_site_error no_height element_place_value' ) ),
			//array( 'name' => 'element_place_name' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'element_place_name no_height' ) ),
			
			array( 'name' => 'element_place_value' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'multiple' => 'multiple' , 'req' => '' , 'val' => 'numeric' , 'class' => 'styledselect_form_1' ) , 'options' => array( 'value_options' => $targetPlaceValues , 'label' => $this->translations[ 'main_place' ] ) ),
			
			
			array( 'name' => 'target_type' , 'type' => 'Zend\Form\Element\Select' , 'attributes' => array( 'multiple' => 'multiple' , 'req' => '' , 'val' => 'numeric' , 'class' => 'styledselect_form_1 bc_target_type' ) , 'options' => array( 'label' => $this->translations[ 'main_target_type' ] , 'value_options' => $targetTypesValues ) ),
			array( 'name' => 'specs' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'target_type target_type_1 banner_spec_choose form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_specializations' ] ) ),
			array( 'name' => 'specs_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'specs' , 'req' => 'target_type[]:reg:[1]' , 'class' => 'off_site_error target_type  target_type_1 no_height content_news_add_edit_specs_value') , 'options' => array() ),
			array( 'name' => 'spec_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => ' target_type target_type_1 no_height content_spec_names' ) ),
			array( 'name' => 'user_types' , 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'user_type_values_set target_type target_type_2 content_add_edit_use_types form-submit' , 'value' => $this->translations[ 'main_select' ] ) , 'options' => array( 'label' => $this->translations[ 'main_user_type' ] ) ),
			array( 'name' => 'user_types_value' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'id' => 'user_types' , 'req' => 'target_type[]:reg:[2]' , 'class' => 'off_site_error target_type target_type_2 no_height user_type_values') , 'options' => array() ),
			array( 'name' => 'user_types_names' , 'type' => 'Zend\Form\Element\Hidden' , 'attributes' => array( 'class' => 'target_type target_type_2 no_height content_spec_names' ) ),
			
			array( 'name' => 'save', 'type' => 'Zend\Form\Element\Button' , 'attributes' => array( 'class' => 'save_button submitStep' , 'title' => $this->translations['main_save'] ,'class' => 'info-tooltip save_button submitStep' ) ),
		);
		
		
		
		
		parent::init( $fields );
	}
	
	
	public function draw() {
		
		$queue = array(
			1 => array(
				'name' => $this->translations[ 'main_basic_information' ],
				'lock' => false,
				'elements' => array(
					'from',
					'to',
					'target_type',
					'specs',
					'specs_value',
					'spec_names',
					'user_types',
					'user_types_value',
					'user_types_names',
					//'element_place',
					'element_place_value',
					//'element_place_name'
				),
				'navigation' => array(
					'save'
				),
			)
		);
		
		$this->form->queue = $queue;
		
		return $this->form;
	}
	
	
	public function setData( $data ) {
		
		parent::setData( $data );
		
		if( isset( $data[ 'to' ] ) ) {
			
			$this->form->get( 'from' )->setAttribute( 'maxdate' , preg_replace( '/-/' , '/' , $data[ 'to' ] ) );
		} if( isset( $data[ 'from' ] ) ) {
			
			$this->form->get( 'to' )->setAttribute( 'mindate' , preg_replace( '/-/' , '/' , $data[ 'from' ] ) );
		}
	}
	
	public function isValid( $data ) {
		
		$this->validation[ 'element_type' ][ 'required' ] = false;
		
		return parent::isValid( $data );
	}
}

?>