<?php

namespace System\Form;

use Zend\Form\Element as FormElement;

class QuestionForExpert extends AbstractForm implements DrawableInterface
{
    protected $name = 'QuestionForExpert';

    public function __construct()
    {
        $fields = [
            ['name' => 'email', 'options' => ['label' => 'Adres e-mail']],
            ['name' => 'title', 'options' => ['label' => 'Tytuł pytania']],
            ['name' => 'question', 'type' => 'Zend\Form\Element\Textarea', 'options' => ['label' => 'Treść pytania']],
            ['name' => 'submit', 'type' => 'Zend\Form\Element\Submit', 'attributes' => ['value' => 'Wyślij', 'class' => 'btn']],
        ];

        $this->validation = [
            'email'    => [
                'validators' => [
                    ['name' => 'not_empty', 'options' => ['messages' => [\Zend\Validator\NotEmpty::IS_EMPTY => 'Adres e-mail nie może być pusty']]],
                    ['name' => 'email_address', 'options' => ['messages' => [\Zend\Validator\EmailAddress::INVALID_FORMAT => 'Adres e-mail musi być poprawny']]]
                ]
            ],
            'title'    => [
                'validators' => [
                    ['name' => 'not_empty', 'options' => ['messages' => [\Zend\Validator\NotEmpty::IS_EMPTY => 'Tytuł pytania nie może być pusty']]]
                ]
            ],
            'question' => [
                'validators' => [
                    ['name' => 'not_empty', 'options' => ['messages' => [\Zend\Validator\NotEmpty::IS_EMPTY => 'Treść pytania nie może być pusta']]]
                ],
                'filters'    => [
                    ['name' => 'strip_tags']
                ]
            ]
        ];

        parent::init($fields);
    }

    public function draw()
    {
        $this->form->queue = ['email', 'title', 'question', 'submit'];

        return $this->form;
    }
}
