<?php

namespace System\Form\Transform;

class CmsBcElement {
	
	protected $transformationRules = array(
		'starts' => 'from',
		'ends' => 'to',
		'target' => 'target_type',
		'type' => 'element_type',
		'specs_value' => 'specs_value',
		'user_type_value' => 'user_type_value',
		'place' => 'element_place_value',
		'content_id' => 'contnt_id',
		'bannerUrl' => 'banner_url',
		'billboardUrl' => 'billboard_url',
		'title' => 'content_title',
		'content' => 'content_data',
		'image' => 'banner_url',
		'url' => 'url',
		'additionalStats' => 'additional_stats'
	);
	
	public function transform( $data ) {
		
		$result = array();
		
		foreach( $data as $key => $value ) {
			
			if( isset( $this->transformationRules[ $key ] ) ) {
				$name = $this->transformationRules[ $key ];
				
				if( 'from' == $name ||
					'to' == $name ) {
					
					if( 10 > strlen( (int)$value )  ) {
						
						if( -1 < strpos( $value , '-' ) ) {
							
							$value = explode( '-' , substr( $value , 0 , 10 ) );
							
							$value = "{$value[2]}/{$value[1]}/{$value[0]}";
						}
						
					} elseif( $value ) {
						
						$value = date( 'd/m/Y' , $value );
					}
					
				}
				
				
				$result[ $this->transformationRules[ $key ] ] = $value;
			} else {
			
				$result[ $key ] = $value;
			}
		}
		
		
		return $result;
	}
}

?>