<?php

namespace System\Impersonate;

/**
* Klasa zmieniająca dane uśytkownika tak bay mógł on oglądać treści przeznaczone dla określonych grup, specializacji.
*/
class User {
	
	protected $identityObject;
	protected $oryginalIdentityObject;
	
	public function __construct( $identityObject ) {
		
		$this->identityObject = $identityObject;
		$this->oryginalIdentityObject = clone $identityObject;
	}
	
	public function setSpect( $spec ) {
		
		$specs = array();
		$fullSpecs = array();
		
		foreach( $spec as $specType => $specList ) {
			if( !in_array( $specType , array( 'MAIN' , 'CURRENT' , 'ADDIT' , 'INTE' ) ) ||
				!is_array( $specList ) ) 
				continue;
			
			$specType = preg_replace( array( '/MAIN/' , '/CURRENT/' , '/ADDIT/' , '/INTE/' ) , array( 2 , 3 , 4 , 5 ) , $specType  );
			
			
			$fullSpecs[ $specType ] = $specList;
			if( 5 > $specType ) {
				
				foreach( $specList as $specCode ) {
				
					$specs[] = $specCode;
				}
			}
		}
		
		$this->identityObject->setProperty( 
			'full_spec_code' , 
			$fullSpecs
		);
		
		$this->identityObject->setProperty( 
			'spec_code' , 
			$specs
		);
		
		return $this;
	}

	public function setGroup( $group ) {
		
		
		return $this;
	}
	
	public function restoreOryginalValues() {
		
		$this->identityObject->setProperty( 'spec_code' , $this->oryginalIdentityObject->spec_code );
	}
}

?>