<?php

namespace System\Misc;

class Filter {

    protected $count = false;
    protected $filters = array();
    protected $constraints = array();
    protected $order = null;
    protected $limit = null;

    public function __construct() {
        
    }

    protected $additionslWhere = array();

    public function addFilter(FilterType\AbstractFilterType $filter) {
        $this->filters[] = $filter;

        if (null !== $filter->getAdditionalJoin()) {
            $this->filters[] = $filter->getAdditionalJoin();
        }

        return $this;
    }

    public function setLimit(FilterConstraint\LimitConstraint $limit, FilterConstraint\OffsetConstraint $offset = null) {
        $this->limit = $limit->getQuery();

        if (null !== $this->limit && null !== $offset) {
            $this->limit .= ' ';
        }

        if (null !== $offset) {
            $this->limit .= $offset->getQuery();
        }
    }

    public function setOrder(FilterConstraint\OrderConstraint $order) {
        $this->order = $order;
    }

    public function getFilters() {
        return $this->filters;
    }

    public function addConstraint(FilterType\Column $constraint) {
        if (null !== $constraint->getQuery()) {
            $this->constraints[] = $constraint;
        }

        return $this;
    }

    public function addConstraints(array $constraints) {
        foreach ($constraints as $constraint) {
            $this->addConstraint($constraint);
        }

        return $this;
    }

    public function count($state) {
        $this->count = (bool) $state;

        return $this;
    }

    public function search($miscForms = false) {
        $where = '';
        $tablesList = array();

        foreach ($this->constraints as $constraint) {
            if (strlen($where))
                $where .= ' AND ';
            $where .= $constraint->getQuery();
        }

        if (null !== $this->order) {
            $order = $this->order->getQuery();
        } else {
            $order = null;
        }

        if (null !== $this->limit) {
            $limit = $this->limit;
        } else {
            $limit = null;
        }

        $result = array();

        if ($miscForms) {
            static $MainMiscForms = null;
            if (null == $MainMiscForms) {
                $MainMiscForms = new \Model\MainMiscForms;
            }
            $result = $MainMiscForms->searchForms($where, $order, $limit);
        } else {
            static $MainMiscSettings = null;
            if (null == $MainMiscSettings) {
                $MainMiscSettings = new \Model\MainMiscSettings;
            }
            $result = $MainMiscSettings->searchSettings($where, $order, $limit);
        }

        if ($this->count) {
            return count($result);
        }

        return $result;
    }

}

?>
