<?php

namespace System\Paginator;

class Paginator {
	
	protected $_rows;
	protected $_onPage;
	protected $_page;
	protected $_pages;
	
	public function __construct($rows,$onPage,$page) {
		$this->_rows = $rows;
		$this->_onPage = $onPage;
		$this->_page = $page > 0 ? (int)$page : 1;
		
		if(($this->_page * $onPage - $onPage) > $this->_rows) {
			
			$this->_page = ceil($rows / $onPage);
		}
		
		$this->_pages = ceil($rows / $onPage);
	}
	
	public function offset() {
	
		$res = ($this->_page * $this->_onPage) - $this->_onPage;
		if($res > $this->_rows || 
		   0 > $res ) {
			return 0;
		}
		return $res;
	}

    public function getOnPage() {
        return $this->_onPage;
    }
	
	public function __get($name) {
		$name = "_$name";
		
		if(isset($this->$name))
			return $this->$name;
		return null;
	}

	public function getArray(){
		if($this->_page == 1){
			$result['prev'] = 1;
		}
		else{
			$result['prev'] = $this->_page - 1;
		}

		if($this->_page == $this->_pages){
			$result['next'] = $this->_pages;
		}
		else{
			$result['next'] = $this->_page + 1;
		}

		$result['current'] = $this->_page;
		$result['pages'] = $this->_pages;
		
		return $result;
	}
}

?>