<?php

namespace System\Soap;

class WbServClient {
	
	protected $wsdl = 'http://wbserv.esculap.com/wsdl';
	protected $client;
	protected $sitecode;
	protected $usercode;
	protected $lang;
	
	public function __construct( $sitecode , $usercode , $lang , $wsdl = null ) {
		
		if( null !== $wsdl ) {
			
			$this->wsdl = $wsdl;
		}
		
		$client = new \SoapClient( $this->wsdl , array( 'cache_wsdl' => WSDL_CACHE_BOTH ) );
		$this->client = $client;
		
		
		$this->sitecode = $sitecode;
		$this->usercode = $usercode;
		$this->lang = $lang;
	}
	
	
	public function getElements( $set , $code = null ) {
		
		$elements = $this->client->getCampaignElements (  
			$this->sitecode,
			$this->usercode,
			$this->lang,
			$set,
			$this->getBcCookie(),
			$code
		);
		//var_dump($elements);
		$this->saveBcCookie( $elements );
		return $this->readElements( $elements );
	}
	
	
	protected function getBcCookie() {
		
		if( !isset( $_COOKIE[ 'bc_history' ] ) ) return '';
		
		$cookie = unserialize( $_COOKIE[ 'bc_history' ] );
		$Xml = new \DomDocument;
		$root = $Xml->createElement( 'history' );
		$Xml->appendChild( $root );
		
		foreach( (array)$cookie as $bcElementId => $views ) {
			
			$entity = $Xml->createElement( 'entity' , $views );
			$entity->setAttribute( 'id' , $bcElementId );
			$root->appendChild( $entity );
		}

		return $Xml->saveXML();
	}
	
	protected function saveBcCookie( $data ) {
		
		$Xml = new \DomDocument();
		
		$cookieData = array();
		if( strlen( $data ) && $Xml->loadXML( $data ) ) {
			
			foreach( $Xml->getElementsByTagName( 'entity' ) as $entity ) {
				
				$cookieData[ $entity->getAttribute( 'id' ) ] = $entity->nodeValue;
			}
		}
		
		setcookie( 'bc_history' , serialize( $cookieData ) , time() + 99999999 );
	}
	
	protected function readElements( $data ) {
		$Xml = new \DomDocument;
		if( $Xml->loadXml( $data ) ) {
			
			$result = array();
			
			
			foreach( $Xml->getElementsByTagName( 'element' ) as $element ) {
				
				$entity = array(
					'elementid' => $element->getAttribute( 'id' )
				);
				
				if( true == $element->getAttribute( 'fake' )) {
					
					$entity[ 'fake' ] = true;
				}
				
				foreach( $element->childNodes as $child ) {
					
					$entity[ $child->tagName ] = $child->nodeValue;
				}
				
				$result[] = $entity;
			}
			
			return $result;
		}
		
		return array();
	}
	
	
	public function notifyHit( $mainBcElementId , $url ) {
		
		$this->client->notifyClick(
			$this->sitecode,
			$this->usercode,
			$this->lang,
			$mainBcElementId,
			$url
		);
		
	}
	
}

?>