<?php

namespace System\Translator;

class Translator {
	protected static $_storage;
	protected static $_Slanguage;
	protected $_language;
	
	public function initStorage() {
		if(null === self::$_storage || $self::$_Slanguage !== $this->_language) {
			self::$_storage = new TranslatorStorage($this->_language);
			self::$_Slanguage = $this->_language;
		}
	}
	
	public function __construct($language) {
	
		$this->_language = 'RU';
	//	$this->_language = $language;
		$this->initStorage();
	}
	
	public function translate($name) {
		
		return self::$_storage->$name;
	}
}

class TranslatorStorage {
	
	protected $_data;
	
	public function __construct($language) {
		$MainPhrase = new \Model\MainPhrase();
		
		try {
			$phrase = $MainPhrase->getAll($language);
		} catch(\Exception $e) {
			$phrase = array();
		}
		
		$this->_data = $phrase;
	}
	
	public function __get($name) {
		
		if(is_array(self::$this->_data) && isset(self::$this->_data[$name])) {
			return self::$this->_data[$name];
		}
		
		return null;
	}
	
	protected function _loadCache() {
		
	}
	
	protected function _saveCache() {
		
	}
}

?>
