<?php

Namespace System\User;

class CookieStorage {
	
	/**
	* LAST_LOGGED_LOGIN
	* LAST_LOGGED_TIME
	* 
	* LANG 
	* LAST_BROWSE_LANG
	* SPECS 
	* SETTINGS 
	*/
	
	protected $_userLogin = null;
	protected $_lifetime = -1;
	protected $_lock = false;
	
	public function __construct($userLogin = null,$lifetime = null) {
		$this->_userLogin = $userLogin;
		$this->_slifetime = $lifetime;
		
		$_lock = true;
	}
	
	
	public function setLastLoggedUser($userLogin) {
		if(null !== $this->_userLogin) 
			return $this->set('LAST_LOGGED_LOGIN',$userLogin);
		return $this->set('LAST_LOGGED_LOGIN',$userLogin);
	}
	
	public function getLastLoggedUser() {
		if(null !== $this->_userLogin)
			return $this->get('LAST_LOGGED_LOGIN');
		return $this->get('LAST_LOGGED_LOGIN');
	}
	
	public function setLastLoggedTime($time) {
		if(null !== $this->_userLogin)
			return $this->set('LAST_LOGGED_TIME',$time);
		return $this->set('LAST_LOGGED_TIME',$time);
	}
	
	public function getLastLoggedTime() {
		if(null !== $this->_userLoign) 
			return $this->get('LAST_LOGGED_TIME');
		return $this->get('LAST_LOGGED_TIME');
	}
	
	public function setLang($lang) {
		
		// jeśli uzytkownik jest zalogowany ustawiam mu język
		if(null !== $this->_userLogin) {
			$this->set($this->_userLogin.'_LANG',$lang);
		}
		// i ustawiam język dla wszystkich
		
		return $this->set('LANG',$lang);
	}
	
	public function getLang() { 
		return $this->get( 'LANG' );
	}
	
	public function setSpec($specs) {
		return $this->set('SPECS',serialize($specs));
	}
	
	public function getSpec() {
		$specs = $this->get('SPECS');
		$specs = @unserialize($specs);
		
		if(is_array($specs))
			return $specs;
		return array();
	}
	
	protected function get( $var ) {
		
		if( isset( $_COOKIE[ sha1( $var ) ] ) )
			return $_COOKIE[ sha1( $var ) ];
		return null;
	}
	
	public function __get( $var ) {
		return $this->get( $var );
	}
	
	protected function set($var,$value,$lifetime = null) {
		
		$lifetime = null == $lifetime ? $this->_lifetime : $lifetime;
		
		return setcookie( sha1( $var ) , $value , time() + 31000000 , '/' , '.esculap.com' );
	}
	
	public function __set($name,$value) {
		if($this->_lock)
			throw new \Exception('Aby przypisać wartość do obiektu użyj finkcji set(string,mixed [,int] )');
			
		$this->$name = $value;
	}
}

?>
