<?php

namespace System\User;

class Filter {
	
	protected $count = false;
	protected $filters = array();
	protected $constraints = array();
	protected $order = null;
	protected $limit = null;
	
	public function __construct() {}
	
	
	// proteza 
	protected $additionslWhere = array();
	
	public function addFilter( FilterType\AbstractFilterType $filter ) {
		
		if( $filter instanceof \System\User\FilterType\WorkCountry ) {
			$this->additionslWhere = $filter->oryginalConstraint;
			
			return $this;
		}
		
		
		
		$this->filters[] = $filter;
		
		if( null !== $filter->getAdditionalJoin() ) {
		
			$this->filters[] = $filter->getAdditionalJoin();
		}
		
		return $this;
	}
	
	
	public function setLimit( FilterConstraint\LimitConstraint $limit , FilterConstraint\OffsetConstraint $offset = null ) {
		
		$this->limit = $limit->getQuery();
		
		if( null !== $this->limit && null !== $offset ) {
			
			$this->limit .= ' ';
		}
		
		if( null !== $offset ) {
			
			$this->limit .= $offset->getQuery();
		}
	}	
	
	
	public function setOrder( FilterConstraint\OrderConstraint $order) {
	
		$this->order = $order;
	}
	
	
	public function getFilters() {
		
		return $this->filters;
	}
	
	
	public function addConstraint( FilterType\Column $constraint ) {
		
		if( null !== $constraint->getQuery() ) {
		
			$this->constraints[] = $constraint;
		}
		
		return $this;
	}
	
	
	public function addConstraints( array $constraints) {
		
		foreach( $constraints as $constraint) {
			
			$this->addConstraint( $constraint );
		}
		
		return $this;
	}
	
	
	public function count( $state ) {
		
		$this->count = (bool) $state;
		
		return $this;
	}
	
	
	public function serch() {
		
		$from = 'main_users ';
		$where = '';
		$tablesList = array();
		$select = 'main_users.*';
		
		foreach( $this->filters as $filter ) {
			
			$table = $filter->getTable();
			
			if(is_array( $table )) {
				
				foreach( $table as $t) {
					
					$tablesList[ $t ][] = $filter;
				}
				
			} else {
				
				$tablesList[ $filter->getTable() ][] = $filter;
			}
		}
		
		foreach( $tablesList as $tableName => $tableConstraints ) {
			
			if( strlen( $select ) ) {
				$select .= ',';
			}
			
			$select .= $tableName.'.*';
			
			
			$from .= " LEFT JOIN {$tableName} ON {$tableName}.user_id = main_users.id";
			
			
			foreach( $tableConstraints as $constraint ) {
				
				if( null !== $constraint->getQuery() ) {
					
					if( strlen( $where ) ) $where .= ' AND ';
					
					$where .= $constraint->getQuery();
				}
			}
		}
		
		
		// dodawanie pojedyńczych warunków, kóre nie dodają tabel left join-ów
		foreach( $this->constraints as $constraint) {
			
			if( strlen( $where ) ) $where .= ' AND ';
			
			$where .= $constraint->getQuery();
		}
		
		
		static $MainUsers = null;
		
		if( null == $MainUsers ) {
			
			$MainUsers = new \Model\MainUsers;
		}
		
		
		// order...
		if( null !== $this->order ) {
			
			$order = $this->order->getQuery();
			
		} else {
			
			$order = null;
		}
		
		
		// limit...
		if( null !== $this->limit ) {
			
			$limit = $this->limit;
		} else {
			
			$limit = null;
		}
		
		
			
		if( !strlen( $select ) ) {
			$select = ' * ';
		}
			
		$result = array();
		
		foreach( $this->additionslWhere as $lang ) {
			$lang = strtolower( $lang );
				
				
			$_select = $select;
			$_from = $from;
			$_where = $where;
			
			$_select .= ",{$lang}_users.*";
				
			$_from  .= " JOIN {$lang}_users ON {$lang}_users.user_id = main_users.id";
				
			$_tmp = $MainUsers->serchUsers( $_select , $_from , $_where , $order , $limit);
				
			foreach( $_tmp as $row ) {
				
				$result[] = $row;
			}
		}
				
				
		if( $this->count ) {
			
			return count( $result );
		}
		
		return $result;
	}
	
	
	public function serch2() {
		
		$from = 'main_users ';
		$where = '';
		$tablesList = array();
		$select = 'main_users.*';
		
		foreach( $this->filters as $filter ) {
			
			$table = $filter->getTable();
			
			if(is_array( $table )) {
				
				foreach( $table as $t) {
					
					$tablesList[ $t ][] = $filter;
				}
				
			} else {
				
				$tablesList[ $filter->getTable() ][] = $filter;
			}
		}
		
		foreach( $tablesList as $tableName => $tableConstraints ) {
			
			if( strlen( $select ) ) {
				$select .= ',';
			}
			
			$select .= $tableName.'.*';
			
			
			$from .= " LEFT JOIN {$tableName} ON {$tableName}.user_id = main_users.id";
			
			
			foreach( $tableConstraints as $constraint ) {
				
				if( null !== $constraint->getQuery() ) {
					
					if( strlen( $where ) ) $where .= ' AND ';
					
					$where .= $constraint->getQuery();
				}
			}
		}
		
		
		// dodawanie pojedyńczych warunków, kóre nie dodają tabel left join-ów
		foreach( $this->constraints as $constraint) {
			
			if( strlen( $where ) ) $where .= ' AND ';
			
			$where .= $constraint->getQuery();
		}
		$where .= 'AND id IN (SELECT user_id FROM esculap_int.main_users_changes)';
		
		static $MainUsers = null;
		
		if( null == $MainUsers ) {
			
			$MainUsers = new \Model\MainUsers;
		}
		
		
		// order...
		if( null !== $this->order ) {
			
			$order = $this->order->getQuery();
			
		} else {
			
			$order = null;
		}
		
		
		// limit...
		if( null !== $this->limit ) {
			
			$limit = $this->limit;
		} else {
			
			$limit = null;
		}
		
		
			
		if( !strlen( $select ) ) {
			$select = ' * ';
		}
			
		$result = array();
		
		foreach( $this->additionslWhere as $lang ) {
			$lang = strtolower( $lang );
				
				
			$_select = $select;
			$_from = $from;
			$_where = $where;
			
			$_select .= ",{$lang}_users.*";
				
			$_from  .= " JOIN {$lang}_users ON {$lang}_users.user_id = main_users.id";
				
			$_tmp = $MainUsers->serchUsers( $_select , $_from , $_where , $order , $limit);
				
			foreach( $_tmp as $row ) {
				
				$result[] = $row;
			}
		}
				
			
		if( $this->count ) {
			
			return count( $result );
		}
		
		return $result;
	}
	
	
}

?>