<?php

namespace System\User\FilterType;

class CountryMembership extends AbstractFilterType {
	
	protected $table = 'main_users';
	protected $field = 'lang';
	
	
	public function __construct( $constraint ) {
		
		if(!is_array( $constraint )) {
			
			$constraint = array( $constraint );
		}
		
		$this->additionalJoin = new ExtCountry( $constraint );
		
		if(is_array( $constraint )) {
			$constraint = implode( ',' , $constraint );
			
			$constraint = preg_replace( '/([a-zA-Z]+)/' , "'$1'" , $constraint );
		} 
		
		parent::__construct( $constraint );
	}
	
	
	public function getQuery() {
		
		return "{$this->table}.{$this->field} in ({$this->constraint})";
	}
}

?>