<?php

namespace System\Validator;

use Zend\Validator\AbstractValidator,
	Model\DictBcElementPlace;

class BcElementPlaceForElement extends AbstractValidator {
	
	const INVALID_PLACE = 'invalidPlace';
	
	protected $messageTemplates = array(
		self::INVALID_PLACE => 'Invalid place selected'
	);
	
	public function isValid( $value , $context = null ) {
		
		try {
			
			if( !isset( $context[ 'element_type' ] ) ) {
				
				$this->error( self::INVALID_PLACE );
				return false;
			}
			
			$DictBcElementPlace = new DictBcElementPlace;
			
			if( false === $DictBcElementPlace->isPlaceAvailabelFormElement( $value , $context[ 'element_type' ] ) ) {
				
				$this->error( self::INVALID_PLACE );
				return false;
			}
			
			return true;
		
		} catch( \Exception $e ) {
			
			$this->error( self::INVALID_PLACE );
			return false;
		}
	}
}

?>