<?php

namespace System\Validator;
use Zend\Validator\AbstractValidator;

/**
* Porównianie elementów gdzie pierwszy musi być większy inaczej walidator zwróvci błąd INVALID_VALUE
*/
class ComparisonGreaterThan extends AbstractValidator {
	
	protected static $field;
	
	const INVALID_VALUE = 'InvalidValue';
	
	protected $messageTemplates = array(
		self::INVALID_VALUE => 'Pierwsza wartość jest mniejsza'
	);
	
	public function isValid( $data ) {
		
		if( is_null( self::$field ) ) {
			
			self::$field = $data;
			return true;
		}
		
		if( $this->prepareToComparison( self::$field ) < $this->prepareToComparison( $data ) ) {
			$this->error( self::INVALID_VALUE );
			return false;
		}
		
		return true;
	}
	
	protected function prepareToComparison( $data ) {
		
		$data = trim($data);
		
		switch(1) {
			case preg_match( '/[0-9]{4}-[0-9]{2}-[0-9]{2}/' , $data ):
				$data = explode( '-' , $data );
				
				
				$data = mktime( 0 , 0 , 0 , $data[ 1 ] , $data[ 2 ] , $data[ 0 ] );
				
				break;
			case preg_match( '/[0-9]{2}\/[0-9]{2}\/[0-9]{4}/' , $data ):
				$data = explode( '/' , $data );
				
				$data = mktime( 0 , 0 , 0 , $data[ 1 ] , $data[ 0 ] , $data[ 2 ] );
				break;
		}
		
		return $data;
	}
}




?>