<?php

namespace System\Validator;
use \Zend\Validator\AbstractValidator,
	\Model\DictEventType;

class EventType extends AbstractValidator {
	
	const EVENT_NOT_EXISTS = 'eventNotExists';
	
	protected $messageTemplates = array(
		self::EVENT_NOT_EXISTS => 'Event not exists'
	);
	
	public function isValid( $value ) {
		
		if( is_array( $value ) ) {
			
			$DictEventType = new DictEventType;
			
			foreach( $value as $eventId ) {
				try {
					if( !$DictEventType->isEventExists( $eventId ) ) {
						
						$this->error( self::EVENT_NOT_EXISTS );
						return false;
					}
				} catch( \Exception $e ) {
					
					$this->error( self::EVENT_NOT_EXISTS );
					return false;
				}
			}
			
			return true;
			
		} elseif( is_int( $value ) || is_string( $value ) ) {
			
			$DictEventType = new DictEventType;
			try {
				if( $DictEventType->isEventExists( $value ) ) {
					
					return true;
				}
			} catch( \Exception $e ) {}
		}
		
		$this->error( self::EVENT_NOT_EXISTS );
		return false;
	}
}

?>