<?php

namespace System\Validator;

use \Zend\Validator\AbstractValidator;

class FileAvatar extends AbstractValidator {

    const FILE_ERROR = 'fileError';

    protected $messageTemplates = array(
        self::FILE_ERROR => 'Error while uploading file',
    );

    public function isValid($value) {
        try {
            if (isset($value['error']) && $value['error'] != 0
                    && (!$this->getOption('allowEmpty') && $value['error'] == 4)) {
                $this->error(self::FILE_ERROR);
                return false;
            }
        } catch (\Exception $e) {
            $this->error(self::FILE_ERROR);
            return false;
        }

        return true;
    }

}

?>