<?php

namespace System\Validator;
use Zend\Validator\AbstractValidator;

class Journal extends AbstractValidator {
	
	const JOURNAL_INCORRECT = 'valieIsIncorrect';
	
	protected $messageTemplates = array(
		self::JOURNAL_INCORRECT => 'Given journal can not be found'
	);
	
	public function isValid( $value ) {
	
		$MainJournals = new \Model\DictJournals;
		
		if( is_array( $value ) ) {
			
			foreach( $value as $valToTest ) {
				$valToTest = (int)$valToTest;
				try {
					if( !$MainJournals->isExists( $valToTest ) ) {
						
						$this->error( self::JOURNAL_INCORRECT );
						return false;
					}
					
				} catch( \Exception $e ) {
				
					$this->error( self::JOURNAL_INCORRECT );
					return false;
				}
			}
			
			return true;
			
		} elseif( is_int( $value) || is_string( $value ) ) {
			$value = (int)$value;
			
			try {
				
				if( !$MainJournals->isExists( $value ) ) {
						
					$this->error( self::JOURNAL_INCORRECT );
					return false;
				}
				
			} catch( \Exception $e ) {
				
				$this->error( self::JOURNAL_INCORRECT );
				return false;
			}
			
			return true;
		}
		
		$this->error( self::JOURNAL_INCORRECT );
		return false;
	}
	
}

?>