<?php

namespace System\Validator;

use \Zend\Validator\AbstractValidator;

class Multiselect extends AbstractValidator {

    const VALUES_NOT_ALLOWED = 'valuesNotAllowed';

    protected $messageTemplates = array(
        self::VALUES_NOT_ALLOWED => 'At least one value is not allowed'
    );
    protected $haystack;

    public function getHaystack() {
        if (!is_array($this->haystack)) {
            return array();
        }
        return $this->haystack;
    }

    public function setHaystack(array $haystack) {
        $this->haystack = $haystack;
        return $this;
    }

    public function isValid($value) {
        $haystack = $this->getHaystack();

        # Jeżeli tablica dozwolonych elementów jest pusta to wszystko jest niedozwolone
        if (empty($haystack)) {
            $this->error(self::VALUES_NOT_ALLOWED);
            return false;
        }

        if (is_array($value)) {
            if (array_intersect($value, $haystack) != $value) {
                $this->error(self::VALUES_NOT_ALLOWED);
                return false;
            }

            return true;
        } else {
            if (!in_array($value, $haystack)) {
                $this->error(self::VALUES_NOT_ALLOWED);
                return false;
            }

            return true;
        }
    }

}

?>