<?php

namespace System\Validator;
use \Zend\Validator\AbstractValidator;

class PublicationType extends AbstractValidator {

	const PUBLICATION_TYPE_NOT_EXISTS = 'publicationTypeNotExists';

	protected $messageTemplates = array(
		self::PUBLICATION_TYPE_NOT_EXISTS => 'Publication type not exists'
	);
	
	public function isValid( $value ) {
		
		$DictPublType = new \Model\DictPublType2;
		
		if( is_array( $value ) ) {
			
			foreach( $value as $valToCheck ) {
				
				if( !$DictPublType->isExists( $value ) ) {
					
					$this->error( self::PUBLICATION_TYPE_NOT_EXISTS );
					return false;
				}
			}
			
			return true;
			
		} elseif( is_string( $value ) ) {
			
			try {
				
				if( $DictPublType->isExists( $value ) ) {
					
					return true;
				}
				
			} catch( \Exception $e ) {
				
				$this->error( self::PUBLICATION_TYPE_NOT_EXISTS );
				return false;
			}
		}
		
		$this->error( self::PUBLICATION_TYPE_NOT_EXISTS );
		return false;
	}
}

?>