<?php

namespace System\Validator;

class RegexBase {
	protected static $patterns = array(
		'phone' 	 => '^([\+]{1}[0-9]{1,3} )?([\(]?[ ]?[0-9]+[ ]?[\)]? )?([0-9]+[ ]?[\-]?[ ]?)+([0-9]+)( [\(]?[ ]?[0-9]+[ ]?[)]?)?$',
		'phone2' 	 => '^[\+0-9\- \(\),\+\/]+$',
		'url' 		 => '^((http:|https:|)\/\/)?(\.www)?([a-z0-9_-]+[\.]){1,4}([a-z]{2,4}[\.]?){1,2}((\/.*)+)?([\?][.]*)?$',
		'email' 	 => '^([a-zA-Z]+[a-zA-Z0-9-_\.]*)+@([a-zA-Z]+[a-zA-Z0-9-_\.]*)\.([a-zA-Z]{2,4})$',
		'zip' 		 => '^([0-9]+([ ]?[-]?[ ]?)?)+[0-9]+$',
		'dateSlash'	 => '^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$',
		'keywords' 	 => '^[^<>\']*?$',
		'pageRange'      => '^[0-9]+(-[0-9]+)?$',
		'nameIdentifier' => '^[a-zA-Z_][a-zA-Z0-9_]*$',
		'nameVisible'    => '/^[\p{L}0-9 -]*$/uD',
                'avatar'         => '^[0-9a-zA-Z\_]*$',
                'num'            => '^[0-9]+$',
	);	


	public static function get( $name ) {
		if( isset( self::$patterns[ $name ] ) ) {
			return self::$patterns[ $name ];
		}
		
		return null;
	}
}


?>