<?php

namespace System\Validator;
use Zend\validator\AbstractValidator;
use Model\DictSpec;

class Spec extends AbstractValidator {
	
	const INVALID_VALUE = 'InvalidValue';
	
	protected $messageTemplates = array(
		self::INVALID_VALUE => 'Valie is invalid'
	);
	
	public function isValid( $value ) {
		
		if( !is_array( $value ) && !strlen( $value ) ) {
			$this->error( self::INVALID_VALUE );
			return false;
		}
		
		if(!is_array($value)) {
			$value = array($value);
		}
		
		$DictSpec = new DictSpec;
		$specsList = $DictSpec->getAll();
		$base = array();
		
		foreach($specsList as $spec) {
			$base[] = $spec['spec_code'];
		}
		
		$count = 0;
		foreach($value as $val) {
			if( in_array( $val , $base ) ) {
				$count++;
			}
		}
		
		if( $count == 0 ) {
			
			$this->error(self::INVALID_VALUE);
			return false;
		}
		
		return true;
	}
}



?>