<?php

namespace System\Validator;

use Zend\Validator\AbstractValidator;

class WebAddress extends AbstractValidator
{
    const INVALID_ADDRESS = 'InvalidAddress';

    protected $messageTemplates = [self::INVALID_ADDRESS => 'The address is invalid'];

    /**
     * Uses php's filter_var to validate url.
     * Previous implementation used file_get_contents.
     * file_get_contents
     * @param string $value
     * @return bool
     */
    public function isValid($value)
    {
        if (!filter_var($value, FILTER_VALIDATE_URL)) {
            $this->error(self::INVALID_ADDRESS);

            return false;
        }

        return true;
    }
}
