<?php

namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper;

class BannerDisplayer extends AbstractHelper {
	
	protected static $inited = false;
	protected static $banners;
	protected $additinalStatistics = array();
	
	
	public static function init( $data , $bcVcode = null ) {
		self::$inited = true;
		
		
		if( null !== $bcVcode ) {
			BannerElement\ElementAbstract::setBcViewCode( $bcVcode );
                        //var_dump($data); die();
                }
                
		
		if( is_array( $data ) ) {
			
			self::$banners = $data;
			
		} else {
		
			self::$banners = array();
		}
	}
	
	public function __invoke( $place ) {
		
		if( 'statistics' == $place ) {
			
			return $this->getAdditionalStatistics();
		}
		
		//trigger_error( $place );
		
		if( false == self::$inited ) return false;
                
		if( false == ( $elements = $this->getElementsFormPlace( $place ) ) ) return false;
                
		$res = "";
		$elementsToDisplay = array();
                
		foreach( $elements as $element ) {
			
			
			$place = $element->getPlace()->getName();
			$place = explode( '_' , $place );
			$placeName = '';
			foreach( $place as $placeNamePart ) {
				
				$placeName .= ucfirst( $placeNamePart );
			}
			
			
			$elementName = explode( '_' , $element->getName() );
			$elementNameParsed = '';
			foreach( $elementName as $elementNameToParse ) {
				
				$elementNameParsed .= ucfirst( $elementNameToParse );
			}
			
			$className = "System\View\Helper\BannerElement\\{$placeName}{$elementNameParsed}";

			if (class_exists($className)) {
				if( strlen( $element->getAdditionalStats() ) ) {
					$this->additinalStatistics[] = $element->getAdditionalStats();
				}
                                
				$elementsToDisplay[] = new $className( $element );
			} else {
				$className = "System\View\Helper\BannerElement\Type\\{$elementNameParsed}Type";
                                if (class_exists($className)) {
                                    if( strlen( $element->getAdditionalStats() ) ) {
					$this->additinalStatistics[] = $element->getAdditionalStats();
                                    }
                                    
                                    $elementsToDisplay[] = new $className( $element );
                                }
			}
		}
                
		//$elementsToDisplay = array_reverse( $elementsToDisplay );
		
		foreach( $elementsToDisplay as $elementToDisplay ) {
			
			$elementToDisplay->setView( $this->getView() );
			
			$res .= $elementToDisplay->display();
		}
		
                //var_dump($res);
		
		return $res;
	}
        
        public static function getElementsFromPlace( $place ) {
		
		if( false == self::$inited ) return false;
		
		$matches = array();
		
                //var_dump(self::$banners);
                
		foreach( self::$banners as $element ) {
			
			if( ( is_int( $place ) &&
				  $element->getPlace()->getId() == (int)$place ) ||
				( is_string( $place ) &&
				  strtolower( $element->getPlace()->getName() ) == strtolower( $place ) ) ) {
				
				$matches[] = $element;
			}
		}
		
                //var_dump($matches);
		return $matches;
	}
	
	protected function getElementsFormPlace( $place ) {
		
		if( false == self::$inited ) return false;
		
		$matches = array();
		
                //var_dump(self::$banners);
                
		foreach( self::$banners as $element ) {
			
			if( ( is_int( $place ) &&
				  $element->getPlace()->getId() == (int)$place ) ||
				( is_string( $place ) &&
				  strtolower( $element->getPlace()->getName() ) == strtolower( $place ) ) ) {
				
				$matches[] = $element;
			}
		}
		
                //var_dump($matches);
		return $matches;
	}
	
	
	protected function staticGetElementsFormPlace( $place ) {
		
		if( false == self::$inited ) return false;
		
		$matches = array();
		
		foreach( self::$banners as $element ) {
			
			if( ( is_int( $place ) &&
				  $element->getPlace()->getId() == (int)$place ) ||
				( is_string( $place ) &&
				  strtolower( $element->getPlace()->getName() ) == strtolower( $place ) ) ) {
				
				$matches[] = $element;
			}
		}
		
		return $matches;
	}
	
	
	public static function count( $place ) {
		
		if( false == self::$inited ) return 0;
		
		$matches = array();
		
		foreach( self::$banners as $element ) {
			
			if( ( is_int( $place ) &&
				  $element->getPlace()->getId() == (int)$place ) ||
				( is_string( $place ) &&
				  strtolower( $element->getPlace()->getName() ) == strtolower( $place ) ) ) {
				
				$matches[] = $element;
			}
		}
		
		return count( $matches );
	}
	
	
	public function getAdditionalStatistics() {
		
		$res = '';
		
		foreach( $this->additinalStatistics as $stats ) {
                        $char = array('"', "'");
                        $enitity = array('&quot;', '&apos;');
                        $url = str_replace($char, $enitity, preg_replace('/[\[]?(timestamp|TIMESTAMP)[\]]?/', time(), $stats));
                        
                        $img = '<img src="' . $url . '" alt="" style="position: absolute; top: 0px; left: 0px;">' . "\n";
			$res .= $img;
		}
		
		return $res;
	}
}

?>