<?php

namespace System\View\Helper\BannerElement;

use System\BannerCampaign\Element\Content,
	System\View\Helper\Truncat;

class SliderContent extends ElementAbstract {
	
	protected $content;
	
	public function __construct( Content $content ) {
		
		$this->content = $content;
	}	
	
	public function display() {
		
		$no = SliderCounter::increment();
		$c = $no == 1 ? 'target' : '';
		
		$target = $this->content->isFake() ? $this->content->getUrl() : $this->view->url( 'bc_element_hit' , array( 'bcElementId' => $this->content->getElementId() ) );
		
		return "
			<article class=\"mod1 {$c}\" id=\"news-" . $no . "\">
				<div class=\"mod1-img grid_9 alpha\">
					<img width=\"350\" height=\"280\" alt=\"\" src=\"/image/".$this->content->getImage().",350,280\"/>
				</div>
				<div class=\"grid_7 omega\">
					<hgroup>
						<h1 class=\"mod1-hdr hdr20\" ><a class=\"banner_click_register\" href=\"{$target}\">{$this->content->getTitle()}</a></h1>
						<!--<h2 class=\"mod1-cat hdr10V\" itemprop=\"articleSection\"><a href=\"index.html\"></a></h2>-->
					</hgroup>
					
					<div class=\"mod1-txt text\" itemprop=\"articleBody\">
						<p>".Truncat::truncat( strip_tags( $this->content->getDescription() ) ,200,true,'...')."</p>
					</div>
				</div>
			</article>
		";
	}
}

?>