<?php

namespace System\View\Helper\BannerElement;

use System\BannerCampaign\Element\ContentData,
    System\View\Helper\Truncat;

class SponsoredContentData extends ElementAbstract {
	
	protected $contentData;

	public function __construct( ContentData $contentData )  {
		
		$this->contentData = $contentData;
	}
	
	public function display() {
		
		
		$target = $this->contentData->isFake() ? $this->contentData->getUrl() : $this->view->url( 'bc_element_hit' , array( 'bcElementId' => $this->contentData->getElementId() ) );
		
		$result = "
			<article class=\"mod3 clearfix\">
				<div class=\"grid_6 alpha mod3-img\">
					<img width=\"230\" height=\"194\" src=\"/image/{$this->contentData->getImage()},230,194\" alt=\"\" >
				</div>
				<div class=\"grid_10 omega\">
					<hgroup>
						<!--<h2 class=\"hdr10V mod3-cat\">Temat tygodnia</h2>-->
						<h1 class=\"hdr16L mod3-hdr\"><a class=\"banner_click_register\" id=\"{$this->contentData->getElementId()}\" href=\"{$target}\">{$this->contentData->getTitle()}</a></h1>
					</hgroup>
					
					<div itemprop=\"articleBody\" class=\"mod3-txt text\">
						<p>" . Truncat::truncat( $this->contentData->getContent() , 250 , true , '...' , 'sneakPeak' ) . "</p>
					</div>
				</div>
			</article>
		";
		
		return $result;
	}
}

?>