<?php

namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper;

class BcCreatorBoard extends AbstractHelper {

	protected $cfg = array();
	protected $maxEvents = 3;

	/**
	 * @param int $from epoch
	 * @param int $to epoch
	 */
	public function __invoke( $from , $to , $translator , \System\BannerCampaign\Collision $collisions , $mainBc , $cfg = array() ) {
		
		$this->cfg = $cfg;
                if (isset($cfg['maxEvents']))  {
                    $this->maxEvents = $this->cfg['maxEvents'];
                }
		
		$from = strtotime( 'midnight' , $from );
		$to = strtotime( 'midnight' , $to );
		
		
		$tmp = strtotime( 'first day of this month' , $from );
		$fuse = 0;
		
		$result = "<div class='create_summary'>";
		
		
		$monthNames = explode( ',' , $translator->translate( 'main_months_names' ) );
		$wDayNames = explode( ',' , $translator->translate( 'mian_days_names_sc' ) );
		
		
		while( (int)$tmp <= (int)$to ) {
			
			$data = getdate( $tmp );
			
			$result .= "<div class='month'>
				<div class='name'>{$monthNames[ $data[ 'mon' ] - 1 ]} {$data[ 'year' ]}</div>
				<div class='days_names_sc'>
					<div class='day'>{$wDayNames[ 0 ]}</div>
					<div class='day'>{$wDayNames[ 1 ]}</div>
					<div class='day'>{$wDayNames[ 2 ]}</div>
					<div class='day'>{$wDayNames[ 3 ]}</div>
					<div class='day'>{$wDayNames[ 4 ]}</div>
					<div class='day'>{$wDayNames[ 5 ]}</div>
					<div class='day'>{$wDayNames[ 6 ]}</div>
				</div>
			";
			
			$result .= $this->fillBegin( $data[ 'wday' ] );
			
			//echo count( $collisions->getCollisions() );
			
			for( $day = 1; $day <= date( 'j' , strtotime( 'last day of this month' , $tmp ) ); $day++ ) {
				
				// zrobione tak z
				$_data = array(
					date( 'm' , $tmp ),
					date( 'Y' , $tmp )
				);
				
				$collision = $collisions->getCollision( strtotime( "{$_data[ 0 ]}/{$day}/{$_data[ 1 ]}" ) );
				$eventsNumber = count( $collision );
				
				if ($eventsNumber > 0) {
                    $debug = 1;
                }

				// sprawdzam czy rozpatrywany dzień mieści się w przedziale wybranych dat, jeśli nie będzie miła klasę zaciemniającą pole i uniemożliwiającą jego kliknięcies
				$dayTime = mktime( 0 , 0 , 0 , $_data[ 0 ] , $day , $_data[ 1 ] );
				
				//echo date( 'd-m-Y' , $dayTime ) . ' - ' . date( 'd-m-Y' , $from ) . ' - ' . date( 'd-m-Y' , $to ) . '<br>';

				if( $dayTime >= $from && $dayTime <= $to ) {					
                                    
					if( $eventsNumber >= $this->maxEvents ) {
						
						$class = 'unavailable';
						
					} elseif( 0 < $eventsNumber ) {
						
						$class = 'partialAvailable';
						
					} else {
						
						$class = 'fullAvailable';
					}
					
				} else {
					
					$class = 'unmarkable';
				}
				
				
				
				
				
				
				$result .= "
					
					<div class='day {$class}' date='{$day}-{$_data[ 0 ]}-{$_data[ 1 ]}'>{$day}";
						
				$reservation = false;
				foreach( $collision as $conflictingElement ) {
					
					$result .= "
						<div class='conflictingElementData' eid='{$conflictingElement[ 'element' ]->getElementId()}' bcid='{$conflictingElement[ 'element' ]->getParent()->getId()}'></div>
					";
					
					if( $conflictingElement[ 'element' ]->isReservation() )
						$reservation = true;
					
				}
				
				if( true === $reservation ) {
					
					$result .= "
						<div class='book'></div>
					";
				}
						
						
				$result .= "</div>";
			}
			
			
			$result .= "</div>";
			
			
			$tmp = strtotime( 'first day of next month' , $tmp );
			
			if( $fuse++ > 1000 ) {
				$error = 1;
				break;
			}
		}
		
		
		// zbieranie informacji o kolidujących kampaniach
		$parsedCampaigns = array();
		$parsedElements = array();
		$result .= "<div class='bc_data_base'>";
		foreach( $collisions->getCollisions() as $bcId => $conflictingElements ) { 
			foreach( $conflictingElements as $conflictingElement ) {
				
				$bcElement = $conflictingElement[ 'element' ];
				
				if( !in_array( $bcElement->getBcId() , $parsedCampaigns ) ) {
					
					$bc = $bcElement->getParent();
					
					
					$result .= "<div class='bc' id='{$bc->getId()}'>
						<span class='name'>{$bc->getName()}</span>
						<span class='creator'>{$bc->getCreator()}</span>
						<span class='client'>{$bc->getClient()}</span>
					</div>";
					
					$parsedCampaigns[] = $bc->getId();
				}
				
				if( !in_array( $bcElement->getElementId() , $parsedElements ) ) {
					
					$target = isset( $conflictingElement[ 'conflict' ] ) ? $conflictingElement[ 'conflict' ] : array();
					
					if( is_array( $target ) ) {
						
						foreach( $target as $k => $targetData ) {
							
							$target[ $k ] = \System\BannerCampaign\Element\Target\TargetFactory::createElement( array( $targetData[ 'type' ] => $targetData[ 'elements' ] ) );
						}
						
					} else $target = array();
					
					$result .= "<div class='element' status='{$bcElement->getStatus( true )}' id='{$bcElement->getElementId()}'>
						<span class='name' >{$translator->translate( 'dict_bc_element_type_' . $bcElement )}</span>
						<span class='from'>" . date( 'd-m-Y H:i' , $bcElement->getStarts() ) . "</span>
						<span class='to'>" . date( 'd-m-Y H:i' , $bcElement->getEnds() ) . "</span>
						<span class='status'>{$translator->translate( 'main_' . $bcElement->getStatus( true ) )}</span>
						<span class='target'>";
						
						
						foreach( $target as $targetElement ) {
							
							$result .= new \System\BannerCampaign\Element\Target\TargetDecorator( $targetElement , $translator );
						}

                    $translatedName = $translator->translate('dict_bc_place_' . $bcElement->getPlace());
                    if ($translatedName == 'dict_bc_place_' . $bcElement->getPlace()) {
                        $translatedName = $bcElement->getPlace();
                    }
						
						$result .= "</span>
						<span class='place'>{$translatedName}</span>
						<span class='creator'>{$bcElement->getCreator()}</span>
					</div>";
					
					
					$parsedElements[] = $bcElement->getElementId();
				}
			}
		}
		
		$result .= "</div></div>";
		
		
		return $result;
	}
	
	
	protected function fillBegin( $day ) {
		if( 0 == $day ) {
			$day = 7;
		}
		
		$res = "";
		
		for( $i = 1; $i < (int)$day; $i++ ) {
			
			$res .= "<div class='day blank'></div>";
		}
		
		return $res;
	}	
}

?>
