<?php

namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper;
use System\BannerCampaign\Element\ElementAbstract;

/**
 * View helper used for outputting additional information about advertisements.
 */
class DecorateBcElement extends AbstractHelper
{
    /**
     * Magic method used in views.
     * @param ElementAbstract $bcElement
     * @return string
     */
    public function __invoke(ElementAbstract $bcElement)
    {
        switch (true) {
            case is_a($bcElement, 'System\BannerCampaign\Element\Banner'):
                /** @var \System\BannerCampaign\Element\Banner $bcElement */
                return "<tr class='{$bcElement->getElementId()}'>
                            <td>Adres url</td>
                            <td colspan='3'>{$bcElement->getUrl()}</td>
                        </tr>";

            case is_a($bcElement, 'System\BannerCampaign\Element\Billboard'):
                /** @var \System\BannerCampaign\Element\Billboard $bcElement */
                return "<tr class='{$bcElement->getElementId()}'>
                            <td>Adres url</td>
                            <td colspan='3'>{$bcElement->getUrl()}</td>
                        </tr>";

            case is_a($bcElement, 'System\BannerCampaign\Element\ContentData'):
                /** @var \System\BannerCampaign\Element\ContentData $bcElement */
                return "<tr class='{$bcElement->getElementId()}'>
                            <td>Tytuł</td>
                            <td><div class='content_height_constraint'>{$bcElement->getTitle()}</div></td>
                            <td>Treść</td>
                            <td><div class='content_height_constraint'>{$bcElement->getContent()}</div></td>
                        </tr>
                        <tr class='{$bcElement->getElementId()}'>
                            <td>Adres url</td>
                            <td colspan='3'>{$bcElement->getUrl()}</td>
                        </tr>";

            case is_a($bcElement, 'System\BannerCampaign\Element\Content'):
                /** @var \System\BannerCampaign\Element\Content $bcElement */
                return "<tr class='{$bcElement->getElementId()}'>
                            <td>Id treści</td>
                            <td>{$bcElement->getContentId()}</td>
                        </tr>";

            default:
                return '';
        }
    }
}
