<?php
namespace System\View\Helper\Form;

use System\Translator;
use Zend\Form\View\Helper\FormTextarea;
use Zend\Form\ElementInterface;

class FormCode extends FormTextarea {

    protected $validSelectAttributes = array(
        'name' => true,
        'autofocus' => true,
        'disabled' => true,
        'form' => true,
        'multiple' => true,
        'required' => true,
        'size' => true,
        'req' => true,
        'val' => true,
    );

    public function render(ElementInterface $element) {
        $translator = Translator\TranslatorEx::get();
        
        $name = $element->getName();
        $attributes = $element->getAttributes();
        if (empty($name) && $name !== 0) {
            throw new Exception\DomainException(sprintf(
                    '%s requires that the element has an assigned name; none discovered', __METHOD__
            ));
        }
        
        $contentID = (int) $element->getOption('content_id');
        $contentName = (string) $element->getOption('content_name');
        $readonly = (bool) $element->getOption('readonly');
        
        $value = $element->getValue();
        
        $field = "<div id=\"{$attributes['id']}\" class=\"{$attributes['class']} code_field\" 
        " . (((bool)$contentID) ? ' data-content-id="' . $contentID . '"' : '') . "
        " . (((bool)$contentName) ? ' data-content-name="' . $contentName . '"' : '') . "
        " . (((bool)$readonly) ? ' data-readonly-mode="true"' : '') . "
        ></div><input type=\"hidden\" name=\"{$name}\" id=\"{$attributes['id']}_hidden\" value=\"{$value}\">";
        
        if ($contentID) {
            $field .= "<button type=\"button\" class=\"form_button content_hide_button\">{$translator->translate('delete', 'main_site_view_type')}</button>";
        }
        
        return $field;
    }

}

?>