<?php
namespace System\View\Helper\Form;

use System\Translator;
use Zend\Form\View\Helper\FormInput;
use Zend\Form\ElementInterface;

class FormImageView extends FormInput {

    protected $validSelectAttributes = array(
        'name' => true,
        'autofocus' => true,
        'disabled' => true,
        'form' => true,
        'required' => true,
        'size' => true,
        'req' => true,
        'val' => true,
        'image_name' => true,
    );

    public function render(ElementInterface $element) {
        $name = $element->getName();
        if (empty($name) && $name !== 0) {
            throw new Exception\DomainException(sprintf(
                    '%s requires that the element has an assigned name; none discovered', __METHOD__
            ));
        }

        $translator = Translator\TranslatorEx::get();
        $noImageText = $translator->translate('no_image_uploaded');

        $attributes = $element->getAttributes();
        $attributes['name'] = $name;

        /* $field = sprintf(
          '<input type="hidden" value="' . $element->getValue() . '" name="' . $element->getName() . '" %s id="' . $name . '_rel_sel_val">', $this->createAttributesString($attributes)
          ); */

        if (isset($attributes['image_name']) && $attributes['image_name']) {
            $field = '<img style="border: 1px solid #ececec; margin: 0; border-radius: 4px;" src="http://esculap.com/image/' . $attributes['image_name'] . '" alt="' . $name . '">';
        } else {
            $field = '<input type="text" disabled="disabled" class="inp-form" value="' . $noImageText . '">';
        }

        return $field;
    }

}

?>