<?php
namespace System\View\Helper\Form;

use System\Translator;
use Zend\Form\View\Helper\FormSelect;
use Zend\Form\ElementInterface;

class FormSelectRelationalHidden extends FormSelect {

    protected $validSelectAttributes = array(
        'name' => true,
        'autofocus' => true,
        'disabled' => true,
        'form' => true,
        'multiple' => true,
        'required' => true,
        'size' => true,
        'req' => true,
        'val' => true,
    );

    public function render(ElementInterface $element) {
        $name = str_replace('_hidden', '', $element->getName());
        if (empty($name) && $name !== 0) {
            throw new Exception\DomainException(sprintf(
                    '%s requires that the element has an assigned name; none discovered', __METHOD__
            ));
        }

        $attributes = $element->getAttributes();
        $attributes['name'] = $name;
        if (array_key_exists('multiple', $attributes) && $attributes['multiple']) {
            $attributes['name'] .= '[]';
        }

        $field = sprintf(
                '<input type="hidden" value="' . $element->getValue() . '" name="' . $element->getName() . '" %s id="' . $name . '_rel_sel_val">', $this->createAttributesString($attributes)
        );

        return $field;
    }

}

?>