<?php
namespace System\View\Helper\Form;

use System\Translator;
use Zend\Form\View\Helper\FormSelect;
use Zend\Form\ElementInterface;

class FormSelectRelationalVisible extends FormSelect {

    protected $validSelectAttributes = array(
        'name' => true,
        'autofocus' => true,
        'disabled' => true,
        'form' => true,
        'multiple' => true,
        'required' => true,
        'size' => true,
        'req' => true,
        'val' => true,
    );

    public function render(ElementInterface $element) {
        $translator = Translator\TranslatorEx::get();
        $mianSelectText = $translator->translate('main_select');
        $mianClearText = $translator->translate('clear');

        $link = rtrim($element->getOption('link'), '/');

        $name = str_replace('_visible', '', $element->getName());
        if (empty($name) && $name !== 0) {
            throw new Exception\DomainException(sprintf(
                    '%s requires that the element has an assigned name; none discovered', __METHOD__
            ));
        }

        $clearLinkHTML = "<a class=\"select_relational_link select_relational_clear\" data-relational-select-name=\"{$name}\" href=\"#\">{$mianClearText}</a>";
        $linkHTML = "<a class=\"relational-view select_relational_link relational-select\" data-relational-select-name=\"{$name}\" href=\"{$element->getOption('link')}\">{$mianSelectText}</a>";
        $attributes = $element->getAttributes();

        $attributes['name'] = $name;
        if (array_key_exists('multiple', $attributes) && $attributes['multiple']) {
            $attributes['name'] .= '[]';
        }

        $field = '
            <input class="inp-form" name="' . $element->getName() . '" type="text" readonly="readonly" value="' . $element->getValue() . '" id="' . $name . '_rel_sel_name">'
                . $linkHTML
                . $clearLinkHTML;
        return $field;
    }

}

?>