<?php

namespace System\View\Helper;
use Zend\View\Helper\AbstractHelper;

class FormSerch extends AbstractHelper {
	
	public function __invoke( \System\Translator\TranslatorStorageEx $translator , $translatorNamespace , $fields , $values = array() ) {
		$res = '
			<form id="phrase_serch_form" name="phrase_serch_form" action="" method="post" class="esculapSerchTable">
				<div class="esculapTableSerchBricksPlace">
		';
		
		if( !is_array( $fields ) ) return '';
		if( !is_array( $values ) ) $values = array(); 
		
		$_values = array();
		foreach( $values as $key => $value ) {
			if( !is_numeric( $key )) {
				$_values = $values;
				break;
			}
			
			$_values = array_merge( $_values , $value );
		}
		
		//print_r( $_values );
		
		$values = new dataWrapper( $_values );
		
		
		
		foreach( $fields as $fieldData ) {
			$field = $fieldData[ 'name' ];
			$data = $fieldData[ 'data' ];
			
			
			if( !is_string( $field ) ) continue;
			
			switch( $field ) {
				case 'text' :
				case 'text-short' :
				
					$short = '';
					if( 'text-short' == $field ) {
						
						$short = '-date';
					}
					
					if( !is_array( $data ) ||
						!isset( $data[ 'name' ] ) ||
					    !isset( $data[ 'label' ] ) ) {
						
						continue;
					}
					
					$name = trim( $data[ 'name' ] );
					
					
					$label = $data[ 'label' ];
					$value = null !== $values->$name ? $values->$name : @$data[ 'value' ];
					$class = @$data[ 'class' ];
					
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\">{$label}: </div>
							<div>
								<input class=\"inp-form{$short} {$class}\" type=\"text\" name=\"{$name}\" value=\"{$value}\">
							</div>
						</div>
					";
					
					break;
				case 'hidden':
					
					if( !is_array( $data ) ||
						!isset( $data[ 'name' ] ) ) {
						
						continue;
					}	
					
					$name = trim( $data[ 'name' ] );
					
					
					$class = @$data[ 'class' ];
					$value = null !== $values->$name ? $values->$name : @$data[ 'value' ];
					
					$res .= "<input type='hidden' name='{$name}' class='{$class}' value='{$value}'>";
					
					break;
				case 'checkboxList' :
					
					if( !is_array( $data ) ||
						!isset( $data[ 'name' ] ) ||
					    !isset( $data[ 'label' ] ) ||
						!isset( $data[ 'values' ] ) ) {
						
						continue;
					}
					
					
					$name = $data[ 'name' ];
					$label = $data[ 'label' ];
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\"> {$label}: </div>
							<div>
								<div>
									<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select_group' , $translatorNamespace )}\">
								</div>
										
								<div style=\"position:relative\">
									
									<div class=\"hiddenContent\" style=\"display:none;\">
											
										<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all' , $translatorNamespace )}</a></div>
													
										<hr class=\"esculapTableFilterBoardSeparator\">";
											
											$_data = null;
											if( null !== $values->$name ) {
												$_data = explode( ',' , $values->$name );
											}
											
											foreach( $data[ 'values' ] as $value => $inputLabel ) {
												if( null !== $_data ) {
													
													if( in_array( $value , $_data ) ) {
														
														$checked = 'checked="checked"';
														
													} else {
														$checked = '';
													}
													
												} else {
													$checked = 'checked="checked"';
												}
												
												$res .= "<div><input type=\"checkbox\" {$checked} value=\"{$value}\" class=\"no-transform\" name=\"{$name}\"/> <a>{$inputLabel}</a></div>";
											}
											
										
								$res .= "<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"{$name}\" style=\"display:none;\"/>		
									</div>
								</div>
							</div>
						</div>
					";
					
				break;
				case 'id_val':
					
					$res .= "
					<div class=\"esculapTableSerchBrick\">
						<div class=\"header\"> {$translator->translate('main_id' , $translatorNamespace )}: </div>
						<div>
							<input class=\"inp-form\" type=\"text\" name=\"id_val\" value=\"{$values->content_id}\">
						</div>
					</div>
					";
					break;
				case 'title_val':
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\">{$translator->translate('main_title' , $translatorNamespace )}: </div>
							<div>
								<input class=\"inp-form\" type=\"text\" name=\"title_val\" value=\"{$values->title}\">
							</div>
						</div>
					";
					break;
                               case 'main_site_name_val':
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\">{$translator->translate('main_site_name' , $translatorNamespace )}: </div>
							<div>
								<input class=\"inp-form\" type=\"text\" name=\"main_site_name_val\" value=\"{$values->main_site_name}\">
							</div>
						</div>
					";
					break;
				case 'group_name':
					if( !is_array( $data ) ) continue;
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\"> {$translator->translate('main_lang' , $translatorNamespace)}: </div>
							<div>
								<div>
									<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select_group' , $translatorNamespace )}\">
								</div>
										
								<div style=\"position:relative\">
									
									<div class=\"hiddenContent\" style=\"display:none;\">
											
										<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all' , $translatorNamespace )}</a></div>
													
										<hr class=\"esculapTableFilterBoardSeparator\">";
											
											$_data = null;
											if( null !== $values->group_name ) {
												$_data = explode( ',' , $values->group_name );
											}
											
											foreach( $data as $lang ) {
												if( null !== $_data ) {
													
													if( in_array( $lang , $_data ) ) {
														
														$checked = 'checked="checked"';
														
													} else {
														$checked = '';
													}
													
												} else {
													$checked = 'checked="checked"';
												}
												
												$res .= "<div><input type=\"checkbox\" {$checked} value=\"{$lang}\" class=\"no-transform\" name=\"group_name\"/> <a>{$translator->translate('main_phrase_lang_'.$lang , $translatorNamespace )}</a></div>";
											}
											
										
								$res .= "<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"group_name\" style=\"display:none;\"/>		
									</div>
								</div>
							</div>
						</div>
					";
						
					break;
				case 'type':
					if( !is_array( $data ) ) continue;
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\"> {$translator->translate('main_type' , $translatorNamespace )}: </div>
							<div>
								<div>
									<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select_group' , $translatorNamespace )}\">
								</div>
										
								<div style=\"position:relative\">
									
									<div class=\"hiddenContent\" style=\"display:none;\">
											
										<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all' , $translatorNamespace )}</a></div>
													
										<hr class=\"esculapTableFilterBoardSeparator\">";
													
											
										foreach( $data as $id => $type) {
											
											$checked = 'checked="checked"';
											$res .= "<div><input type=\"checkbox\" {$checked} value=\"{$id}\" class=\"no-transform\" name=\"type\"/> <a>{$type}</a></div>";
										}
										
								$res .=  "<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"type\" style=\"display:none;\"/>		
									</div>
								</div>
							</div>
						</div>
					";
						
					break;
				case 'event_type':
					if( !is_array( $data ) ) continue;
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\"> {$translator->translate('main_type' , $translatorNamespace )}: </div>
							<div>
								<div>
									<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select_group' , $translatorNamespace )}\">
								</div>
										
								<div style=\"position:relative\">
									
									<div class=\"hiddenContent\" style=\"display:none;\">
											
										<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all' , $translatorNamespace )}</a></div>
													
										<hr class=\"esculapTableFilterBoardSeparator\">";
										
										
										$_data = null;
										if( null !== $values->event_type ) {
											
											$_data = explode( ',' , $values->event_type );
										}
										
										
										foreach( $data as $code => $name) {
											if( null !== $_data ) {
											
												if( in_array( $code , $_data ) ) {
													
													$checked = 'checked="checked"';
													
												} else {
													
													$checked = '';
												}
												
											} else {
												
												$checked = 'checked="checked"';
											}
											
											$res .= "<div><input type=\"checkbox\" {$checked} value=\"{$code}\" class=\"no-transform\" name=\"event_type\"/> <a>{$name}</a></div>";
										}
										
								$res .=  "<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"event_type\" style=\"display:none;\"/>		
									</div>
								</div>
							</div>
						</div>
					";
						
					break;
				case 'specs':
					
					if( !is_array( $data ) ) continue; 
					$res .= "
					<div class=\"esculapTableSerchBrick\">
						<div class=\"header\">{$translator->translate('main_specializations' , 'content_news')}: </div>
						<div>
							<div>
								<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select_specialization' , $translatorNamespace )}\">
							</div>
									
							<div style=\"position:relative\">
								
								<div class=\"hiddenContent\" style=\"display:none;\">
										
									<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all' , $translatorNamespace )}</a></div>
												
									<hr class=\"esculapTableFilterBoardSeparator\">
									<div style=\"max-height:250px;overflow-y:scroll;\">";
									
										
										$_data = null;
										if( null !== $values->spec_cod ) {
											
											$_data = explode( ',' , $values->spec_cod );
										}
										
										
										foreach( $data as $code => $name) {
											if( null !== $_data ) {
											
												if( in_array( $code , $_data ) ) {
													
													$checked = 'checked="checked"';
													
												} else {
													
													$checked = '';
												}
												
											} else {
												
												$checked = 'checked="checked"';
											}
												
											$res .= "<div><input type=\"checkbox\" {$checked} value=\"{$code}\" class=\"no-transform\" name=\"specs\"/> <a>{$name}</a></div>";
										}
										
								$res .= "</div>
									<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"specs\" style=\"display:none;\"/>		
								</div>
							</div>
						</div>
					</div>
					";
						
					break;
				case 'status':
					
					$res .= "
					<div class=\"esculapTableSerchBrick\">
						<div class=\"header\">{$translator->translate( 'main_active' , 'content_news')}: </div>
						<div>
							<div>
								<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select')}...\">
							</div>
									
							<div style=\"position:relative\">
								
								<div class=\"hiddenContent\" style=\"display:none;\">
										
									<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all')}</a></div>
												
									<hr class=\"esculapTableFilterBoardSeparator\">
										
										<div><input type=\"checkbox\" " . ( null !== $values->active ? ( strpos( $values->active , 'false' ) > -1 ? 'checked="checked"' : '' ) : 'checked="checked"' ) . " value=\"1\" class=\"no-transform\" name=\"status\"/> <a>{$translator->translate( 'main_no' , $translatorNamespace )}</a></div>
										
										<div><input type=\"checkbox\" " . ( null !== $values->active ? ( strpos( $values->active , 'true' ) > -1 ? 'checked="checked"' : '' ) : 'checked="checked"' ) . "' value=\"2\" class=\"no-transform\" name=\"status\"/> <a>{$translator->translate( 'main_yes' , $translatorNamespace )}</a></div>
										
									<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"status\" style=\"display:none;\"/>		
								</div>
							</div>
						</div>
					</div>";
						
					break;
                case 'add_by_user':
                    $res .= "
					<div class=\"esculapTableSerchBrick\">
						<div class=\"header\">{$translator->translate('main_add_by_user', 'content_event')}: </div>
						<div>
							<div>
								<input type=\"text\" onclick=\"return false;\" class=\"hiddenContentSwitch styledselect_form_3\" value=\"{$translator->translate('main_select')}...\">
							</div>

							<div style=\"position:relative\">

								<div class=\"hiddenContent\" style=\"display:none;\">

									<div><input class=\"esculapTableFilterBoardSelectAll\" type=\"checkbox\" checked><a>{$translator->translate('ok_map_select_clear_all')}</a></div>

									<hr class=\"esculapTableFilterBoardSeparator\">

										<div><input type=\"checkbox\" " . ( null !== $values->add_by_user ? ( strpos( $values->add_by_user , '1' ) > -1 ? 'checked="checked"' : '' ) : 'checked="checked"' ) . " value=\"1\" class=\"no-transform\" name=\"add_by_user\"/> <a>{$translator->translate( 'main_no' , $translatorNamespace )}</a></div>

										<div><input type=\"checkbox\" " . ( null !== $values->add_by_user ? ( strpos( $values->add_by_user , '2' ) > -1 ? 'checked="checked"' : '' ) : 'checked="checked"' ) . "' value=\"2\" class=\"no-transform\" name=\"add_by_user\"/> <a>{$translator->translate( 'main_yes' , $translatorNamespace )}</a></div>

									<input type=\"checkbox\" checked=\"checked\" value=\"0\" class=\"no-transform nochange\" name=\"status\" style=\"display:none;\"/>
								</div>
							</div>
						</div>
					</div>";
                    break;
				case 'add_date_from':
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\">  {$translator->translate('main_add_date_from' , $translatorNamespace )}: </div>
							<div>
								<input value=\"" . ( null !== $values->add_date_from ? $values->add_date_from : '' ) . "\" class=\"datepicker depminsrc_1 depmaxtarget_1 date-pick inp-form-date date-pick-max-date-set\" maxdate=\" " . date( 'd/m/Y' ) . "\" maxlength=\"10\" size=\"10\" type=\"text\" name=\"add_date_from\" autocomplete=\"off\" />
							</div>
						</div>
					";
					// " . ( isset( $where[ 'add_date_from' ] ) ) ? "value=\"" . ( strlen( $where[ 'add_date_from' ] ) == 10 ? date( 'd/m/Y' , $where['add_date_from'] ) : '' ) . "
					break;
				case 'add_date_to':
					
					$res .= "
						<div class=\"esculapTableSerchBrick\">
							<div class=\"header\">  {$translator->translate('main_add_date_to' ,  $translatorNamespace )}: </div>
							<div>
								<input value=\"" . ( null !== $values->add_date_to ? $values->add_date_to : '' ) . "\" class=\"datepicker depmaxsrc_1 depmintarget_1 date-pick inp-form-date date-pick-max-date-set\" maxdate=\" " . date( 'd/m/Y' ) . "\" maxlength=\"10\" size=\"10\" type=\"text\" name=\"add_date_to\" autocomplete=\"off\" />
							</div>
						</div>
					";
						// <?php echo date( 'd/m/Y' , strtotime( '+1 days' ) ); " maxlength="10" size="10" type="text" name="add_date_to" autocomplete="off" <?php if(isset($where['add_date_to'])) echo "value=\"" . ( strlen( $where[ 'add_date_to' ] ) == 10 ? date( 'd/m/Y' , $where['add_date_to'] ) : '' ) . "\"";
					break;
			}
		}
		
		$res .= "
				</div>
				
				<div>
					<a class=\"form-submit search_button info-tooltip\" title=\"{$translator->translate( 'main_search' , $translatorNamespace )}\" ></a>
				</div>
				
			</form>
		";
		
		return $res;
	}
}

class dataWrapper {
	protected $data;
	
	public function __construct( $data ) { $this->data = $data; }
	public function __get( $name ) { if( isset( $this->data[ $name ] ) ) return $this->data[ $name ] ; return null; }
}

?>