<?php

namespace System\View\Helper;
use Zend\View\Helper\AbstractHelper;
use System\Content\Element\AbstractContentElement;

class FormatViewElement extends AbstractHelper {
	
	public function __invoke($elements,$type) {
		
		$view = $this->view;
		
		return new FormatViewElementHelper( $elements , $type , $view );
	}
}

class FormatViewElementHelper {
	
	protected $_elements = array();
	protected $_pushedElements = array();
	protected $_separator = '';
	protected $_displayType;
	protected $_maxPushedIndex; // zawiera najwyśszy index ko, którego dołożono element
	protected $view;
	
	public function __construct( $elements , $type , $view ) {
		
		$this->view = $view;
		
		if(!is_array($elements) && !($elements instanceof AbstractContentElement)) {
			// czasowo wyłączone
			//throw new \Exception(__METHOD__.'. Argument przesłany do konstruktora musi być obiektem klasy "AbstractContentElement" lub tablicą takich obiektów');
		}
		
		$this->_displayType = ucfirst( $type );
		
		if(!is_array($elements)) {
			$elements = array($elements);
		}
                
		foreach( $elements as $element ) {
			
			$newElement = $this->process( $element );
                        
			if(null === $newElement) continue;
			
			$this->_elements[] = $newElement;
		}
	}
	
	protected function process($element) {
		
		if(!($element instanceof AbstractContentElement)) {
			// czasowo wyłączone
			//throw new \Exception(__METHOD__.'. Argument przesłany do konstruktora musi być obiektem klasy "AbstractContentElement"');
		}
		
		$className = explode( '\\' , get_class( $element ) );
		$className = count($className) > 0 ? $className[count($className) -1]  : $className[0];
		
		$className = "\System\View\Helper\Formatted\\".ucfirst($className).$this->_displayType;
		
		if(class_exists($className)) {
			
			$elem = new $className($element);
			$elem->setView( $this->view );
			return $elem;
		} else {
                var_dump($className); die();
                }
                
		exit( $element );
		
		return null;
	}
	
	/**
	* Wkłada do kolejki podany element, lub grupę elementów lub całą kolekcję
	* @param $elements mixed obiekt będący potomkiem AbstracCollectionElement, tablica obiektów AbstractContentElement, obiekt formatViewElement
	* @param $position int miejsce w kolejce elementów w, które ma zostać wstawiony $element. Element wstawiony zostanie w miejsce $position w orygimnalnej kolejce podanej w pierwszym miejscu np jeśli mamy 10 elementów wstawiamy reklame w 2 a później kolejną reklamę w 4 to reklama wynik będzie taki A A R A A R A...
	*/
	public function append($elements,$position = 1) {
		
		if($this->_maxPushedIndex < $position) {
			$this->_maxPushedIndex = $position;
		}
		
		if(isset($this->_pushedElements[$position]) && !is_array($this->_pushedElements[$position])) {
			$this->_pushedElements[$position] = array(
				$this->_pushedElements[$position]
			);
		}
		
		if(is_array($elements)) {
			foreach($elements as $element) {
				
				$this->_pushedElements[$position][] = $element;
			}
		} else {
			
			if(isset($this->_pushedElements[$position]) && is_array($this->_pushedElements[$position])) {
				$this->_pushedElements[$position][] = $elements;
			} else {
				$this->_pushedElements[$position] = $elements;
			}
		}
	}
	
	public function __toString() {
		$result = "";
		
		$place = 1;
                
                
		foreach($this->_elements as $element) {
			if(strlen($result)) $result .= $this->_separator;
			
			$result .= $this->getPushedForPlace($this->_pushedElements,$place);
			
                        Formatted\PublicationSlider::$no++;
                        Formatted\NewsSlider::$no++;
                        
			$result .= $element;
			$place++;
		}
		
		while($place <= $this->_maxPushedIndex) {
			
			$result .= $this->getPushedForPlace($this->_pushedElements,$place);
			
			$place++;
		}
		
                
                
		return $result;
	}
	
	protected function getPushedForPlace($pushedElements,$place) {
		$result = '';
	
		if(isset($pushedElements[$place])) {
			
			if(is_array($pushedElements[$place]) && count($pushedElements[$place])) {
				
				foreach($pushedElements[$place] as $key => $_element) {
					$result .= $_element;
				}
			} else {
				
				$result .= $pushedElements[$place];
				
			}
		}
			
		return $result;
	}
}

?>