<?php

namespace System\View\Helper\Formatted\Comment;

class SortEngine {
	
	public static function sortElements($elements) {
		if(!is_array($elements)) {
			$elements = array($elements);
		}
		
		// korzenie
		$roots = array();
		// liście
		$leafes = array();
		
		foreach($elements as $element) {
			if(!is_a($element,'System\Content\ElementComment')) {
				
				$element = new \System\Content\ElementComment( $element );
				//throw new \Exception(__METHOD__.'. Klasa musi być instancją  System\Content\ElementComment');
			}
			
			if((int)$element->parentCommentId > 0) {
				array_push($leafes,$element);
			} else {
				array_push($roots,$element);
			}	
		}
		
		
		if(count($roots)) {
			$roots = self::process($roots,$leafes);
			
			return $roots;
		}
		
		return array();
	}
	
	protected static function process($roots,&$leafes) {
		// próba przypisania liścia do korzenia
		foreach($roots as $root) {
			foreach($leafes as $key => $leafe) {
				if($root->commentId == $leafe->parentCommentId) {
					
					$root->appendComment($leafe);
					unset($leafes[$key]);
				}
			}
			
			if( count( $root->childrens() ) ) {
				
				$root->setChildrens(
					self::process(
						$root->childrens(),
						$leafes
					)
				);
			}
		}
		
		return $roots;
	}
	
	
}


?>