<?php

namespace System\View\Helper\Formatted;
use System\Content\ElementComment;
use System\View\Helper\Formatted\Comment\SortEngine;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;

class CommentDisplayer extends SortEngine {
	
	protected $_elements;
	protected $_translator;
	
	public function __construct( $comments ) {
		// sprawdzam czy wszystkie emenety są instancią odpowiedniego obiektu
		
		// sortowanie 
		$this->_translator = TranslatorEx::get();
		$this->_elements = self::sortElements( $comments );
	}
	
	public function displayComments() {
		
		return $this->prepare( $this->_elements );
	}
	
	protected function prepare($elements,$id = null) {
		
		$result = "<ol class=\"list19\" ".(null !== $id ? "id=\"komentarze-{$id}\"" : 'id="comments"')."> ";
		
		
		foreach($elements as $element) {
			$result .= "<li>";
			
			// wyświetlanie bieżącego elementu
			$result .= "
			<article class=\"mod5\">
				<h3 class=\"mod5-hdrl hdr11-a comment_owner\" id=\"{$element->commentId}\"><span>~{$element->nick}</span>, <time>".substr($element->addDate,0,16)."</time></h3>
					
				<blockquote class=\"mod5-txt text12\">
					<p>{$element->body}</p>
				</blockquote>

				<!--<ul class=\"mod5-nav list11\">
					<li><a href=\"#add_comment\" class=\"link8 response_to_comment\" id=\"{$element->commentId}\">{$this->_translator->translate('main_reply')}</a></li>
					<li><a href=\"#komentarze-{$element->commentId}\" class=\"ico-expand\">{$this->_translator->translate('main_view_replies')} (".$element->countResponses().")</a></li>
				</ul>-->
			</article>
			";
			
			// jeśli element ma dzieci wyświetlam je
			$childrens = $element->childrens();
			if(count($childrens)) {
				$result .= $this->prepare($childrens,$element->commentId);
			}
			
			$result .= "</li>";
		}
		
		$result .= "</ol>";
		
		return $result;
	}
}

?>