<?php 

namespace System\View\Helper\Formatted;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\Content\Element\Event;
use System\View\Helper\Formatted\WrappableInterface;

class EventContent extends AbstractFormattedElement implements WrappableInterface{
	
	protected $_eventObject;
	protected $_translator;
	
	public function __construct(Event $eventObject) {
		$this->_translator = TranslatorEx::get();
		$this->_eventObject = $eventObject;
	}
	
	public function __toString() {
		$result = "
		<div class=\"mod19 print_content\">
			<header class=\"mod19-top\">
				<ul class=\"print_remove mod19-nav list18\">			  
					<!--<li>" . ( strlen( $this->_eventObject->fileUrl ) > 1 ? "<a class=\"link7 ico-pdf\" href=\"{$this->_eventObject->fileUrl}\" >pdf</a> " : '' ) . "</li>-->
					<!--<li><a class=\"print_button link7 ico-print\">{$this->_translator->translate('main_print')}</a></li>-->
				</ul>

				<h1 class=\"mod19-hdr hdr22\">{$this->_eventObject->title}</h1>
			</header>

			<dl class=\"list22\">
				
				".(null !== $this->_eventObject->type ?"
				<dt>{$this->_translator->translate('main_event_type')}:</dt>
				<dd>".$this->_translator->translate("dict_event_type_{$this->_eventObject->type}")."</dd>
				" : '')."
				
				<dt>{$this->_translator->translate('main_date')}:</dt>
				<dd><time>{$this->_eventObject->start}</time> - <time>{$this->_eventObject->end}</time></dd>
				
				".(null !== $this->_eventObject->city ?"
				<dt>{$this->_translator->translate('main_city')}:</dt>
				<dd>{$this->_eventObject->city}</dd>
				" : '')."
				
				".(null !== $this->_eventObject->zip ?"
				<dt>{$this->_translator->translate('main_postal_code')}:</dt>
				<dd>{$this->_eventObject->zip}</dd>
				" : '')."
				
				".(null !== $this->_eventObject->address ?"
				<dt>{$this->_translator->translate('main_address')}:</dt>
				<dd>{$this->_eventObject->address}</dd>
				" : '')."
				
				
				".(null !== $this->_eventObject->link ?"
				<dt>{$this->_translator->translate('main_website')}:</dt>
				<dd><a href=\"http://{$this->_eventObject->link}\">{$this->_eventObject->link}</a></dd>
				" : '')."
				
				".(null !== $this->_eventObject->orgName ? "
				<dt>{$this->_translator->translate('main_organizer_name')}:</dt>
				<dd>{$this->_eventObject->orgName}</dd>
				" : '')."
				
                                ".(null !== $this->_eventObject->info ? "
				<dt>{$this->_translator->translate('main_additional_info')}:</dt>
				<dd>{$this->_eventObject->info}</dd>
                                " : '')."
				
				".(null !== $this->_eventObject->org_addr ? "
				<dt>{$this->_translator->translate('main_contact_organizer')}:</dt>
				<dd>{$this->_eventObject->org_addr}</dd>
				" : '')."
				
				".(null !== $this->_eventObject->fileUrl ? "
				<dt>{$this->_translator->translate('main_annex')}:</dt>
				<dd><a href=\"{$this->_eventObject->fileUrl}\">{$this->_translator->translate('main_annex')}</a></dd>
				" : '')."

				
				
			</dl>
		</div>
		";
		
		return $result;
	}
}

?>