<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Event;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class EventLinkList extends AbstractFormattedElement implements WrappableInterface{
	protected $_eventObject;	
	protected $_translator;
	
	public function __construct(Event $eventObject) {
		$this->_translator = TranslatorEx::get();
		$this->_eventObject = $eventObject;
	}
	
	public function __toString() {
		$result = "
			<article class=\"mod9\">
				<h1 class=\"hdr13\"><a href=\"".FormatUrl::format('/event/'.$this->_eventObject->id.'/'.$this->_eventObject->title, $this->_eventObject->main_site->getUrlForViewHelper())."\">".$this->_eventObject->title."</a></h1>
				<dl class=\"mod9-det\">
					<dt>{$this->_translator->translate('main_address')}:</dt>
					<dd>".$this->_eventObject->zip." ".$this->_eventObject->city." ".$this->_eventObject->address."</dd>
					<dt>{$this->_translator->translate('main_date')}:</dt>
					<dd>{$this->_translator->translate('main_date_from')} <time>".$this->_eventObject->start."</time> {$this->_translator->translate('main_date_until')} <time>".$this->_eventObject->end."</time></dd>
				</dl>
			</article>
		";

		return $result;
	}
}

?>