<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Event;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class EventList extends AbstractFormattedElement implements WrappableInterface{
	protected $_eventObject;
	protected $_translator;
	
	public function __construct(Event $eventObject) {	
		$this->_translator = TranslatorEx::get();
		$this->_eventObject = $eventObject;
	}
	
	public function __toString() {
		
		$result = "
			<li>
				<h2 class=\"hdr13\"><a href=\"".FormatUrl::format('/event/'.$this->_eventObject->id.'/'.$this->_eventObject->title,$this->_eventObject->main_site->getUrlForViewHelper())."\">{$this->_eventObject->title}</a></h2>
				
				<dl class=\"list21\">
					" . ( strlen( $this->_eventObject->address ) ? "<dt>{$this->_translator->translate('main_address')}:</dt><dd>{$this->_eventObject->address}</dd> " : '' ) . "
					<dt>{$this->_translator->translate('main_date')}:</dt>
				<dd>{$this->_translator->translate('main_date_from')} <time>{$this->_eventObject->start}</time> {$this->_translator->translate('main_date_until')} <time>{$this->_eventObject->end}</time></dd>
				</dl>
			</li>
		";
		
		if( 1 == $this->_eventObject->lastMatched )
			$result .= "
			</ul>
				<div class=\"form4-sbt\" style=\"text-align:center;font-weight:bold;padding: 0 10px 20px 10px;font-size:15px;\">Zobacz informacje o innych wydarzeniach medycznych</div>
			<ul class=\"list6\">";
		
		return $result;
	}
}

?>