<?php

namespace System\View\Helper\Formatted;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\Content\Element\Event;
use System\View\Helper\Formatted\WrappableInterface;
use Zend\Filter\StripTags;

class EventSearchResult extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_eventObject;
	protected $_type = 'event';
	protected $_translator;
	
	public function __construct(Event $eventObject) {
		$this->_translator = TranslatorEx::get();
		$this->_eventObject = $eventObject;
	}
	
	public function __toString() {
		$this->_eventObject->mathlevel = ceil( $this->_eventObject->mathlevel * 100 );
		
		$filter = new StripTags( array( 'allowTags' => 'b' ) );
		$head = $filter->filter( $this->_eventObject->head );
		
		return "
		<article class=\"mod18\">
					<hgroup>
						<h1 class=\"mod18-hdr hdr13\"><a href=\"".FormatUrl::format('/event/'.$this->_eventObject->id.'/'.$this->_eventObject->title,$this->_eventObject->main_site->getUrlForViewHelper())."\">".$this->_eventObject->title."</a></h1>
						<!--<h2 class=\"mod18-cat hdr10V\">Artykuł naukowy</h2>-->
					</hgroup>

					<div class=\"mod18-txt text\">
						<p>{$head}</p>
					</div>

					<footer>
						<br/>
						<meter value=\"{$this->_eventObject->mathlevel}\" max=\"100\">{$this->_eventObject->mathlevel}</meter>
					</footer>
				</article>
		";
	}
}

?>