<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\Formatted\CommentDisplayer;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;
use Zend\Session\Container as SessionContainer;


class NewsContent extends AbstractFormattedElement implements WrappableInterface{
	protected $_newsObject;	
	protected $_translator;
	
	public function __construct(News $newObject) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newObject;
	}
	
	public function __toString() {
	
		// przygotowanie komentarzy
		$comments = new CommentDisplayer($this->_newsObject->comments);
		
		
		$result = "
				<article class=\" mod19 print_content\">
					<div class=\"mod19-top\">
						<header>
							<ul class=\"mod19-nav list18 print_remove\">
								<li><a href=\"#comments\" class=\"ico-com\">".count($this->_newsObject->comments)."<span class=\"hide\">{$this->_translator->translate('main_comments')}</span></a></li>
								<!--<li><a class=\"link7 ico-print print_button\">{$this->_translator->translate('main_pirnt')}</a></li>-->
							</ul>

							<h1 class=\"mod19-hdr hdr22\">{$this->_newsObject->title}</h1>
						</header>
						
						
						
						<dl class=\"list17\">
							<dt class=\"hide\">{$this->_translator->translate('main_section')}:</dt>
							<dd><span itemprop=\"articleSection\">{$this->_newsObject->newsTypeName}</span></dd>

							<dt class=\"hide\">{$this->_translator->translate('main_date')}:</dt>
							<dd><time datetime=\"2012-04-12\" itemprop=\"datePublished\">". substr( trim( $this->_newsObject->date ) , 0 , 10 ) ."</time></dd>

							<dt class=\"hide\">{$this->_translator->translate('main_source')}:</dt>
							<dd>[\"<span itemprop=\"publisher\">".$this->_newsObject->author."</span>\"]</dd>
						</dl>
						
						
						
					</div>

					<div class=\"text textj\" itemprop=\"articleBody\">
						<div class=\"print_remove grid_6 alpha mod19-img\">
							<img width=\"221\" height=\"194\" alt=\"\" src=\"/image/".$this->_newsObject->avatar.",221,194\"/>
						</div>
						
						<!--<p>
							{$this->_newsObject->head}
						</p>-->
						
						{$this->_newsObject->body}
						
					</div>
					
					
					<form id=\"eveluation_place\" action=\"/content_evaluation\" method=\"post\" class=\"form3 mod19-btm print_remove\">
						<input type=\"hidden\" name=\"lang\" value=\"{$this->_newsObject->langId}\">
						<input type=\"hidden\" name=\"content_id\" value=\"{$this->_newsObject->id}\">
						<input type=\"hidden\" name=\"mark\" value=\"\">";
						
						
						if( isset( $_SESSION[ 'content_evaluation' ] ) && is_array( $_SESSION[ 'content_evaluation' ] ) ) {
							
							$data = $_SESSION[ 'content_evaluation' ];
							$message = $class = null;
							
							if( array_key_exists( 0 , $data ) ) {
								$message = $data[ 0 ];
								$class = 'evaluation_red';
							} elseif( array_key_exists( 1 , $data ) ) {
								$message = $data[ 1 ];
								$class = 'evaluation_green';
							}
							$result .= "<p class=\"text\"><b class=\"{$class}\">{$message}</b></p>";
							
						}
						
						if( isset( $_SESSION[ 'content_evaluation' ] ) ) unset( $_SESSION[ 'content_evaluation' ] );
						
						
						
				$result .= "<p class=\"form3-hdr text\">{$this->_translator->translate('main_rate_content')}:</p>
						
						
						
						" . ( 1 !== $this->_newsObject->evaluation_available ? "
						
						<ol class=\"form3-marks evaluation_mark print_remove\">
							<li name=\"1\"><input type=\"image\" src=\"/gfx/mark-1.png\" alt=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 1\" title=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 1\"/></li>
							<li name=\"2\"><input type=\"image\" src=\"/gfx/mark-2.png\" alt=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 2\" title=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 2\"/></li>
							<li name=\"3\"><input type=\"image\" src=\"/gfx/mark-3.png\" alt=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 3\" title=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 3\"/></li>
							<li name=\"4\"><input type=\"image\" src=\"/gfx/mark-4.png\" alt=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 4\" title=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 4\"/></li>
							<li name=\"5\"><input type=\"image\" src=\"/gfx/mark-5.png\" alt=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 5\" title=\"{$this->_translator->translate('main_evaluate' , 'content_view' )} 5\"/></li>
						</ol>
						
						" : "" ) . "
						
						
						
						
						<p class=\"form3-txt text\">
							(
								<b itemprop=\"ratingCount\">{$this->_newsObject->evaluated} {$this->_translator->translate('main_votes_cast')}</b>, 
								{$this->_translator->translate('main_rating')}: 
								<b>{$this->_newsObject->evaluation}<img class=\"form3-mark content_evaluation_value\" width=\"65\" height=\"14\" alt=\"\" src=\"/gfx/mark-" . preg_replace( '/\./' , '' , $this->_newsObject->evaluationRounded ) . ".png\"/></b>
							) 
							<a href=\"#comments\" class=\"ico-com\">{$this->_translator->translate('main_comments')}: 
								<b>".count($this->_newsObject->comments)."</b>
							</a>
						</p>
					
					
					
					
					
					</form>
					
					
					
				</article>
				
				<hr>
					
				<section id=\"comment\" class=\"mod19\">
						<h1 class=\"mod10-top hdr20\">{$this->_translator->translate('main_comments', 'Content\Element')} <span>(".count($this->_newsObject->comments).")</span></h1>
						
						
						<form class=\"print_remove\" name=\"addComment\" action=\"".FormatUrl::format('/add_comment')."\" method=\"post\" id=\"add_comment\">
							<input type=\"hidden\" id=\"content_id\" name=\"content_id\" value=\"{$this->_newsObject->id}\">
							<input type=\"hidden\" id=\"response_to\" name=\"response_to\" value=\"0\">
							<input type=\"hidden\" id=\"content_lang\" name=\"content_lang\" value=\"{$this->_newsObject->langId}\">
							
							<div id=\"response_to_container\" >
								<div id=\"response_to_header\">
									{$this->_translator->translate( 'main_response_to_comment_header' )}
								</div>
								<div id=\"response_to_source\"></div>
								<div id=\"response_to_cancel\" title=\"{$this->_translator->translate( 'main_response_to_comment_cancel' )}\">&nbsp;</div>
							</div>
							
							<fieldset class=\"form6\">
								<legend><span class=\"hide\">{$this->_translator->translate('main_add_comment')}</span></legend>
							
								<div>
									<label for=\"FC-nick\">{$this->_translator->translate('main_nickname')}:</label>
									<div class=\"comment_add_error\">{$this->_translator->translate('error_nickname_required')}</div>
									<input type=\"text\" name=\"nick\" id=\"FC-nick\"/>
								</div>
								<div>
									<label for=\"FC-text\">{$this->_translator->translate('main_comment_contents')}:</label>
									<div class=\"comment_add_error\">{$this->_translator->translate('error_contents_required')}</div>
									<textarea name=\"content\" id=\"FC-text\" rows=\"3\" cols=\"50\"></textarea>
								</div>
							</fieldset>
							<div class=\"form6-sbt\">
								<button type=\"submit\" class=\"btn1 \">{$this->_translator->translate('main_add_comment')}</button>
							</div>
						</form>

						".($comments->displayComments())."
				</section>
		";	
		
		return $result;
	}
}

?>