<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class NewsLinkList extends AbstractFormattedElement implements WrappableInterface{
	
	protected $_name = 'linkList';
	protected $_newsObject;
	protected $_translator;
	
	public function __construct(News $newsObj) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newsObj;
	}
	
	public function __toString() {
		
		$result = "<li><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">{$this->_newsObject->title}</a></li>";

		return $result;
	}
}

?>