<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class NewsList extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_newsObject;
	protected $_type = 'news';
	protected $_translator;
	
	public function __construct( News $element ) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $element;
	}
	
	public function __toString() {
		$result = "
		<article class=\"mod16\">
			<div class=\"grid_4 alpha omega mod16-img\">
				<img width=\"120\" height=\"88\" alt=\"\" src=\"/image/".$this->_newsObject->avatar.",120,88\"/>
			</div>
			<div class=\"grid_12x alpha mod16-txt\">
				<h2 class=\"hdr16L\" ><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">".$this->_newsObject->title."</a></h2>
			<dl class=\"list14\">
					<dt>{$this->_translator->translate('main_author')}:</dt>
					<dd><span itemprop=\"author\">".$this->_newsObject->author."</span></dd>
				<dt>{$this->_translator->translate('main_date')}:</dt>
					<dd><time >".substr( $this->_newsObject->date ,0 , 10 )."</time></dd>
				</dl>
				
				
				<dl class=\"list15\">
					<dt class=\"hide\">{$this->_translator->translate('main_rating')}:</dt>
					<dd><b>{$this->_newsObject->evaluation}</b> <img width=\"65\" height=\"14\" alt=\"\" src=\"gfx/mark-" . preg_replace( '/\./' , '' , $this->_newsObject->evaluationRounded ) . ".png\"/> (<span>{$this->_newsObject->evaluated}</span> {$this->_translator->translate('main_votes_cast')})</dd>
				<dt><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper()).(count( $this->_newsObject->comments ) ? '#comments' : '#comment' )."\" class=\"ico-com\">{$this->_translator->translate('main_comments')}:</a></dt>
					<dd><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\"><b>".count( $this->_newsObject->comments )."</b></a></dd>
				</dl>
				
				
				
			</div>
		</article>
		";
		
		return $result;
	}
}



?>
