<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;
use System\View\Helper\Formatted\WrappableInterface;

class NewsMain extends AbstractFormattedElement implements WrappableInterface{
	
	protected $_newsObject;
	protected $type = 'main';
	protected $_translator;
	
	public function __construct(News $newsObject) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newsObject;
	}

	public function __toString() {
		//url ===> $this->_newsObject->main_site->getUrl()
		$result = "
			<article class=\"mod6 clearfix\">
					<div class=\"mod6-img\">
						<img width=\"120\" height=\"88\" alt=\"\" src=\"/image/".$this->_newsObject->avatar.",120,88\"/>
					</div>

					<h1 class=\"mod6-hdr hdr16L\"><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">{$this->_newsObject->title}</a></h1>

					<div class=\"mod6-txt text12\">
						<p>{$this->_newsObject->head}</p>
					</div>
					
					<section class=\"mod6-com\">
						<h2 class=\"hide\">{$this->_translator->translate('main_comments', 'Content\Element')}</h2>";
						
						$lp = 1;
						foreach($this->_newsObject->comments as $comment) {
							
							$result .= "
								<article class=\"mod5\">
									<h3 class=\"mod5-hdr hdr11-a\">{$this->_translator->translate('main_comment_date')}: <time datetime=\"2012-03-13\" itemprop=\"dateCreated\">".(strtr(substr($comment->addDate,0,16),'-','.'))."</time></h3>

									<blockquote class=\"mod5-txt text12\">
										<p>".Truncat::truncat($comment->body,80,true,'...')." <a href=\"/news/{$this->_newsObject->id}/{$this->_newsObject->title}#comment{$lp}\">{$this->_translator->translate('main_read_more')}</a></p>
									</blockquote>
								</article>
							";
							
							if( $lp++ == 3 ) {
								break;
							}
						}
						
						$result .= "
						<!--<p><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}".(count($this->_newsObject->comments) ? '#komentarze' : ''))."\" class=\"link3 ico-com\">{$this->_translator->translate('main_view_all_comments')} (".count($this->_newsObject->comments).")</a>-->
					</section>
					
				</article>
		";
		
		return $result;
	}
}

?>