<?php

namespace System\View\Helper\Formatted;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\Content\Element\News;
use System\View\Helper\Formatted\WrappableInterface;
use Zend\Filter\StripTags;

class NewsSearchResult extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_newsObject;
	protected $_type = 'news';
	protected $_translator;
	
	public function __construct(News $newsObject) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newsObject;
	}
	
	public function __toString() {
		$this->_newsObject->mathlevel = ceil( $this->_newsObject->mathlevel * 100 );
		
		//trigger_error( $this->_newsObject->mathlevel );
		
		$filter = new StripTags( array( 'allowTags' => 'b' ) );
		$head = $filter->filter( $this->_newsObject->head );
		
		return "
		<article class=\"mod18\">
					<hgroup>
						<h1 class=\"mod18-hdr hdr13\"><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">".$this->_newsObject->title."</a></h1>
						<!--<h2 class=\"mod18-cat hdr10V\">Artykuł naukowy</h2>-->
					</hgroup>

					<div class=\"mod18-txt text\">
						<p>{$head}</p>
					</div>

					<footer>
						<meter value=\"{$this->_newsObject->mathlevel}\" max=\"100\">{$this->_newsObject->mathlevel}</meter>
					</footer>
				</article>
		";
	}
}

?>