<?php
namespace System\View\Helper\Formatted;

use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;

class NewsSlider extends AbstractFormattedElement {

    protected $_newsObject;
    protected $_type = 'news';
    protected $_translator;
    public static $no = 0;

    public function __construct(News $element) {
        $this->_translator = TranslatorEx::get();
        $this->_newsObject = $element;
    }

    public function __toString() {
        $result = "
		<article class=\"mod1 " . ((self::$no == 1) ? 'target' : '') . "\" itemscope=\"itemscope\" itemtype=\"http://schema.org/Article\" id=\"news-" . (self::$no) . "\">
			<div class=\"mod1-img grid_9 alpha\">
				<img width=\"350\" height=\"280\" alt=\"\" src=\"/image/" . $this->_newsObject->avatar . ",350,280\"/>
			</div>
			<div class=\"grid_7 omega\">
				<hgroup>";
        
        if ($this->_newsObject->newsType == 4) {
            $result .= "<h1 class=\"mod1-hdr hdr20\" itemprop=\"name\"><a class=\"banner_click_register\" id=\"{$this->_newsObject->cfgId}\" href=\"" . FormatUrl::format("{$this->_newsObject->content_data_url}") . "\"" . ((substr($this->_newsObject->content_data_url, 0, 4) == 'http') ? 'target="_blank"' : '') . ">{$this->_newsObject->title}</a></h1>";
        } else {
            $result .= "<h1 class=\"mod1-hdr hdr20\" itemprop=\"name\"><a class=\"banner_click_register\" id=\"{$this->_newsObject->cfgId}\" href=\"" . FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}", $this->_newsObject->main_site->getUrlForViewHelper()) . "\">{$this->_newsObject->title}</a></h1>";
        }
        
        $result .= "<!--<h2 class=\"mod1-cat hdr10V\" itemprop=\"articleSection\"><a href=\"index.html\"></a></h2>-->
				</hgroup>
				<div class=\"mod1-txt text\" itemprop=\"articleBody\">
					<p>" . trim(Truncat::truncat($this->_newsObject->head, 250 - strlen($this->_newsObject->title), true, ''));

        if ($this->_newsObject->id) { //bez id są sponsorowane
            $result .= "&hellip;";
        }

        $result .= "</p>
				</div>
			</div>
		</article>
		";

        return $result;
    }

}

?>