<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\View\Helper\Truncat;
use System\Translator\TranslatorEx;

class NewsSneakPeak extends AbstractFormattedElement {
	
	protected $_newsObject;
	protected $type = 'SneakPeak';
	protected $_translator;
	
	public function __construct(news $newsObject) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newsObject;
	}
	
	public function __toString() {
		$result = "
		<article class=\"mod8 grid_6 alpha\">
			<h2 class=\"hdr13 mod8-hdr\"><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">".$this->_newsObject->title."</a></h2>
			<div class=\"mod8-txt text\">
				<p>".Truncat::truncat($this->_newsObject->body,200,true,'...','sneakPeak')."</p>
			</div>
		</article>
		";
		
		return $result;
	}
}


?>