<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\News;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;

class NewsSneakPeakOmega extends AbstractFormattedElement {
	
	protected $_newsObject;
	protected $_translator;
	
	public function __construct(News $newsObject) {
		$this->_translator = TranslatorEx::get();
		$this->_newsObject = $newsObject;
		
	}
	
	public function __toString() {
		
		$result = "
		<article class=\"mod8 grid_5 omega\">
			<h2 class=\"hdr13 mod8-hdr\"><a href=\"".FormatUrl::format("/news/{$this->_newsObject->id}/{$this->_newsObject->title}",$this->_newsObject->main_site->getUrlForViewHelper())."\">{$this->_newsObject->title}</a></h2>
			<div class=\"mod8-txt text\" itemprop=\"articleBody\">
				<p>".Truncat::truncat($this->_newsObject->body,200,true,'...','sneakPeak')."</p>
			</div>
		</article>
		";
		
		return $result;
	}
}

?>