<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Publication;
use System\View\Helper\Formatted\CommentDisplayer;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class PublicationContent extends AbstractFormattedElement implements WrappableInterface{
	
	protected $_publicationObject;
	protected $_translator;
	
	public function __construct(Publication $publicationObject) {
		$this->_translator = TranslatorEx::get();
		$this->_publicationObject = $publicationObject;
	}
	
	public function __toString() {
		
		// przygotowanie komentarzy
		$comments = new CommentDisplayer($this->_publicationObject->comments);
		
		$keywords = array();
		
		if(mb_strpos($this->_publicationObject->keywords,',')) {
			
			$keywords = explode(',',$this->_publicationObject->keywords);
			
		} else {
		
			$keywords[] = $this->_publicationObject->keywords;
		}
		
                //var_dump($this->_publicationObject->journalEdition);
                
		$result = "
				<article class=\"mod19 print_content\">
					<div class=\"mod19-top\">
						
						<header>
							<ul class=\"mod19-nav list18 print_remove\">
								<li><a href=\"#comments\" class=\"ico-com\">".count($this->_publicationObject->comments)."<span class=\"hide\">{$this->_translator->translate('main_comments')}</span></a></li>
								<li>" . ( strlen( $this->_publicationObject->fileUrl ) > 1 ? "<a class=\"link7 ico-pdf\" href=\"/sitefile/{$this->_publicationObject->fileUrl}\" >pdf</a> " : '' ) . "</li>
								<!--<li><a class=\"link7 print_button ico-print\">{$this->_translator->translate('main_pirnt')}</a></li>-->
							</ul>
							
							<h1 class=\"mod19-hdr hdr22\">{$this->_publicationObject->title}</h1>
						</header>
						
						" . ( strlen( $this->_publicationObject->englishTitle ) > 0 && $this->_publicationObject->englishTitle != 0 ? "
						<dl class=\"list14 mod19-det\">
							<dt>{$this->_translator->translate('main_english_title')}:</dt>
							<dd><span itemprop=\"author\">".$this->_publicationObject->englishTitle."</dd>
						</dl>
							" : '' ) . "

						<dl class=\"list14 mod19-det\">
							<dt>{$this->_translator->translate('main_author')}:</dt>
							<dd><span itemprop=\"author\">".$this->_publicationObject->author."</dd>
						</dl>
						
						" . ( strlen( $this->_publicationObject->journalName ) > 0 ?
						
							"<dl class=\"list14 mod19-det\">
								<dt>
									{$this->_translator->translate( 'main_journal' )}:
								</dt>
								<dd>
									{$this->_publicationObject->journalName}" . ($this->_publicationObject->journalEdition['edition_nr'] ? " nr {$this->_publicationObject->journalEdition['edition_nr']}, " : '')
                                                                        . ($this->_publicationObject->journalEdition['edition_book_nr'] ? "z. {$this->_publicationObject->journalEdition['edition_book_nr']} " : '') . ($this->_publicationObject->journalEdition['book_nr'] ? "({$this->_publicationObject->journalEdition['book_nr']}) {$this->_publicationObject->journalEdition['book_year']}" : '' ) . "
									" . (
										(int)$this->_publicationObject->page > 0 
											?
												'<b>' . $this->_translator->translate( 'main_page' ) . '</b>: ' . $this->_publicationObject->page
											:
												''
									) . "
									
								</dd>
							</dl>"
							:
							''
						) . "
						
						<dl class=\"list14 mod19-det\">
							<dt>{$this->_translator->translate('main_keywords')}:</dt>
							<dd>
								<ul class=\"list20\">";
								
								foreach($keywords as $keyword) {
									
									$result .= "<li><a class=\"publication_keyword\" href=\"#\">{$keyword}</a></li>";
								}
								
									//<li><a href=\"\">przykładowe słowa</a></li>
									//<li><a href=\"\">przykładowe słowa 2</a></li>
						$result .= "</ul>
							</dd>
						</dl>
						
						<dl class=\"list14 mod19-det\">
							<dt>
									{$this->_translator->translate( 'main_published_date' )}:
							</dt>
							<dd>
									{$this->_publicationObject->date}
							</dd>
						</dl>
						
						
					</div>

					<div class=\"text textj\">
						<div class=\"grid_6 alpha mod19-img print_remove\">
							<img width=\"221\" height=\"194\" alt=\"\" src=\"/image/".$this->_publicationObject->avatar.",221,194\"/>
						</div>
						
						
						<!--<p>
							{$this->_publicationObject->head}
						</p>-->
						
						{$this->_publicationObject->body}
						
					</div>
					
					
					<form id=\"eveluation_place\" action=\"/content_evaluation\" method=\"post\" class=\"print_remove form3 mod19-btm\">
						<input type=\"hidden\" name=\"lang\" value=\"{$this->_publicationObject->langId}\">
						<input type=\"hidden\" name=\"content_id\" value=\"{$this->_publicationObject->id}\">
						<input type=\"hidden\" name=\"mark\" value=\"\">";
						
						
						if( isset( $_SESSION[ 'content_evaluation' ] ) && is_array( $_SESSION[ 'content_evaluation' ] ) ) {
							
							$data = $_SESSION[ 'content_evaluation' ];
							$message = $class = null;
							
							if( array_key_exists( 0 , $data ) ) {
								$message = $data[ 0 ];
								$class = 'evaluation_red';
							} elseif( array_key_exists( 1 , $data ) ) {
								$message = $data[ 1 ];
								$class = 'evaluation_green';
							}
							$result .= "<p class=\"text\"><b class=\"{$class}\">{$message}</b></p>";
							
						}
						
						if( isset( $_SESSION[ 'content_evaluation' ] ) ) unset( $_SESSION[ 'content_evaluation' ] );
				
				
				$result .= "<p class=\"form3-hdr text\">{$this->_translator->translate('main_rate_content')}:</p>
						
						
						" . ( 1 !== $this->_publicationObject->evaluation_available ? "
						
							<ol class=\"form3-marks evaluation_mark\">
								<li name=\"1\"><input type=\"image\" src=\"/gfx/mark-1.png\" alt=\"oceń na 1\" title=\"oceń na 1\"/></li>
								<li name=\"2\"><input type=\"image\" src=\"/gfx/mark-2.png\" alt=\"oceń na 2\" title=\"oceń na 2\"/></li>
								<li name=\"3\"><input type=\"image\" src=\"/gfx/mark-3.png\" alt=\"oceń na 3\" title=\"oceń na 3\"/></li>
								<li name=\"4\"><input type=\"image\" src=\"/gfx/mark-4.png\" alt=\"oceń na 4\" title=\"oceń na 4\"/></li>
								<li name=\"5\"><input type=\"image\" src=\"/gfx/mark-5.png\" alt=\"oceń na 5\" title=\"oceń na 5\"/></li>
							</ol>
						" : "" ) . "
						
						
						<p class=\"form3-txt text\">
							(
								<b itemprop=\"ratingCount\">{$this->_publicationObject->evaluated} {$this->_translator->translate('main_votes_cast')}</b>, 
								{$this->_translator->translate('main_rating')}: 
								<b>{$this->_publicationObject->evaluation}<img class=\"form3-mark\" width=\"65\" height=\"14\" alt=\"\" src=\"/gfx/mark-" . preg_replace( '/\./' , '' , $this->_publicationObject->evaluationRounded ) . ".png\"/></b>
							) 
							<a href=\"#comments\" class=\"ico-com\">{$this->_translator->translate('main_comments')}: 
							<b>".count($this->_publicationObject->comments)."</b></a>
						</p>
						
					</form>
				</article>
				
				<hr>
					
				<section id=\"comment\" class=\"mod19\">
						<h1 class=\"mod10-top hdr20\">{$this->_translator->translate('main_comments', 'Content\Element')} <span>(".count($this->_publicationObject->comments).")</span></h1>

						<form name=\"addComment\" action=\"".FormatUrl::format('/add_comment')."\" method=\"post\" id=\"dodaj-komentarz\">
							<input type=\"hidden\" id=\"content_id\" name=\"content_id\" value=\"{$this->_publicationObject->id}\">
							<input type=\"hidden\" id=\"response_to\" name=\"response_to\" value=\"0\">
							<input type=\"hidden\" id=\"content_lang\" name=\"content_lang\" value=\"{$this->_publicationObject->langId}\">
							
							
							<div id=\"response_to_container\" >
								<div id=\"response_to_header\">
									{$this->_translator->translate( 'main_response_to_comment_header' )}
								</div>
								<div id=\"response_to_source\"></div>
								<div id=\"response_to_cancel\" title=\"{$this->_translator->translate( 'main_response_to_comment_cancel' )}\">&nbsp;</div>
							</div>
							
							
							<fieldset class=\"form6\">
								<legend><span class=\"hide\">{$this->_translator->translate('main_add_comment')}</span></legend>
							
								<div>
									<label for=\"FC-nick\">{$this->_translator->translate('main_nickname')}:</label>
									<div class=\"comment_add_error\">{$this->_translator->translate('error_nickname_required')}</div>
									<input type=\"text\" name=\"nick\" id=\"FC-nick\"/>
								</div>
								<div>
									<label for=\"FC-text\">{$this->_translator->translate('main_comment_contents')}:</label>
									<div class=\"comment_add_error\">{$this->_translator->translate('error_contents_required')}</div>
									<textarea name=\"content\" id=\"FC-text\" rows=\"3\" cols=\"50\"></textarea>
								</div>
							</fieldset>
							<div class=\"form6-sbt\">
								<button type=\"submit\" class=\"btn1 \">{$this->_translator->translate('main_add_comment')}</button>
							</div>
						</form>

						".($comments->displayComments())."
				</section>
		";
		
		return $result;
	}
}

?>