<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Publication;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class PublicationList extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_publicationObject;
	protected $_translator;
	
	public function __construct(Publication $publicationObject) {
		$this->_translator = TranslatorEx::get();
		$this->_publicationObject = $publicationObject;
	} 

	public function __toString() {
		$result = "
		<article class=\"mod16\">
			<div class=\"grid_4 alpha omega mod16-img\">
				<img height=\"88\" alt=\"\" src=\"/image/".$this->_publicationObject->avatar.",120,88\"/>
			</div>
			<div class=\"grid_12x alpha mod16-txt\">
				<h2 class=\"hdr16L\" ><a href=\"".FormatUrl::format("/publication/{$this->_publicationObject->id}/{$this->_publicationObject->title}",$this->_publicationObject->main_site->getUrlForViewHelper())."\">".$this->_publicationObject->title."</a></h2>
			<dl class=\"list14\">
					<dt>{$this->_translator->translate('main_author')}:</dt>
					<dd><span itemprop=\"author\">".$this->_publicationObject->author."</span></dd>
				<dl class=\"list15\">
				
				
				
					<dt class=\"hide\">{$this->_translator->translate('main_rating')}:</dt>
					<dd><b>{$this->_publicationObject->evaluation}</b> <img width=\"65\" height=\"14\" alt=\"\" src=\"gfx/mark-" . preg_replace( '/\./' , '' , $this->_publicationObject->evaluationRounded ) . ".png\"/> (<span>{$this->_publicationObject->evaluated}</span> {$this->_translator->translate('main_votes_cast')})</dd>
				<dt><a href=\"".FormatUrl::format("/news/{$this->_publicationObject->id}/{$this->_publicationObject->title}",$this->_publicationObject->main_site->getUrlForViewHelper()).(count( $this->_publicationObject->comments ) ? '#comments' : '#comment' )."\" class=\"ico-com\">{$this->_translator->translate('main_comments')}:</a></dt>
					<dd><a href=\"".FormatUrl::format("/news/{$this->_publicationObject->id}/{$this->_publicationObject->title}",$this->_publicationObject->main_site->getUrlForViewHelper())."\"><b>".count( $this->_publicationObject->comments )."</b></a></dd>
				</dl>
				
				
			</div>
		</article>
		";
		
		return $result;
	}
}

?>