<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Publication;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class PublicationMain extends AbstractFormattedElement implements WrappableInterface{

	protected $_publObject;
	protected $_translator;
	
	public function __construct(Publication $publObject) {
		$this->_translator = TranslatorEx::get();
		$this->_publObject = $publObject;
	}
	
	public function __toString() {
		$result = "
		<article class=\"mod6\">
			<div class=\"mod6-img\">
				<img width=\"120\" height=\"88\" alt=\"\"src=\"/image/".$this->_publObject->avatar."\"/>
			</div>
			<h2 class=\"mod6-hdr hdr16L\"><a href=\"".FormatUrl::format("/publication/{$this->_publObject->id}/{$this->_publObject->title}",$this->_publObject->main_site->getUrlForViewHelper())."\">{$this->_publObject->title}</a></h2>
			<dl class=\"mod6-det\">
				<dt>{$this->_translator->translate('main_author')}:</dt>
				<dd>{$this->_publObject->author}</dd>
					<dt>{$this->_translator->translate('main_date')}:</dt>
				<dd>
					<time datetime=\"2012-03-22\">".$this->_publObject->date."</time>
				</dd>
			</dl>
		</article>
		";
		
		return $result;
	}
	
}


?>