<?php

namespace System\View\Helper\Formatted;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\Content\Element\Publication;
use System\View\Helper\Formatted\WrappableInterface;
use Zend\Filter\StripTags;
class PublicationSearchResult extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_publicationObject;
	protected $_type = 'publication';
	protected $_translator;
	
	public function __construct(Publication $publicationObject) {
		$this->_translator = TranslatorEx::get();
		$this->_publicationObject = $publicationObject;
	}
	
	public function __toString() {
		$this->_publicationObject->mathlevel = ceil( $this->_publicationObject->mathlevel * 100 );
		
		$filter = new StripTags( array( 'allowTags' => 'b' ) );
		$head = $filter->filter( $this->_publicationObject->head );
		
		return "
		<article class=\"mod18\">
			<hgroup>
				<h1 class=\"mod18-hdr hdr13\"><a href=\"".FormatUrl::format("/publication/{$this->_publicationObject->id}/{$this->_publicationObject->title}",$this->_publicationObject->main_site->getUrlForViewHelper())."\">{$this->_publicationObject->title}</a></h1>
				<h2 class=\"mod18-cat hdr10V\">{$this->_publicationObject->contentType}</h2>
			</hgroup>
			<div class=\"mod18-txt text\">
				<p>{$head}</p>
			</div>
			<footer>
				<meter value=\"{$this->_publicationObject->mathlevel}\" max=\"100\">{$this->_publicationObject->mathlevel}</meter>
			</footer>
		</article>
		";
		
	}
}

?>