<?php
namespace System\View\Helper\Formatted;

use System\Content\Element\Publication;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;

class PublicationSlider extends AbstractFormattedElement {

    protected $_publicationObject;
    protected $_type = 'publication';
    protected $_translator;
    public static $no = 0;

    public function __construct(Publication $element) {
        $this->_translator = TranslatorEx::get();
        $this->_publicationObject = $element;
    }

    public function __toString() {
        $result = "
		<article class=\"mod1 " . ((self::$no == 1) ? 'target' : '') . "\" itemscope=\"itemscope\" itemtype=\"http://schema.org/Article\" id=\"news-" . (self::$no) . "\">
			<div class=\"mod1-img grid_9 alpha\">
				<img width=\"350\" height=\"280\" alt=\"\" src=\"/image/" . $this->_publicationObject->avatar . ",350,280\"/>
			</div>
			<div class=\"grid_7 omega\">
				<hgroup>
					<h1 class=\"mod1-hdr hdr20\" itemprop=\"name\"><a class=\"banner_click_register\" id=\"{$this->_publicationObject->cfgId}\" href=\"" . FormatUrl::format("/news/{$this->_publicationObject->id}/{$this->_publicationObject->title}", $this->_publicationObject->main_site->getUrlForViewHelper()) . "\">{$this->_publicationObject->title}</a></h1>
					<!--<h2 class=\"mod1-cat hdr10V\" itemprop=\"articleSection\"><a href=\"index.html\"></a></h2>-->
				</hgroup>
				
				<div class=\"mod1-txt text\" itemprop=\"articleBody\">
					<p>" . trim(Truncat::truncat($this->_publicationObject->head, 250 - strlen($this->_publicationObject->title), true, '')) . "&hellip;</p>
				</div>
			</div>
		</article>
		";

        return $result;
    }

}

?>