<?php

namespace System\View\Helper\Formatted;

use System\Content\Element\Publication;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Truncat;

class PublicationSponsored extends AbstractFormattedElement {
	
	protected $_publicationObject;
	protected $_translator;
	
	public function __construct(Publication $publicationObject) {
		$this->_translator = TranslatorEx::get();
		$this->_publicationObject = $publicationObject;
	} 

	public function __toString() {
		
		$result = "
		
			<article class=\"mod3 clearfix posnsox\"><!-- tt2 -->
				<div class=\"grid_6 alpha mod3-img\">
					<img width=\"230\" height=\"194\" src=\"/image/{$this->_publicationObject->avatar},230,194\" alt=\"\" >
				</div>
				<div class=\"grid_10 omega\">
					<hgroup>
						<!--<h2 class=\"hdr10V mod3-cat\">Temat tygodnia</h2>-->
						<h1 class=\"hdr16L mod3-hdr\"><a class=\"banner_click_register\" id=\"{$this->_publicationObject->cfgId}\" href=\"".FormatUrl::format("/publication/{$this->_publicationObject->id}/{$this->_publicationObject->title}",$this->_publicationObject->main_site->getUrlForViewHelper())."\">{$this->_publicationObject->title}</a></h1>
					</hgroup>
					
					<div itemprop=\"articleBody\" class=\"mod3-txt text\">
						<p>".Truncat::truncat($this->_publicationObject->head,250,true,'...','sneakPeak')."</p>
					</div>
				</div>
			</article>
		";
		

		return $result;
	}	

}






?>



