<?php

namespace System\View\Helper\Formatted;

use System\Content\Element\Quiz, 
	System\View\Helper\FormatUrl,
	System\Translator\TranslatorEx;

class QuizMain extends AbstractFormattedElement {
	
	protected $_quizObj;
	protected $_translator;
	
	public function __construct( Quiz $quizObj) {
		
		$this->_translator = TranslatorEx::get();
		$this->_quizObj = $quizObj;
	}
	
	public function __toString() {
		
		$userAnswer = false;
		if( $this->view->identity() ) {
	
			$RelContentQuizAnswer = new \Model\RelContentQuizAnswer;
			$userAnswer = $RelContentQuizAnswer->getUserAnswer( 
				$this->_quizObj->id,
				$this->_quizObj->langId,
				$this->view->identity()->id
			);
		}
		
		$result = "
			
			<form id=\"esculap_quiz\" method=\"get\" class=\"form2 esculap_quiz\" action=\"{$this->view->url( 'questionnaire_vote' , array( 'id' => $this->_quizObj->id , 'lang' => strtoupper( $this->_quizObj->langId ) ) )}\">
				<fieldset>
					<legend><span class=\"hdr16L-a\">{$this->_quizObj->name}</span></legend>
				
					<p class=\"hdr13\">{$this->_quizObj->question}</p><br/>";
				
		if( false !== $userAnswer ) {
			
			$result .= "<p>" . date( 'd-m-Y H:i' , strtotime( $userAnswer[ 'date' ] ) ) . 
					   " {$this->view->translator->translate( 'main_quiz_answer_answered' )}:<br/>\"<i>" . $userAnswer[ 'answer_description' ] . "\"</i></p><br/></fieldset>";
			
			$result .= $this->view->QuizResults( $this->_quizObj->id , $this->_quizObj->langId );
			
		} else {
				
		$result .= "<span class=\"quiz_content\">";
				
		foreach( $this->_quizObj->answers as $answer ) {
			
			$result .= "<div>
							<label>
								<input type=\"{$answer->type}\" name=\"answer\" value=\"{$answer->answerNo}\"/>
								{$answer->description}
							</label>
						</div>";
		}
				
			$result .= "</span>";
				
			$result .= "</fieldset><div class=\"submit\">
					<input id=\"quiz_submit\" type=\"submit\" value=\"Głosuj\" title=\"Głosuj\" class=\"btn1\"/>
					<div class=\"quiz_no_anser_error error\">{$this->view->translator->translate( 'main_quiz_choose_answer' )}</div>
					<div class=\"quiz_no_anser_message message\"></div>
					<!--<a href=\"ankieta-wyniki.html\" class=\"btn1\">Wyniki</a>-->
				</div>";
				
		}
                        $commentUrl = ltrim($this->view->url( 'questionnaire_view' , array( 'id' => $this->_quizObj->id ) ), '/');
                        $archiveUrl = ltrim($this->view->url( 'questionnaire' ), '/');
                
			$result .= "<p><a href=\"{$this->_quizObj->main_site->getUrl()}{$commentUrl}#comment\" class=\"link5\">Dodaj komentarz (" . count( $this->_quizObj->comments ) . ")</a> <a href=\"{$this->_quizObj->main_site->getUrl()}{$archiveUrl}\" class=\"link5\">Archiwum ankiet</a></p>
			</form>
			
			<hr/>
		";
		
		 
		return $result;
	}
	
}


?>