<?php

namespace System\View\Helper\Formatted;

use System\Content\Element\Video;
use System\View\Helper\Formatted\CommentDisplayer;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;
use System\View\Helper\ScriptHelper;

class VideoContent extends AbstractFormattedElement implements WrappableInterface
{
    protected $_videoObject;
    protected $_translator;

    public function __construct(Video $videoObject)
    {
        $this->_translator = TranslatorEx::get();
        $this->_videoObject = $videoObject;
    }

    public function __toString()
    {
        $video = $this->_videoObject;
        $translator = $this->_translator;

        $result = '
<article class="mod19 print_content">
    <div class="mod19-top">
        <header>
            <ul class="mod19-nav list18 print_remove">
                <li><!--suppress HtmlUnknownAnchorTarget -->
                    <a href="#comments" class="ico-com">' . count($video->comments) . '<span class="hide">' . $translator->translate('main_comments') . '</span></a>
                </li>
            </ul>
            <h1 class="mod19-hdr hdr22">' . $video->title . '</h1>
        </header>
        <dl class="list14 mod19-det">
            <dt>' . $translator->translate('main_author') . ':</dt>
            <dd><span itemprop="author">' . $video->author . '</dd>
        </dl>
        <dl class="list14 mod19-det">
            <dt>' . $translator->translate('main_published_date') . ':</dt>
            <dd>' . $video->date . '</dd>
        </dl>
    </div>';

        $result .= '<div class="pe_video_kontener">
                    <div data-swf="//releases.flowplayer.org/5.4.2/commercial/flowplayer.swf"
                     class="flowplayer no-toggle play-button"
                     data-embed="false" data-keyboard="false"
                     data-ratio="0.416" data-key="$332386810996685"
                     data-rtmp="rtmp://media.esculap.pl/fastplay/"
                     style="display:block; width:524px; height:328px; background-size: 100%;
                     background: url(\'/image/' . $video->avatar . ',542,328\') no-repeat center;">
                    <video>
                     <source type="application/x-mpegurl" src="http://media.esculap.pl:1935/vod/_definst_/mp4:esculap_tv/' . $video->mainStream['stream'] . '/playlist.m3u8">
                     <source type="video/flash" src="/mp4:/esculap_tv/' . $video->mainStream['stream'] . '">
                    </video>
                    </div>
                    </div>

                    <div class="text textj">
                        '.$video->body.'
                    </div>';

        $result .= "<form id=\"eveluation_place\" action=\"/content_evaluation\" method=\"post\" class=\"print_remove form3 mod19-btm\">
						<input type=\"hidden\" name=\"lang\" value=\"{$video->langId}\">
						<input type=\"hidden\" name=\"content_id\" value=\"{$video->id}\">
						<input type=\"hidden\" name=\"mark\" value=\"\">";

        if (isset($_SESSION['content_evaluation']) && is_array($_SESSION['content_evaluation'])) {
            $data = $_SESSION['content_evaluation'];
            $message = $class = null;
            if (array_key_exists(0, $data)) {
                $message = $data[0];
                $class = 'evaluation_red';
            } elseif (array_key_exists(1, $data)) {
                $message = $data[1];
                $class = 'evaluation_green';
            }
            $result .= "<p class=\"text\"><b class=\"{$class}\">{$message}</b></p>";
        }
        if (isset($_SESSION['content_evaluation'])) {
            unset($_SESSION['content_evaluation']);
        }

        $comments = new CommentDisplayer($video->comments);
        $result .= "<p class=\"form3-hdr text\">{$translator->translate('main_rate_content')}:</p>
" . (1 !== $video->evaluation_available ? "
							<ol class=\"form3-marks evaluation_mark\">
								<li name=\"1\"><input type=\"image\" src=\"/gfx/mark-1.png\" alt=\"oceń na 1\" title=\"oceń na 1\"/></li>
								<li name=\"2\"><input type=\"image\" src=\"/gfx/mark-2.png\" alt=\"oceń na 2\" title=\"oceń na 2\"/></li>
								<li name=\"3\"><input type=\"image\" src=\"/gfx/mark-3.png\" alt=\"oceń na 3\" title=\"oceń na 3\"/></li>
								<li name=\"4\"><input type=\"image\" src=\"/gfx/mark-4.png\" alt=\"oceń na 4\" title=\"oceń na 4\"/></li>
								<li name=\"5\"><input type=\"image\" src=\"/gfx/mark-5.png\" alt=\"oceń na 5\" title=\"oceń na 5\"/></li>
							</ol>
						" : "") . "
						<p class=\"form3-txt text\">
							(
								<b itemprop=\"ratingCount\">{$video->evaluated} {$translator->translate('main_votes_cast')}</b>,
								{$translator->translate('main_rating')}:
								<b>{$video->evaluation}<img class=\"form3-mark\" width=\"65\" height=\"14\" alt=\"\" src=\"/gfx/mark-" . preg_replace('/\./', '', $video->evaluationRounded) . ".png\"/></b>
							)
							<a href=\"#comments\" class=\"ico-com\">{$translator->translate('main_comments')}:
							<b>" . count($video->comments) . "</b></a>
						</p>
					</form>
				</article>
				<hr>
				<section id=\"comment\" class=\"mod19\">
						<h1 class=\"mod10-top hdr20\">{$translator->translate('main_comments', 'Content\Element')} <span>(" . count($video->comments) . ")</span></h1>
						<form name=\"addComment\" action=\"" . FormatUrl::format('/add_comment') . "\" method=\"post\" id=\"dodaj-komentarz\">
							<input type=\"hidden\" id=\"content_id\" name=\"content_id\" value=\"{$video->id}\">
							<input type=\"hidden\" id=\"response_to\" name=\"response_to\" value=\"0\">
							<input type=\"hidden\" id=\"content_lang\" name=\"content_lang\" value=\"{$video->langId}\">
							<div id=\"response_to_container\" >
								<div id=\"response_to_header\">
									{$translator->translate('main_response_to_comment_header')}
								</div>
								<div id=\"response_to_source\"></div>
								<div id=\"response_to_cancel\" title=\"{$translator->translate('main_response_to_comment_cancel')}\">&nbsp;</div>
							</div>
							<fieldset class=\"form6\">
								<legend><span class=\"hide\">{$translator->translate('main_add_comment')}</span></legend>
								<div>
									<label for=\"FC-nick\">{$translator->translate('main_nickname')}:</label>
									<div class=\"comment_add_error\">{$translator->translate('error_nickname_required')}</div>
									<input type=\"text\" name=\"nick\" id=\"FC-nick\"/>
								</div>
								<div>
									<label for=\"FC-text\">{$translator->translate('main_comment_contents')}:</label>
									<div class=\"comment_add_error\">{$translator->translate('error_contents_required')}</div>
									<textarea name=\"content\" id=\"FC-text\" rows=\"3\" cols=\"50\"></textarea>
								</div>
							</fieldset>
							<div class=\"form6-sbt\">
								<button type=\"submit\" class=\"btn1 \">{$translator->translate('main_add_comment')}</button>
							</div>
						</form>
 " . ($comments->displayComments()) . "</section>";

        return $result;
    }
}
