<?php
namespace System\View\Helper\Formatted;

use System\Content\Element\Video;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class VideoLinkList extends AbstractFormattedElement implements WrappableInterface {

    protected $_videoObject;
    protected $_translator;

    public function __construct(Video $videoObject) {
        $this->_translator = TranslatorEx::get();
        $this->_videoObject = $videoObject;
    }

    public function __toString() {
        $result = "<li><a href=\"" . FormatUrl::format("/video/{$this->_videoObject->id}/{$this->_videoObject->title}", $this->_videoObject->main_site->getUrlForViewHelper()) . "\">{$this->_videoObject->title}</a></li>";

        return $result;
    }

}

?>