<?php

namespace System\View\Helper\Formatted;
use System\Content\Element\Video;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\View\Helper\Formatted\WrappableInterface;

class VideoList extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_videoObject;
	protected $_translator;
	
	public function __construct(Video $videoObject) {
		$this->_translator = TranslatorEx::get();
		$this->_videoObject = $videoObject;
	} 

	public function __toString() {
		$result = "
		<article class=\"mod16\">
			<div class=\"grid_4 alpha omega mod16-img\">
				<img height=\"88\" alt=\"\" src=\"/image/".$this->_videoObject->avatar.",120,88\"/>
			</div>
			<div class=\"grid_12x alpha mod16-txt\">
				<h2 class=\"hdr16L\" ><a href=\"".FormatUrl::format("/video/{$this->_videoObject->id}/{$this->_videoObject->title}",$this->_videoObject->main_site->getUrlForViewHelper())."\">".$this->_videoObject->title."</a></h2>
			<dl class=\"list14\">
					<dt>{$this->_translator->translate('main_author')}:</dt>
					<dd><span itemprop=\"author\">".$this->_videoObject->author."</span></dd>
				<dl class=\"list15\">
				
				
				
					<dt class=\"hide\">{$this->_translator->translate('main_rating')}:</dt>
					<dd><b>{$this->_videoObject->evaluation}</b> <img width=\"65\" height=\"14\" alt=\"\" src=\"gfx/mark-" . preg_replace( '/\./' , '' , $this->_videoObject->evaluationRounded ) . ".png\"/> (<span>{$this->_videoObject->evaluated}</span> {$this->_translator->translate('main_votes_cast')})</dd>
				<dt><a href=\"".FormatUrl::format("/video/{$this->_videoObject->id}/{$this->_videoObject->title}",$this->_videoObject->main_site->getUrlForViewHelper()).(count( $this->_videoObject->comments ) ? '#comments' : '#comment' )."\" class=\"ico-com\">{$this->_translator->translate('main_comments')}:</a></dt>
					<dd><a href=\"".FormatUrl::format("/video/{$this->_videoObject->id}/{$this->_videoObject->title}",$this->_videoObject->main_site->getUrlForViewHelper())."\"><b>".count( $this->_videoObject->comments )."</b></a></dd>
				</dl>
				
				
			</div>
		</article>
		";
		
		return $result;
	}
}

?>