<?php

namespace System\View\Helper\Formatted;
use System\View\Helper\FormatUrl;
use System\Translator\TranslatorEx;
use System\Content\Element\Video;
use System\View\Helper\Formatted\WrappableInterface;
use Zend\Filter\StripTags;
class VideoSearchResult extends AbstractFormattedElement implements WrappableInterface {
	
	protected $_videoObject;
	protected $_type = 'video';
	protected $_translator;
	
	public function __construct(Video $videoObject) {
		$this->_translator = TranslatorEx::get();
		$this->_videoObject = $videoObject;
	}
	
	public function __toString() {
		$this->_videoObject->mathlevel = ceil( $this->_videoObject->mathlevel * 100 );
		
		$filter = new StripTags( array( 'allowTags' => 'b' ) );
		$head = $filter->filter( $this->_videoObject->head );
		
                //var_dump($this->_videoObject);
                
		return "
		<article class=\"mod18\">
			<hgroup>
				<h1 class=\"mod18-hdr hdr13\"><a href=\"".FormatUrl::format("/video/{$this->_videoObject->id}/{$this->_videoObject->title}",$this->_videoObject->main_site->getUrlForViewHelper())."\">{$this->_videoObject->title}</a></h1>
				<h2 class=\"mod18-cat hdr10V\">{$this->_videoObject->contentType}</h2>
			</hgroup>
			<div class=\"mod18-txt text\">
				<p>{$head}</p>
			</div>
			<footer>
				<meter value=\"{$this->_videoObject->mathlevel}\" max=\"100\">{$this->_videoObject->mathlevel}</meter>
			</footer>
		</article>
		";
		
	}
}

?>