<?php

namespace System\View\Helper\Formatted\Wrappers;
use System\View\Helper\FormatViewElement;

class WrapperFactory {
	
	protected function __construct() {}	

	public static function wrap( $elements , $wrapType ) {
		
		if( !is_array($elements ) ) {
			throw new \Exception( __METHOD__ . '. "elements" musi być tablicą' );
		}
		
		$FormatViewElement = new FormatViewElement();
		
		switch($wrapType) {
			case 'news':
				
				if(!isset($elements['main']) || !isset($elements['links'])) {
					//throw new \Exception(__METHOD__.'. Nie podane kluczy lub jednego zniech : "main" i/lub "links" w tablicy elements');
				}
				
				return new NewsWrapper(
					$FormatViewElement->__invoke(
						@$elements['main'],
						'main'
					),
					$FormatViewElement->__invoke(
						@$elements['links'],
						'linkList'
					)
				);
				
				break;
			case 'publications':
				
				if(!isset($elements['main']) || !isset($elements['links'])) {
					//throw new \Exception(__METHOD__.'. Nie podane kluczy lub jednego zniech : "main" i/lub "links" w tablicy elements');
				}
				
				return new PublicationsWrapper(
					@$elements['main'],
					@$elements['links']
				);
			
				break;
			case 'event':
				
				if(!isset($elements['links'])) {
					//throw new \Exception(__METHOD__.'. Nie podane kluczy lub jednego zniech : "links" w tablicy elements');
				}
				
				return new EventWrapper(
					@$elements['links']
				);
			
				break;
			case 'mostRead':
				
				return  new MostRead( $elements );
				
				break;
		}
	}
	
}

?>