<?php

namespace System\View\Helper;
use Zend\View\Helper\AbstractHelper;
use System\View\Helper\formatUrl;
use System\Paginator\Paginator as PaginatorObj;

class Paginator extends AbstractHelper {
	
	public function __invoke( PaginatorObj $paginator , $visibleLinks = 2 , $style = 'standard' , $data = null) {
		
		switch($style) {
		
			default:
			case 'standard':
				
				return $this->standard( $paginator , $visibleLinks , $data);
				
			case 'search' :
				
				return $this->search( $paginator , $visibleLinks , $data );
		}
	}
	
	protected function standard( $paginator , $visibleLinks , $data ) {
		$pages = ceil($paginator->rows / $paginator->onPage);
	
		$result = "
		<footer>
			<ul class=\"list12\">
			<li><a href=\"?page=".($paginator->page - 1 > 0 ? $paginator->page - 1 : 1)."\" rel=\"prev\"><img src=\"gfx/arrLeftGrey1.png\"/></a>
				
			</li>";
			
			$url = '/';
			
			for($i = 1;$i <= $pages; $i++) {
				
				if($i > 1 && $paginator->page > $i + $visibleLinks) {
					$result .= '<li>…</li>';
					$i = $paginator->page - $visibleLinks;
				} elseif($i > $paginator->page + $visibleLinks && $pages - $i > 0) {
				
					$result .= '<li>…</li>';
					$i = $pages;
				}
				
				
				
				if( count( $_GET ) ) {
					if( preg_match( '/page=[0-9]+/' , $_SERVER[ 'REQUEST_URI' ] ) ) {
						
						$url = preg_replace( '/page=[0-9]+/' , 'page=' . $i , $_SERVER[ 'REQUEST_URI' ] );
						
					} else {
						
						$url = $_SERVER[ 'REQUEST_URI' ] . '&page=' . $i;
					}
						
				} else {
						
					$url = $_SERVER[ 'REQUEST_URI' ] . '?page=' . $i;
				}
				
				
				
				$result .= "<li ".($paginator->page == $i ? "class=\"current\"": '') ."><a href=\"{$url}\">$i</a></li>";
			}
				
		$result .= "<li><a href=\"{$url}".($paginator->page < $pages ? $paginator->page + 1 : $pages)."\" rel=\"next\"><img src=\"gfx/arrRightGrey1.png\"/></a></li>
			</ul>
		</footer>
		";
		
		return $result;
	}
	
	
	protected function search( $paginator , $visibleLinks , $data ) {
		$pages = ceil($paginator->rows / $paginator->onPage);
	
		$result = "
		<footer>
			<form action=\"\" method=\"post\" name=\"paginator_form\">";
				
				if( is_array( $data ) ) {
					foreach( $data as $field => $value ) {
						
						$result .= "<input type=\"hidden\" name=\"{$field}\" value=\"{$value}\">";
					}
				}
				
				$result .= "<ul class=\"list12\">
				<li><a href=\"?page=".($paginator->page - 1 > 0 ? $paginator->page - 1 : 1)."\" rel=\"prev\"><img src=\"/gfx/arrLeftGrey1.png\"/></a>
					
				</li>";
				
				for($i = 1;$i <= $pages; $i++) {
					
					if($i > 1 && $paginator->page > $i + $visibleLinks) {
						$result .= '<li>…</li>';
						$i = $paginator->page - $visibleLinks;
					} elseif($i > $paginator->page + $visibleLinks && $pages - $i > 0) {
					
						$result .= '<li>…</li>';
						$i = $pages;
					}
					
					$url = $_SERVER[ 'REQUEST_URI' ];
					
					$result .= "<li ".($paginator->page == $i ? "class=\"current\"": '') .">
										<a href=\"$url&page=$i\">$i</a>
								</li>";
				}
				
			$result .= "<li><a href=\"?page=".($paginator->page < $pages ? $paginator->page + 1 : $pages)."\" rel=\"next\"><img src=\"/gfx/arrRightGrey1.png\"/></a></li>
				</ul>
				<inputr type=\"submit\" style=\"display:none\">
			</form>
		</footer>
		";
		
		return $result;
	}
}


?>