<?php

namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper,
	Zend\Db\Sql\Select,
	Zend\Db\Sql\Expression;

class QuizResults extends AbstractHelper {
	
	public function __invoke( $contentId , $langId ) {
		$contentId = (int)$contentId;
		try {
		$ExtContentQuiz = new \Model\ExtContentQuiz;
		$quizAnswersData = $ExtContentQuiz->getGrouppedAnswers( $contentId , $langId );
		} catch( \Exception $e ) {
			
			return $e->getMessage();
		}
		
		
		$total = 0;
		foreach( $quizAnswersData as $k => $answerData )
			$total += (int)$answerData[ 'count' ];
		
		$result = "<div class=\"quiz_answer_rsummary\">{$this->view->translator->translate( 'main_quiz_summary' )} ({$total})</div><br/>";
		
		foreach( $quizAnswersData as $k => $answerData ) {
			
			$result .= "
				<div class=\"quiz_answer_result\">
					<span class=\"description\"></span>
					<span class=\"\">
						{$answerData[ 'description' ]}
						<br/>";
						
			if( 0 < (int)$answerData[ 'count' ] ) {
				
				$value = (int)( $answerData[ 'count' ] / $total * 100 );
				
				$result .= "<meter value=\"{$value}\" max=\"100\">{$value}</meter>";

			} else {
			
				$result .= "<meter value=\"0\" max=\"{$total}\">0</meter>";
			}
						
			$result .= "</span>
				</div><br/>
			";
			
		}
		
		return $result;
	}
}

?>