<?php
namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper;

class Toolbar extends AbstractHelper {

    const BUTTON_EXPORT = 'ACTION_EXPORT';
    const BUTTON_ADD = 'ACTION_ADD';
    const BUTTON_RETURN = 'ACTION_RETURN';

    protected $view;
    protected $toolbar = '';
    protected $toolbarButtons = array();

    public function __invoke() {
        $this->view = $this->getView();
        return $this;
    }

    public function addButton(array $button) {
        $toolbarButton = '';

        if ((isset($button['acl']) && $this->view->acl->isAllowed($this->view->identity['username'], $button['acl'])) || !isset($button['acl'])) {
            $toolbarButtonPermission = true;
        } else {
            $toolbarButtonPermission = false;
        }

        if (isset($button['label'])) {
            $toolbarButtonTitle = 'title="' . $button['label'] . '"';
        } else {
            $toolbarButtonTitle = '';
        }

        $relationalButton = '';
        if (isset($button['relational']) && $button['relational']) {
            $relationalButton = ' relational-view';
        }

        switch ($button['type']) {
            case self::BUTTON_EXPORT:
                if ($toolbarButtonPermission) {
                    if (!$toolbarButtonTitle) {
                        $toolbarButtonTitle = 'title="Export"';
                    }
                    $toolbarButton = '<a href="' . $button['url'] . '" class="info-tooltip export_button' . $relationalButton . '"' . $toolbarButtonTitle . '></a>';
                }
                break;
            case self::BUTTON_ADD:
                if ($toolbarButtonPermission) {
                    if (!$toolbarButtonTitle) {
                        $toolbarButtonTitle = 'title="' . $this->view->translator->translate('main_add') . '"';
                    }
                    $toolbarButton = '<a href="' . $button['url'] . '" class="info-tooltip add_button' . $relationalButton . '"' . $toolbarButtonTitle . '></a>';
                }
                break;
            case self::BUTTON_RETURN:
                if ($toolbarButtonPermission) {
                    if (!$toolbarButtonTitle) {
                        $toolbarButtonTitle = 'title="' . $this->view->translator->translate('main_return') . '"';
                    }
                    $toolbarButton = '<a href="' . $button['url'] . '" class="info-tooltip return_button' . $relationalButton . '"' . $toolbarButtonTitle . '></a>';
                }
                break;
        }

        $this->toolbarButtons[] = $toolbarButton;

        return $this;
    }

    public function generate() {
        if (!empty($this->toolbarButtons)) {
            $this->toolbar .= '<div class="toolbar">';
            $this->toolbar .= implode(null, $this->toolbarButtons);
            $this->toolbar .= '</div>';
        }

        return $this->toolbar;
    }

}

?>