<?php
namespace System\View\Helper;

use Zend\View\Helper\AbstractHelper;
use Zend\Filter\StripTags;

class Truncat extends AbstractHelper {

    public function __invoke($string, $count, $replace, $toNextWord = false) {
        return self::truncat($string, $count, $replace, $toNextWord);
    }

    public static function truncat($string, $count, $toNextWord = false, $replace = '...', $opt = null) {
        if (null !== $opt) {
            if ($opt == 'sneakPeak') {
                $filter = new StripTags(array('allowTags' => 'br'));
                $string = $filter->filter($string);
            }
        }

        $encoding = mb_regex_encoding();

        if (mb_strlen($string, $encoding) > $count) {

            $result = mb_substr($string, 0, $count, $encoding);
            $string = mb_substr($string, $count, mb_strlen($string, $encoding), $encoding);

            if (($posAmp = strrpos($result, '&')) !== false) {
                $strAfterAmp = substr($result, $posAmp); // 1. pobieram substring po ostatnim ampersandzie

                if ((strpos($strAfterAmp, ';') === false) // 2. jeżeli w pobranym substringu nie ma średnika
                        && (($posSemicolon = strpos($string, ';')) !== false)) { // ale jest dalej w tekście
                    $strBeforeSemicolon = substr($string, 0, $posSemicolon + 1); // to pobieram substring do średnika

                    $entity = $strAfterAmp . $strBeforeSemicolon;
                    if ($entity != html_entity_decode($entity)) { // 3. jeżeli string pomiędzy '&' a ';' jest prawdziwą encją
                        $result .= $strBeforeSemicolon; // to dopełniam substrin do pełnej encji
                    }
                }
            }

            // jeśli ostatni znak uciętego stringu nie jest spacją lub kropką a opcja toNextWord jest włączona dopełniamy string do pełnego słowa

            if ($toNextWord && !(mb_substr($result, mb_strlen($result, $encoding) - 1, 1, $encoding) == ' ' || mb_substr($string, 0, 1, $encoding) == '.')) {

                $t = 0;

                do {
                    $data = mb_substr($string, 0, 1, $encoding);

                    $result .= $data;

                    $string = mb_substr($string, 1, mb_strlen($string, $encoding), $encoding);
                } while (!mb_ereg(' ', mb_substr($string, 0, 1, $encoding)) && !mb_ereg('.', mb_substr($string, 0, 1, $encoding)));
            }

            $result .= $replace;
        } else {
            $result = $string;
        }

        return $result;
    }

}

?>