<?php

/**
 * 
 * Klasy wspierające wyświetlanie i administarcję banerami
 * 
 */

require_once 'PDOS.class.php';
require_once 'dimage.class.php';

/**
 * 
 * Enter description here ...
 * @author sroszczyk
 *
 */
class banner
{
    protected $data = null;
    protected $exist = false; 
    protected $devel = false;
    
    /**
     * Konstruktor banera
     * @param unknown_type $banner_id
     */
    public function __construct($banner_id = null, $view_id = null)
    {
        if($view_id && !$banner_id)
            $banner_id = $this->searchId($view_id);
        
        if($banner_id){
            $this->data['banner_id'] = $banner_id;
            $this->load();
        }
    }
    
    /**
     * 
     */
    public function searchId($view_id)
    {
        $sql = "SELECT banner_id FROM main_banners_views WHERE view_id=$view_id";
        return PDOS::getInstance()->getOne($sql);
    }

	/**
     * Zwraca zewnetrznego urla do piksela
	 * @return string
	 * @author plawecki
     */
    public function pixelUrl($view_id)
    {
		$banner_id = $this->searchId($view_id);
        $sql = "SELECT view_link FROM main_banners WHERE banner_id='$banner_id'";
        return PDOS::getInstance()->getOne($sql);
    }
    
    /**
     * Enter description here ...
     */
    public function load()
    {
        $sql = <<< ESQUEL
SELECT * FROM main_banners WHERE banner_id='{$this->data['banner_id']}'
ESQUEL;
        $this->devel = PDOS::getInstance()->isDevel();
        if($data = PDOS::getInstance()->getRow($sql)){
            $data2 = unserialize($data['data']);
            unset($data['data']);
            $this->data = array_merge($data, is_array($data2)?$data2:array());
            $this->exists = true;
        }
    }
    
    /**
     * 
     */
    public function getData()
    {
        return $this->data;
    }
    
    /**
     * Podbicie statystyk
     */
    public function raiseStats($view_id, $mode, $login = null)
    {
        $update = null;
        if($mode=='link'){
            $update[] = "clicks=clicks+1";
            if($login) {
                $update[] = "clicks_logged=clicks_logged+1";
                PDOS::getInstance()->exec("INSERT INTO main_banners_clicks (view_id, user_login) VALUES ('$view_id', '$login')");
            }
        }
        if($mode=='rev'){
            $update[] = "reveals=reveals+1";
            if($login) $update[] = "reveals_logged=reveals_logged+1"; 
        }
        
        if($update){
            if(!PDOS::getInstance()->getOne("SELECT COUNT(1) FROM main_banners_stats WHERE view_id='$view_id' AND day=CURRENT_DATE"))
                PDOS::getInstance()->exec("INSERT INTO main_banners_stats (view_id) VALUES ('$view_id')");
            $update = implode(',', $update);
            $sql = "UPDATE main_banners_stats SET $update WHERE view_id='$view_id' AND day=CURRENT_DATE";
            PDOS::getInstance()->exec($sql);
        }
        
    }
    
    /**
     * Zwraca kod HTML banera
     * @return string
     */
    public function getCode($view_id, $login = null)
    {
        $end = $this->devel?'d':'w';
        $beg = $this->devel?'tst':'www';
        $end2 = $login?','.$login:'';
        $check = md5(date('h').'qwerty'.$login.$view_id);
        $rand = rand(10000000, 99999999);
        $code = $this->data['body'];
        $new_link = "http://{$beg}.esculap.pl/banner/{$end},link,{$view_id}{$end2},{$check},1920/";

		$pikselUrl = $this->pixelUrl($view_id);

		if(!empty($pikselUrl)){
			$opn_url = $pikselUrl;
		}
		else{
			$opn_url = "http://{$beg}.esculap.pl/banner/{$end},rev,{$view_id}{$end2},{$check},{$rand}/";
		}

        $code = str_replace($this->data['link'], $new_link, $code);
        $code .= "\n<img src=\"{$opn_url}\" style=\"width:1px;height:1px;\"/>";
        return $code;
    }
}

/**
 * 
 * Enter description here ...
 * @author sroszczyk
 *
 */
class banner_holder
{
    protected $data = null;
    protected $exist = false;
    
    /**
     * Konstruktor holdera banerów
     * @param string $name
     * @param integer $width
     * @param integer $height
     * @param integer $slots
     */
    public function __construct($holder_id, $width = null, $height = null, $slots = null)
    {
        $this->data['holder_id'] = $holder_id;
        $this->data['max_width'] = $width;
        $this->data['max_height'] = $height;
        $this->data['max_slots'] = $slots;
        $this->load();
        $this->save();
        $this->saveCallLocation();
    }
    
    /**
     * Enter description here ...
     */
    private function load()
    {
        $sql = <<< ESQUEL
SELECT * FROM main_banners_holders WHERE holder_id = '{$this->data['holder_id']}' 
ESQUEL;
        if($data = PDOS::getInstance()->getRow($sql)){
            $this->exist = true;
            #Zablokowane aby ponadpisywać błędne wpisy
            if($this->data['max_width']/* && !$data['active']*/) $data['max_width'] = $this->data['max_width'];
            if($this->data['max_height']/* && !$data['active']*/) $data['max_height'] = $this->data['max_height'];
            if($this->data['max_slots']/* && !$data['active']*/) $data['max_slots'] = $this->data['max_slots'];
            $this->data = $data;
        }
    }
    
    /**
     * Enter description here ...
     */
    private function save()
    {
        if($this->data['active']) return;
        
        if($this->exist){
            $sql = <<< ESKUEL
UPDATE main_banners_holders SET 
max_width='{$this->data['max_width']}', 
max_height='{$this->data['max_height']}', 
max_slots='{$this->data['max_slots']}' 
WHERE holder_id = '{$this->data['holder_id']}'
ESKUEL;
        }else{
            $sql = <<< ESKUEL
INSERT INTO main_banners_holders 
(holder_id, max_width, max_height, max_slots, site_id) 
VALUES 
('{$this->data['holder_id']}', '{$this->data['max_width']}', '{$this->data['max_height']}', '{$this->data['max_slots']}', '{SITE_ID}')
ESKUEL;
        }
        
        PDOS::getInstance()->exec($sql);
        $this->exist = true;
    }
    
    /**
     * 
     */
    public function saveCallLocation()
    {
        if(defined('CMS_USAGE') && CMS_USAGE===true) return;
        $data = null;
        $data['holder_id'] = $this->data['holder_id'];
        if(defined('DOMAIN')) $data['domain'] = DOMAIN;
        if(defined('SITE_ID')) $data['site_id'] = SITE_ID;
        if(defined('CONTR_NAME')) $data['controller'] = CONTR_NAME;
        if(defined('CONTR_ACTION')) $data['action'] = CONTR_ACTION;
        if($data==null) return;
        $whr = null;
        foreach($data as $k=>$v) $whr[] = "{$k}='{$v}'";
        $where = implode(' AND ', $whr); 
        $location_id = PDOS::getInstance()->getOne("SELECT location_id FROM main_banners_holders_locations WHERE $where");
        if($location_id){
            $whr[] = 'last_update=NOW()';
            $update = implode(', ', $whr);
            PDOS::getInstance()->exec("UPDATE main_banners_holders_locations SET $update WHERE location_id=$location_id");
        }else{
            PDOS::getInstance()->exec("INSERT INTO main_banners_holders_locations (".implode(',',array_keys($data)).") VALUES ('".implode("','",array_values($data))."')");
        }
    }
    
    /**
     * (De)Aktywacja holdera
     */
    public function activate($a = true)
    {
        $a = $a?'true':'false';
        $sql = "UPDATE main_banners_holders SET activate=$a WHERE holder_id = '{$this->data['holder_id']}'";
        PDOS::getInstance()->exec($sql);
    }
    
    /**
     * Usuwanie holdera
     */
    public function delete($d = true)
    {
        $d = $d?'true':'false';
        $sql = "UPDATE main_banners_holders SET delete=$d WHERE holder_id = '{$this->data['holder_id']}'";
        PDOS::getInstance()->exec($sql);
    }
    
    /**
     * Enter description here ...
     */
    public function getData()
    {
        return $this->data;
    }
    
    /**
     * Enter description here ...
     */
    public function getCode($margin = 5, $count = false)
    {
        $login = defined('CONTR_USER')?CONTR_USER:null;
        $bb = ($login=='slawek' && isset($_COOKIE['ss']))?"border-top:2px solid red;border-bottom:2px dashed red;":'';
        $dib = "<div id=\"BH_{$this->data['holder_id']}\" style=\"width:{$this->data['max_width']}px;{$bb}\">";
        $die = "</div>";
        if($count && (!$this->exist || $this->data['delete'])) return false;
        if($count && !$this->data['active']) return true;
        if(!$this->exist) return;
        if($this->data['delete']) return;
        if(!$this->data['active']) return "{$dib}Aktywuj ten holder ({$this->data['holder_id']}) banerów w CMSie.{$die}";
        $html = null;
        $udata = null;
        require_once('Functions/global.funct.php');
        if($login) $udata = get_user_data($login);
        $sql = <<< ESQUEL
SELECT mb.banner_id, mb.campain_id, mbv.slot, mbv.rotation, mbv.view_id 
FROM main_banners mb 
INNER JOIN main_banners_views mbv ON mb.banner_id=mbv.banner_id 
INNER JOIN main_banners_campains mbc ON mb.campain_id=mbc.campain_id 
WHERE mbv.holder_id='{$this->data['holder_id']}' 
AND mbc.ready=true AND mbc.start_date<NOW() AND mbc.start_date IS NOT NULL AND (mbc.end_date>NOW() OR mbc.end_date IS NULL) 
ORDER BY mbv.slot, mbv.rotation 
ESQUEL;
        $data = PDOS::getInstance()->getAll($sql);
        
        //Wywalenie niepotrzebnych banerów
        $banners = null;$amount = 0;
        foreach($data as $banner){
            $camp = new banner_campain($banner['campain_id']);
            $camp->checkLimits();
            $obj = new banner($banner['banner_id']);
            $bdata = $obj->getData();
            switch($bdata['authorize']){
                case 'all':
                    break;
                case 'logged':
                    if(!$login) continue(2);
                    if(isset($bdata['for_utypes']) && is_array($bdata['for_utypes']) && count($bdata['for_utypes']) && !in_array($udata['user_type'], $bdata['for_utypes']))
                        continue(2);
					//jezeli by ktos dodal specki do seriali to wygladaloby mniej wiecej tak
					//nie pamietam pod jakim indeksem sa trzymane specki
                    /*if(isset($bdata['for_specs']) && is_array($bdata['for_specs']) && count($bdata['for_specs']) && array_intersect($bdata['for_specs'], $udata['spec']) == 0)
                        continue(2);*/
                    break;
                case 'anonymous':
                    if($login) continue(2);
                    break;
            }
            $banners[$banner['slot']][] = array('banner_id'=>$banner['banner_id'], 'view_id'=>$banner['view_id']);
            $amount++;
        }
        
        if($count) return $amount;
        
        $rot = isset($_SESSION['banrotator'][$this->data['holder_id']])?$_SESSION['banrotator'][$this->data['holder_id']]:null;
        
        if($banners){
            foreach($banners as $slot => $rotation){
                $r = 0;$am = count($rotation);
                if($am > 1)
                    $r = $rot[$slot] = (!isset($rot[$slot]) || $rot[$slot]+1>=$am)?0:$rot[$slot]+1;
                $obj = new banner($rotation[$r]['banner_id']);
                $html[] = $obj->getCode($rotation[$r]['view_id'], $login);
            }
        }
        
        if($rot)
            $_SESSION['banrotator'][$this->data['holder_id']] = $rot;
        
        if(is_array($html))
            $html = implode("<div style=\"height:{$margin}px;\"></div>", $html);
        $html = $dib."\n".$html."\n".$die;
        
        return $html;
    }
}

/**
 * 
 * Enter description here ...
 * @author sroszczyk
 *
 */
class banner_campain
{
    protected $data = null;
    protected $exist = false;
    
    public function __construct($campain_id = null)
    {
        if($campain_id){
            $this->data['campain_id'] = $campain_id;
            $this->load();
        }
    }
    
    /**
     * Enter description here ...
     */
    public function load()
    {
        $sql = <<< ESQUEL
SELECT * FROM main_banners_campains WHERE campain_id='{$this->data['campain_id']}'
ESQUEL;
        if($data = PDOS::getInstance()->getRow($sql)){
            $this->data = $data;
            $this->exists = true;
            $status = 'NEW';
            if(!$data['start_date'] || strtotime($data['start_date'])>time()) $status = 'NEW';
            elseif(!$data['ready'] && strtotime($data['start_date'])<time()) $status = 'SHIFT';
            elseif(!$data['end_date'] || strtotime($data['end_date'])>time()) $status = 'ACTIVE';
            else $status = 'OLD';
            $this->data['status'] = $status;
        }
    }
    
    /**
     * Enter description here ...
     */
    public function getData()
    {
        return $this->data;
    }
    
    public function checkLimits()
    {
        $campain_id = $this->data['campain_id'];
        if(is_numeric($this->data['rev_limit']) && $this->data['rev_limit']>0){
            $sql = <<< ESQUEL
SELECT SUM(a.reveals)
FROM main_banners_stats a 
INNER JOIN main_banners_views b ON a.view_id=b.view_id 
INNER JOIN main_banners c ON b.banner_id=c.banner_id 
WHERE c.campain_id=$campain_id
ESQUEL;
            $reveals = PDOS::getInstance()->getOne($sql);
            if($reveals>$this->data['rev_limit'] && !$this->data['end_date']){
                $sql = "UPDATE main_banners_campains SET end_date=NOW() WHERE campain_id=$campain_id";
                PDOS::getInstance()->exec($sql);
            }
        }
        if(is_numeric($this->data['cli_limit']) && $this->data['cli_limit']>0){
            $sql = <<< ESQUEL
SELECT SUM(a.clicks)
FROM main_banners_stats a 
INNER JOIN main_banners_views b ON a.view_id=b.view_id 
INNER JOIN main_banners c ON b.banner_id=c.banner_id 
WHERE c.campain_id=$campain_id
ESQUEL;
            $clicks = PDOS::getInstance()->getOne($sql);
            if($clicks>$this->data['cli_limit'] && !$this->data['end_date']){
                $sql = "UPDATE main_banners_campains SET end_date=NOW() WHERE campain_id=$campain_id";
                PDOS::getInstance()->exec($sql);
            }
        }
    }
}



?>