<?php

require_once 'model/content.tabs.php';

/**
 * 
 * Klasa ogrania tresci esculap
 * @author slawek
 * @category zarzadzanie tresciami
 * @version 0.1
 * @final
 * 
 */
class content
{
    public static $lang = 'PL';
    public static $rows = 10;
    public static $specs = null;
    protected $tlang = null;
    protected $trows = null;
    protected $tpage = 0;
    protected $tcollect = null;
    protected $tspecs = null;
    protected $tsearch = null;
    protected $tcondit = null;
    protected $torder = null;
    protected $tplugin = array();
    protected $amount = null;
    protected $types = array('album', 'movie');
    protected $extended = array();//tabele do pol po ktorych mozna wyszukiwac [main_content_???]
    protected $content_id = null;
    
    /**
     * Konstruktor
     * @param integer $content_id
     */
    public function __construct($content_id = null)
    {
        $this->tlang = self::$lang;
        $this->trows = self::$rows;
        //$this->tpage = self::$page;
        $this->tspecs = self::$specs;
        $this->content_id = $content_id;
    }
    
    /**
     * Ustawia kolekcje z ktorej bedzie pobierana lista
     * @param array/integer/string $collection_id
     */
    public function setCollection($collection_id)
    {
        $this->tcollect = $collection_id;
    }
    
    /**
     * Ustawia specjalizacje do wyboru
     * @param array/string [[[string] string] ...]
     */
    public function setSpecs()
    {
        $num = func_num_args();
	    $args = func_get_args();
	    
	    if($num==1 && is_array($args[0])){
	        $num = count($args[0]);
	        $args = $args[0];
	    }
	    
	    $this->tspecs = $args;
    }
    
    /**
     * Ustawia pojedyncze specjalizacje
     */
    public function addSpec($spec)
    {
        $this->tspecs[] = $spec;
    }
    
    /**
     * Ustawia string do wyszukania
     * @param string $search
     */
    public function setSearch($search)
    {
        $this->tsearch = $search;
    }
    
    /**
     * Dodawanie warunku pobierania listy
     * @param string $field nazwa kolumny np 'add_date' lub 'news.title'
     * @param string $op operator porownania np '=', '<', 'LIKE', 'IN'
     * @param string $value wartosc porownywana lub inne pole?
     * @param string $func funkcja do wykonania na polu i wartosci
     */
    public function addCondition($field, $op, $value, $func = null)
    {
        $this->tcondit[] = array($field, $op, $value, $func);
    }
    
    /**
     * Sortowanie rekordów
     * @param string $field nazwa kolumny np 'add_date' lub 'news.title'
     * @param boolean $desc czy sortowanie malejace ma byc
     */
    public function addOrder($field, $desc = false)
    {
        $this->torder[] = array($field, $desc);
    }
    
    /**
     * 
     * @param unknown_type $lang
     */
    public function setLang($lang)
    {
        $this->tlang = $lang;
    }
    
    /**
     * Ustawuia limit rekordow na strone
     * @param unknown_type $limit
     */
    public function setRows($rows)
    {
        $this->trows = $rows;
    }
    
    /**
     * Ustawia aktualnie wyswietlona strone
     * @param unknown_type $page
     */
    public function setPage($page)
    {
        $this->tpage = $page;
    }
    
    /**
     * Pobiera liste rozszerzana o pelne dane
     */
    public function getList()
    {
        $MC = new main_content();$MC->debug();
        $MC->setLimit($this->trows);
        $MC->setPage($this->tpage);
        $MC->addCondition('lang_id', '=', $this->tlang);
        $MC->addCondition('active', '=', true);
        if($this->tcollect){
            $MC->makeJoin('rel_content_collection');
            $MC->makeJoin('main_content_collection');
            $MC->addCondition('main_content_collection.path', 'LIKE', $this->tcollect.'%');
        }
        if($this->tspecs){
            $MC->makeJoin('rel_content_spec');
            foreach($this->tspecs as $spec)
                $MC->addCondition('rel_content_spec.spec_code', '=', $spec);
            $MC->mergeConditions(count($this->tspecs));
        }
        if($this->tsearch){
            $config = PDOS::_()->getOne("SELECT config_name FROM dict_lang WHERE lang_id='{$this->tlang}'");
            $MC->addCondition('tsearch', '@@', "plainto_tsquery('{$config}', '{$this->tsearch}')");
            $MC->addCondition('searchable', '=', true);
        }
        if($this->tcondit){
            foreach($this->tcondit as $data){
                list($field, $op, $value, $func) = $data;
                if(strpos($field, '.')!==false){
                    list($pre, $post) = explode('.', $field);
                    if(in_array($pre, $this->types)){
                        $MC->addCondition('main_content_'.$field, $op, $value, $func);
                    }else{
                        trigger_error("Bad alias name: $field");
                    }
                }else{
                    $MC->addCondition($field, $op, $value, $func);
                }
            }
        }
        //$MC->makeJoin('main_content_reveal');
        //$MC->addOrder('main_content_reveal.reveal_id', true);
        //$MC->addOrder();
        if($this->torder){
            foreach($this->torder as $data){
                list($field, $desc) = $data;
                $MC->addOrder($field, $desc);
            }
        }else{
            //$MC->addOrder('add_date', true);
        }
        $MC->search();
        $this->amount = $MC->getAmount();
        $ids = $MC->getList();
        $data = null;
        foreach($ids as $pri){
            $tmp = $this->getFullItemData($pri['content_id'], $pri['lang_id']);
            //Wykonywanie zdarzenia i rosrzerzanie danych dla listy
            foreach($this->tplugin as $obj){
                $obj->onListLoad($pri['content_id'], $pri['lang_id']);
                $data2 = $obj->extendList();
                $tmp = array_merge($tmp, $data2);
            }
            $data[] = $tmp;
        }
        return $data;
    }
    
    /**
     * Pobiera pelen pojedynczy rekor
     */
    public function getItem()
    {
        $data = $this->getFullItemData($this->content_id, $this->tlang, true);
        //Wykonywanie zdarzen i rozszerzanie listy dla elementu
        if($data)
            foreach($this->tplugin as $obj){
                $obj->onItemLoad($this->content_id, $this->tlang);
                $data2 = $obj->extendItem();
                $data = array_merge($data, $data2);
            }
        return $data;
    }
    
    /**
     * Pobiera pelen rekord danej tresci
     * @param unknown_type $content_id
     * @param unknown_type $lang_id
     */
    protected function getFullItemData($content_id, $lang_id, $full = false)
    {
        $data = null;
        $MC = new main_content($content_id, $lang_id);
        $row = $MC->getFields();
        if(!$MC->exists() || !$row['active']){
            return null;
        }
        $MCT = $MC->getChilds('main_content_'.$row['type']);
        $MCT->list2item();
        $rowt = $MCT->getFields();
        if($row['type']=='movie'){
            $rowt['streams'] = $MCT->getChilds('main_content_movie_stream')->getListArray();
            $rowt['thumbs'] = $MCT->getChilds('main_content_movie_thumb')->getListArray();
        }
        $data = null;
        foreach($row as $k=>$v) $data[$k] = $v;
        foreach($rowt as $k=>$v) $data[$k] = $v;
        return $data;
    }
    
    /**
     * 
     */
    public function getAmount()
    {
        return $this->amount;
    }
    
    /**
     * Dołącza obiekty pokrewne ktore beda wywolywane przy ladowaniu pojedynczego elementu
     * @param object $obj
     */
    public function addPlugin($obj)
    {
        if(is_object($obj) && in_array('contentPlugin', class_implements($obj))){
            $this->tplugin[] = $obj;
            return true;
        }
        trigger_error('Uzyj obiektu implementujacego interfejs contentPlugin!', E_USER_WARNING);
        return false;
    }
}

/**
 * 
 * Interfejs klas wykorzystywanych podczas ladowania tresci
 * @author slawek
 *
 */
interface contentPlugin
{
    /**
     * @param integer $content_id identyfikator tresci
     * @param string $lang_id jezyk tresci 'PL'
     */
    public function onItemLoad($content_id, $lang_id);
    
    /**
     * Rozszerza załadowany pojedynczy element
     * @return array rozszerzenie tablicy tresci
     */
    public function extendItem();
    
    /**
     * @param integer $content_id identyfikator tresci
     * @param string $lang_id jezyk tresci 'PL'
     */
    public function onListLoad($content_id, $lang_id);
    
    /**
     * Rozszerza liste elementow
     * @return array rozszerzenie tablicy tresci
     */
    public function extendList();
}

/**
 * 
 * Komentarze
 * @author sroszczyk
 *
 */
class contentComment implements contentPlugin
{
    /**
     * Moderatorzy mogsacy usuwac komenty
     * @var array
     */
    protected $moderators = array('slawek');
    protected $content_id = null;
    protected $lang_id = null;
    protected $user_login = null;
    protected $errors = null;
    protected $recursive = true;
    protected static $delete_time = 3600;
    protected $dtime = 0;
    
    public function __construct($content_id = null, $lang_id = null)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
        $this->dtime = self::$delete_time;
        if(isset($_SESSION['auth']['username']))
            $this->user_login = $_SESSION['auth']['username'];
    }
    
    public function onItemLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
    }
    
    public function extendItem()
    { 
        $MCComm = new main_content_comment();
        $MCComm->addCondition('content_id', '=', $this->content_id);
        $MCComm->addCondition('lang_id', '=', $this->lang_id);
        $MCComm->search();
        $amount = $MCComm->getAmount();
        return array('comments_amount'=>$amount, 'comments_list'=>$this->get()); 
    }
    
    public function onListLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
    }
    
    public function extendList()
    {
        $MCComm = new main_content_comment();
        $MCComm->addCondition('content_id', '=', $this->content_id);
        $MCComm->addCondition('lang_id', '=', $this->lang_id);
        $MCComm->search();
        $amount = $MCComm->getAmount();
        return array('comments_amount'=>$amount); 
    }
    
    /**
     * Zwraca komentarze
     * @return array
     */
    public function get($comment_id = null)
    {
        if(!$this->content_id){
            $this->errors['CONTENT_ID_NULL'] = 'Nie ma treści do której powiazany zostałby komentarz.';
            return null;
        }
        $level = 1;
        if($comment_id){
            $parent = new main_content_comment($comment_id);
            $level = $parent->getField('level')+1;
        }
        $MCComm = new main_content_comment();
        $MCComm->addCondition('content_id', '=', $this->content_id);
        $MCComm->addCondition('lang_id', '=', $this->lang_id);
        $MCComm->addCondition('level', '=', $level);
        $MCComm->addOrder('add_date', $comment_id?false:true);
        if($comment_id) $MCComm->addCondition('parent_comment_id', '=', $comment_id);
        $MCComm->search();
        $list = $MCComm->getListArray();$new_list = null;
        $amount = $MCComm->getAmount();
        
        $data = array();
        if(is_array($list))
        foreach($list as $item){
            $data2 = $this->get($item['comment_id']);
            $item['comments_amount'] = count($data2);
            $item['delete_possibility'] = $this->canBeDeleted($item);
            $data[] = $item;
            $data = array_merge($data, $data2);
        }
        
        return $data;
    }
    
    /**
     * 
     */
    protected function canBeDeleted($item)
    {
        if(!$this->user_login) return false;
        $ad = $item['add_date'];
        $ad = mktime(substr($ad, 11, 2), substr($ad, 14, 2), substr($ad, 17, 2), substr($ad, 5, 2), substr($ad, 8, 2), substr($ad, 0, 4));
        if(!in_array($this->user_login, $this->moderators) && ($item['user_login']!=$this->user_login || $ad>time()-$this->dtime)){
            return false;
        }
        return true;
    }
    
    /**
     * Zapisywanie komentarza
     * @param unknown_type $title
     * @param unknown_type $comment
     * @param unknown_type $nick
     * @param unknown_type $comment_id
     */
    public function add($title, $comment, $nick, $comment_id = null)
    {
        if(!$this->content_id){
            $this->errors['CONTENT_ID_NULL'] = 'Nie ma treści do której powiazany zostałby komentarz.';
            return null;
        }
        if(!$this->user_login){
            $this->errors['USER_LOGIN_NULL'] = 'Tylko zalogowani użytkownicy mogą komentować.';
            return null;
        }
        if(!strlen($title)){
            $this->errors['TITLE_NULL'] = 'Podaj tytuł komentarza.';
            return null;
        }
        if(!strlen($comment)){
            $this->errors['BODY_NULL'] = 'Podaj treść komentarza.';
            return null;
        }
        if(!strlen($nick)){
            $this->errors['Nick_NULL'] = 'Podaj podpis pod komentarzem.';
            return null;
        }
        
        $level = 1;
        if($comment_id){
            $parent = new main_content_comment($comment_id);
            $level = $parent->getField('level')+1;
        }
        
        $MCComm = new main_content_comment();
        $MCComm->setField('content_id', $this->content_id);
        $MCComm->setField('lang_id', $this->lang_id);
        $MCComm->setField('user_login', $this->user_login);
        $MCComm->setField('title', $title);
        $MCComm->setField('body', $comment);
        $MCComm->setField('nick', $nick);
        $MCComm->setField('parent_comment_id', $comment_id);
        $MCComm->setField('level', $level);
        $res = $MCComm->SaveItem();
        return $res;
    }
    
    public function delete($comment_id)
    {
        $MCComm = new main_content_comment($comment_id);
        if(!$MCComm->exists()){
            $this->errors['CONTENT_NOT_EXISTS'] = 'Nie istnieje już taki komentarz.';
            return false;
        }
        if(!$this->user_login){
            $this->errors['USER_LOGIN_NULL'] = 'Tylko zalogowani użytkownicy mogą usuwać komentarze.';
            return null;
        }
        $ad = $MCComm->getField('add_date');
        $ad = mktime(substr($ad, 11, 2), substr($ad, 14, 2), substr($ad, 17, 2), substr($ad, 5, 2), substr($ad, 8, 2), substr($ad, 0, 4));
        if(!in_array($this->user_login, $this->moderators) && ($MCComm->getField('user_login')!=$this->user_login || $ad>time()-$this->dtime)){
            $this->errors['USER_LOGIN_NULL'] = 'Nie masz praw do usnięcia tego komentarza.';
            return null;
        }
        $res = $MCComm->deleteItem();
        return $res;
    }
    
    public function getErrors()
    {
        return $this->errors;
    }
}

/**
 * 
 * Zlicza odslony 
 * @author slawek
 *
 */
class contentReveal implements contentPlugin
{
    protected $content_id = null;
    protected $lang_id = null;
    protected $user_login = null;
    
    public function __construct()
    {
        if(isset($_SESSION['auth']['username']))
            $this->user_login = $_SESSION['auth']['username'];
    }
    
    public function onItemLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
        if($this->content_id && $this->user_login){
            $MCRev = new main_content_reveal();
            $MCRev->addCondition('content_id', '=', $this->content_id);
            $MCRev->addCondition('lang_id', '=', $this->lang_id);
            $MCRev->addCondition('user_login', '=', $this->user_login);
            $MCRev->addCondition('add_date', '>', "NOW() - INTERVAL '2 HOURS'");
            $MCRev->search();
            if(!$MCRev->getAmount()){
                $MCRev->setField('content_id', $this->content_id);
                $MCRev->setField('lang_id', $this->lang_id);
                $MCRev->setField('user_login', $this->user_login);
                $MCRev->saveItem();
            }
        }
    }
    
    public function extendItem()
    {
        return array();
    }
    
    public function onListLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
    }
    
    public function extendList()
    {
        return array();
    }
}

/**
 * 
 * Ocena 
 * @author sroszczyk
 *
 */
class contentRate implements contentPlugin
{
    protected $content_id = null;
    protected $lang_id = null;
    protected $user_login = null;
    protected $errors = null;
    protected $rates = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
    
    public function __construct()
    {
        if(isset($_SESSION['auth']['username']))
            $this->user_login = $_SESSION['auth']['username'];
    }
    
    public function onItemLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
    }
    
    public function extendItem()
    { 
        $MCRate = new main_content_rate();
        $MCRate->addCondition('content_id', '=', $this->content_id);
        $MCRate->addCondition('lang_id', '=', $this->lang_id);
        $MCRate->search();
        $amount = $MCRate->getAmount();
        $list = $MCRate->getListArray();
        $rate = 0;
        if(is_array($list)){
            foreach($list as $ll) $rate += $ll['rate'];
            $rate /= $amount;
        }
        return array('rate_avarage'=>$rate, 'rate_amount'=>$amount); 
    }
    
    public function onListLoad($content_id, $lang_id)
    {
        $this->content_id = $content_id;
        $this->lang_id = $lang_id;
    }
    
    public function extendList()
    { 
        return $this->extendItem();
    }
    
    public function add($rate)
    {
        if(!$this->content_id){
            $this->errors['CONTENT_ID_NULL'] = 'Nie ma treści do której powiazana została by ocena.';
            return null;
        }
        if(!$this->user_login){
            $this->errors['USER_LOGIN_NULL'] = 'Tylko zalogowani użytkownicy mogą oceniać.';
            return null;
        }
        if(!in_array($rate, $this->rates)){
            $this->errors['RATE_UNEXPECTED'] = 'Nieprawidłowa wartość oceny.';
            return null;
        }
        $MCRate = new main_content_rate();
        $MCRate->addCondition('content_id', '=', $this->content_id);
        $MCRate->addCondition('lang_id', '=', $this->lang_id);
        $MCRate->addCondition('user_login', '=', $this->user_login);
        $MCRate->search();
        if($MCRate->getAmount()){
            $this->errors['RATED_ALREDY'] = 'Już oceniałeś ten element.';
            return null;
        }
        $MCRate->setField('content_id', $this->content_id);
        $MCRate->setField('lang_id', $this->lang_id);
        $MCRate->setField('user_login', $this->user_login);
        $MCRate->setField('rate', $rate);
        $res = $MCRate->saveItem();
        return $res;
    }
    
    public function getErrors()
    {
        return $this->errors;
    }
}

?>