<?php

class dictionary
{
    /** Uchwyt do bazy danych **/
    private $db;
    
    /**
     *  Konstruktor,
     **/
    public function __construct()
    {
        global $db;
        $this->db = $db;
    }
    
    /**
     *  Serwisy
     **/
    public function getServices($all = false)
    {
        $sql = "SELECT * FROM dict_services ORDER BY service_code";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['service_code']] = $dd['service_name'];
        return $dane;
    }
    
    /**
     *  Typy użytkowników
     **/
    public function getUserTypes($all = false)
    {
        $sql = "SELECT * FROM dict_user_type ORDER BY sort_index";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['user_type_code']] = $dd['user_type_name'];
        return $dane;
    }
    
    /**
     *  Wojewodztwa
     **/
    public function getCountries($all = false)
    {
        $sql = "SELECT * FROM dict_countries WHERE country_name_pl IS NOT NULL ORDER BY country_name_pl";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['country_code']] = $dd['country_name_pl'];
        return $dane;
    }
    
    /**
     *  Wojewodztwa
     **/
    public function getProvs($all = false)
    {
        $sql = "SELECT * FROM dict_prov_pl ORDER BY name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['prov_code']] = $dd['name'];
        return $dane;
    }
    
    /**
     *  Specjalizacje
     **/
    public function getSpecs($med = false, $all = false)
    {
        $whr = '';
        if($med)
            $whr = 'WHERE spec_type=\'MED\'';
        $sql = "SELECT * FROM dict_spec $whr ORDER BY mdm_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['spec_code']] = $dd['mdm_name'];
        return $dane;
    }
    
    /**
     *  Zwraca listę SITE_ID
     **/
    public function getSites($all = false)
    {
        $sql = "SELECT * FROM main_site ORDER BY site_name, site_id";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
        {
            if($dd['site_name'])
                $dane[$dd['site_id']] = $dd['site_name'];
            else
                $dane[$dd['site_id']] = $dd['site_id'];
        }
        return $dane;
    }
    
    /**
     *  Zwraca listę języków
     **/
    public function getLangs($all = false)
    {
        $sql = "SELECT * FROM dict_lang ORDER BY lang_id";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['lang_id']] = $dd['pl_name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getJournals($status = true, $all = false)
    {
        $whr = null;
        if($status===true || $status==='VIS')
            $whr[] = "status='VIS'";
        if($status===false || $status==='HID')
            $whr[] = "status='HID'";
        if($whr)
            $whr = 'WHERE '.implode(' AND ', $whr);
        $sql = "SELECT * FROM main_journals {$whr} ORDER BY title";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['id_journal']] = $dd['title'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getOrganizations($status = true, $all = false)
    {
        $whr = null;
        $whr[] = "org_type_code<>'PRD'";
        if($status===true || $status==='VIS')
            $whr[] = "status='VIS'";
        if($status===false || $status==='HID')
            $whr[] = "status='HID'";
        if($whr)
            $whr = 'WHERE '.implode(' AND ', $whr);
        $sql = "SELECT * FROM main_organizations {$whr} ORDER BY org_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['id_org']] = $dd['org_name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getCopyrights($all = false)
    {
        $sql = "SELECT * FROM dict_copyrights ORDER BY name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['copyright_id']] = $dd['name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getPublType($all = false)
    {
        $sql = "SELECT * FROM dict_publ_type ORDER BY name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['publ_type_code']] = $dd['name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getPublType2($all = false)
    {
        $sql = "SELECT * FROM dict_publ_type2 ORDER BY name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['publ_type_code']] = $dd['name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getEventType($all = false)
    {
        $sql = "SELECT * FROM dict_event_type ORDER BY event_type_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['event_type_code']] = $dd['event_type_name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getNewsType($all = false)
    {
        $sql = "SELECT * FROM dict_news_type ORDER BY news_type_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['news_type_code']] = $dd['news_type_name'];
        return $dane;
    }
    
    /**
     *  Pobiera listę webpage'ow
     **/
    public function getWebpages($all = false)
    {
        $sql = "SELECT * FROM dict_webpages ORDER BY webpage_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['webpage_code']] = $dd['webpage_name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getLinkType($all = false)
    {
        $sql = "SELECT * FROM dict_link_type ORDER BY link_type_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['link_type_code']] = $dd['link_type_name'];
        return $dane;
    }
    
    /**
     *
     **/
    public function getOrgType($all = false)
    {
        $sql = "SELECT * FROM dict_org_type ORDER BY org_type_name";
        $data = $this->db->getAll($sql);
        if($all)
            return $data;
        $dane = null;
        foreach($data as $dd)
            $dane[$dd['org_type_code']] = $dd['org_type_name'];
        return $dane;
    }

}

?>