<?php

/******************************************************************************
 *                                                                            *
 *      Klasa obsługująca edycje publikacji (TERAPIA)                         *
 *      @category data                                                        *
 *      @author Sławek                                                        *
 *                                                                            *
 *                                                                            *
 ******************************************************************************/

require_once('dimage.class.php');

class edition
{
    /** Uchwyt bazy danych **/
    private $db;
    private $site_id;
    
    /**
     *  Konstruktor, 
     **/
    public function __construct()
    {
        global $db;
        $this->db = $db;
        
        if(defined('SITE_ID'))
            $this->site_id = SITE_ID;
    }
    
    /**
     *
     **/
    public function getList($year = null, $subiect = null, $limit = 999)
    {
        $whr = null;
        $whr[] = "status='VIS'";
        if($year)
            $whr[] = "book_year='{$year}'";
        if($subiect)
            $whr[] = "subject LIKE '%{$subiect}%'";
        $whr = 'WHERE '.implode(' AND ', $whr);
        $sql = "SELECT * FROM main_editions {$whr} ORDER BY id_edition DESC LIMIT {$limit}";
        $sql = "SELECT * FROM pl_content.main_editions {$whr} ORDER BY book_nr DESC LIMIT {$limit}";
        $data = $this->db->getAll($sql);
        $dimage = new dimage;
        for($i=0; $i<count($data); $i++){
            $images = $dimage->getRelatedImages('edition', $data[$i]['id_edition']);
            if(isset($images[0]['image_name']) && !empty($images[0]['image_name']))
                $data[$i]['cover'] = $images[0]['image_name'];
            else
                $data[$i]['cover'] = null;
        }
        return $data;
    }
    
    /**
     *
     **/
    public function getElement($id)
    {
        $sql = "SELECT * FROM pl_content.main_editions WHERE id_edition='{$id}'";
        $data = $this->db->getRow($sql);
        if(!$data)
            return null;
        
        $dimage = new dimage;
        $images = $dimage->getRelatedImages('edition', $data['id_edition']);
        if(isset($images[0]['image_name']) && !empty($images[0]['image_name']))
            $data['cover'] = $images[0]['image_name'];
        else
            $data['cover'] = null;
        return $data;
    }
	public function getPublication($id)
    {
        $sql = "SELECT * FROM pl_content.main_content_publ WHERE content_id='{$id}'";
        $data = $this->db->getRow($sql);
        if(!$data)
            return null;
         
        //$dimage = new dimage;
        //$images = $dimage->getRelatedImages('edition', $data['id_edition']);
        //if(isset($images[0]['image_name']) && !empty($images[0]['image_name']))
         //   $data['cover'] = $images[0]['image_name'];
        //else
         //   $data['cover'] = null;
		
        return $data;
    }
    
    /**
     *
     **/
    public function getPublications($id)
    {
        $sql = <<< ESQUEL
SELECT 
a.content_id, 
a.author, 
a.title,
a.keywords, 
LOWER(a.title) as _expander
FROM 
pl_content.main_content_publ a 
INNER JOIN 
pl_content.rel_publ_edition b 
ON 
a.content_id=b.id_publ 
WHERE 
b.id_edition='{$id}' 
ORDER BY 
a.content_id 
ESQUEL;
        $publs = $this->db->getAll($sql);
        
        for($i=0; $i<count($publs); $i++){
            $publs[$i]['keyword'] = $publs[$i]['keywords'];
            $publs[$i]['hash'] = md5('0123456789'.$publs[$i]['id_publ'].'*_*'.$this->site_id.'9876543210');
            $publs[$i]['_expander'] = $this->prepare_expander($publs[$i]['_expander']);
        }
        return $publs;
    }

    
    /**
     *	Pobiera słowa kluczowe publikacji
     *	@param int $publ_id - identyfikator publikacji
     *	@return string - słowa kluczowe
     **/
	 /*
    private function getpublKeyword($publ_id)
    {
        $sql = "SELECT keywords FROM pl_content.main_content.publ WHERE content_id='{$publ_id}'";
        $keywords = $this->db->getAll($sql);
        $tmp = null;
        foreach($keywords as $keyword){
                $tmp[] = $keyword['keyword'];
        }
        if($tmp == null)
                return null;
        $keywords = implode(', ', $tmp);
        return $keywords;
    }
    */
    */
    /**
     *	Przygotowuje tekst wstawiany do url'a jako rozpychacz
     *	@param string $expander - tekst do przerobienia na url'owy rozpychacz
     *	@return string - url'owy rozpychacz
     **/
	 public function getSection($section_name)
     {
        $sql = <<< ESQUEL
SELECT 
*
FROM
pl_content.main_content_section

WHERE 
section_name='{$section_name}' 

ESQUEL;

        $data = $this->db->getAll($sql);
        
       
        return $data;
    }
    private function prepare_expander($expander)
    {
		$from = array('Ę', 'ę', 'Ó', 'ó', 'Ą', 'ą', 'Ś', 'ś', 'Ł', 'ł', 'Ż', 'ż', 'Ź', 'ź', 'Ć', 'ć', 'Ń', 'ń', ' ');
		$to = array('e', 'e', 'o', 'o', 'a', 'a', 's', 's', 'l', 'l', 'z', 'z', 'z', 'z', 'c', 'c', 'n', 'n', '_');
		$expander = str_replace($from, $to, $expander);
		$from = array('!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '-', '+', '=', '`', '~', '[', ']', '{', '}', ':', ';', '"', "'", '?', '/', '\\', ',', '.', '<', '>');
		$to = '_';
		$expander = str_replace($from, $to, $expander);
		$from = array('______', '_____', '____', '___', '__');
		$to = '_';
		$expander = str_replace($from, $to, $expander);
		$expander = trim($expander, '_');
		return $expander;
    }
    
    /**
     *
     **/
    public function getYears()
    {
        $sql = "SELECT DISTINCT book_year as value FROM pl_content.main_editions WHERE status='VIS' ORDER BY book_year ASC";
        $data = $this->db->getCol($sql);
        return $data;
    }
    
    /**
     *
     **/
    public function getSubjects()
	
    {
	
	 
        $sql = "SELECT DISTINCT subject as value FROM pl_content.main_editions WHERE status='VIS' ORDER BY subject ASC";
        $data = $this->db->getCol($sql);
		
        for($i=0;$i<count($data);$i++){
            if(strpos($data[$i], '-')){
                $tmp = explode('-', $data[$i]);
                $data[$i] = trim($tmp[0]);
            }
            if(strpos($data[$i], ',')){
                $tmp = explode(',', $data[$i]);
                $data[$i] = trim($tmp[0]);
            }
        }
        $data = array_unique($data);
        return $data;
    }
	
	public function getEvents($id_collection, $offset)
	
    {  	$date=date("Y-m-d");  
	
		$sql = <<< ESQUEL
SELECT 
a.content_id as id, 
a.title , 
a.info as head,
a.link as url,
a.city as cityname,
a.zip,
a.address,
a.event_type as type_code,
a.tel as telefon,
a.fax,
a.email,
a.country,
a.date_start,
a.date_end,
a.org_name,
a.org_addr as org_address
 

FROM 
pl_content.main_content_event a 
INNER JOIN 
pl_content.rel_content_collection b 
ON 
a.content_id=b.main_content_id
WHERE
b.main_collection_id='{$id_collection}' and date_end > '{$date}' 
ORDER BY date_end
LIMIT 6 OFFSET {$offset};
ESQUEL;

        $events = $this->db->getAll($sql);
	 
   
        return $events;
    }
	public function getVarEvents($id_collection)
	
    {  	$date=date("Y-m-d");  
	
		$sql = <<< ESQUEL
SELECT 
a.content_id as id, 
a.title , 
a.info as head,
a.link as url,
a.city as cityname,
a.zip,
a.address,
a.event_type as type_code,
a.tel as telefon,
a.fax,
a.email,
a.country,
a.date_start,
a.date_end,
a.org_name,
a.org_addr as org_address
 

FROM 
pl_content.main_content_event a 
INNER JOIN 
pl_content.rel_content_collection b 
ON 
a.content_id=b.main_content_id
WHERE
b.main_collection_id='{$id_collection}' and date_end > '{$date}'  AND EXTRACT(MONTH FROM date_end)='Czerwiec'
ORDER BY date_end
ESQUEL;

        $events = $this->db->getAll($sql);
	 
   
        return $events;
    }
	
	public function getComments($id_publ) {

		
		//commenty przypiete do publ
		$sql = "SELECT * FROM pl_content.main_content_comment WHERE content_id={$id_publ} and lang_id='PL' ORDER BY add_date DESC ";
        $comments = $this->db->getAll($sql);
		//ilośc
		
		
		return $comments;
	}
	
	public function getCountComments($id_publ){ 
	 
	
	
		$sql= "SELECT count(*) FROM pl_content.main_content_comment WHERE content_id={$id_publ} and lang_id='PL'";		
		$count = $this->db->getOne($sql);
		
		
		return $count; 
		
	}
	
	public function SaveComments($content_id, $lang_id,$title, $body, $nick, $user_login, $source_domain, $source_site){
	
							
		$sql = "INSERT INTO pl_content.main_content_comment (content_id,lang_id,title,body,nick,user_login, source_domain, source_site) VALUES (:content_id,:lang_id,:title,:body,:nick,:user_login,:source_domain,:source_site)";
		$q = $this->db->prepare($sql);
		$q->execute(array(':content_id'=>$content_id,':lang_id'=>$lang_id,':title'=>$title,':body'=>$body,':nick'=>$nick,':user_login'=>$user_login,':source_domain'=>$source_domain,':source_site'=>$source_site));
		
		
		return true;
		
	}
	
	
	
	/*
	public function add($contentId,$langId,$content,$nick,$userLogin,$parent = null) {
		
		//id_contentu
		try {
			
			$res = $this->adapter->createStatement("
				INSERT INTO {$this->table()} 
				(content_id,lang_id,body,nick,user_login".(null !== $parent ? ",parent_comment_id" : '').") VALUES 
				($contentId,'$langId','$content','$nick','$userLogin'".(null !== $parent ? ",$parent" : '').")")->execute();
			
			return true;
			
		} catch(\Exception $e) {
			
			throw new \Exception($e->getMessage().'. pg_last_error:'.pg_last_error(),1);
		}
	}
	
	//sprawdzanie czy comment istnieje.
	public function commentExists( $contentId , $commentId ) {
		
		try {
			
			$res = $this->adapter->createStatement("
				SELECT * FROM {$this->table()} WHERE content_id = {$contentId} AND comment_id = {$commentId}
			")->execute();
			
			return (bool)$res->count();
			
		} catch( \Exception $e ) {
			
			throw new \Exception( __METHOD__ . ". Nieudana próba sparawdzenia czy koemntarz istnieje. " . $e->getMessage() );
		}
	}	
    
    */
} 

?>