<?php

/******************************************************************************
 *                                                                                                                           *
 *      Klasa obsługująca FAQ                                                                                       *
 *      @category data                                                                                               *
 *      @author Piotr                                                                                                  *
 *      UWAGA: używać w klasach potomnych Controller.class.php                                     *
 *                                                                                                                          *
 ******************************************************************************/


class faq
{
    /** Uchwyt do bazy danych **/
    private $db;
    
    /** **/
    private $amount = 0;
    private $rows = 5;
    private $range = 5;
    
    
    /** Zalogowany użytkownik **/
    private $user_login;
    
    public $is_expert = false;
    
    /**  identyfikator holdera, unikalnny **/
    public $holder_code;
    
    /** opis holdera, moze byc null **/
    protected $holder_name;
    
    /** email experta **/
    public $expert_email;
    
    /** id numeryczne grupy **/
    protected $group_id;
    
    
    
    /**
     *  Konstruktor,
     *  @param string $holder_code - identyfikator holdera, wymagany
     *  @param string $holder_name - opis holdera, moze byc null
     *  @param string $expert_email - email experta, wymagany
     **/
    public function __construct( $holder_code, $holder_name = null, $expert_login ,$expert_email )
    {
        #global $db;
        //polaczenie z baza w ten sposob jest chwilowe, bo uprawnienia do tablic dotycza editora a nie portala        
        $db = DB_connect(EDITOR_DB);
        $this->db = $db;
	  $this->db->debug = true;

        $this->holder_code = $holder_code;
        $this->holder_name = $holder_name;
	  
	  
        $this->user_login = defined('CONTR_USER')?CONTR_USER:null;	  
	  
	  
	  
	  if( !$this->is_group_exist( $this->holder_code ) )
	  {		
		$this->group_id = $this->add_group( $this->holder_code,  $this->holder_name, $expert_login, $expert_email );
		//$this->expert_email = $this->expert_email;
		$group = $this->get_group( $this->holder_code );
		
		$this->group_id = $group['group_id'];
		$this->expert_email = $group['expert_email'];
		$this->expert_login = $group['expert_login'];	
		
	  } else {
		$group = $this->get_group( $this->holder_code );
		
		$this->group_id = $group['group_id'];
		$this->expert_email = $group['expert_email'];
		$this->expert_login = $group['expert_login'];	
	  }
	  
	  $this->is_expert = ($this->expert_login==$this->user_login)?true:false;
	  
    }


    /**
     *  Pobiera grupe  o zadanej nazwie
     *  @param string $name - nazwa grupy,jadnoznaczna
     *  @return bool/int - int or false
     **/
    public function get_group( $name = null )
    {
        $sql = "SELECT * FROM main_faq_group WHERE name='{$name}'";
	  $res = $this->db->getRow($sql);	  	  
	  
	  if($res) {		
		return $res;
    	  } else {
		return false;
	  }	          
    }
    

    /**
     *  Pobiera grupe  o zadanej nazwie
     *  @param string $name - nazwa grupy,jadnoznaczna
     *  @return bool/int - int or false
     **/
    public function get_group_id( $name = null )
    {
        $sql = "SELECT group_id FROM main_faq_group WHERE name='{$name}'";
	  $res = $this->db->getOne($sql);	  	  
	  
	  if($res) {		
		return $res;
    	  } else {
		return false;
	  }	      
    
    }
    

    /**
     *  Sprawdza czy istnieje groupa  o zadanej nazwie
     *  @param string $name - nazwa grupy,jadnoznaczna
     *  @return bool 
     **/
    public function is_group_exist( $name = null )
    {
        $sql = "SELECT COUNT(1) FROM main_faq_group WHERE name='{$name}'";
	  
	  if( $this->db->getOne($sql) ) {		
		return true;
    	  } else {
		return false;
	  }	  
    
    }


    /**
     *  Dodaje grupe,     
     *  @param string $name - nazwa grupy,jadnoznaczna
     *  @param descr string - opis, moze = null
     *  @param expert_email - email experta opiekujacego sie ta groupa
     *  @return integer or false - zwraca id wstawionej grupy lub false
     **/
    public function add_group( $name, $descr, $expert_login,$expert_emaill )
    {
        $sql = "INSERT INTO main_faq_group ( name, descr, expert_login ,expert_email ) VALUES (  '{$name}', '{$descr}','{$expert_login}' ,'{$expert_emaill}' ) RETURNING group_id";
	  $question_id = $this->db->getOne( $sql );
	  
	  if($question_id)
	  {	
		return $question_id;
	  }else
	  {
		return false;
	  }
    }    

    /**
     *Dodaj pytanie
     * @ param string $value - tresc pytania
     * @ param string $name - imie i nazwisko
     * @ param string $email - email
     * @return int or false - zwraca id wstawionego pytania lub false     
     **/
     public function add_question(  $value = null, $name = null, $email = null)
     {        
        $sql = "INSERT INTO main_faq_question  (group_id, value , user_login, name, email ) VALUES  ( {$this->group_id}, '{$value}', '{$this->user_login}', '{$name}', '{$email}' )  RETURNING question_id;";
        
        $question_id= $this->db->getOne($sql);      
        if(!$question_id )
        {
            return false;
        }else{
            return $question_id;
        }
    }


    /**
     *Dodaj odpowiedź
     *@param int $question_id - id pytania, wymagany
     *@param string $value - tresc odpowiedzi, wymagany
     *@return int or false - zwraca id wstawionej odpowiedz lub false
     **/
    public function add_reply( $question_id = null, $value = null )
    {
	  $sql = "INSERT INTO main_faq_reply (  question_id, value  ) VALUES ( {$question_id}, '{$value}' )  RETURNING reply_id";
	  $reply_id = $this->db->getOne($sql);
	 if($reply_id)
	 {
	  return $reply_id;
	 }else{
	  return false;
	 }
    }

    
    /**
     *Pobiera pytanie - odpowiedz, jezeli takowa istnieje
     *@return array or bool - zwraca  tablice albo false
     **/
    public function get_elements( $page = 0, $whr = null )
    {

	  $whr_sql = null;
	  if( !empty($whr) ){
		foreach( $whr as $condition ){
		    $whr_sql.=' AND '. $condition;		
		}
	  }
	  
	  $sql  = "SELECT
g.group_id as group_group_id,
g.name as group_name,
g.descr as group_descr,
g.expert_email as group_expert_email,
g.expert_login as group_expert_login,
q.question_id as question_question_id,
q.group_id as question_group_id,
q.user_login as question_user_login,
q.add_date as question_add_date,
q.value as question_value,
r.reply_id as reply_reply_id,
r.question_id as reply_question_id,
r.user_login as reply_user_login,
r.add_date as reply_add_date,
r.value as reply_value

FROM
		main_faq_group g
		inner JOIN main_faq_question q
		    ON g.group_id =q.group_id
		left JOIN main_faq_reply r
		    ON q.question_id = r.question_id		
		where g.name='{$this->holder_code}' {$whr_sql} LIMIT {$this->rows} OFFSET {$page}  ";
	  
	  $data= $this->db->getAll( $sql );
	  
	  foreach($data as $key=>$row)
	  {
		$data[$key]['hash'] = md5($row['question_question_id'].$this->holder_code) ;
	  }
	  
	  $whr_sql2 = null;
	  if( !empty($whr) ){
		$whr_sql2 = ' WHERE ';
		
		if( count($whr)>1 ) {
		    foreach( $whr as $condition ){
			  $whr_sql2.= $condition.' AND ';		
		    }
		} else {
			  $whr_sql2.= $condition;
		}		
	  }
	  $sql2= "SELECT COUNT(1) FROM main_faq_group g INNER JOIN main_faq_question q ON g.group_id =q.group_id
		    left JOIN main_faq_reply r
		    ON q.question_id = r.question_id	 {$whr_sql2}";
	  $this->amount = $this->db->getOne($sql2);
#	  echo $sql2;
	  return ($data)?$data:false;	 	  
    }

    /**
     *  Paginacja wszystkiego z tej klasy ;-)
     **/
    public function getPages($page = 0)
    {
        $rows = $this->rows;
        $range = $this->range;
        $range = $range==null?$this->config['pagging_range']:$range;
        
        $pages = null;
        $pages_amount = ceil($this->amount / $rows);
      
        if($pages_amount<=1)
            return null;//Jedna lub brak stron
        
        //pierwsza strona
        $pages['first'] = array('view' => 'first', 'goto' => 0);
        
        //popszednia strona
        if($page>0)
            $pages['prev'] = array('view' => 'prev', 'goto' => $page-1);
        
        //pierwszy separator
        if($page>$range+1+1)
            $pages['sep1'] = array('view' => 'sep', 'goto' => floor(($page-$range)/2));
        
        //mięso
        $start = $page-$range;
        if($start<0) $start = 0;
        $stop = $page+$range;
        if($stop>$pages_amount) $stop = $pages_amount;
        for($i=$start; $i<$stop; $i++){
            $key = 'step'.($page+$i);
            $pages[$key] = array('view' => $i+1, 'goto' => $i);
        }
        
        //drugi separator
        if($pages_amount-$page>$range+1+1)
            $pages['sep2'] = array('view' => 'sep', 'goto' => ceil(($pages_amount-$page+$range)/2));
        
        //następna strona
        if($page<$pages_amount-1)
            $pages['next'] = array('view' => 'next', 'goto' => $page+1);
        
        //ostatnia strona
        $pages['last'] = array('view' => 'last', 'goto' => $pages_amount-1);
        
        return $pages;
    }


    public function get_all_categories()
    {
        $sql = "SELECT * from main_faq_group";
        $data = $this->db->getAll( $sql );
        return $data;            
    }

    public function get_category_by_id( $id = null)
    {
        $sql = "SELECT name from main_faq_group WHERE group_id = {$id} LIMIT 1";
        $data = $this->db->getOne( $sql );          
        return $data;            
    }

    
    public function get_question_by_id( $id = null )
    {
        $sql = "SELECT * from main_faq_question WHERE question_id = {$id} LIMIT 1";         
        $data = $this->db->getRow( $sql );
        
        return $data;            
    }



    public function get_thread ( $question_id = null, $limit = 999 )
    {
        $sql = "SELECT
        q.group_id,
        q.question_id,
        q.user_login as question_owner,
        q.add_date as question_add_date,
        q.value as question_value,
        r.reply_id as reply,
        r.user_login as reply_owner,
        r.add_date as reply_add_date,
        r.value as reply_value
        from main_faq_question as q
        LEFT JOIN main_faq_reply as r
        ON
        q.question_id = r.question_id                
        WHERE q.question_id = {$question_id} LIMIT {$limit}";
        $data = $this->db->getAll($sql);
        return $data;
    }

     public function get_faq_by_group( $group_id = null, $limit = 999 )
     {
                    
        $sql = "SELECT
        g.name,
        g.descr,
        q.group_id,
        q.question_id,
        q.user_login as question_owner,
        q.add_date as question_add_date,
        q.value as question_value,
        r.reply_id as reply,
        r.user_login as reply_owner,
        r.add_date as reply_add_date,
        r.value as reply_value
        FROM
        main_faq_group as g, main_faq_question as  q
        LEFT JOIN main_faq_reply as r
        ON r.question_id = q.question_id    
        WHERE g.group_id = {$group_id} AND g.group_id = q.group_id LIMIT {$limit};";
        $data = $this->db->getAll($sql);
        
        return $data;

    }
}