<?php
// library.inc.php
//
// biblioteka funkcji pomocniczych dla esculap.pl
// by Cegedim Group Poland (mz) XII.2007-II.2008
//
// aktualizacja 19.11.2008 by mz - dodanie funkcji getTypesDict() i getSpecsDict()
// aktualizacja 20.11.2008 by mz - dodanie funkcji formatDate2
// aktualizacja 24.11.2008 by mz - dodanie funkcji getJournalDict
// aktualizacja 28.11.2008 by mz - dodanie funkcji getCollectionDict
// aktualizacja 07.12.2008 by mz - dodanie getTypesDict("news")
// aktualizacja 12.12.2008 by mz - dodanie getTypesDict("event")
// aktualizacja 17.12.2008 by mz - getCollectionDict(count)
// aktualizacja 29.01.2009 by mz - dodanie secure_input nickname
// aktualizacja 23.03.2009 by mz - dodanie function getMaxNewsOrder

/**
* @author Marek Zieliński <marek.zielinski@eu.dendrite.com>
* @version 1.0
* @package esculap
*
*/

require_once("constants.inc.php");

// funkcje korzystajace z bazy wymagaja instnienia obiektu PDO 'global $dbh'

// wszystkie uzyte stale tekstowe
define("BLAD_POLACZENIA",  $constants['connection_failure']);
$tydzien = array($constants["sunday"], $constants["monday"], $constants["tuesday"], $constants["wendsday"], $constants["thursday"], $constants["friday"], $constants["saturday"]);
$rok = array('', $constants["january"], $constants["february"], $constants["march"], $constants["april"], $constants["may"], $constants["june"], $constants["july"], $constants["august"], $constants["september"], $constants["october"], $constants["november"], $constants["december"]);

//
$serwer = ($_SERVER['HTTP_HOST']=='dev1.esculap.pl')?'dev1.esculap.pl':'www.esculap.pl';

$session_timeout = 60;	// w minutach
$sec_session_timeout = 30;	// sesja edycji danych osobowych

// dla funkcji isCorporateUser
$corporate_users = array("85.222.53.53", "217.153.224.51", "194.5.134.185","89.77.166.249");

// dla dbconnect (e-mail z komunikatem o bledzie polaczenia z baza)
$admin_email = "marek.zielinski@eu.dendrite.com";

$levels = array(''        => 1,  // hash do zamiany level'a z napisu na liczbe.
											 'none'    => 1,
											 'partial' => 2,
											 'full'    => 3,
											 'editor'  => 4,
											 'admin'   => 5,
											 'user_conf'   => 9,
											 1         => 1,
											 2         => 2,
											 3         => 3,
											 4         => 4,
											 5         => 5,
									 		 9         => 9,
											);
						
// hash do zamiany statusu uzytkownika z napisu na liczbe
$status_hash = array(	'noaccess' => 0,  
					''         => 1,
					'partial'  => 2,
					'full'     => 3,
					'editor'   => 4,
					'admin'    => 5,
				  );

// rodzaje newsow
$news_types = array(	1	=> $constants['science_world'],
						2	=> $constants['local_news'],
						3	=> $constants['global_news']);

//
// polaczenie z baza
//
/**
 * klasa rozszerzająca PDO o automatyczne logowanie błędow w php.log
 *
*/
class PDOext extends PDO
{
	private $reported = false;
	
	public function query($query)
	{
		$result = parent::query($query);
		//if (count($this->err) == 0)
			$this->logerror($query);
		return $result;
	}
	
	public function exec($query)
	{
		$result = parent::exec($query);
		//if (count($this->err) == 0)
			$this->logerror($query);
		return $result;
	}
	
	private function logerror($query) {
		$err = $this->errorInfo();
		if (!$this->reported && array_key_exists(2,$err) && strlen($err[2])) {
			$this->reported = true;
			error_log("PDO error: " . $err[2] . " [" . substr($query, 0, 512) . "...] in " . $_SERVER['SCRIPT_FILENAME']);
		}
	}
	
	/***************************************************************************/
	public function getAll($sql)
	{
		$sth = $this->prepare($sql);
		$sth->execute();
		$result = $sth->fetchAll(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function getRow($sql)
	{
		$sth = $this->prepare($sql);
		$sth->execute();
		$result = $sth->fetch(PDO::FETCH_ASSOC);
		return $result;
	}
	
	public function getOne($sql)
	{
		$sth = $this->prepare($sql);
		$sth->execute();
		$result = $sth->fetchColumn();
		return $result;
	}
	/***************************************************************************/
}// class PDOext

/**
 * uniwersalna funkcja do łączenia z bazą
 *
* @param string $baza nazwa uchwytu wg definicji z pliku /usr/lib/php/modules/dbcred.php
* @param string $encoding LATIN2 (domyślnie) /UTF8
* @return boolean|PDOext object 
*/
function dbconnect($baza = "burak", $encoding = "LATIN2") {	// UTF8
	global $admin_email;
	global $constants;
		
	include("/usr/lib/php/modules/dbcred.php");
		
	$dbcred[$baza]['dsn'] = "pgsql:dbname=" . $dbcred[$baza]['dbname'] . ";host=" . $dbcred[$baza]['dbserver'];
	
	// przerwa techniczna
	//if (!isCorporateUser()) die($constants['server_unavailable']);	// docelowo redirect do planszy bledu
	
	try {
		$conn = new PDOext($dbcred[$baza]['dsn'], $dbcred[$baza]['dblogin'], $dbcred[$baza]['dbpassword']);
		if ($conn) $conn->exec("SET CLIENT_ENCODING TO $encoding;");
		return $conn;
   	} catch (PDOException $e) {
		//show($e->getMessage(),BLAD_POLACZENIA);
		$error_file = $_SERVER['DOCUMENT_ROOT'] . "DBERROR";
		if (!file_exists($error_file)) {
			$headers .= "Content-type: text/plain; charset=iso-8859-2\n";
			$error = BLAD_POLACZENIA . ": " . $e->getMessage() . "\r\n" . "from: " . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
			mail($admin_email, '[ERROR]' , $error, $headers);
			file_put_contents($error_file, $error);
		}
		echo $constants['server_unavailable'];	// tu redirect do planszy bledu
		return false;
   	}
}// function dbconnect

// prezentuje drzewiasta postac tablicy (do debugowania)
function show($var,$comment = '', $level = 0) {
	//if (isCorporateUser())
	{
		echo "<br />" . str_repeat("&nbsp;", 8 * $level) . $comment . ":";
		if (is_array($var)) {
		       //echo "array:";
		       foreach($var as $key => $elt) {
		       show($elt,$key, $level + 1);
		   }
		}
		else echo $var;
	}
}
// debugging zapytan SQL
function showSQL($rawSQL, $params, $ret) {
	if (array_key_exists('sql', $_GET) && isCorporateUser()) {
		foreach($params as $key => $value) {
			//$rawSQL = str_replace("?", $params, $rawSQL);
			$rawSQL = preg_replace("/\?/", ((is_numeric($value))?$value:"'$value'"), $rawSQL, 1);
		}
		if ($ret)
			return $rawSQL;
		else 
			show($rawSQL,"showSQL");
	}
}

// formatuje bierzaca date do wyswietlenia w portalu
function getCurrentDate() {
	global $tydzien, $rok;
  	$data = getdate();
	return "<b>" . $tydzien[$data['wday']] . "</b>, " . $data['mday'] . " " . $rok[$data['mon']] . " " . $data['year'];
}

// pobiera bierzace imieniny
function getCurrentNames() {
	global $dbh;
  	$data = getdate();
	$warunek = "month=" . $data['mon'] . " AND day=" . $data['mday'];
	$sql_query = "SELECT name1,name2,name3 FROM dict_calendar WHERE $warunek";
	$sth = $dbh->query($sql_query);
	$result = $sth->fetch(PDO::FETCH_ASSOC);	
	if (is_array($result))
		return trim(implode(', ',$result),", ");
}


// pobiera z bazy rekord uzytkownika
function getUserRecord($user_login) {
	global $dbh;
	$sql_query = "SELECT * FROM main_users WHERE user_login='$user_login'";
	$sth = $dbh->query($sql_query);
	$rekord = $sth->fetch(PDO::FETCH_ASSOC);
	
	$sql_query = "SELECT mdm_name FROM rel_users_spec AS r,dict_spec AS d WHERE user_login='$user_login' AND d.spec_code=r.spec_code";
	$sth2 = $dbh->query($sql_query);
	$specs = array();
	while($spec = $sth2->fetch())
		$rekord['specs'][] = trim($spec['mdm_name']);
	 
	return $rekord;
}
//function getUserRecord


function getUserName($user_login) {
        global $dbh;
        $sql_query = "SELECT first_name,last_name  FROM main_users WHERE user_login='$user_login'";
        $sth = $dbh->query($sql_query);
        $rekord = $sth->fetch(PDO::FETCH_ASSOC);

        return $rekord;
}
//function getUserName


// formatuje imie i nazwisko uzytkownika
function formatUserName($user_record) {
	$imie = ucfirst($user_record['first_name']);
	$nazwisko = ucfirst($user_record['last_name']);
	return "$imie $nazwisko";
}//function formatUserName

// formatuje adres uzytkownika
function formatUserAddress($user_record) {
	return $user_record['addr_prefix'] . " " . $user_record['address'] . " " . $user_record['addr_house'] . " / " . $user_record['addr_apartm'] . "\n" . $user_record['zip'] . " " . $user_record['cityname'];
}//function formatUserAddress

// wybiera email uzytkownika
function formatUserEmail($user_record, $priorytet = "external") {
	$email = ($priorytet == "esculap")?$user_record['email_esc']:$user_record['email_ext'];
	
	if (!strlen($email))
		$email = ($priorytet == "esculap")?$user_record['email_ext']:$user_record['email_esc'];
	return $email;
}
//function formatUserEmail

// 
function formatUserSpec($user_record) {
	return implode(", ", $user_record['specs']);
}
//function formatUserSpec



// formatuje date (z postaci yyyy-mm-dd na dd-mm-yyyy) 
function formatDate($data, $separator = '-') {
	return substr($data, 8, 2) . $separator . substr($data, 5, 2) . $separator . substr($data, 0, 4);
}//function formatDate
// odwrotnie (z postaci dd-mm-yyyy na yyyy-mm-dd) 
function formatDate2($data, $separator = '-') {
	return substr($data, 6, 4) . $separator . substr($data, 3, 2) . $separator . substr($data, 0, 2);
}//function formatDate

// pobiera zawartosc pliku ze sciezki wzglednej
function get_file_contents($file) {
	return file_get_contents($_SERVER['DOCUMENT_ROOT'] . $file);
}//function get_file_contents

// usuwa puste elementy z tablicy
function array_trim($array) {
	foreach ($array as $key => $value)
		if(is_array($value))
			$array[$key] = array_trim($value);
		else
			if (!$value)
				unset($array[$key]);
	return $array;
}// function array_trim

// wyciecie kluczy numerycznych
function array_trim_keys($arr) {
	$narr = array();
	foreach($arr as $key => $val)
		if (!is_numeric($key))
			$narr[$key] = $val;
	return $narr;
}

function pokaz_slownik($config = false) {
	global $constants;
	global $dbh;
	
	if (!$config) return;
	$default_config = array(	'search_key' => "", 
								'db_type'	=> "both", 
								'limit' => 5,
								'sl_nolimit' => false);
		$config = array_merge($default_config, $config);

		// parametry z formularza
		if (array_key_exists('search_key',$_POST) && array_key_exists('sl_db_type',$_POST)) {
			$config['search_key'] = secure_input('search',$_POST['search_key']);
			$config['sl_db_type'] = secure_input('search',$_POST['sl_db_type']);	
		}
		if (array_key_exists('search_key',$_GET) && array_key_exists('sl_db_type',$_GET)) {
			$config['search_key'] = secure_input('search',$_GET['search_key']);
			$config['sl_db_type'] = secure_input('search',$_GET['sl_db_type']);
			if (array_key_exists('sl_nolimit',$_GET))
				$config['sl_nolimit'] = secure_input('id',$_GET['sl_nolimit']);
		}
		
		$out = '<div class="box_slownik">
					<div class="nagl"><img src="img/header_slownik.gif" alt="' . $constants['dictionary'] . '"/></div>
					' . $constants['dictionary_languages'] . '
					<br />
					<br />
					<div style="padding-left: 19px;">
						<form name="search_form" method="post" action="index.php?search">
							<div style="padding-bottom: 2px; font-weight:bold;">' . $constants['word(s)'] . ':</div>
							<input type="text" name="search_key" class="input" style="border: solid 1px #4AA4B7;" value="' . $config['search_key'] . '" />
							<div style="padding-bottom: 2px; padding-top: 7px; font-weight:bold;">' . $constants['dictionary'] . ':</div>
							<select name="sl_db_type" class="select">
								  <option value="both">' . $constants['both_sides'] . '</option>
								  <option value="pol">' . $constants['pol2eng'] . '</option>
								  <option value="eng">' . $constants['eng2pol'] . '</option>
								  <option value="eng">test</option>
						    </select>
							<input name="search_submit" type="submit" value="' . $constants['translate'] . '" class="submit" />
						</form>
					</div>
				</div><br />';
		
		//show($config,'config');
		
		if (!$config['search_key'] || !$config['sl_db_type']) 
			return $out;	// tylko formularz
		// wyniki
		$query = "SELECT term, definition, term_lang, definition_lang
							FROM main_dict_sto
							WHERE lower(term) LIKE lower('%" . $config['search_key'] . "%') ";
		if ($config['sl_db_type'] != "both")
			$query .= " AND term_lang=UPPER('" . $config['sl_db_type'] . "') ";
		$query .= " ORDER BY term"; //" OFFSET " . $config['offset'] . " LIMIT " . $config['limit'];
				
		//show($query,'query');
		$sth = $dbh->query($query);
	//	$sth = $config['auth']->dbh->query($query);
		
		$rekordy = $sth->fetchAll();
		$ile = count($rekordy);
		
		if (!$ile)
			$out .= '<p><b>' . $constants['nothing_found'] . '</b><br /><hr size="1" color="gainsboro"></p>';
		else 
			$out .= '<p class="text"><b>' . $constants['found'] . $ile . $constants['terms'] . '</b></p>';
		
		foreach($rekordy as $i => $rekord)
			if ($config['sl_nolimit'] || $i < $config['limit']) {
				$out .= '<dt class="selecttext"><hr size="1" color="gainsboro"><em>' . $rekord['term'] . '</em></dt>';
				$out .= '<dd class="text">' . $rekord['definition'] . '</dd>';
			}
		$out .= '</dl>';
		// link "pokaz wszystkie"
		if ($i + 1 <= $ile && !$config['sl_nolimit'])
			$out .= "<br /><div style=\"text-align:right\"><a href=\"index.php?search_key=" . $config['search_key'] . "&amp;sl_db_type=" . $config['sl_db_type'] . "&amp;sl_nolimit=1\"><b>" . $constants['show_all'] . "</b></a></div>";
			
		$out .= "<br />";
	 return $out;
}// pokaz_slownik

// walidacja wejscia z GET i POST
function secure_input($klucz, $input_string) {

		$input_variables = array(
			'loginform_username' => array('type' => 'login', 'maxlength' => 32),
			'loginform_userpass' => array('type' => 'login', 'maxlength' => 32),
			'authlogin'			=> array('type' => 'login', 'maxlength' => 12),
			'authpasswd'			=> array('type' => 'password', 'maxlength' => 32),
			'search'			=> array('type' => 'string', 'maxlength' => 96),
			'ssid'				=> array('type' => 'ssid', 'maxlength' => 24),
			'page'				=> array('type' => 'alfa', 'maxlength' => 24),
			'id'				=> array('type' => 'integer', 'max' => 999999, 'min' => 0),
			'comment'			=> array('type' => 'string', 'maxlength' => 2048),
			'nickname'			=> array('type' => 'string', 'maxlength' => 64)
		);

 switch($input_variables[$klucz]['type']) {
 	case 'integer':	$out = intval($input_string);
		   		if (isset($input_variables[$klucz]['max']) && $out > $input_variables[$klucz]['max'])
		   			$out = $input_variables[$klucz]['max'];
				if (isset($input_variables[$klucz]['min']) && $out < $input_variables[$klucz]['min'])
					$out = $input_variables[$klucz]['min'];
				break;
	case 'login':	
				if (!preg_match("/^\w+$/", $input_string)) $input_string = '';
				$out = htmlspecialchars(pg_escape_string(substr($input_string, 0, $input_variables[$klucz]['maxlength'])));
				break;

	default: $out = htmlspecialchars(pg_escape_string(mb_substr($input_string, 0, $input_variables[$klucz]['maxlength'])));
 }
 return $out;
}

// generowanie paska nawigacyjnego do paginacji publikacji
function pagingMenu($config = array()) {
	global $constants;
	
	$default_config = array(
							'back_icon' 		=> '<img src="img/back.gif" width="5" height="9" alt="&lt;" border="0" />',
							'forward_icon' 		=> '<img src="img/forward.gif" width="5" height="9" alt="&gt;" border="0" />',
							'align'				=> "right",
							'max_showed'		=> 5,			// ilosc numerkow stron
							'separator'			=> "&nbsp;|&nbsp;",
							'wrap'				=> "<div style=\"text-align:right\">|</div><br />",
							);
	$config = array_merge($default_config, $config);
	$links = array();
	$buttons = array();
	
	$request = $_SERVER['REQUEST_URI'];
	$request = preg_replace("/\x26pageno=\d*/","", $request);
	$request = preg_replace("/\x26type=[^\x26]*/","", $request);
	$links['first'] = $request . "&amp;type=" . $config['art_type'] . "&amp;pageno=1#" . $config['art_type'] . "\" title=\"" . $constants['first_page'] . "\"";
	$links['prev'] = $request . "&amp;type=" . $config['art_type'] . "&amp;pageno=" . $config['pubs']['prev'] . "#" . $config['art_type'] . "\" title=\"" . $constants['prev_page'] . "\"";
	$links['next'] = $request . "&amp;type=" . $config['art_type'] . "&amp;pageno=" . $config['pubs']['next'] . "#" . $config['art_type'] . "\" title=\"" . $constants['next_page'] . "\"";
	$links['last'] = $request . "&amp;type=" . $config['art_type'] . "&amp;pageno=" . $config['pubs']['last'] . "#" . $config['art_type'] . "\" title=\"" . $constants['last_page'] . "\"";
	if ($config['pubs']['page'] > 1) {
		$buttons['first'] = $config['back_icon'] . $config['back_icon'] . "&nbsp;";
		$buttons['prev'] = $config['back_icon'] . "&nbsp;&nbsp;&nbsp;";	
	}
	
	// numery stron
	$buttons_tmp = array();
	$range = ($config['max_showed'] - 1) / 2;
	$numerki = array();
	$first = $config['pubs']['page'] - $range;
		if ($first <= 0) $first = 1;
	$last = $config['pubs']['page'] + $range;
		if ($last >= $config['pubs']['pages']) $last = $config['pubs']['pages']; 
	for($p = $first; $p <= $last; $p++) {
		$buttons_tmp['num' . $p] = $p;
		if ($p != $config['pubs']['page'])
			$links['num' . $p] = $request . "&amp;type=" . $config['art_type'] . "&amp;pageno=$p#" . $config['art_type'] . "\" title=\"" . $constants['go_to_page'] . "$p\"";
		else
			$buttons_tmp['num' . $p] = "<b>" . $buttons_tmp['num' . $p] . "</b>";
		$buttons_tmp[] = $config['separator'];
	}
	
	array_pop($buttons_tmp);
	$buttons = array_merge($buttons, $buttons_tmp);
	
	if ($config['pubs']['page'] < $config['pubs']['pages']) {
		$buttons['next'] = "&nbsp;&nbsp;&nbsp;" . $config['forward_icon'] . "&nbsp;";
		$buttons['last'] = $config['forward_icon'] . $config['forward_icon'];
	}
	
	// zamien na linki
	foreach($buttons as $key => $button)
		if (array_key_exists($key, $links) && $links[$key])
			$buttons[$key] = "<a href=\"" . $links[$key] . ">$button</a>";

	$out = implode("&nbsp;", $buttons);
			
	if ($config['wrap'])
		$out = str_replace("|", $out, $config['wrap']);
		
	return $out;
}// function pagingMenu

// array_fill_keys
if (! function_exists("array_fill_keys")) {
    function array_fill_keys(array $keys, $value) {
        return array_combine($keys, array_fill(0, count($keys), $value));
    }
}

// czyszczenie tresci dla uzyskania lepszej zgodnosci z XHTML
function xhtml_clean($str) {
	if (is_string($str)) {
		$str = preg_replace("/<BR>/", "<br />", $str);
		$str = preg_replace("/<HR>/", "<hr />", $str);
	}
	
	return $str;
}

// lamanie dlugich slow w stringu
function breakLongWords($str, $maxLen = 80, $breakingChar = '\n') {
	return preg_replace('/(\S{' . $maxLen . '})/', '${1}<br />'/* . $breakingChar*/, $str);	
}

// zapis wywolania do logu tekstowego
function writeLog($co = '') {
	$server_name = str_replace("www.www.", "www.", "www." . $_SERVER['SERVER_NAME']);
	$logf = fopen('/data/web/logs/' . $server_name . date("/Y.n.j"),"a");
	if (!strlen($co))
		$co = implode("\t",array(	date("g:i:s"),
									$_SERVER['PHP_SELF'],
									(array_key_exists('username',$_SESSION)?$_SESSION['username']:""),
									array_key_exists('HTTP_REFERER', $_SERVER)?$_SERVER['HTTP_REFERER']:'',
									$_SERVER['HTTP_USER_AGENT'],
									$_SERVER['REMOTE_ADDR']));
	fwrite($logf, $co . "\n");
	fclose($logf);
}

// dopisanie otwieranych podstron do bazy				
function register_page($dbh, $serwis, $page_arr) {
	
	// interesuja nas tylko pola z tabeli pages			
	$pola = array("serwis","page","template","menu","authorize","last_access","access_counter","parent","hidden");
	foreach($page_arr as $pole => $wart)
		if (!in_array($pole, $pola))
			unset($page_arr[$pole]);
	$page_arr['serwis'] = $serwis;

	// przygotuj dane dla zapytania
	foreach($page_arr as $key => $val)
			if (!is_numeric($val))
				if (is_bool($val))
					$page_arr[$key] = $val?"'TRUE'":"'FALSE'";
				else
					$page_arr[$key] = "'$val'";
				
	
	$query = "SELECT " . implode(",", $pola) 
				. " FROM main_pages
				WHERE serwis='$serwis' AND page=" . $page_arr['page'];
	$result = $dbh->query($query);
		
	if (is_array($db_page = $result->fetch())) {	// strona juz zarejestrowana
		$page_arr['last_access'] = "NOW()";	// default NOW()
		$page_arr['access_counter'] = $db_page['access_counter'] + 1;
		foreach($page_arr as $key => $val)
			$page_arr[$key] = "$key=$val";  
		$query = "UPDATE main_pages SET " . implode(",", $page_arr)
				. " WHERE serwis='$serwis' AND " . $page_arr['page'];	
	}
	else // strona jeszcze nie zarejestrowana
		$query = "INSERT INTO main_pages (" . implode(",", array_keys($page_arr)) . ", access_counter) VALUES (" . implode(",", $page_arr) . ",1)";
	return $dbh->exec($query);
}

// opakowania obiektu HTML (znacznik '|') w kod HTML
function htmlWrap($co, $opakowanie) {
	if (strpos($opakowanie, "|") === false)
		$opakowanie .= "|";
	return preg_replace("/\|/", $co, $opakowanie);	
}

// przekierowanie na dany url
function redirect($url, $die = false) {
	header("Location: $url");
	echo "<html><head><meta HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; " . $constants['charset'] . "\"></head>
			    <body>
			    <script language=\"Javascript\">
				    window.open('$url','_self');
			    </script>
			    " . $constants['redirect_failed'] . "<a href=\"$url\">" . $constants['click2redirect'] . "$url</a>
		    </body></html>";	
	if ($die) die();
}

// Pobranie naglowka z tabeli main_heads
//
function getHead($klucz = '') {
	global $dbh;
	$sql_query = "SELECT head FROM main_heads WHERE head_code='$klucz' ORDER BY last_changed DESC LIMIT 1";
	$sth = $dbh->query($sql_query);
	if ($result = $sth->fetch())
		return $result['head'];
	else
		return false;
}
//
//
// opakowuje string lub elementy tablicy w string
function wrap($content, $wrapper) {
    if (is_array($content)) {
	$out = array();
	foreach($content as $k => $v)
		$out[$k] = wrap($v, $wrapper);
	return $out;
   }
	
    if (strlen($wrapper))
        return str_replace("|", $content, $wrapper);
    else return $content;
}
// opakowuje kazdy element tablicy w inny wrapper
function array_wrap($content_arr, $wrapper_arr) {
   if (is_array($content)) {
	$out = array();
	foreach($content as $k => $v)
		$out[$k] = wrap($v, $wrapper_arr[$k]);
	return $out;
   }
   else
	return false;
}
// zwraca element poprzedzajacy opakowania
function open_wrap($wrap) {
        $wrap = explode("|", $wrap);
        if (count($wrap) == 2)
                return $wrap[0];
        else return "";
}
// zwraca element koncowy opakowania
function close_wrap($wrap) {
        $wrap = explode("|", $wrap);
        if (count($wrap) == 2)
                return $wrap[1];
        else return "";
}

// konwersja daty na postgresowy DATE...
function date2Pg($date) {
	$time = mktime(0,0,0, intval(substr($date, 3, 2)), intval(substr($date, 0, 2)), intval(substr($date, 6, 4)));
	return date("Y-m-d", $time);
}
// ...i odwrotnie
function datefromPg($date) {
	$time = mktime(0,0,0, intval(substr($date, 5, 2)), intval(substr($date, 8, 2)), intval(substr($date, 0, 4)));
	return date("d.m.Y", $time);
}

// usuwa klucze numeryczne z tablicy
function noNumericKeys($arr) {
    $out_arr = array();
    foreach($arr as $k => $v)
	if (!is_numeric($k))
	    $out_arr[$k] = $arr[$k];
    return $out_arr;
}// function noNumericKeys


// czy aktualny klient jest na liscie "testers"
function isCorporateUser() {
	global $corporate_users;
	//echo $_SERVER['REMOTE_ADDR'];
	return in_array($_SERVER['REMOTE_ADDR'],$corporate_users);
}

// pobiera czas z dokladnoscia do milisekund
function getmicrotime(){ 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
}

// pobiera liste dostepnych specjalnosci
function getSpecsDict() {
	global $dict_spec;
	global $dbh;
	
	if (!is_array($dict_spec)) {
		$dict_spec = array();
		
		$query = "SELECT spec_code AS code, mdm_name AS name FROM dict_spec ORDER BY mdm_name";	//docelowo dict_spec2
		$result = $dbh->query($query);
		while($row = $result->fetch())
			$dict_spec[$row['code']] = $row['name'];
	}
	
	return $dict_spec;
}// function getSpecsDict

// pobiera liste dostepnych webpage'ow
function getWebpagesDict() {
	global $dict_webpage;
	global $dbh;
	
	if (!is_array($dict_webpage)) {
		$dict_webpage = array();
		
		$query = "SELECT webpage_code AS code, webpage_name AS name FROM dict_webpages ORDER BY webpage_name";
		$result = $dbh->query($query);
		while($row = $result->fetch())
			$dict_webpage[$row['code']] = $row['name'];
	}
	
	return $dict_webpage;
}// function getSpecsDict

// pobiera slownik typow publikacji
function getTypesDict($content_class, $wybierz = false) {
	global $dict_publ_type;
	global $dbh;
	
	if (!is_array($dict_publ_type))
		$dict_publ_type = array();
	
	if ($wybierz || !array_key_exists($content_class, $dict_publ_type))	//is_array($dict_publ_type[$content_class])
	{
		if ($wybierz)
			$dict_publ_type[$content_class] = array(0 => "--- wybierz ---");
		else
			$dict_publ_type[$content_class] = array();
		
		switch($content_class) {
			case "news":	$query = "SELECT news_type_code AS code, news_type_name AS name FROM dict_news_type ORDER BY name";
					break;
			case "event":
					$query = "SELECT event_type_code AS code, event_type_name AS name FROM dict_event_type ORDER BY name";
					break;
			case "link":
					$query = "SELECT link_type_code AS code, link_type_name AS name FROM dict_link_type ORDER BY name";
					break;
			case "pub_old":
					$query = "SELECT publ_type_code AS code, name FROM dict_publ_type ORDER BY name";
					break;
			case "pub":
			default:
					$query = "SELECT publ_type_code AS code, name FROM dict_publ_type2 ORDER BY name";
					break;
	
		}
		
		$result = $dbh->query($query);
		
		while($row = $result->fetch())
			$dict_publ_type[$content_class][$row['code']] = $row['name'];
		
	}	
	return $dict_publ_type[$content_class];
}
//function getTypesDict

// pobiera liste czasopism
function getJournalDict() {
	global $dict_journal;
	global $dbh;
	
	if (!is_array($dict_journal)) {
		$dict_journal = array();
		
		$query = "SELECT * FROM main_journals WHERE status = 'VIS' ORDER BY title ASC";
		$result = $dbh->query($query);
			$dict_journal['0']= '---wybierz---';	
		while($row = $result->fetch())
	//		$dict_journal[$row['id_journal']] = $row;
		$dict_journal[$row['id_journal']] = $row['title'];
	}	
	return $dict_journal;
}// function getJournalDict


// pobiera liste kolekcji
function getCollectionDict($config = array('mode' => "", 'limit' => 0, 'cclass' => "")) {
	global $dict_collection;
	global $benchmark;
	global $dbh;
	
	$benchmark->start("getCollectionDict()");
	
	/*if (!is_array($dict_collection)) {
		$dict_collection = array();*/
	//$dbh_portal = dbconnect("portal", "UTF8");
	//$dbh_portal = $dbh;

	switch ($config['mode']) {
		
	case 'count':	// tylko o liczebnosci > 0,  z podaniem liczebnosci
		
		$query = "SELECT mc.id_kolekcji, mc.collection_id, count(*) AS licznosc
				FROM main_collection AS mc, rel_collection AS rc
				WHERE mc.id_kolekcji=rc.id_kolekcji
				AND mc.active=true
				GROUP BY mc.id_kolekcji, mc.collection_id
				ORDER BY mc.collection_id ASC";
		if ($config['limit'])
			$query .= " LIMIT " . $config['limit'];
		$result = $dbh->query($query);
		while($row = $result->fetch())
			$dict_collection[$row['id_kolekcji']] = $row;
		
		$last_path = array();
		$last_levels = 0;
		$out = "";
		foreach($dict_collection as $id_kolekcji => $kolekcja) {
			$path = explode("###", $kolekcja['collection_id']);
			array_pop($path);
			$levels = count($path);
			
			// zamykamy tagi
			if ($out) {
				$diff = "";
				for($level = $last_levels - 1; $level >= 0; $level--)
					if (!array_key_exists($level, $path) || !array_key_exists($level, $last_path) || $path[$level] != $last_path[$level])
						$diff .= str_repeat("\t", $level) . "</item>";
				$out .= $diff;
			}
			
			// otwieramy tagi
			for($level = 0; $level < $levels; $level++)
				if ($path[$level] != $last_path[$level])
					$out .= /*"($levels)" . $kolekcja['collection_id'] . "\n" .*/ str_repeat("\t", $level)
						. "<item text=\"" . $path[$level] . (($level == $levels - 1)?" (" . $kolekcja['licznosc'] . ")":"") . "\" id=\"" . (($level == $levels - 1)?"k" . $id_kolekcji:$id_kolekcji . "_" . $level)
						. "\" im0=\"" . (($level == $levels - 1)?"leaf":"book") . ".gif\" im1=\"books_open.gif\" im2=\"books_close.gif\" >";
			
			$last_path = $path;
			$last_levels = $levels;
		}
		// zamykamy ostatnie tagi
		for($level = $levels - 1; $level >= 0; $level--)
			$out .= str_repeat("\t", $level) . "</item>";
		
		$benchmark->stop("getCollectionDict()");
		
		//return wrap($out, "<?xml version='1.0' encoding='utf-8'//\n<tree id=\"0\">\n|</tree>");
		return wrap($out, "<tree id=\"0\">|</tree>");
		break;
	case 'AdubyTree':
		$query = "SELECT * FROM main_collection WHERE active=true ORDER BY collection_id ASC";
		if ($config['limit'])
			$query .= " LIMIT " . $config['limit'];
		$result = $dbh->query($query);
		while($row = $result->fetch())
			$dict_collection[$row['id_kolekcji']] = $row;
		
		$last_path = array();
		$last_levels = 0;
		$out = "";
		foreach($dict_collection as $id_kolekcji => $kolekcja) {
			$path = explode("###", $kolekcja['collection_id']);
			array_pop($path);
			$levels = count($path);
			
			// zamykamy tagi
			if ($out) {
				$diff = "";
				for($level = $last_levels - 1; $level >= 0; $level--)
					if (!array_key_exists($level, $path) || !array_key_exists($level, $last_path) || $path[$level] != $last_path[$level])
						$diff .= /*str_repeat("\t", $level) .*/ "</children></node>";
				$out .= $diff;
			}
			
			// otwieramy tagi
			for($level = 0; $level < $levels; $level++)
				if ($path[$level] != $last_path[$level])
					$out .= /*"($levels)" . $kolekcja['collection_id'] . "\n" . str_repeat("\t", $level)*/
						"<node><id>" . (($level == $levels - 1)?"k" . $id_kolekcji:$id_kolekcji . "_" . $level) . "</id><data>" . $path[$level] . "</data><children>";
						//. "<node><id>" . (($level == $levels - 1)?"k" . $id_kolekcji:$id_kolekcji . "_" . $level) . "</id><data>x</data><children>";
			
			$last_path = $path;
			$last_levels = $levels;
		}
		// zamykamy ostatnie tagi
		for($level = $levels - 1; $level >= 0; $level--)
			$out .= /*str_repeat("\t", $level) .*/ "</children></node>";
		
		$out = str_replace("<children></children>","", $out);
				   		
		$benchmark->stop("getCollectionDict()");
		
		//return wrap($out, "<?xml version='1.0' encoding='utf-8'//\n<tree id=\"0\">\n|</tree>");
		return $out; //wrap($out, "<node>|</node>");
		break;
		
	case 'all':
	default:
		
		$cclass = $config['cclass'] ? " AND type='" . $config['cclass'] . "'" : "";
		
		
		$query = "SELECT * FROM main_collection WHERE active=true $cclass ORDER BY collection_id ASC";
		if ($config['limit'])
			$query .= " LIMIT " . $config['limit'];
		$result = $dbh->query($query);
		while($row = $result->fetch()) {
			$dict_collection[$row['id_kolekcji']] = $row;
		}
		
		//show($dict_collection);
		
		$last_path = array();
		$last_levels = 0;
		$out = "";
		foreach($dict_collection as $id_kolekcji => $kolekcja) {
			$path = explode("###", $kolekcja['collection_id']);
			array_pop($path);	//pusty elt
			$levels = count($path);
			
			// zamykamy tagi
			if ($out) {
				$diff = "";
				//for($level = $last_levels - 1; $level >= 0; $level--)
				$trunk_change = false;
				for($level = 0; $level <= $last_levels - 1; $level++) {
					$trunk_change = $trunk_change || ($path[$level] != $last_path[$level]);
					if ($trunk_change || !array_key_exists($level, $path) || !array_key_exists($level, $last_path))
						$diff .= str_repeat("\t", $level) . "</item>";
				}
				$out .= $diff;
			}
			
			// otwieramy tagi
			$trunk_change = false;
			for($level = 0; $level < $levels; $level++) {
				$trunk_change = $trunk_change || ($path[$level] != $last_path[$level]);
				if ($trunk_change || $path[$level] != $last_path[$level])
					$out .= /*"($levels)" . $kolekcja['collection_id'] . "\n" .*/ str_repeat("\t", $level)
						. "<item text=\"" . $path[$level] . "\" id=\"" . (($level == $levels - 1)?"k" . $id_kolekcji:$id_kolekcji . "_" . $level)
						. "\" im0=\"" . (($level == $levels - 1)?"leaf":"book") . ".gif\" im1=\"books_open.gif\" im2=\"books_close.gif\" >";
			}
			
			$last_path = $path;
			$last_levels = $levels;
		}
		// zamykamy ostatnie tagi
		for($level = $levels - 1; $level >= 0; $level--)
			$out .= str_repeat("\t", $level) . "</item>";
		
		$benchmark->stop("getCollectionDict()");
		
		//return wrap($out, "<?xml version='1.0' encoding='utf-8'//\n<tree id=\"0\">\n|</tree>");
		return wrap($out, "<tree id=\"0\">|</tree>");
		break;
	}//switch
	$benchmark->stop("getCollectionDict()");
	
	return $dict_collection;

		
}// function getCollectionDict


// obcina string dodajac wielokropek w razie potrzeby
function tnij($str, $len) {
	$str2 = substr($str, 0, $len);
	if (strlen($str) > strlen($str2))
		$str2 .= "...";
	return $str2;
}

// pobranie maksymalnej wartosci pola news_order - dla wstecznej zgodnosci
function getMaxNewsOrder() {
	global $dbh;
	$query = "SELECT MAX(news_order) AS max FROM main_news";
	$sth = $dbh->query($query);
	if ($sth)
		$row = $sth->fetch();
	return $row['max'];
}
	
?>
