<?php

require_once 'abstractTable.class.php';

/**
 * 
 * Tabela glowna tresci
 * @author sroszczyk
 *
 */
class main_content extends abstractTable
{
    protected $table = 'esculap.main_content';
    protected $related = array(
        'main_content_album' => array('type'=>'child'),
    	'main_content_movie' => array('type'=>'child'),
        'rel_content_spec' => array('type'=>'child', 'natural'=>'content_id'),
        'main_content_comment' => array('type'=>'child'),
    	'main_content_rate' => array('type'=>'child'),
    	'main_content_reveal' => array('type'=>'child'),
    	'rel_content_collection' => array('type'=>'child', 'natural'=>'content_id'),
    );
    //protected $save_model = true;
    
    /**
     * Zapisuje specjalizacje
     * @param string/array lista specjalizacji
     */
    public function saveSpecs()
    {
        $num = func_num_args();
	    $args = func_get_args();
	    
	    if($num==1 && is_array($args[0])){
	        $num = count($args[0]);
	        $args = $args[0];
	    }
	    
	    $specs = $this->getChilds('rel_content_spec')->getListObject();
	    
        //Usuwamy zbedne rekordy
        if(is_array($specs))
            foreach($specs as $RCS){
                $del = true;
                if(is_array($args))
                    foreach($args as $spec_code)
                        if($RCS->getField('spec_code')==$spec_code)
                            $del = false;
                if($del)
                    $RCS->deleteItem();
            }
        
        //Dodawanie nowych i edycja
        if(is_array($args))
            foreach($args as $spec_code){
                $save = true;
                if(is_array($specs))
                    foreach($specs as $RCS)
                        if($RCS->getField('spec_code')==$spec_code)
                            $save = false;
                if($save){
                    $RCS = new rel_content_spec();
                    $RCS->setField('content_id', $this->getField('content_id'));
                    $RCS->setField('spec_code', $spec_code);
                    $RCS->saveItem();
                }
            }
    }
    
    /**
     * Zapisuje kolekcje
     * @param integer/array lista kolekcji
     */
    public function saveCollections()
    {
        $num = func_num_args();
	    $args = func_get_args();
	    
	    if($num==1 && is_array($args[0])){
	        $num = count($args[0]);
	        $args = $args[0];
	    }
	    
        $coll = $this->getChilds('rel_content_collection')->getListObject();
	    
        //Usuwamy zbedne rekordy
        if(is_array($coll))
            foreach($coll as $RCC){
                $del = true;
                if(is_array($args))
                    foreach($args as $collection_id)
                        if($RCC->getField('collection_id')==$collection_id)
                            $del = false;
                if($del)
                    $RCC->deleteItem();
            }
        
        //Dodawanie nowych i edycja
        if(is_array($args))
            foreach($args as $collection_id){
                $save = true;
                if(is_array($coll))
                    foreach($coll as $RCC)
                        if($RCC->getField('collection_id')==$collection_id)
                            $save = false;
                if($save){
                    $RCC = new rel_content_collection();
                    $RCC->setField('content_id', $this->getField('content_id'));
                    $RCC->setField('collection_id', $collection_id);
                    $RCC->saveItem();
                }
            }
    }
}

/**
 * 
 * Polaczenie pomiedzy tresciami a specjalizacjami
 * @author sroszczyk
 *
 */
class rel_content_spec extends abstractTable
{
    protected $table = 'esculap.rel_content_spec';
    protected $related = array(
        'main_content' => array('type'=>'parent', 'natural'=>'content_id'),
    	'dict_spec' => array('type'=>'parent', 'natural'=>'spec_code'),
    );
    //protected $save_model = true;
}

/**
 * 
 * Specjalizacje
 * @author sroszczyk
 *
 */
require_once 'dict_spec.tab.php';

/**
 * 
 * Komentarze do tresci
 * @author sroszczyk
 *
 */
class main_content_comment extends abstractTable
{
    protected $table = 'esculap.main_content_comment';
    protected $related = array(
        'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    );
}

/**
 * 
 * Ocena tresci
 * @author sroszczyk
 *
 */
class main_content_rate extends abstractTable
{
    protected $table = 'esculap.main_content_rate';
    protected $related = array(
        'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    );
}

/**
 * 
 * Odslony tresci
 * @author sroszczyk
 *
 */
class main_content_reveal extends abstractTable
{
    protected $table = 'esculap.main_content_reveal';
    protected $related = array(
        'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    );
}

/**
 * 
 * Kolekcje
 * @author sroszczyk
 *
 */
class main_content_collection extends abstractTable
{
    protected $table = 'esculap.main_content_collection';
    protected $related = array(
        'rel_content_collection' => array('type'=>'child', 'natural'=>'collection_id'),
    );
}

/**
 * 
 * Polaczenie tresci z kolekcjami
 * @author sroszczyk
 *
 */
class rel_content_collection extends abstractTable
{
    protected $table = 'esculap.rel_content_collection';
    protected $related = array(
        'main_content' => array('type'=>'parent', 'natural'=>'content_id'),
        'main_content_collection' => array('type'=>'parent', 'natural'=>'collection_id'),
    );
}

/**
 * 
 * Typ tresci album
 * @author sroszczyk
 *
 */
class main_content_album extends abstractTable
{
    protected $table = 'esculap.main_content_album';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
        'main_content_movie' => array('type'=>'child', 'from'=>array('content_id', 'lang_id'), 'to'=>array('album_id', 'lang_id')),
    );
    //protected $save_model = true;
}

/**
 * 
 * Typ tresci dla filmu
 * @author sroszczyk
 *
 */
class main_content_movie extends abstractTable
{
    protected $table = 'esculap.main_content_movie';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    	'main_content_album' => array('type'=>'parent', 'from'=>array('album_id', 'lang_id'), 'to'=>array('content_id', 'lang_id')),
        'main_content_movie_stream' => array('type'=>'child'),
    	'main_content_movie_thumb' => array('type'=>'child'),
    );
    //protected $save_model = true;
    
    /**
     * Zapisuje strumienie
     * @param array $data
     */
    public function saveStreams($data = null)
    {
        $streams = $this->getChilds('main_content_movie_stream')->getListObject();
        
        //Usuwamy zbedne rekordy
        if(is_array($streams))
            foreach($streams as $MCMS){
                $del = true;
                if(is_array($data))
                    foreach($data as $stream)
                        if($MCMS->getField('stream_id')==$stream['stream_id'])
                            $del = false;
                if($del)
                    $MCMS->deleteItem();
            }
        
        //Dodawanie nowych i edycja
        if(is_array($data))
            foreach($data as $stream){
                if($stream['stream_id']){
                    $MCMS = new main_content_movie_stream($stream['stream_id']);
                }else{
                    $MCMS = new main_content_movie_stream();
                    $MCMS->setField('content_id', $this->getField('content_id'));
                    $MCMS->setField('lang_id', $this->getField('lang_id'));
                }
                $MCMS->debug();
                $MCMS->setField('protocol', $stream['protocol']);
                $MCMS->setField('stream', $stream['stream']);
                $MCMS->setField('bitrate', $stream['bitrate']);
                $MCMS->setField('dimension', $stream['dimension']);
                $MCMS->saveItem();
            }
    }
    
    /**
     * Zapisuje miniaturki
     * @param array $data
     */
    public function saveThumbs($data)
    {
        $thumbs = $this->getChilds('main_content_movie_thumb')->getListObject();
        
        //Usuwamy zbedne rekordy
        if(is_array($thumbs))
            foreach($thumbs as $MCMT){
                $del = true;
                if(is_array($data))
                    foreach($data as $stream)
                        if($MCMT->getField('thumb_id')==$stream['thumb_id'])
                            $del = false;
                if($del)
                    $MCMT->deleteItem();
            }
        
        //Dodawanie nowych i edycja
        if(is_array($data))
            foreach($data as $stream){
                if($stream['thumb_id']){
                    $MCMT = new main_content_movie_thumb($stream['thumb_id']);
                }else{
                    $MCMT = new main_content_movie_thumb();
                    $MCMT->setField('content_id', $this->getField('content_id'));
                    $MCMT->setField('lang_id', $this->getField('lang_id'));
                }
                $MCMT->debug();
                $MCMT->setField('name', $stream['name']);
                $MCMT->setField('dimension', $stream['dimension']);
                $MCMT->saveItem();
            }
    }
}

/**
 * 
 * Rozszerzenie danych filmow
 * @author sroszczyk
 *
 */
class main_content_movie_stream extends abstractTable
{
    protected $table = 'esculap.main_content_movie_stream';
    protected $related = array(
        'main_content_movie' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    );
}

/**
 * 
 * Rozszerzenie danych filmow
 * @author sroszczyk
 *
 */
class main_content_movie_thumb extends abstractTable
{
    protected $table = 'esculap.main_content_movie_thumb';
    protected $related = array(
        'main_content_movie' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id')),
    );
}

/**
 * 
 * Typ tresci news
 * @author sroszczyk
 *
 */
class main_content_news extends abstractTable
{
    protected $table = 'esculap.main_content_news';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id'))
    );
    //protected $save_model = true;
}

/**
 * 
 * Typ tresci news
 * @author sroszczyk
 *
 */
class main_content_publ extends abstractTable
{
    protected $table = 'esculap.main_content_publ';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id'))
    );
    //protected $save_model = true;
}

/**
 * 
 * Typ tresci news
 * @author sroszczyk
 *
 */
class main_content_event extends abstractTable
{
    protected $table = 'esculap.main_content_event';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id'))
    );
    //protected $save_model = true;
}

/**
 * 
 * Typ tresci news
 * @author sroszczyk
 *
 */
class main_content_section extends abstractTable
{
    protected $table = 'esculap.main_content_section';
    protected $related = array(
    	'main_content' => array('type'=>'parent', 'natural'=>array('content_id', 'lang_id'))
    );
    //protected $save_model = true;
}

/**
 * 
 * Enter description here ...
 * @author sroszczyk
 *
 */
class avatar_type extends abstractTable{
    protected $table = 'esculap.dict_image_avatar_type';
}

/**
 * 
 * Enter description here ...
 * @author sroszczyk
 *
 */
class avatar extends abstractTable{
    protected $table = 'esculap.main_image_avatar';
}