<?php

/******************************************************************************
 *                                                                            *
 *      Klasa obsługująca płatności                                           *
 *      @category data                                                        *
 *      @author Sławek                                                        *
 *      UWAGA: używać w klasach poytomnych Controller.class.php               *
 *                                                                            *
 ******************************************************************************/

require_once('product.class.php');

class payment
{
    /** Uchwyt do bazy danych **/
    private $db;
    
    /** Zalogowany użytkownik **/
    private $user_login;
    
    /** Identyfikator **/
    private $id = null;
    
    /** Tryb działania **/
    private $manage = false;
    
    /**
     *  Konstruktor,
     *  @param string $user_login - login użytkownika, podawać tylko gdy inny niż wywołujący skrypt
     **/
    public function __construct($manage = false, $user_login = null)
    {
        global $db;
        $this->db = $db;
        $this->user_login = defined('CONTR_USER')?CONTR_USER:null;
        $this->manage = $manage;
    }
    
    /***************************************************************************
     *  Dodawanie płatności
     **************************************************************************/
    
    /**
     *  Tworzy lub otwiera nie zatwierdzoną płatność
     **/
    public function open()
    {
        $sql = "SELECT COUNT(1) FROM main_payments WHERE user_login='{$this->user_login}' AND is_ready=FALSE";
        if($this->db->getOne($sql)){
            $sql = "SELECT COUNT(1) FROM main_payments WHERE user_login='{$this->user_login}' AND is_ready=FALSE";
            $this->id = $this->db->getOne($sql);
        }else{
            $sql = "INSERT INTO main_payments (user_login) VALUES ('{$this->user_login}') RETURNING payment_id";
            $this->id = $this->db->getOne($sql);
        }
        return true;
    }
    
    /**
     *  Dodaje do płatności produkty
     *  @param mixed $product_id
     *  @param iteger $amount
     **/
    public function addProduct($product_id, $amount = 1)
    {
        if(!$this->id)
            return false;
        
        $product = new product();
        $data = $product->getItem($product_id);
        if(!$data)
            return false;
        
        $sql = <<< ESQUEL
INSERT INTO rel_payment_product 
(payment_id, product_id, amount, base_price, tax) 
VALUES 
('{$this->id}', '{$data['product_id']}', '{$amount}', '{$data['base_price']}', '{$data['tax']}')
ESQUEL;
        $res = $this->db->exec($sql);
        if($res) return true;
        return false;
    }
    
    /**
     *
     **/
    public function setReady()
    {
        if(!$this->id)
            return false;
        
        $sql = "UPDATE main_payments SET ready_date=NOW(), is_ready=TRUE WHERE payment_id='{$this->id}'";
        $this->id = null;
        return true;
    }
    
    /**
     *  Zwraca identyfikator otwartej płatności
     **/
    public function returnId()
    {
        return $this->id;
    }
    
    /**
     *  Sprawdza czy płatność zapłacono
     **/
    public function isPaid($payment_id)
    {
        $sql = "SELECT COUNT(1) FROM main_payments WHERE payment_id=$payment_id AND IS_paid=TRUE";
        if($this->db->getOne($sql))
            return true;
        return false;
    }
    
    /***************************************************************************
     *  Obsługa płatności (panel użytkownika, CMS)
     **************************************************************************/
    
    /**
     *  pobiera płatności
     **/
    public function getItem()
    {
        
    }
    
    /**
     *  Pobiera płatności
     **/
    public function getItems()
    {
        
    }
    
    /**
     *  
     **/
    public function setPaid()
    {
        if(!$this->id)
            return false;
        
        $sql = "UPDATE main_payments SET pay_date=NOW(), is_paid=TRUE WHERE payment_id='{$this->id}'";
        $this->id = null;
        return true;
    }
}

?>