<?php

require_once 'model/phrase.tab.php';

/**
 * 
 * Odczyt danych z slownika
 * @author sroszczyk
 *
 */
class phrase
{
    protected static $debug = true;
    
    /**
     * Pobiera i aktualizuje dane frazy
     * @param mixed $phrase_id identyfikator tekstowy lub liczbowy
     * @param string $lang_id kod jezyka
     * @param array $tags tagi do podmiany ('nazwa tagu'=>'wartosc')
     * @param array $defs wartosci domyslne ('kod jeyka'=>'wartosc')
     */
    public function get($phrase_id = null, $lang_id = null, $tags = null, $defs = null)
    {
        $output = '<!--undefined-->';
        if(!$lang_id) $lang_id = defined('CONTR_LANG')?CONTR_LANG:'PL';
        if(!is_array($tags)) $tags = array();
        if(!is_array($defs)) $defs = array();
        if(is_string($phrase_id)){
            $phrase = new main_phrase();
            $phrase->addCondition('text_id', '=', $phrase_id, 'LOWER');
            $phrase->search();
            if($phrase->getAmount()){
                $phrase->list2item();
                $phrase_id = $phrase->getField('phrase_id');
            }else{
                $phrase->clear();
                $phrase->setField('text_id', $phrase_id);
                $phrase->setField('tags', array_keys($tags));
                $phrase->saveItem();
                $phrase_id = $phrase->getField('phrase_id');
            }
        }else{
            $phrase = new main_phrase($phrase_id);
        }
        
        if(self::$debug){
            foreach($defs as $k=>$v){
                $value = new main_phrase_value($phrase_id, $k);
                if(!$value->exists()){
                    $value->setField('phrase_id', $phrase_id);
                    $value->setField('lang_id', $k);
                    $value->setField('value', $v);
                    $value->saveItem();
                }elseif($value->getField('value')==$output){
                    $value->setField('value', $v);
                    $value->saveItem();
                }
            }
        }
        
        $value = new main_phrase_value($phrase_id, $lang_id);
        if($value->exists()){
            $output = $value->getField('value');
        }else{
            $value->setField('phrase_id', $phrase_id);
            $value->setField('lang_id', $lang_id);
            $value->setField('value', $output);
            $value->saveItem();
        }
        
        foreach($tags as $k=>$v)
            $output = str_replace("<!--{$k}-->", $v, $output);
        
        //zmiany w tagach
        $old_tags = is_array($old_tags = $phrase->getField('tags'))?$old_tags:array();
        $new_tags = array_keys($tags);
        sort($old_tags);sort($new_tags);
        if(array_diff($new_tags, $old_tags)){
            $phrase->setField('tags', $new_tags);
            $phrase->saveItem();
        }
        
        if(self::$debug){
            if($output=='<!--undefined-->') 
                $output = 'Undefined:'.$phrase->getField('text_id').'('.$phrase_id.')';
        }
        
        return $output;
    }
}

?>