<?php

require_once('Functions/validation.php');
require_once('Mail/htmlMimeMail5Ext.php');

class quest
{
    /**
     *  Uchwyt do bazy
     **/
    private $db;
    
    /**
     *  tablica błędów
     **/
    public $errors = null;
    
    /**
     *  Konstruktor
     **/
    public function __construct()
    {
        global $db;
        $this->db = $db;
    }
    
    /**
     *  Dodanie pytania
     **/
    public function addQuest($user_login, $name, $email, $quest, $site_id = 'UNKNOWN', $emails_to = null)
    {
        if(!valid_email($email))
            $this->errors['email_not_valid'] = true;
        
        if(strlen($name)<5)
            $this->errors['name_to_short'] = true;
        
        if(strlen($quest)<10)
            $this->errors['quest_to_short'] = true;
        
        if($this->errors!=null)
            return false;
        
        $sql = "INSERT INTO main_quest(user_login, quest_author, quest_email, quest, site_code) ".
               "VALUES ('{$user_login}', '{$name}', '{$email}', '{$quest}', '{$site_id}')";
        $this->db->exec($sql);
        
        if(is_array($emails_to)){
            $mail = new htmlMimeMail5Ext();
            $mail->setSMTPParams('217.153.222.73');
            $mail->setHTMLCharset('UTF-8');
            $mail->setTextCharset('UTF-8');
            $mail->setHeadCharset('UTF-8');
            $mail->setFrom('Pytanie <esculap@esculap.pl>');
            $subject = "Otrzymano pytanie ze strony {$site_id}.";
            $mail->setSubject($subject);
            $text_content = "LOGIN: {$user_login}\nIMIE NAZWISKO: {$name}\nEMAIL: {$email}\n\n{$quest}";
            $mail->setText($text_content);
            $html_content = "<pre>LOGIN: {$user_login}\nIMIE NAZWISKO: {$name}\nEMAIL: {$email}\n\n{$quest}</pre>";
            $mail->setHTML($html_content);
            $result = $mail->send($emails_to, 'smtp');
        }
        return true;
    }
}

?>