<?php

/******************************************************************************
 *                                                                            *
 *      Klasa obsługująca sekcje                                              *
 *      Wymagana stala: CONTR_LANG (określa kod języka strony)                *
 *                                                                            *
 ******************************************************************************/

require_once('dimage.class.php');

class section
{
    /** Uchwyt do bazy danych **/
    private $db;
    
    /** Identyfikator holdera na sekcje **/
    private $holder_code = null;
    private $lang = CONTR_LANG;
    
    /** Zawartosc sekcji wczytana z bazy **/
    private $content = null;
    private $images = null;
    
    /** Takie tam flagi **/
    private $force_show;
    
    /** Tablica błędów **/
    //private $errors = null;
    
    /**
     *  Konstruktor, tworzy i ładuje holder dla sekcji
     *  @param string $holder_code - identyfikator holdera
     *  @param string $holder_name - nazwa holdera
     *  @param boolean $force_show - jeśli true to gdy nie bedzie odpowiedniej wersji językowej wyświetli domyślną
     **/
    public function __construct($holder_code, $holder_name = '', $force_show = false)
    {
        global $db;
        $this->db = $db;
        $this->holder_code = $holder_code;
        $this->force_show = $force_show;
        $this->saveHolder($holder_name);
        $this->loadHolder();
    }
    
    /**
     *  Wczytuje holder z bazy danych
     *  @return boolean - czy się powiodło
     **/
    private function loadHolder()
    {
        $sql = "SELECT COUNT(1) FROM main_sections_holders WHERE holder_code='{$this->holder_code}'";
        if($this->db->getOne($sql)==1){
            $sql = "SELECT section_id, section FROM main_sections WHERE holder_code='{$this->holder_code}' AND visible=true AND lang_id='{$this->lang}'";
            $row = $this->db->getRow($sql);
            if(!$row && $this->force_show){//Wyswietlamy oryginalny tekst (pierwszy dodany w grupie)
                $sql = "SELECT section_id, section FROM main_sections WHERE holder_code='{$this->holder_code}' AND visible=true AND parent_id IS NULL";
                $row = $this->db->getRow($sql);
            }
            $this->content = $row['section'];
            $dimage = new dimage();
            $this->images = $dimage->getRelatedImages('section', $row['section_id']);
            return true;
        }
        return false;
    }
    
    /**
     *  Zapisuje holder do bazy danych
     *  @param string $holder_name - nazwa holdera
     *  @return boolean - czy się powiodło
     **/
    private function saveHolder($holder_name = '')
    {
        $sql = "SELECT COUNT(1) FROM main_sections_holders WHERE holder_code='{$this->holder_code}'";
        if($this->db->getOne($sql)==0){
            $ins = null;
            $ins['holder_code'] = $this->holder_code;
            if(defined('SITE_ID'))
                $ins['site_id'] = SITE_ID;
            if($holder_name)
                $ins['holder_name'] = $holder_name;
            $fields = implode(',', array_keys($ins));
            $values = "'".implode("','", array_values($ins))."'";
            $sql = "INSERT INTO main_sections_holders ($fields) ".
                   "VALUES ($values)";
            $this->db->exec($sql);
            return true;
        }
        return false;
    }
    
    /**
     *  Zwraca zawartość sekcji
     *  @return string - zawartość sekcji
     **/
    public function getContent()
    {
        return $this->content;
    }
    
    /**
     *  Zwraca przywiązane grafiki
     **/
    public function getImages()
    {
        return $this->images;
    }
}

?>