<?php

require_once('Functions/sms.php');

class smsAction
{
    /** Uchwyt bazy danych **/
    private $db;
    
    /**
     *  Konstruktor, 
     **/
    public function __construct()
    {
        global $db;
        $this->db = $db;
    }
    
    /**
     *  Rejestruje odpowiedzi smsowe na akcje zdefiniowane w bazie
     **/
    public function register($sms_from, $sms_text, $sms_to, $sms_date)
    {
        if($sms_from==$sms_to)
            return;
        
        $sms_text = strtolower($sms_text);
        $action_id = null;
        
        if($action_id = $this->searchAction($sms_text)){
            if($this->searchKey($action_id, $sms_text)){
                if($this->activeAction($action_id)){
                    $status = 'OK';
                }else{
                    $status = 'TO_LATE';
                }
            }else{
                $status = 'BAD_KEY';
            }
        }else{
            $status = 'BAD_ACTION';
        }
        
        $ins = array();
        $ins['sms_from'] = $sms_from;
        $ins['sms_text'] = addslashes($sms_text);
        $ins['sms_to'] = $sms_to;
        $mode = preg_match('(664078111)', $sms_to)?3:2;
        $ins['sms_date'] = date('Y-m-d H:i:s', $sms_date);
        if($action_id)
            $ins['action_id'] = $action_id;
        if($status)
            $ins['status'] = $status;
        
        $sql = 'INSERT INTO cms.main_sms_response ('.implode(',', array_keys($ins)).') VALUES (\''.implode('\',\'', array_values($ins)).'\')';
        $this->db->exec($sql);
        
        if($status=='OK'){
            //Potwierdzenie
            send_sms($sms_from, 'Potwierdzamy poprawność smsa. Zgłoszenie zostało przyjęte.', $mode);
        }elseif($status=='TO_LATE'){
            //Akcja wyekspirowała
            send_sms($sms_from, 'Przepraszamy, podany kod jest już nie aktywny.', $mode);
        }else{
            //Coś nie tak
            send_sms($sms_from, 'Witamy serdecznie. Prosimy o sprawdzenie i odeslanie odpowiedzi w poprawnym formacie.', $mode);
        }
        
        return true;
    }
    
    /**
     *
     **/
    public function testCode($sms_text)
    {
        $sms_text = strtolower($sms_text);
        $action_id = null;
        
        if($action_id = $this->searchAction($sms_text)){
            if($this->searchKey($action_id, $sms_text)){
                if($this->activeAction($action_id)){
                    $status = 'OK';
                }else{
                    $status = 'TO_LATE';
                }
            }else{
                $status = 'BAD_KEY';
            }
        }else{
            $status = 'BAD_ACTION';
        }
        
        return $status;
    }
    
    public function searchAction($sms_text)
    {
        $sms_text = strtolower($sms_text);
        $action_id = null;
        
        $sth = $this->db->prepare("SELECT * FROM cms.main_sms WHERE start_date<NOW() ORDER BY start_date DESC");
        $sth->execute();
        while($result = $sth->fetch(PDO::FETCH_ASSOC)){
            $action_name = strtolower($result['code']);
            if(strpos($sms_text, $action_name)!==false){
                $text_tmp = str_replace($action_name, '&=&', $sms_text);
                if(preg_match('([a-zA-Z0-9]&=&)', $text_tmp) || preg_match('(&=&[a-zA-Z0-9])', $text_tmp))
                    continue;
                $action_id = $result['id'];
                break;
            }
        }
        
        return $action_id;
    }
    
    private function activeAction($action_id)
    {
        $sql = "SELECT COUNT(1) FROM cms.main_sms WHERE id='{$action_id}' AND (end_date>NOW() OR end_date IS NULL)";
        if($this->db->getOne($sql))
            return true;
        return false;
    }
    
    private function searchKey($action_id, $sms_text)
    {
        $data = $this->db->getRow("SELECT * FROM cms.main_sms WHERE id='{$action_id}'");
        $action_name = strtolower($data['code']);
        $regexp = $data['regexp'];
        
        $preg = "(^{$action_name}[. ]{$regexp}[. ]?$)";
        if($res = preg_match($preg, $sms_text)){
            return true;
        }
        
        return false;
    }
}

?>