<?php

require_once 'model/stuff_calendar.tab.php';
require_once 'dimage.class.php';

/**
 * 
 * Kalendarz
 * @author sroszczyk
 *
 */
class stuffCalendar
{
    protected $ctime = null;
    protected $iscms = false;
    
    public function __construct()
    {
        $this->ctime = time();
        if(defined('CMS_USAGE') && constant('CMS_USAGE')) $this->iscms = true;
    }
    
    /**
     * Zwraca dni tygodnia 
     * @param integer $iv okresla tydzien wzglredem obecnego tygodnia
     */
    public function getActualWeek($iv=0)
    {
        $t = $this->ctime+($iv*3600*24*7);
        $data = $this->getWeek($t);
        return $data;
    }
    
    /**
     * 
     */
    public function getYearWeek($week, $year = null)
    {
        $t = mktime(0, 0, 0, 1, $week*7+1, $year?$year:date('Y'));
        $data = $this->getWeek($t);
        return $data;
    }
    
    /**
     * 
     */
    protected function getWeek($t)
    {
        $sday = date('N', $t)-1;
        $data = array();
        for($i=0;$i<7;$i++){
            $dt = mktime(0, 0, 0, date('n', $t), date('j', $t)+$i-$sday, date('Y', $t));
            $data[$i] = array(
            	'time' => $dt, 
            	'day' => date('d', $dt),
            	'weekday' => date('N', $dt),
                'week' => date('W', $dt),
                'month' => date('m', $dt),
                'year' => date('Y', $dt)
            );
            if(is_array($tmp = $this->getDayData($dt))){
                $data[$i] = array_merge($data[$i], $tmp);
            }
        }
        return $data;
    }
    
    /**
     * Pobiera informacje o danym dniu
     * @param string/integer $data data YYYY-MM-DD lub timestamp
     */
    public function getDayData($data)
    {
        if(preg_match('([0-9]{4}-[0-9]{2}-[0-9]{2})', $data)){
            $day = $data;
        }elseif(is_numeric($data)){
            $day = date('Y-m-d', $data);
        }else{
            return null;
        }
        //pobieramy magicznie to co nam na dany dzień do arraya
        $SC = new stuff_calendar();
        $SC->addCondition('day', '=', $day);
        if(!$this->iscms)
            $SC->addCondition('active', '=', true);
        $SC->addOrder('id', true);
        $SC->search();
        $data = null;
        if($SC->list2item()){
            $data['title'] = $SC->getField('title');
            //$data['url'] = $SC->getField('url');
            $dimage = new dimage();
            $image = $dimage->getRelatedImages('calendar', $SC->getField('id'));
            $data['image'] = count($image)?$image[0]['image_name']:null;
            if($this->iscms){
                $data['id'] = $SC->getField('id');
                $data['active'] = $SC->getField('active');
            }
            $data = array_merge($data, is_array($tmp = $SC->getField('data'))?$tmp:array());
        }
        return $data;
    }
}

?>