<?php
// template.inc.php
//
// renderowanie templatow HTML
// by Cegedim Group Poland (mz) XII.2007
//
// aktualizacja 20.11.2008 by mz - dodanie metody importCSS()
// aktualizacja 12.12.2008 by mz - dodanie metody setTitle

class Template {
  
  public $blocks;			// bloki szablonu (placeholdery i bloki HTML)
  public $replace;			// tablica z kodem do wstawienia w szablon
  private $import_js;			// tablica plikow JS do zaimportowania
  private $import_css;			// tablica plikow CSS do zaimportowania
  private $title;			// zawartosc <title>
  private $keywords = array();		// <meta name="keywords"
  private $description;			// <meta name="description"
  
	public function __construct($template_file, $replace_links = false, $noJQuery = false, $noJavaScript = false) {
		$template_file = explode(",", $template_file);	// template moze byc zlozony z kilku plikow
		$root = $_SERVER['DOCUMENT_ROOT'] . "/";
	  	foreach($template_file as $filename)	
	  	  	$this->template .= file_get_contents($root . $filename);
  		// wyciecie tytulow templatow
	 	$this->template = preg_replace("/<!--\s*template\s*(\w*)\s*-->/","",$this->template);	//if (strpos($part_of_template, "<!-- template") === 0)	$part_of_template = trim(substr($part_of_template, strpos($part_of_template, "-->") + strlen("-->")));
  		
	 	// defaultowy kod JavaScript
		if(!$noJavaScript)
		  if ($noJQuery)
			$js = '	<!-- ###js_import_placeholder### -->
				  <!-- ###js_code_tagged_placeholder### -->
				  <script type="text/javascript">
				    <!-- ###js_code_placeholder### -->
				  </script>';
		  else
		    $js = '	<script type="text/javascript" src="/js/jquery.js"></script>
				  <!-- ###js_import_placeholder### -->
				  <script type="text/javascript">
				  $(document).ready(function() {<!-- ###js_code_placeholder### -->
				   });
				  </script>
				  <!-- ###js_code_tagged_placeholder### -->';
	 	
	 	// podmiana javascriptu z naglowka
	 	if (preg_match("/<head>(.*)<\/head>/s", $this->template, $matches)) {
	 	 	$head = preg_replace("/<script.*<\/script>/s","", $matches[1]) . "\n$js";
		 	$this->template = preg_replace("/<head>(.*)<\/head>/s","<head>$head\n</head>", $this->template);
	 	}
	 	$this->import_js = array();
		$this->import_css = array();		 	
	 	
		$this->replace = array('js_import_placeholder' => "", 'js_code_placeholder' => "", 'js_code_tagged_placeholder' => "");
		$this->nested_blocks = array();
		if ($replace_links)
			$this->template = $this->replace_links();
		$this->blocks = $this->parse($this->template);
	}
	
	// wstawia import pliku JS do szablonu
	public function importJavaScript($src) {
		$this->import_js[$src] = true;
	}
	// wstawia kod JS (zawierajacy tagi <script>) do szablonu
	public function insertJavaScriptTagged($code) {
		$this->replace['js_code_tagged_placeholder'] .= "\n$code";
	}
        // wstawia kod JS do szablonu
        public function insertJavaScript($code) {
		$this->replace['js_code_placeholder'] .= "\n$code";
	}
	// wstawia import pliku CSS do szablonu
	public function importCSS($src) {
		$this->import_css[$src] = true;
	}
	
	// dzieli szablon na bloki statyczne i do podmiany
	public function parse($template) {
		
		$znacznik_nl = "[*--znacznik n--*]";	// usuniecie znakow konca linii na czas przetwarzania
		$template = str_replace("\n", $znacznik_nl, $this->template);
		
		$blocks = array();
		
		// szukamy markerow ###
		preg_match_all('/<!--\s*###(\w+)/', $template, $markery);
		$markery = $markery[1];		//show($markery,'markery');
		
		// przed pierwszym markerem
		$blocks[] = substr($template, 0, strpos($template, "<!-- ###" . $markery[0])); 
			
		// szukamy blokow oznaczonych markerami
		foreach($markery as $marker) {
			$blocks[$marker] = "!!!";

			// marker otwierajaco-zamykajacy i statyczny blok HTML
			if (preg_match("/<!--\\s*###$marker###\\s*-->(.*?)(<!--\\s*###|$)/", $template, $matches)) {
				$blocks[$marker] = "";	// zawartosc bloku
				if (count($matches) > 1)	
					$blocks[] = $matches[1];	// po bloku jest blok statycznego HTML
			} else
				// marker otwierajacy, zamykajacy i statyczny blok HTML
				if (preg_match("/<!--\\s*###$marker\\s*-->(.*)<!--\\s*$marker###\\s*-->(.*?)(<!--\\s*###|$)/", $template, $matches)) {
					$blocks[$marker] = $matches[1];	// zawartosc bloku
					if (count($matches) > 2)	
						$blocks[] = $matches[2];	// po bloku jest blok statycznego HTML
				}
			//show(explode("****",htmlentities(implode("****",$matches))), '<br>matches ' . $marker);
		}
		foreach($blocks as $id => $block)
	 		$blocks[$id] = str_replace($znacznik_nl, "\n", $block);	//do testow: $blocks[$id] = nl2br(htmlentities(str_replace($znacznik_nl, "\n", $block)));
			
		//show($blocks,'blocks');
		return $blocks;  	
	}// function parse
	
	// poprzednia wersja metody parse, bez preg
	private function parse_old($template) {
		$tmp_blocks = array();
		$blocks = array();
		
		$tmp_blocks = explode('###',$template);
		
	 	foreach($tmp_blocks as $klucz => $blok) {
	 	  	$old_len = strlen($blok);
	 	  	// wyciecie znakow komentarza (separatorow)
			$blok = ltrim($blok," -->");
			$blok = rtrim($blok,"<!-- ");	 	  	
	 	  	$blok_len = strlen($blok);
	 	  	if ($blok_len == $old_len) {	// nie bylo znakow komentarza (separatorow)
	 	  		$tmp_arr = explode(" -->",$blok);
	  			$tag = $tmp_arr[0];
	  			if ($blok_len != strlen($tag)) { 	// jest znacznik otwierajacy i zamykajacy
	  				$starting = strlen("$tag -->");
	  				$ending = strlen("<!-- $tag");
	  				$blocks[$tag] = substr($blok, $starting, $blok_len - $starting - $ending); // zawartosc miedzy znacznikami
  				}
				else	// pojedynczy znacznik
	 	  			$blocks[$tag] = '';
	 	 	}
	 	 	else	// blok statyczny HTML
	 	 		$blocks[] = $blok;
	 	  }
	 	  
		return $blocks;  	
	}
	
	// podmienia odpowiednie elementy szablonu i scala calosc strony
	public function render($echo_output = false) {
		
		// zebranie importow JS
		foreach($this->import_js as $src => $nic)
			$this->replace['js_import_placeholder'] .= "\t<script type=\"text/javascript\" src=\"$src\"></script>\n";	// wstawia w headzie
		
		// zebranie importow CSS
		foreach($this->import_css as $src => $nic)
			$this->replace['js_import_placeholder'] .= "\t<link href=\"$src\" rel=\"stylesheet\" type=\"text/css\" />\n";	// wstawia tuz pod importami JS w headzie
					
		// zestawienie blokow w jeden ciag
		$out = "";
		foreach($this->blocks as $klucz => $wartosc)
			if (is_numeric($klucz))	// blok statyczny
				$out .=  $wartosc;
			else			// blok do podmiany
			  	if (array_key_exists($klucz, $this->replace))
				    if (array_key_exists('template', $_GET) && isCorporateUser())	// mozliwosc podejrzenia surowego template'a
					$out .=  $wartosc;			// nie podmieniamy
				    else
					$out .= $this->replace[$klucz];		// podmieniamy
					//$out .= "[$klucz!]";
					
		// <title>

list($a,$b) = explode('</head>', $out) ;
$out = $a ;
		if ($this->title)
		  $out = preg_replace("/<title>(.*)<\/title>/s","<title>" . $this->title . "</title>", $out);
		// <meta name="keywords"
		if ($this->keywords)
		  $out = preg_replace("/<\/title>/s","</title>\n<meta name=\"keywords\" content=\"" . implode(",", $this->keywords). "\"/>", $out);
		// <meta name="description"
		  $out = preg_replace("/<\/title>/s","</title>\n<meta name=\"description\" content=\"" . $this->description . "\"/>", $out);

$out = $out . '</head>' .$b ;
		if ($echo_output) echo $out;
		
		return $out;
    }
    	
   	// zachowanie zawartosci bloku, ktora byla w szablonie
   	public function noreplace($nazwa_bloku) {
   		$this->replace[$nazwa_bloku] = preg_replace("|<!-- (\w+)## -->|U", "", preg_replace("|<!-- ##(\w+) -->|U", "", $this->blocks[$nazwa_bloku]));	// skopiuj blok usuwajac z niego markery dla blokow czastkowych
 	}
 	
 	// // znajdz bloki czastkowe (<!-- ##blok -->content<!-- blok## -->)
 	public function parse_inner($nazwa_bloku) {

 		// szukamy markerow ##
 		$inner_blocks = array();
		preg_match_all('/<!--\s*##(\w+)/', $this->blocks[$nazwa_bloku], $markery);
		$markery = $markery[1];		//show($markery,'markery');
		
 		// szukamy blokow oznaczonych markerami
		foreach($markery as $marker) 
			if (!is_numeric($marker)) {
				$inner_blocks[$marker] = "";
				// marker otwierajacy, zamykajacy i statyczny blok HTML
				if (preg_match("/<!--\\s*##$marker\\s*-->(.*)<!--\\s*$marker##\\s*-->/", $this->blocks[$nazwa_bloku], $matches))
					$inner_blocks[$marker] = $matches[1];	// zawartosc bloku
			}
	 	return $inner_blocks;
 	}
 	
 	// podmiana markerow czastkawych w ramach jednego bloku
 	public function render_block($nazwa_bloku, $markery) {
 		$block = $this->blocks[$nazwa_bloku];
                
                // \n
 		$znacznik_nl = "[*--znacznik n--*]";	// usuniecie znakow konca linii na czas przetwarzania
		$block = str_replace("\n", $znacznik_nl, $block);
		 		
 		// markery dwuelementowe
		foreach($markery as $marker => $content)
			$block = preg_replace('/<!--\s*##' . $marker . '\s*-->(.*)<!--\s*' . $marker . '##\s*-->/', $content, $block);
 		// markery jednoelementowe
 		foreach($markery as $marker => $content)
 			$block = preg_replace('/<!--\s*##' . $marker . '##\s*-->/U', $content, $block);
 		
 		// \n
 		$block = str_replace($znacznik_nl, "\n", $block);	//do testow: $blocks[$id] = nl2br(htmlentities(str_replace($znacznik_nl, "\n", $block)));
		
                return $block;
 	}
	
	// podmiana zawartosci tagu <title>
	public function setTitle($title) {
	  $this->title = $title;
	}
	
	// podmiana zawartosci tagu <title>
	public function setDescription($description) {
	  $this->description = $description;
	}
	
	// wstawienie slow kluczowych do <head>			//zastosowanie: $tmpl->insertKeyword("fraza 1,fraza 2");
	public function insertKeyword($keyword) {
	  $this->keywords[] = $keyword;
	}
}// class Template
?>
